import { __commonJS, __toESM, __require } from './chunk-JBWKEMOK.js';
import program from 'commander';
import chalk15, { cyan, yellow } from 'chalk';
import { spawn } from 'child_process';
import envinfo from 'envinfo';
import leven from 'leven';
import { findPackageSync, findPackage } from 'fd-package-json';
import invariant5 from 'tiny-invariant';
import { logger, instance } from '@storybook/core/node-logger';
import { addToGlobalContext, telemetry } from '@storybook/core/telemetry';
import { versions, removeAddon, JsPackageManagerFactory, parseList, getEnvConfig, getStorybookInfo, getCoercedStorybookVersion, cache, commandLog, paddedLog, HandledError, getProjectRoot, serverRequire, loadMainConfig, frameworkPackages, rendererPackages, isCorePackage, commonGlobOptions, frameworkToRenderer as frameworkToRenderer$1, extractProperFrameworkName, builderPackages, getPackageDetails } from '@storybook/core/common';
import { withTelemetry, buildDevStandalone, buildStaticStandalone } from '@storybook/core/core-server';
import { readFile, appendFile } from 'fs/promises';
import findUp2 from 'find-up';
import prompts5 from 'prompts';
import { telemetry as telemetry$1 } from 'storybook/internal/telemetry';
import { NxProjectDetectedError } from '@storybook/core/server-errors';
import { dedent } from 'ts-dedent';
import process2 from 'node:process';
import semver, { prerelease, lt, eq, gt, validRange, minVersion, satisfies } from 'semver';
import * as fs2 from 'fs';
import fs2__default, { existsSync as existsSync$1 } from 'fs';
import { resolve } from 'node:path';
import fse, { move, remove, existsSync, readdir, createWriteStream, readdirSync, readFile as readFile$1, writeFile, readJson, writeJson } from 'fs-extra';
import path8, { join, isAbsolute, basename, dirname } from 'path';
import 'strip-json-comments';
import downloadTarball from '@ndelangen/get-tarball';
import getNpmTarballUrl from 'get-npm-tarball-url';
import ora from 'ora';
import detectIndent from 'detect-indent';
import { readConfig, writeConfig, loadConfig, formatConfig } from '@storybook/core/csf-tools';
import { UpgradeStorybookInWrongWorkingDirectory, UpgradeStorybookToLowerVersionError, UpgradeStorybookToSameVersionError, UpgradeStorybookUnknownCurrentVersionError, GenerateNewProjectOnInitError, MissingAngularJsonError } from 'storybook/internal/server-errors';
import execa from 'execa';
import { sync, spawn as spawn$1 } from 'cross-spawn';
import { withTelemetry as withTelemetry$1 } from 'storybook/internal/core-server';
import { EOL } from 'os';
import { downloadTemplate } from 'giget';

var require_eastasianwidth=__commonJS({"../../node_modules/eastasianwidth/eastasianwidth.js"(exports,module){var eaw={};typeof module>"u"?window.eastasianwidth=eaw:module.exports=eaw;eaw.eastAsianWidth=function(character){var x=character.charCodeAt(0),y=character.length==2?character.charCodeAt(1):0,codePoint=x;return 55296<=x&&x<=56319&&56320<=y&&y<=57343&&(x&=1023,y&=1023,codePoint=x<<10|y,codePoint+=65536),codePoint==12288||65281<=codePoint&&codePoint<=65376||65504<=codePoint&&codePoint<=65510?"F":codePoint==8361||65377<=codePoint&&codePoint<=65470||65474<=codePoint&&codePoint<=65479||65482<=codePoint&&codePoint<=65487||65490<=codePoint&&codePoint<=65495||65498<=codePoint&&codePoint<=65500||65512<=codePoint&&codePoint<=65518?"H":4352<=codePoint&&codePoint<=4447||4515<=codePoint&&codePoint<=4519||4602<=codePoint&&codePoint<=4607||9001<=codePoint&&codePoint<=9002||11904<=codePoint&&codePoint<=11929||11931<=codePoint&&codePoint<=12019||12032<=codePoint&&codePoint<=12245||12272<=codePoint&&codePoint<=12283||12289<=codePoint&&codePoint<=12350||12353<=codePoint&&codePoint<=12438||12441<=codePoint&&codePoint<=12543||12549<=codePoint&&codePoint<=12589||12593<=codePoint&&codePoint<=12686||12688<=codePoint&&codePoint<=12730||12736<=codePoint&&codePoint<=12771||12784<=codePoint&&codePoint<=12830||12832<=codePoint&&codePoint<=12871||12880<=codePoint&&codePoint<=13054||13056<=codePoint&&codePoint<=19903||19968<=codePoint&&codePoint<=42124||42128<=codePoint&&codePoint<=42182||43360<=codePoint&&codePoint<=43388||44032<=codePoint&&codePoint<=55203||55216<=codePoint&&codePoint<=55238||55243<=codePoint&&codePoint<=55291||63744<=codePoint&&codePoint<=64255||65040<=codePoint&&codePoint<=65049||65072<=codePoint&&codePoint<=65106||65108<=codePoint&&codePoint<=65126||65128<=codePoint&&codePoint<=65131||110592<=codePoint&&codePoint<=110593||127488<=codePoint&&codePoint<=127490||127504<=codePoint&&codePoint<=127546||127552<=codePoint&&codePoint<=127560||127568<=codePoint&&codePoint<=127569||131072<=codePoint&&codePoint<=194367||177984<=codePoint&&codePoint<=196605||196608<=codePoint&&codePoint<=262141?"W":32<=codePoint&&codePoint<=126||162<=codePoint&&codePoint<=163||165<=codePoint&&codePoint<=166||codePoint==172||codePoint==175||10214<=codePoint&&codePoint<=10221||10629<=codePoint&&codePoint<=10630?"Na":codePoint==161||codePoint==164||167<=codePoint&&codePoint<=168||codePoint==170||173<=codePoint&&codePoint<=174||176<=codePoint&&codePoint<=180||182<=codePoint&&codePoint<=186||188<=codePoint&&codePoint<=191||codePoint==198||codePoint==208||215<=codePoint&&codePoint<=216||222<=codePoint&&codePoint<=225||codePoint==230||232<=codePoint&&codePoint<=234||236<=codePoint&&codePoint<=237||codePoint==240||242<=codePoint&&codePoint<=243||247<=codePoint&&codePoint<=250||codePoint==252||codePoint==254||codePoint==257||codePoint==273||codePoint==275||codePoint==283||294<=codePoint&&codePoint<=295||codePoint==299||305<=codePoint&&codePoint<=307||codePoint==312||319<=codePoint&&codePoint<=322||codePoint==324||328<=codePoint&&codePoint<=331||codePoint==333||338<=codePoint&&codePoint<=339||358<=codePoint&&codePoint<=359||codePoint==363||codePoint==462||codePoint==464||codePoint==466||codePoint==468||codePoint==470||codePoint==472||codePoint==474||codePoint==476||codePoint==593||codePoint==609||codePoint==708||codePoint==711||713<=codePoint&&codePoint<=715||codePoint==717||codePoint==720||728<=codePoint&&codePoint<=731||codePoint==733||codePoint==735||768<=codePoint&&codePoint<=879||913<=codePoint&&codePoint<=929||931<=codePoint&&codePoint<=937||945<=codePoint&&codePoint<=961||963<=codePoint&&codePoint<=969||codePoint==1025||1040<=codePoint&&codePoint<=1103||codePoint==1105||codePoint==8208||8211<=codePoint&&codePoint<=8214||8216<=codePoint&&codePoint<=8217||8220<=codePoint&&codePoint<=8221||8224<=codePoint&&codePoint<=8226||8228<=codePoint&&codePoint<=8231||codePoint==8240||8242<=codePoint&&codePoint<=8243||codePoint==8245||codePoint==8251||codePoint==8254||codePoint==8308||codePoint==8319||8321<=codePoint&&codePoint<=8324||codePoint==8364||codePoint==8451||codePoint==8453||codePoint==8457||codePoint==8467||codePoint==8470||8481<=codePoint&&codePoint<=8482||codePoint==8486||codePoint==8491||8531<=codePoint&&codePoint<=8532||8539<=codePoint&&codePoint<=8542||8544<=codePoint&&codePoint<=8555||8560<=codePoint&&codePoint<=8569||codePoint==8585||8592<=codePoint&&codePoint<=8601||8632<=codePoint&&codePoint<=8633||codePoint==8658||codePoint==8660||codePoint==8679||codePoint==8704||8706<=codePoint&&codePoint<=8707||8711<=codePoint&&codePoint<=8712||codePoint==8715||codePoint==8719||codePoint==8721||codePoint==8725||codePoint==8730||8733<=codePoint&&codePoint<=8736||codePoint==8739||codePoint==8741||8743<=codePoint&&codePoint<=8748||codePoint==8750||8756<=codePoint&&codePoint<=8759||8764<=codePoint&&codePoint<=8765||codePoint==8776||codePoint==8780||codePoint==8786||8800<=codePoint&&codePoint<=8801||8804<=codePoint&&codePoint<=8807||8810<=codePoint&&codePoint<=8811||8814<=codePoint&&codePoint<=8815||8834<=codePoint&&codePoint<=8835||8838<=codePoint&&codePoint<=8839||codePoint==8853||codePoint==8857||codePoint==8869||codePoint==8895||codePoint==8978||9312<=codePoint&&codePoint<=9449||9451<=codePoint&&codePoint<=9547||9552<=codePoint&&codePoint<=9587||9600<=codePoint&&codePoint<=9615||9618<=codePoint&&codePoint<=9621||9632<=codePoint&&codePoint<=9633||9635<=codePoint&&codePoint<=9641||9650<=codePoint&&codePoint<=9651||9654<=codePoint&&codePoint<=9655||9660<=codePoint&&codePoint<=9661||9664<=codePoint&&codePoint<=9665||9670<=codePoint&&codePoint<=9672||codePoint==9675||9678<=codePoint&&codePoint<=9681||9698<=codePoint&&codePoint<=9701||codePoint==9711||9733<=codePoint&&codePoint<=9734||codePoint==9737||9742<=codePoint&&codePoint<=9743||9748<=codePoint&&codePoint<=9749||codePoint==9756||codePoint==9758||codePoint==9792||codePoint==9794||9824<=codePoint&&codePoint<=9825||9827<=codePoint&&codePoint<=9829||9831<=codePoint&&codePoint<=9834||9836<=codePoint&&codePoint<=9837||codePoint==9839||9886<=codePoint&&codePoint<=9887||9918<=codePoint&&codePoint<=9919||9924<=codePoint&&codePoint<=9933||9935<=codePoint&&codePoint<=9953||codePoint==9955||9960<=codePoint&&codePoint<=9983||codePoint==10045||codePoint==10071||10102<=codePoint&&codePoint<=10111||11093<=codePoint&&codePoint<=11097||12872<=codePoint&&codePoint<=12879||57344<=codePoint&&codePoint<=63743||65024<=codePoint&&codePoint<=65039||codePoint==65533||127232<=codePoint&&codePoint<=127242||127248<=codePoint&&codePoint<=127277||127280<=codePoint&&codePoint<=127337||127344<=codePoint&&codePoint<=127386||917760<=codePoint&&codePoint<=917999||983040<=codePoint&&codePoint<=1048573||1048576<=codePoint&&codePoint<=1114109?"A":"N"};eaw.characterLength=function(character){var code=this.eastAsianWidth(character);return code=="F"||code=="W"||code=="A"?2:1};function stringToArray(string){return string.match(/[\uD800-\uDBFF][\uDC00-\uDFFF]|[^\uD800-\uDFFF]/g)||[]}eaw.length=function(string){for(var characters=stringToArray(string),len=0,i=0;i<characters.length;i++)len=len+this.characterLength(characters[i]);return len};eaw.slice=function(text,start,end){textLen=eaw.length(text),start=start||0,end=end||1,start<0&&(start=textLen+start),end<0&&(end=textLen+end);for(var result="",eawLen=0,chars=stringToArray(text),i=0;i<chars.length;i++){var char=chars[i],charLen=eaw.length(char);if(eawLen>=start-(charLen==2?1:0))if(eawLen+charLen<=end)result+=char;else break;eawLen+=charLen;}return result};}});var require_emoji_regex=__commonJS({"../../node_modules/emoji-regex/index.js"(exports,module){module.exports=function(){return /\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62(?:\uDB40\uDC77\uDB40\uDC6C\uDB40\uDC73|\uDB40\uDC73\uDB40\uDC63\uDB40\uDC74|\uDB40\uDC65\uDB40\uDC6E\uDB40\uDC67)\uDB40\uDC7F|(?:\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFE])|(?:\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFC-\uDFFF])|\uD83D\uDC68(?:\uD83C\uDFFB(?:\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF]))|\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFC-\uDFFF])|[\u2695\u2696\u2708]\uFE0F|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))?|(?:\uD83C[\uDFFC-\uDFFF])\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF]))|\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83D\uDC68|(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFE])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])\uFE0F|\u200D(?:(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D[\uDC66\uDC67])|\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC)?|(?:\uD83D\uDC69(?:\uD83C\uDFFB\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|(?:\uD83C[\uDFFC-\uDFFF])\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69]))|\uD83E\uDDD1(?:\uD83C[\uDFFB-\uDFFF])\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1)(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC69(?:\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83E\uDDD1(?:\u200D(?:\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83D\uDC69\u200D\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D\uDC69\u200D\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|(?:\uD83D\uDC41\uFE0F\u200D\uD83D\uDDE8|\uD83E\uDDD1(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|\uD83D\uDC69(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|\uD83D\uDE36\u200D\uD83C\uDF2B|\uD83C\uDFF3\uFE0F\u200D\u26A7|\uD83D\uDC3B\u200D\u2744|(?:(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF])\u200D[\u2640\u2642]|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]|\uD83C\uDFF4\u200D\u2620|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])\u200D[\u2640\u2642]|[\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u2328\u23CF\u23ED-\u23EF\u23F1\u23F2\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB\u25FC\u2600-\u2604\u260E\u2611\u2618\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u2692\u2694-\u2697\u2699\u269B\u269C\u26A0\u26A7\u26B0\u26B1\u26C8\u26CF\u26D1\u26D3\u26E9\u26F0\u26F1\u26F4\u26F7\u26F8\u2702\u2708\u2709\u270F\u2712\u2714\u2716\u271D\u2721\u2733\u2734\u2744\u2747\u2763\u27A1\u2934\u2935\u2B05-\u2B07\u3030\u303D\u3297\u3299]|\uD83C[\uDD70\uDD71\uDD7E\uDD7F\uDE02\uDE37\uDF21\uDF24-\uDF2C\uDF36\uDF7D\uDF96\uDF97\uDF99-\uDF9B\uDF9E\uDF9F\uDFCD\uDFCE\uDFD4-\uDFDF\uDFF5\uDFF7]|\uD83D[\uDC3F\uDCFD\uDD49\uDD4A\uDD6F\uDD70\uDD73\uDD76-\uDD79\uDD87\uDD8A-\uDD8D\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA\uDECB\uDECD-\uDECF\uDEE0-\uDEE5\uDEE9\uDEF0\uDEF3])\uFE0F|\uD83C\uDFF3\uFE0F\u200D\uD83C\uDF08|\uD83D\uDC69\u200D\uD83D\uDC67|\uD83D\uDC69\u200D\uD83D\uDC66|\uD83D\uDE35\u200D\uD83D\uDCAB|\uD83D\uDE2E\u200D\uD83D\uDCA8|\uD83D\uDC15\u200D\uD83E\uDDBA|\uD83E\uDDD1(?:\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC|\uD83C\uDFFB)?|\uD83D\uDC69(?:\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC|\uD83C\uDFFB)?|\uD83C\uDDFD\uD83C\uDDF0|\uD83C\uDDF6\uD83C\uDDE6|\uD83C\uDDF4\uD83C\uDDF2|\uD83D\uDC08\u200D\u2B1B|\u2764\uFE0F\u200D(?:\uD83D\uDD25|\uD83E\uDE79)|\uD83D\uDC41\uFE0F|\uD83C\uDFF3\uFE0F|\uD83C\uDDFF(?:\uD83C[\uDDE6\uDDF2\uDDFC])|\uD83C\uDDFE(?:\uD83C[\uDDEA\uDDF9])|\uD83C\uDDFC(?:\uD83C[\uDDEB\uDDF8])|\uD83C\uDDFB(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA])|\uD83C\uDDFA(?:\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF])|\uD83C\uDDF9(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF])|\uD83C\uDDF8(?:\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF])|\uD83C\uDDF7(?:\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC])|\uD83C\uDDF5(?:\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE])|\uD83C\uDDF3(?:\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF])|\uD83C\uDDF2(?:\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF])|\uD83C\uDDF1(?:\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE])|\uD83C\uDDF0(?:\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF])|\uD83C\uDDEF(?:\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5])|\uD83C\uDDEE(?:\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9])|\uD83C\uDDED(?:\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA])|\uD83C\uDDEC(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE])|\uD83C\uDDEB(?:\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7])|\uD83C\uDDEA(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA])|\uD83C\uDDE9(?:\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF])|\uD83C\uDDE8(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF5\uDDF7\uDDFA-\uDDFF])|\uD83C\uDDE7(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF])|\uD83C\uDDE6(?:\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF])|[#\*0-9]\uFE0F\u20E3|\u2764\uFE0F|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])|\uD83C\uDFF4|(?:[\u270A\u270B]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5])(?:\uD83C[\uDFFB-\uDFFF])|(?:[\u261D\u270C\u270D]|\uD83D[\uDD74\uDD90])(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])|[\u270A\u270B]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC08\uDC15\uDC3B\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE2E\uDE35\uDE36\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5]|\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD]|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF]|[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF84\uDF86-\uDF93\uDFA0-\uDFC1\uDFC5\uDFC6\uDFC8\uDFC9\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC07\uDC09-\uDC14\uDC16-\uDC3A\uDC3C-\uDC3E\uDC40\uDC44\uDC45\uDC51-\uDC65\uDC6A\uDC79-\uDC7B\uDC7D-\uDC80\uDC84\uDC88-\uDC8E\uDC90\uDC92-\uDCA9\uDCAB-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDDA4\uDDFB-\uDE2D\uDE2F-\uDE34\uDE37-\uDE44\uDE48-\uDE4A\uDE80-\uDEA2\uDEA4-\uDEB3\uDEB7-\uDEBF\uDEC1-\uDEC5\uDED0-\uDED2\uDED5-\uDED7\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0D\uDD0E\uDD10-\uDD17\uDD1D\uDD20-\uDD25\uDD27-\uDD2F\uDD3A\uDD3F-\uDD45\uDD47-\uDD76\uDD78\uDD7A-\uDDB4\uDDB7\uDDBA\uDDBC-\uDDCB\uDDD0\uDDE0-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6]|(?:[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u270A\u270B\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF93\uDFA0-\uDFCA\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF4\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC3E\uDC40\uDC42-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDD7A\uDD95\uDD96\uDDA4\uDDFB-\uDE4F\uDE80-\uDEC5\uDECC\uDED0-\uDED2\uDED5-\uDED7\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0C-\uDD3A\uDD3C-\uDD45\uDD47-\uDD78\uDD7A-\uDDCB\uDDCD-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6])|(?:[#\*0-9\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23E9-\u23F3\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB-\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u261D\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u267F\u2692-\u2697\u2699\u269B\u269C\u26A0\u26A1\u26A7\u26AA\u26AB\u26B0\u26B1\u26BD\u26BE\u26C4\u26C5\u26C8\u26CE\u26CF\u26D1\u26D3\u26D4\u26E9\u26EA\u26F0-\u26F5\u26F7-\u26FA\u26FD\u2702\u2705\u2708-\u270D\u270F\u2712\u2714\u2716\u271D\u2721\u2728\u2733\u2734\u2744\u2747\u274C\u274E\u2753-\u2755\u2757\u2763\u2764\u2795-\u2797\u27A1\u27B0\u27BF\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B50\u2B55\u3030\u303D\u3297\u3299]|\uD83C[\uDC04\uDCCF\uDD70\uDD71\uDD7E\uDD7F\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE02\uDE1A\uDE2F\uDE32-\uDE3A\uDE50\uDE51\uDF00-\uDF21\uDF24-\uDF93\uDF96\uDF97\uDF99-\uDF9B\uDF9E-\uDFF0\uDFF3-\uDFF5\uDFF7-\uDFFF]|\uD83D[\uDC00-\uDCFD\uDCFF-\uDD3D\uDD49-\uDD4E\uDD50-\uDD67\uDD6F\uDD70\uDD73-\uDD7A\uDD87\uDD8A-\uDD8D\uDD90\uDD95\uDD96\uDDA4\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA-\uDE4F\uDE80-\uDEC5\uDECB-\uDED2\uDED5-\uDED7\uDEE0-\uDEE5\uDEE9\uDEEB\uDEEC\uDEF0\uDEF3-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0C-\uDD3A\uDD3C-\uDD45\uDD47-\uDD78\uDD7A-\uDDCB\uDDCD-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6])\uFE0F|(?:[\u261D\u26F9\u270A-\u270D]|\uD83C[\uDF85\uDFC2-\uDFC4\uDFC7\uDFCA-\uDFCC]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66-\uDC78\uDC7C\uDC81-\uDC83\uDC85-\uDC87\uDC8F\uDC91\uDCAA\uDD74\uDD75\uDD7A\uDD90\uDD95\uDD96\uDE45-\uDE47\uDE4B-\uDE4F\uDEA3\uDEB4-\uDEB6\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1F\uDD26\uDD30-\uDD39\uDD3C-\uDD3E\uDD77\uDDB5\uDDB6\uDDB8\uDDB9\uDDBB\uDDCD-\uDDCF\uDDD1-\uDDDD])/g};}});var require_boxes=__commonJS({"../../node_modules/cli-boxes/boxes.json"(exports,module){module.exports={single:{topLeft:"\u250C",top:"\u2500",topRight:"\u2510",right:"\u2502",bottomRight:"\u2518",bottom:"\u2500",bottomLeft:"\u2514",left:"\u2502"},double:{topLeft:"\u2554",top:"\u2550",topRight:"\u2557",right:"\u2551",bottomRight:"\u255D",bottom:"\u2550",bottomLeft:"\u255A",left:"\u2551"},round:{topLeft:"\u256D",top:"\u2500",topRight:"\u256E",right:"\u2502",bottomRight:"\u256F",bottom:"\u2500",bottomLeft:"\u2570",left:"\u2502"},bold:{topLeft:"\u250F",top:"\u2501",topRight:"\u2513",right:"\u2503",bottomRight:"\u251B",bottom:"\u2501",bottomLeft:"\u2517",left:"\u2503"},singleDouble:{topLeft:"\u2553",top:"\u2500",topRight:"\u2556",right:"\u2551",bottomRight:"\u255C",bottom:"\u2500",bottomLeft:"\u2559",left:"\u2551"},doubleSingle:{topLeft:"\u2552",top:"\u2550",topRight:"\u2555",right:"\u2502",bottomRight:"\u255B",bottom:"\u2550",bottomLeft:"\u2558",left:"\u2502"},classic:{topLeft:"+",top:"-",topRight:"+",right:"|",bottomRight:"+",bottom:"-",bottomLeft:"+",left:"|"},arrow:{topLeft:"\u2198",top:"\u2193",topRight:"\u2199",right:"\u2190",bottomRight:"\u2196",bottom:"\u2191",bottomLeft:"\u2197",left:"\u2192"}};}});var require_cli_boxes=__commonJS({"../../node_modules/cli-boxes/index.js"(exports,module){var cliBoxes2=require_boxes();module.exports=cliBoxes2;module.exports.default=cliBoxes2;}});var require_ansi_regex=__commonJS({"../../node_modules/ansi-regex/index.js"(exports,module){module.exports=({onlyFirst=!1}={})=>{let pattern=["[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)","(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))"].join("|");return new RegExp(pattern,onlyFirst?void 0:"g")};}});var require_strip_ansi=__commonJS({"../../node_modules/string-width/node_modules/strip-ansi/index.js"(exports,module){var ansiRegex3=require_ansi_regex();module.exports=string=>typeof string=="string"?string.replace(ansiRegex3(),""):string;}});var require_is_fullwidth_code_point=__commonJS({"../../node_modules/is-fullwidth-code-point/index.js"(exports,module){var isFullwidthCodePoint=codePoint=>Number.isNaN(codePoint)?!1:codePoint>=4352&&(codePoint<=4447||codePoint===9001||codePoint===9002||11904<=codePoint&&codePoint<=12871&&codePoint!==12351||12880<=codePoint&&codePoint<=19903||19968<=codePoint&&codePoint<=42182||43360<=codePoint&&codePoint<=43388||44032<=codePoint&&codePoint<=55203||63744<=codePoint&&codePoint<=64255||65040<=codePoint&&codePoint<=65049||65072<=codePoint&&codePoint<=65131||65281<=codePoint&&codePoint<=65376||65504<=codePoint&&codePoint<=65510||110592<=codePoint&&codePoint<=110593||127488<=codePoint&&codePoint<=127569||131072<=codePoint&&codePoint<=262141);module.exports=isFullwidthCodePoint;module.exports.default=isFullwidthCodePoint;}});var require_emoji_regex2=__commonJS({"../../node_modules/string-width/node_modules/emoji-regex/index.js"(exports,module){module.exports=function(){return /\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62(?:\uDB40\uDC65\uDB40\uDC6E\uDB40\uDC67|\uDB40\uDC73\uDB40\uDC63\uDB40\uDC74|\uDB40\uDC77\uDB40\uDC6C\uDB40\uDC73)\uDB40\uDC7F|\uD83D\uDC68(?:\uD83C\uDFFC\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFB|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFE])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFD])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFC])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83D\uDC68|(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D[\uDC66\uDC67])|[\u2695\u2696\u2708]\uFE0F|\uD83D[\uDC66\uDC67]|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|(?:\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708])\uFE0F|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C[\uDFFB-\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC69)\uD83C\uDFFB|\uD83E\uDDD1(?:\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1(?:\uD83C[\uDFFB-\uDFFF])|\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1)|(?:\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFE])|(?:\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC69)(?:\uD83C[\uDFFB\uDFFC])|\uD83D\uDC69(?:\uD83C\uDFFE\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFC-\uDFFF])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|(?:\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC69)(?:\uD83C[\uDFFB-\uDFFD])|\uD83D\uDC69\u200D\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D[\uDC66\uDC67])|(?:\uD83D\uDC41\uFE0F\u200D\uD83D\uDDE8|\uD83D\uDC69(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|(?:(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)\uFE0F|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF])\u200D[\u2640\u2642]|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD6-\uDDDD])(?:(?:\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]|\u200D[\u2640\u2642])|\uD83C\uDFF4\u200D\u2620)\uFE0F|\uD83D\uDC69\u200D\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|\uD83C\uDFF3\uFE0F\u200D\uD83C\uDF08|\uD83D\uDC15\u200D\uD83E\uDDBA|\uD83D\uDC69\u200D\uD83D\uDC66|\uD83D\uDC69\u200D\uD83D\uDC67|\uD83C\uDDFD\uD83C\uDDF0|\uD83C\uDDF4\uD83C\uDDF2|\uD83C\uDDF6\uD83C\uDDE6|[#\*0-9]\uFE0F\u20E3|\uD83C\uDDE7(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF])|\uD83C\uDDF9(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF])|\uD83C\uDDEA(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA])|\uD83E\uDDD1(?:\uD83C[\uDFFB-\uDFFF])|\uD83C\uDDF7(?:\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC])|\uD83D\uDC69(?:\uD83C[\uDFFB-\uDFFF])|\uD83C\uDDF2(?:\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF])|\uD83C\uDDE6(?:\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF])|\uD83C\uDDF0(?:\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF])|\uD83C\uDDED(?:\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA])|\uD83C\uDDE9(?:\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF])|\uD83C\uDDFE(?:\uD83C[\uDDEA\uDDF9])|\uD83C\uDDEC(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE])|\uD83C\uDDF8(?:\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF])|\uD83C\uDDEB(?:\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7])|\uD83C\uDDF5(?:\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE])|\uD83C\uDDFB(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA])|\uD83C\uDDF3(?:\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF])|\uD83C\uDDE8(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF5\uDDF7\uDDFA-\uDDFF])|\uD83C\uDDF1(?:\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE])|\uD83C\uDDFF(?:\uD83C[\uDDE6\uDDF2\uDDFC])|\uD83C\uDDFC(?:\uD83C[\uDDEB\uDDF8])|\uD83C\uDDFA(?:\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF])|\uD83C\uDDEE(?:\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9])|\uD83C\uDDEF(?:\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5])|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uD83C[\uDFFB-\uDFFF])|(?:[\u261D\u270A-\u270D]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC70\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDCAA\uDD74\uDD7A\uDD90\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD36\uDDB5\uDDB6\uDDBB\uDDD2-\uDDD5])(?:\uD83C[\uDFFB-\uDFFF])|(?:[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u270A\u270B\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF93\uDFA0-\uDFCA\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF4\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC3E\uDC40\uDC42-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDD7A\uDD95\uDD96\uDDA4\uDDFB-\uDE4F\uDE80-\uDEC5\uDECC\uDED0-\uDED2\uDED5\uDEEB\uDEEC\uDEF4-\uDEFA\uDFE0-\uDFEB]|\uD83E[\uDD0D-\uDD3A\uDD3C-\uDD45\uDD47-\uDD71\uDD73-\uDD76\uDD7A-\uDDA2\uDDA5-\uDDAA\uDDAE-\uDDCA\uDDCD-\uDDFF\uDE70-\uDE73\uDE78-\uDE7A\uDE80-\uDE82\uDE90-\uDE95])|(?:[#\*0-9\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23E9-\u23F3\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB-\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u261D\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u267F\u2692-\u2697\u2699\u269B\u269C\u26A0\u26A1\u26AA\u26AB\u26B0\u26B1\u26BD\u26BE\u26C4\u26C5\u26C8\u26CE\u26CF\u26D1\u26D3\u26D4\u26E9\u26EA\u26F0-\u26F5\u26F7-\u26FA\u26FD\u2702\u2705\u2708-\u270D\u270F\u2712\u2714\u2716\u271D\u2721\u2728\u2733\u2734\u2744\u2747\u274C\u274E\u2753-\u2755\u2757\u2763\u2764\u2795-\u2797\u27A1\u27B0\u27BF\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B50\u2B55\u3030\u303D\u3297\u3299]|\uD83C[\uDC04\uDCCF\uDD70\uDD71\uDD7E\uDD7F\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE02\uDE1A\uDE2F\uDE32-\uDE3A\uDE50\uDE51\uDF00-\uDF21\uDF24-\uDF93\uDF96\uDF97\uDF99-\uDF9B\uDF9E-\uDFF0\uDFF3-\uDFF5\uDFF7-\uDFFF]|\uD83D[\uDC00-\uDCFD\uDCFF-\uDD3D\uDD49-\uDD4E\uDD50-\uDD67\uDD6F\uDD70\uDD73-\uDD7A\uDD87\uDD8A-\uDD8D\uDD90\uDD95\uDD96\uDDA4\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA-\uDE4F\uDE80-\uDEC5\uDECB-\uDED2\uDED5\uDEE0-\uDEE5\uDEE9\uDEEB\uDEEC\uDEF0\uDEF3-\uDEFA\uDFE0-\uDFEB]|\uD83E[\uDD0D-\uDD3A\uDD3C-\uDD45\uDD47-\uDD71\uDD73-\uDD76\uDD7A-\uDDA2\uDDA5-\uDDAA\uDDAE-\uDDCA\uDDCD-\uDDFF\uDE70-\uDE73\uDE78-\uDE7A\uDE80-\uDE82\uDE90-\uDE95])\uFE0F|(?:[\u261D\u26F9\u270A-\u270D]|\uD83C[\uDF85\uDFC2-\uDFC4\uDFC7\uDFCA-\uDFCC]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66-\uDC78\uDC7C\uDC81-\uDC83\uDC85-\uDC87\uDC8F\uDC91\uDCAA\uDD74\uDD75\uDD7A\uDD90\uDD95\uDD96\uDE45-\uDE47\uDE4B-\uDE4F\uDEA3\uDEB4-\uDEB6\uDEC0\uDECC]|\uD83E[\uDD0F\uDD18-\uDD1F\uDD26\uDD30-\uDD39\uDD3C-\uDD3E\uDDB5\uDDB6\uDDB8\uDDB9\uDDBB\uDDCD-\uDDCF\uDDD1-\uDDDD])/g};}});var require_string_width=__commonJS({"../../node_modules/string-width/index.js"(exports,module){var stripAnsi2=require_strip_ansi(),isFullwidthCodePoint=require_is_fullwidth_code_point(),emojiRegex4=require_emoji_regex2(),stringWidth4=string=>{if(typeof string!="string"||string.length===0||(string=stripAnsi2(string),string.length===0))return 0;string=string.replace(emojiRegex4(),"  ");let width=0;for(let i=0;i<string.length;i++){let code=string.codePointAt(i);code<=31||code>=127&&code<=159||code>=768&&code<=879||(code>65535&&i++,width+=isFullwidthCodePoint(code)?2:1);}return width};module.exports=stringWidth4;module.exports.default=stringWidth4;}});var require_ansi_align=__commonJS({"../../node_modules/ansi-align/index.js"(exports,module){var stringWidth4=require_string_width();function ansiAlign2(text,opts){if(!text)return text;opts=opts||{};let align=opts.align||"center";if(align==="left")return text;let split=opts.split||`
`,pad=opts.pad||" ",widthDiffFn=align!=="right"?halfDiff:fullDiff,returnString=!1;Array.isArray(text)||(returnString=!0,text=String(text).split(split));let width,maxWidth=0;return text=text.map(function(str){return str=String(str),width=stringWidth4(str),maxWidth=Math.max(width,maxWidth),{str,width}}).map(function(obj){return new Array(widthDiffFn(maxWidth,obj.width)+1).join(pad)+obj.str}),returnString?text.join(split):text}ansiAlign2.left=function(text){return ansiAlign2(text,{align:"left"})};ansiAlign2.center=function(text){return ansiAlign2(text,{align:"center"})};ansiAlign2.right=function(text){return ansiAlign2(text,{align:"right"})};module.exports=ansiAlign2;function halfDiff(maxWidth,curWidth){return Math.floor((maxWidth-curWidth)/2)}function fullDiff(maxWidth,curWidth){return maxWidth-curWidth}}});var require_shallowEqual=__commonJS({"../../node_modules/@babel/types/lib/utils/shallowEqual.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=shallowEqual;function shallowEqual(actual,expected){let keys=Object.keys(expected);for(let key of keys)if(actual[key]!==expected[key])return !1;return !0}}});var require_deprecationWarning=__commonJS({"../../node_modules/@babel/types/lib/utils/deprecationWarning.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=deprecationWarning;var warnings=new Set;function deprecationWarning(oldName,newName,prefix=""){if(warnings.has(oldName))return;warnings.add(oldName);let{internal,trace}=captureShortStackTrace(1,2);internal||console.warn(`${prefix}\`${oldName}\` has been deprecated, please migrate to \`${newName}\`
${trace}`);}function captureShortStackTrace(skip,length){let{stackTraceLimit,prepareStackTrace}=Error,stackTrace;if(Error.stackTraceLimit=1+skip+length,Error.prepareStackTrace=function(err,stack){stackTrace=stack;},new Error().stack,Error.stackTraceLimit=stackTraceLimit,Error.prepareStackTrace=prepareStackTrace,!stackTrace)return {internal:!1,trace:""};let shortStackTrace=stackTrace.slice(1+skip,1+skip+length);return {internal:/[\\/]@babel[\\/]/.test(shortStackTrace[1].getFileName()),trace:shortStackTrace.map(frame=>`    at ${frame}`).join(`
`)}}}});var require_generated=__commonJS({"../../node_modules/@babel/types/lib/validators/generated/index.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.isAccessor=isAccessor;exports.isAnyTypeAnnotation=isAnyTypeAnnotation;exports.isArgumentPlaceholder=isArgumentPlaceholder;exports.isArrayExpression=isArrayExpression2;exports.isArrayPattern=isArrayPattern;exports.isArrayTypeAnnotation=isArrayTypeAnnotation;exports.isArrowFunctionExpression=isArrowFunctionExpression;exports.isAssignmentExpression=isAssignmentExpression;exports.isAssignmentPattern=isAssignmentPattern;exports.isAwaitExpression=isAwaitExpression;exports.isBigIntLiteral=isBigIntLiteral;exports.isBinary=isBinary;exports.isBinaryExpression=isBinaryExpression;exports.isBindExpression=isBindExpression;exports.isBlock=isBlock;exports.isBlockParent=isBlockParent;exports.isBlockStatement=isBlockStatement;exports.isBooleanLiteral=isBooleanLiteral;exports.isBooleanLiteralTypeAnnotation=isBooleanLiteralTypeAnnotation;exports.isBooleanTypeAnnotation=isBooleanTypeAnnotation;exports.isBreakStatement=isBreakStatement;exports.isCallExpression=isCallExpression;exports.isCatchClause=isCatchClause;exports.isClass=isClass;exports.isClassAccessorProperty=isClassAccessorProperty;exports.isClassBody=isClassBody;exports.isClassDeclaration=isClassDeclaration;exports.isClassExpression=isClassExpression;exports.isClassImplements=isClassImplements;exports.isClassMethod=isClassMethod;exports.isClassPrivateMethod=isClassPrivateMethod;exports.isClassPrivateProperty=isClassPrivateProperty;exports.isClassProperty=isClassProperty;exports.isCompletionStatement=isCompletionStatement;exports.isConditional=isConditional;exports.isConditionalExpression=isConditionalExpression;exports.isContinueStatement=isContinueStatement;exports.isDebuggerStatement=isDebuggerStatement;exports.isDecimalLiteral=isDecimalLiteral;exports.isDeclaration=isDeclaration;exports.isDeclareClass=isDeclareClass;exports.isDeclareExportAllDeclaration=isDeclareExportAllDeclaration;exports.isDeclareExportDeclaration=isDeclareExportDeclaration;exports.isDeclareFunction=isDeclareFunction;exports.isDeclareInterface=isDeclareInterface;exports.isDeclareModule=isDeclareModule;exports.isDeclareModuleExports=isDeclareModuleExports;exports.isDeclareOpaqueType=isDeclareOpaqueType;exports.isDeclareTypeAlias=isDeclareTypeAlias;exports.isDeclareVariable=isDeclareVariable;exports.isDeclaredPredicate=isDeclaredPredicate;exports.isDecorator=isDecorator;exports.isDirective=isDirective;exports.isDirectiveLiteral=isDirectiveLiteral;exports.isDoExpression=isDoExpression;exports.isDoWhileStatement=isDoWhileStatement;exports.isEmptyStatement=isEmptyStatement;exports.isEmptyTypeAnnotation=isEmptyTypeAnnotation;exports.isEnumBody=isEnumBody;exports.isEnumBooleanBody=isEnumBooleanBody;exports.isEnumBooleanMember=isEnumBooleanMember;exports.isEnumDeclaration=isEnumDeclaration;exports.isEnumDefaultedMember=isEnumDefaultedMember;exports.isEnumMember=isEnumMember;exports.isEnumNumberBody=isEnumNumberBody;exports.isEnumNumberMember=isEnumNumberMember;exports.isEnumStringBody=isEnumStringBody;exports.isEnumStringMember=isEnumStringMember;exports.isEnumSymbolBody=isEnumSymbolBody;exports.isExistsTypeAnnotation=isExistsTypeAnnotation;exports.isExportAllDeclaration=isExportAllDeclaration;exports.isExportDeclaration=isExportDeclaration;exports.isExportDefaultDeclaration=isExportDefaultDeclaration;exports.isExportDefaultSpecifier=isExportDefaultSpecifier;exports.isExportNamedDeclaration=isExportNamedDeclaration;exports.isExportNamespaceSpecifier=isExportNamespaceSpecifier;exports.isExportSpecifier=isExportSpecifier;exports.isExpression=isExpression;exports.isExpressionStatement=isExpressionStatement;exports.isExpressionWrapper=isExpressionWrapper;exports.isFile=isFile;exports.isFlow=isFlow;exports.isFlowBaseAnnotation=isFlowBaseAnnotation;exports.isFlowDeclaration=isFlowDeclaration;exports.isFlowPredicate=isFlowPredicate;exports.isFlowType=isFlowType;exports.isFor=isFor;exports.isForInStatement=isForInStatement;exports.isForOfStatement=isForOfStatement;exports.isForStatement=isForStatement;exports.isForXStatement=isForXStatement;exports.isFunction=isFunction;exports.isFunctionDeclaration=isFunctionDeclaration2;exports.isFunctionExpression=isFunctionExpression;exports.isFunctionParent=isFunctionParent;exports.isFunctionTypeAnnotation=isFunctionTypeAnnotation;exports.isFunctionTypeParam=isFunctionTypeParam;exports.isGenericTypeAnnotation=isGenericTypeAnnotation;exports.isIdentifier=isIdentifier2;exports.isIfStatement=isIfStatement;exports.isImmutable=isImmutable;exports.isImport=isImport;exports.isImportAttribute=isImportAttribute;exports.isImportDeclaration=isImportDeclaration;exports.isImportDefaultSpecifier=isImportDefaultSpecifier;exports.isImportExpression=isImportExpression;exports.isImportNamespaceSpecifier=isImportNamespaceSpecifier;exports.isImportOrExportDeclaration=isImportOrExportDeclaration;exports.isImportSpecifier=isImportSpecifier;exports.isIndexedAccessType=isIndexedAccessType;exports.isInferredPredicate=isInferredPredicate;exports.isInterfaceDeclaration=isInterfaceDeclaration;exports.isInterfaceExtends=isInterfaceExtends;exports.isInterfaceTypeAnnotation=isInterfaceTypeAnnotation;exports.isInterpreterDirective=isInterpreterDirective;exports.isIntersectionTypeAnnotation=isIntersectionTypeAnnotation;exports.isJSX=isJSX;exports.isJSXAttribute=isJSXAttribute;exports.isJSXClosingElement=isJSXClosingElement;exports.isJSXClosingFragment=isJSXClosingFragment;exports.isJSXElement=isJSXElement;exports.isJSXEmptyExpression=isJSXEmptyExpression;exports.isJSXExpressionContainer=isJSXExpressionContainer;exports.isJSXFragment=isJSXFragment;exports.isJSXIdentifier=isJSXIdentifier;exports.isJSXMemberExpression=isJSXMemberExpression;exports.isJSXNamespacedName=isJSXNamespacedName;exports.isJSXOpeningElement=isJSXOpeningElement;exports.isJSXOpeningFragment=isJSXOpeningFragment;exports.isJSXSpreadAttribute=isJSXSpreadAttribute;exports.isJSXSpreadChild=isJSXSpreadChild;exports.isJSXText=isJSXText;exports.isLVal=isLVal;exports.isLabeledStatement=isLabeledStatement;exports.isLiteral=isLiteral;exports.isLogicalExpression=isLogicalExpression;exports.isLoop=isLoop;exports.isMemberExpression=isMemberExpression;exports.isMetaProperty=isMetaProperty;exports.isMethod=isMethod;exports.isMiscellaneous=isMiscellaneous;exports.isMixedTypeAnnotation=isMixedTypeAnnotation;exports.isModuleDeclaration=isModuleDeclaration;exports.isModuleExpression=isModuleExpression;exports.isModuleSpecifier=isModuleSpecifier;exports.isNewExpression=isNewExpression;exports.isNoop=isNoop;exports.isNullLiteral=isNullLiteral;exports.isNullLiteralTypeAnnotation=isNullLiteralTypeAnnotation;exports.isNullableTypeAnnotation=isNullableTypeAnnotation;exports.isNumberLiteral=isNumberLiteral;exports.isNumberLiteralTypeAnnotation=isNumberLiteralTypeAnnotation;exports.isNumberTypeAnnotation=isNumberTypeAnnotation;exports.isNumericLiteral=isNumericLiteral;exports.isObjectExpression=isObjectExpression2;exports.isObjectMember=isObjectMember;exports.isObjectMethod=isObjectMethod;exports.isObjectPattern=isObjectPattern;exports.isObjectProperty=isObjectProperty2;exports.isObjectTypeAnnotation=isObjectTypeAnnotation;exports.isObjectTypeCallProperty=isObjectTypeCallProperty;exports.isObjectTypeIndexer=isObjectTypeIndexer;exports.isObjectTypeInternalSlot=isObjectTypeInternalSlot;exports.isObjectTypeProperty=isObjectTypeProperty;exports.isObjectTypeSpreadProperty=isObjectTypeSpreadProperty;exports.isOpaqueType=isOpaqueType;exports.isOptionalCallExpression=isOptionalCallExpression;exports.isOptionalIndexedAccessType=isOptionalIndexedAccessType;exports.isOptionalMemberExpression=isOptionalMemberExpression;exports.isParenthesizedExpression=isParenthesizedExpression;exports.isPattern=isPattern;exports.isPatternLike=isPatternLike;exports.isPipelineBareFunction=isPipelineBareFunction;exports.isPipelinePrimaryTopicReference=isPipelinePrimaryTopicReference;exports.isPipelineTopicExpression=isPipelineTopicExpression;exports.isPlaceholder=isPlaceholder;exports.isPrivate=isPrivate;exports.isPrivateName=isPrivateName;exports.isProgram=isProgram;exports.isProperty=isProperty;exports.isPureish=isPureish;exports.isQualifiedTypeIdentifier=isQualifiedTypeIdentifier;exports.isRecordExpression=isRecordExpression;exports.isRegExpLiteral=isRegExpLiteral;exports.isRegexLiteral=isRegexLiteral;exports.isRestElement=isRestElement;exports.isRestProperty=isRestProperty;exports.isReturnStatement=isReturnStatement;exports.isScopable=isScopable;exports.isSequenceExpression=isSequenceExpression;exports.isSpreadElement=isSpreadElement;exports.isSpreadProperty=isSpreadProperty;exports.isStandardized=isStandardized;exports.isStatement=isStatement;exports.isStaticBlock=isStaticBlock;exports.isStringLiteral=isStringLiteral2;exports.isStringLiteralTypeAnnotation=isStringLiteralTypeAnnotation;exports.isStringTypeAnnotation=isStringTypeAnnotation;exports.isSuper=isSuper;exports.isSwitchCase=isSwitchCase;exports.isSwitchStatement=isSwitchStatement;exports.isSymbolTypeAnnotation=isSymbolTypeAnnotation;exports.isTSAnyKeyword=isTSAnyKeyword;exports.isTSArrayType=isTSArrayType;exports.isTSAsExpression=isTSAsExpression;exports.isTSBaseType=isTSBaseType;exports.isTSBigIntKeyword=isTSBigIntKeyword;exports.isTSBooleanKeyword=isTSBooleanKeyword;exports.isTSCallSignatureDeclaration=isTSCallSignatureDeclaration;exports.isTSConditionalType=isTSConditionalType;exports.isTSConstructSignatureDeclaration=isTSConstructSignatureDeclaration;exports.isTSConstructorType=isTSConstructorType;exports.isTSDeclareFunction=isTSDeclareFunction;exports.isTSDeclareMethod=isTSDeclareMethod;exports.isTSEntityName=isTSEntityName;exports.isTSEnumDeclaration=isTSEnumDeclaration;exports.isTSEnumMember=isTSEnumMember;exports.isTSExportAssignment=isTSExportAssignment;exports.isTSExpressionWithTypeArguments=isTSExpressionWithTypeArguments;exports.isTSExternalModuleReference=isTSExternalModuleReference;exports.isTSFunctionType=isTSFunctionType;exports.isTSImportEqualsDeclaration=isTSImportEqualsDeclaration;exports.isTSImportType=isTSImportType;exports.isTSIndexSignature=isTSIndexSignature;exports.isTSIndexedAccessType=isTSIndexedAccessType;exports.isTSInferType=isTSInferType;exports.isTSInstantiationExpression=isTSInstantiationExpression;exports.isTSInterfaceBody=isTSInterfaceBody;exports.isTSInterfaceDeclaration=isTSInterfaceDeclaration;exports.isTSIntersectionType=isTSIntersectionType;exports.isTSIntrinsicKeyword=isTSIntrinsicKeyword;exports.isTSLiteralType=isTSLiteralType;exports.isTSMappedType=isTSMappedType;exports.isTSMethodSignature=isTSMethodSignature;exports.isTSModuleBlock=isTSModuleBlock;exports.isTSModuleDeclaration=isTSModuleDeclaration;exports.isTSNamedTupleMember=isTSNamedTupleMember;exports.isTSNamespaceExportDeclaration=isTSNamespaceExportDeclaration;exports.isTSNeverKeyword=isTSNeverKeyword;exports.isTSNonNullExpression=isTSNonNullExpression;exports.isTSNullKeyword=isTSNullKeyword;exports.isTSNumberKeyword=isTSNumberKeyword;exports.isTSObjectKeyword=isTSObjectKeyword;exports.isTSOptionalType=isTSOptionalType;exports.isTSParameterProperty=isTSParameterProperty;exports.isTSParenthesizedType=isTSParenthesizedType;exports.isTSPropertySignature=isTSPropertySignature;exports.isTSQualifiedName=isTSQualifiedName;exports.isTSRestType=isTSRestType;exports.isTSSatisfiesExpression=isTSSatisfiesExpression;exports.isTSStringKeyword=isTSStringKeyword;exports.isTSSymbolKeyword=isTSSymbolKeyword;exports.isTSThisType=isTSThisType;exports.isTSTupleType=isTSTupleType;exports.isTSType=isTSType;exports.isTSTypeAliasDeclaration=isTSTypeAliasDeclaration;exports.isTSTypeAnnotation=isTSTypeAnnotation;exports.isTSTypeAssertion=isTSTypeAssertion;exports.isTSTypeElement=isTSTypeElement;exports.isTSTypeLiteral=isTSTypeLiteral;exports.isTSTypeOperator=isTSTypeOperator;exports.isTSTypeParameter=isTSTypeParameter;exports.isTSTypeParameterDeclaration=isTSTypeParameterDeclaration;exports.isTSTypeParameterInstantiation=isTSTypeParameterInstantiation;exports.isTSTypePredicate=isTSTypePredicate;exports.isTSTypeQuery=isTSTypeQuery;exports.isTSTypeReference=isTSTypeReference;exports.isTSUndefinedKeyword=isTSUndefinedKeyword;exports.isTSUnionType=isTSUnionType;exports.isTSUnknownKeyword=isTSUnknownKeyword;exports.isTSVoidKeyword=isTSVoidKeyword;exports.isTaggedTemplateExpression=isTaggedTemplateExpression;exports.isTemplateElement=isTemplateElement;exports.isTemplateLiteral=isTemplateLiteral;exports.isTerminatorless=isTerminatorless;exports.isThisExpression=isThisExpression;exports.isThisTypeAnnotation=isThisTypeAnnotation;exports.isThrowStatement=isThrowStatement;exports.isTopicReference=isTopicReference;exports.isTryStatement=isTryStatement;exports.isTupleExpression=isTupleExpression;exports.isTupleTypeAnnotation=isTupleTypeAnnotation;exports.isTypeAlias=isTypeAlias;exports.isTypeAnnotation=isTypeAnnotation;exports.isTypeCastExpression=isTypeCastExpression;exports.isTypeParameter=isTypeParameter;exports.isTypeParameterDeclaration=isTypeParameterDeclaration;exports.isTypeParameterInstantiation=isTypeParameterInstantiation;exports.isTypeScript=isTypeScript;exports.isTypeofTypeAnnotation=isTypeofTypeAnnotation;exports.isUnaryExpression=isUnaryExpression;exports.isUnaryLike=isUnaryLike;exports.isUnionTypeAnnotation=isUnionTypeAnnotation;exports.isUpdateExpression=isUpdateExpression;exports.isUserWhitespacable=isUserWhitespacable;exports.isV8IntrinsicIdentifier=isV8IntrinsicIdentifier;exports.isVariableDeclaration=isVariableDeclaration2;exports.isVariableDeclarator=isVariableDeclarator2;exports.isVariance=isVariance;exports.isVoidTypeAnnotation=isVoidTypeAnnotation;exports.isWhile=isWhile;exports.isWhileStatement=isWhileStatement;exports.isWithStatement=isWithStatement;exports.isYieldExpression=isYieldExpression;var _shallowEqual=require_shallowEqual(),_deprecationWarning=require_deprecationWarning();function isArrayExpression2(node,opts){return !node||node.type!=="ArrayExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isAssignmentExpression(node,opts){return !node||node.type!=="AssignmentExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isBinaryExpression(node,opts){return !node||node.type!=="BinaryExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isInterpreterDirective(node,opts){return !node||node.type!=="InterpreterDirective"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isDirective(node,opts){return !node||node.type!=="Directive"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isDirectiveLiteral(node,opts){return !node||node.type!=="DirectiveLiteral"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isBlockStatement(node,opts){return !node||node.type!=="BlockStatement"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isBreakStatement(node,opts){return !node||node.type!=="BreakStatement"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isCallExpression(node,opts){return !node||node.type!=="CallExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isCatchClause(node,opts){return !node||node.type!=="CatchClause"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isConditionalExpression(node,opts){return !node||node.type!=="ConditionalExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isContinueStatement(node,opts){return !node||node.type!=="ContinueStatement"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isDebuggerStatement(node,opts){return !node||node.type!=="DebuggerStatement"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isDoWhileStatement(node,opts){return !node||node.type!=="DoWhileStatement"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isEmptyStatement(node,opts){return !node||node.type!=="EmptyStatement"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isExpressionStatement(node,opts){return !node||node.type!=="ExpressionStatement"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isFile(node,opts){return !node||node.type!=="File"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isForInStatement(node,opts){return !node||node.type!=="ForInStatement"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isForStatement(node,opts){return !node||node.type!=="ForStatement"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isFunctionDeclaration2(node,opts){return !node||node.type!=="FunctionDeclaration"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isFunctionExpression(node,opts){return !node||node.type!=="FunctionExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isIdentifier2(node,opts){return !node||node.type!=="Identifier"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isIfStatement(node,opts){return !node||node.type!=="IfStatement"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isLabeledStatement(node,opts){return !node||node.type!=="LabeledStatement"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isStringLiteral2(node,opts){return !node||node.type!=="StringLiteral"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isNumericLiteral(node,opts){return !node||node.type!=="NumericLiteral"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isNullLiteral(node,opts){return !node||node.type!=="NullLiteral"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isBooleanLiteral(node,opts){return !node||node.type!=="BooleanLiteral"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isRegExpLiteral(node,opts){return !node||node.type!=="RegExpLiteral"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isLogicalExpression(node,opts){return !node||node.type!=="LogicalExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isMemberExpression(node,opts){return !node||node.type!=="MemberExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isNewExpression(node,opts){return !node||node.type!=="NewExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isProgram(node,opts){return !node||node.type!=="Program"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isObjectExpression2(node,opts){return !node||node.type!=="ObjectExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isObjectMethod(node,opts){return !node||node.type!=="ObjectMethod"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isObjectProperty2(node,opts){return !node||node.type!=="ObjectProperty"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isRestElement(node,opts){return !node||node.type!=="RestElement"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isReturnStatement(node,opts){return !node||node.type!=="ReturnStatement"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isSequenceExpression(node,opts){return !node||node.type!=="SequenceExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isParenthesizedExpression(node,opts){return !node||node.type!=="ParenthesizedExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isSwitchCase(node,opts){return !node||node.type!=="SwitchCase"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isSwitchStatement(node,opts){return !node||node.type!=="SwitchStatement"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isThisExpression(node,opts){return !node||node.type!=="ThisExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isThrowStatement(node,opts){return !node||node.type!=="ThrowStatement"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTryStatement(node,opts){return !node||node.type!=="TryStatement"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isUnaryExpression(node,opts){return !node||node.type!=="UnaryExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isUpdateExpression(node,opts){return !node||node.type!=="UpdateExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isVariableDeclaration2(node,opts){return !node||node.type!=="VariableDeclaration"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isVariableDeclarator2(node,opts){return !node||node.type!=="VariableDeclarator"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isWhileStatement(node,opts){return !node||node.type!=="WhileStatement"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isWithStatement(node,opts){return !node||node.type!=="WithStatement"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isAssignmentPattern(node,opts){return !node||node.type!=="AssignmentPattern"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isArrayPattern(node,opts){return !node||node.type!=="ArrayPattern"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isArrowFunctionExpression(node,opts){return !node||node.type!=="ArrowFunctionExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isClassBody(node,opts){return !node||node.type!=="ClassBody"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isClassExpression(node,opts){return !node||node.type!=="ClassExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isClassDeclaration(node,opts){return !node||node.type!=="ClassDeclaration"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isExportAllDeclaration(node,opts){return !node||node.type!=="ExportAllDeclaration"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isExportDefaultDeclaration(node,opts){return !node||node.type!=="ExportDefaultDeclaration"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isExportNamedDeclaration(node,opts){return !node||node.type!=="ExportNamedDeclaration"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isExportSpecifier(node,opts){return !node||node.type!=="ExportSpecifier"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isForOfStatement(node,opts){return !node||node.type!=="ForOfStatement"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isImportDeclaration(node,opts){return !node||node.type!=="ImportDeclaration"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isImportDefaultSpecifier(node,opts){return !node||node.type!=="ImportDefaultSpecifier"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isImportNamespaceSpecifier(node,opts){return !node||node.type!=="ImportNamespaceSpecifier"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isImportSpecifier(node,opts){return !node||node.type!=="ImportSpecifier"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isImportExpression(node,opts){return !node||node.type!=="ImportExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isMetaProperty(node,opts){return !node||node.type!=="MetaProperty"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isClassMethod(node,opts){return !node||node.type!=="ClassMethod"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isObjectPattern(node,opts){return !node||node.type!=="ObjectPattern"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isSpreadElement(node,opts){return !node||node.type!=="SpreadElement"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isSuper(node,opts){return !node||node.type!=="Super"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTaggedTemplateExpression(node,opts){return !node||node.type!=="TaggedTemplateExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTemplateElement(node,opts){return !node||node.type!=="TemplateElement"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTemplateLiteral(node,opts){return !node||node.type!=="TemplateLiteral"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isYieldExpression(node,opts){return !node||node.type!=="YieldExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isAwaitExpression(node,opts){return !node||node.type!=="AwaitExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isImport(node,opts){return !node||node.type!=="Import"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isBigIntLiteral(node,opts){return !node||node.type!=="BigIntLiteral"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isExportNamespaceSpecifier(node,opts){return !node||node.type!=="ExportNamespaceSpecifier"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isOptionalMemberExpression(node,opts){return !node||node.type!=="OptionalMemberExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isOptionalCallExpression(node,opts){return !node||node.type!=="OptionalCallExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isClassProperty(node,opts){return !node||node.type!=="ClassProperty"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isClassAccessorProperty(node,opts){return !node||node.type!=="ClassAccessorProperty"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isClassPrivateProperty(node,opts){return !node||node.type!=="ClassPrivateProperty"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isClassPrivateMethod(node,opts){return !node||node.type!=="ClassPrivateMethod"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isPrivateName(node,opts){return !node||node.type!=="PrivateName"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isStaticBlock(node,opts){return !node||node.type!=="StaticBlock"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isAnyTypeAnnotation(node,opts){return !node||node.type!=="AnyTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isArrayTypeAnnotation(node,opts){return !node||node.type!=="ArrayTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isBooleanTypeAnnotation(node,opts){return !node||node.type!=="BooleanTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isBooleanLiteralTypeAnnotation(node,opts){return !node||node.type!=="BooleanLiteralTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isNullLiteralTypeAnnotation(node,opts){return !node||node.type!=="NullLiteralTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isClassImplements(node,opts){return !node||node.type!=="ClassImplements"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isDeclareClass(node,opts){return !node||node.type!=="DeclareClass"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isDeclareFunction(node,opts){return !node||node.type!=="DeclareFunction"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isDeclareInterface(node,opts){return !node||node.type!=="DeclareInterface"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isDeclareModule(node,opts){return !node||node.type!=="DeclareModule"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isDeclareModuleExports(node,opts){return !node||node.type!=="DeclareModuleExports"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isDeclareTypeAlias(node,opts){return !node||node.type!=="DeclareTypeAlias"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isDeclareOpaqueType(node,opts){return !node||node.type!=="DeclareOpaqueType"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isDeclareVariable(node,opts){return !node||node.type!=="DeclareVariable"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isDeclareExportDeclaration(node,opts){return !node||node.type!=="DeclareExportDeclaration"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isDeclareExportAllDeclaration(node,opts){return !node||node.type!=="DeclareExportAllDeclaration"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isDeclaredPredicate(node,opts){return !node||node.type!=="DeclaredPredicate"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isExistsTypeAnnotation(node,opts){return !node||node.type!=="ExistsTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isFunctionTypeAnnotation(node,opts){return !node||node.type!=="FunctionTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isFunctionTypeParam(node,opts){return !node||node.type!=="FunctionTypeParam"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isGenericTypeAnnotation(node,opts){return !node||node.type!=="GenericTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isInferredPredicate(node,opts){return !node||node.type!=="InferredPredicate"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isInterfaceExtends(node,opts){return !node||node.type!=="InterfaceExtends"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isInterfaceDeclaration(node,opts){return !node||node.type!=="InterfaceDeclaration"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isInterfaceTypeAnnotation(node,opts){return !node||node.type!=="InterfaceTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isIntersectionTypeAnnotation(node,opts){return !node||node.type!=="IntersectionTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isMixedTypeAnnotation(node,opts){return !node||node.type!=="MixedTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isEmptyTypeAnnotation(node,opts){return !node||node.type!=="EmptyTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isNullableTypeAnnotation(node,opts){return !node||node.type!=="NullableTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isNumberLiteralTypeAnnotation(node,opts){return !node||node.type!=="NumberLiteralTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isNumberTypeAnnotation(node,opts){return !node||node.type!=="NumberTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isObjectTypeAnnotation(node,opts){return !node||node.type!=="ObjectTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isObjectTypeInternalSlot(node,opts){return !node||node.type!=="ObjectTypeInternalSlot"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isObjectTypeCallProperty(node,opts){return !node||node.type!=="ObjectTypeCallProperty"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isObjectTypeIndexer(node,opts){return !node||node.type!=="ObjectTypeIndexer"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isObjectTypeProperty(node,opts){return !node||node.type!=="ObjectTypeProperty"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isObjectTypeSpreadProperty(node,opts){return !node||node.type!=="ObjectTypeSpreadProperty"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isOpaqueType(node,opts){return !node||node.type!=="OpaqueType"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isQualifiedTypeIdentifier(node,opts){return !node||node.type!=="QualifiedTypeIdentifier"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isStringLiteralTypeAnnotation(node,opts){return !node||node.type!=="StringLiteralTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isStringTypeAnnotation(node,opts){return !node||node.type!=="StringTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isSymbolTypeAnnotation(node,opts){return !node||node.type!=="SymbolTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isThisTypeAnnotation(node,opts){return !node||node.type!=="ThisTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTupleTypeAnnotation(node,opts){return !node||node.type!=="TupleTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTypeofTypeAnnotation(node,opts){return !node||node.type!=="TypeofTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTypeAlias(node,opts){return !node||node.type!=="TypeAlias"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTypeAnnotation(node,opts){return !node||node.type!=="TypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTypeCastExpression(node,opts){return !node||node.type!=="TypeCastExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTypeParameter(node,opts){return !node||node.type!=="TypeParameter"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTypeParameterDeclaration(node,opts){return !node||node.type!=="TypeParameterDeclaration"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTypeParameterInstantiation(node,opts){return !node||node.type!=="TypeParameterInstantiation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isUnionTypeAnnotation(node,opts){return !node||node.type!=="UnionTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isVariance(node,opts){return !node||node.type!=="Variance"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isVoidTypeAnnotation(node,opts){return !node||node.type!=="VoidTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isEnumDeclaration(node,opts){return !node||node.type!=="EnumDeclaration"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isEnumBooleanBody(node,opts){return !node||node.type!=="EnumBooleanBody"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isEnumNumberBody(node,opts){return !node||node.type!=="EnumNumberBody"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isEnumStringBody(node,opts){return !node||node.type!=="EnumStringBody"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isEnumSymbolBody(node,opts){return !node||node.type!=="EnumSymbolBody"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isEnumBooleanMember(node,opts){return !node||node.type!=="EnumBooleanMember"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isEnumNumberMember(node,opts){return !node||node.type!=="EnumNumberMember"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isEnumStringMember(node,opts){return !node||node.type!=="EnumStringMember"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isEnumDefaultedMember(node,opts){return !node||node.type!=="EnumDefaultedMember"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isIndexedAccessType(node,opts){return !node||node.type!=="IndexedAccessType"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isOptionalIndexedAccessType(node,opts){return !node||node.type!=="OptionalIndexedAccessType"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isJSXAttribute(node,opts){return !node||node.type!=="JSXAttribute"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isJSXClosingElement(node,opts){return !node||node.type!=="JSXClosingElement"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isJSXElement(node,opts){return !node||node.type!=="JSXElement"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isJSXEmptyExpression(node,opts){return !node||node.type!=="JSXEmptyExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isJSXExpressionContainer(node,opts){return !node||node.type!=="JSXExpressionContainer"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isJSXSpreadChild(node,opts){return !node||node.type!=="JSXSpreadChild"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isJSXIdentifier(node,opts){return !node||node.type!=="JSXIdentifier"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isJSXMemberExpression(node,opts){return !node||node.type!=="JSXMemberExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isJSXNamespacedName(node,opts){return !node||node.type!=="JSXNamespacedName"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isJSXOpeningElement(node,opts){return !node||node.type!=="JSXOpeningElement"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isJSXSpreadAttribute(node,opts){return !node||node.type!=="JSXSpreadAttribute"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isJSXText(node,opts){return !node||node.type!=="JSXText"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isJSXFragment(node,opts){return !node||node.type!=="JSXFragment"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isJSXOpeningFragment(node,opts){return !node||node.type!=="JSXOpeningFragment"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isJSXClosingFragment(node,opts){return !node||node.type!=="JSXClosingFragment"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isNoop(node,opts){return !node||node.type!=="Noop"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isPlaceholder(node,opts){return !node||node.type!=="Placeholder"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isV8IntrinsicIdentifier(node,opts){return !node||node.type!=="V8IntrinsicIdentifier"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isArgumentPlaceholder(node,opts){return !node||node.type!=="ArgumentPlaceholder"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isBindExpression(node,opts){return !node||node.type!=="BindExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isImportAttribute(node,opts){return !node||node.type!=="ImportAttribute"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isDecorator(node,opts){return !node||node.type!=="Decorator"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isDoExpression(node,opts){return !node||node.type!=="DoExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isExportDefaultSpecifier(node,opts){return !node||node.type!=="ExportDefaultSpecifier"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isRecordExpression(node,opts){return !node||node.type!=="RecordExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTupleExpression(node,opts){return !node||node.type!=="TupleExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isDecimalLiteral(node,opts){return !node||node.type!=="DecimalLiteral"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isModuleExpression(node,opts){return !node||node.type!=="ModuleExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTopicReference(node,opts){return !node||node.type!=="TopicReference"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isPipelineTopicExpression(node,opts){return !node||node.type!=="PipelineTopicExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isPipelineBareFunction(node,opts){return !node||node.type!=="PipelineBareFunction"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isPipelinePrimaryTopicReference(node,opts){return !node||node.type!=="PipelinePrimaryTopicReference"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSParameterProperty(node,opts){return !node||node.type!=="TSParameterProperty"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSDeclareFunction(node,opts){return !node||node.type!=="TSDeclareFunction"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSDeclareMethod(node,opts){return !node||node.type!=="TSDeclareMethod"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSQualifiedName(node,opts){return !node||node.type!=="TSQualifiedName"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSCallSignatureDeclaration(node,opts){return !node||node.type!=="TSCallSignatureDeclaration"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSConstructSignatureDeclaration(node,opts){return !node||node.type!=="TSConstructSignatureDeclaration"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSPropertySignature(node,opts){return !node||node.type!=="TSPropertySignature"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSMethodSignature(node,opts){return !node||node.type!=="TSMethodSignature"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSIndexSignature(node,opts){return !node||node.type!=="TSIndexSignature"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSAnyKeyword(node,opts){return !node||node.type!=="TSAnyKeyword"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSBooleanKeyword(node,opts){return !node||node.type!=="TSBooleanKeyword"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSBigIntKeyword(node,opts){return !node||node.type!=="TSBigIntKeyword"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSIntrinsicKeyword(node,opts){return !node||node.type!=="TSIntrinsicKeyword"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSNeverKeyword(node,opts){return !node||node.type!=="TSNeverKeyword"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSNullKeyword(node,opts){return !node||node.type!=="TSNullKeyword"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSNumberKeyword(node,opts){return !node||node.type!=="TSNumberKeyword"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSObjectKeyword(node,opts){return !node||node.type!=="TSObjectKeyword"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSStringKeyword(node,opts){return !node||node.type!=="TSStringKeyword"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSSymbolKeyword(node,opts){return !node||node.type!=="TSSymbolKeyword"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSUndefinedKeyword(node,opts){return !node||node.type!=="TSUndefinedKeyword"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSUnknownKeyword(node,opts){return !node||node.type!=="TSUnknownKeyword"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSVoidKeyword(node,opts){return !node||node.type!=="TSVoidKeyword"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSThisType(node,opts){return !node||node.type!=="TSThisType"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSFunctionType(node,opts){return !node||node.type!=="TSFunctionType"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSConstructorType(node,opts){return !node||node.type!=="TSConstructorType"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSTypeReference(node,opts){return !node||node.type!=="TSTypeReference"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSTypePredicate(node,opts){return !node||node.type!=="TSTypePredicate"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSTypeQuery(node,opts){return !node||node.type!=="TSTypeQuery"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSTypeLiteral(node,opts){return !node||node.type!=="TSTypeLiteral"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSArrayType(node,opts){return !node||node.type!=="TSArrayType"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSTupleType(node,opts){return !node||node.type!=="TSTupleType"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSOptionalType(node,opts){return !node||node.type!=="TSOptionalType"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSRestType(node,opts){return !node||node.type!=="TSRestType"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSNamedTupleMember(node,opts){return !node||node.type!=="TSNamedTupleMember"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSUnionType(node,opts){return !node||node.type!=="TSUnionType"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSIntersectionType(node,opts){return !node||node.type!=="TSIntersectionType"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSConditionalType(node,opts){return !node||node.type!=="TSConditionalType"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSInferType(node,opts){return !node||node.type!=="TSInferType"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSParenthesizedType(node,opts){return !node||node.type!=="TSParenthesizedType"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSTypeOperator(node,opts){return !node||node.type!=="TSTypeOperator"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSIndexedAccessType(node,opts){return !node||node.type!=="TSIndexedAccessType"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSMappedType(node,opts){return !node||node.type!=="TSMappedType"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSLiteralType(node,opts){return !node||node.type!=="TSLiteralType"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSExpressionWithTypeArguments(node,opts){return !node||node.type!=="TSExpressionWithTypeArguments"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSInterfaceDeclaration(node,opts){return !node||node.type!=="TSInterfaceDeclaration"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSInterfaceBody(node,opts){return !node||node.type!=="TSInterfaceBody"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSTypeAliasDeclaration(node,opts){return !node||node.type!=="TSTypeAliasDeclaration"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSInstantiationExpression(node,opts){return !node||node.type!=="TSInstantiationExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSAsExpression(node,opts){return !node||node.type!=="TSAsExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSSatisfiesExpression(node,opts){return !node||node.type!=="TSSatisfiesExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSTypeAssertion(node,opts){return !node||node.type!=="TSTypeAssertion"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSEnumDeclaration(node,opts){return !node||node.type!=="TSEnumDeclaration"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSEnumMember(node,opts){return !node||node.type!=="TSEnumMember"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSModuleDeclaration(node,opts){return !node||node.type!=="TSModuleDeclaration"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSModuleBlock(node,opts){return !node||node.type!=="TSModuleBlock"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSImportType(node,opts){return !node||node.type!=="TSImportType"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSImportEqualsDeclaration(node,opts){return !node||node.type!=="TSImportEqualsDeclaration"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSExternalModuleReference(node,opts){return !node||node.type!=="TSExternalModuleReference"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSNonNullExpression(node,opts){return !node||node.type!=="TSNonNullExpression"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSExportAssignment(node,opts){return !node||node.type!=="TSExportAssignment"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSNamespaceExportDeclaration(node,opts){return !node||node.type!=="TSNamespaceExportDeclaration"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSTypeAnnotation(node,opts){return !node||node.type!=="TSTypeAnnotation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSTypeParameterInstantiation(node,opts){return !node||node.type!=="TSTypeParameterInstantiation"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSTypeParameterDeclaration(node,opts){return !node||node.type!=="TSTypeParameterDeclaration"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isTSTypeParameter(node,opts){return !node||node.type!=="TSTypeParameter"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isStandardized(node,opts){if(!node)return !1;switch(node.type){case"ArrayExpression":case"AssignmentExpression":case"BinaryExpression":case"InterpreterDirective":case"Directive":case"DirectiveLiteral":case"BlockStatement":case"BreakStatement":case"CallExpression":case"CatchClause":case"ConditionalExpression":case"ContinueStatement":case"DebuggerStatement":case"DoWhileStatement":case"EmptyStatement":case"ExpressionStatement":case"File":case"ForInStatement":case"ForStatement":case"FunctionDeclaration":case"FunctionExpression":case"Identifier":case"IfStatement":case"LabeledStatement":case"StringLiteral":case"NumericLiteral":case"NullLiteral":case"BooleanLiteral":case"RegExpLiteral":case"LogicalExpression":case"MemberExpression":case"NewExpression":case"Program":case"ObjectExpression":case"ObjectMethod":case"ObjectProperty":case"RestElement":case"ReturnStatement":case"SequenceExpression":case"ParenthesizedExpression":case"SwitchCase":case"SwitchStatement":case"ThisExpression":case"ThrowStatement":case"TryStatement":case"UnaryExpression":case"UpdateExpression":case"VariableDeclaration":case"VariableDeclarator":case"WhileStatement":case"WithStatement":case"AssignmentPattern":case"ArrayPattern":case"ArrowFunctionExpression":case"ClassBody":case"ClassExpression":case"ClassDeclaration":case"ExportAllDeclaration":case"ExportDefaultDeclaration":case"ExportNamedDeclaration":case"ExportSpecifier":case"ForOfStatement":case"ImportDeclaration":case"ImportDefaultSpecifier":case"ImportNamespaceSpecifier":case"ImportSpecifier":case"ImportExpression":case"MetaProperty":case"ClassMethod":case"ObjectPattern":case"SpreadElement":case"Super":case"TaggedTemplateExpression":case"TemplateElement":case"TemplateLiteral":case"YieldExpression":case"AwaitExpression":case"Import":case"BigIntLiteral":case"ExportNamespaceSpecifier":case"OptionalMemberExpression":case"OptionalCallExpression":case"ClassProperty":case"ClassAccessorProperty":case"ClassPrivateProperty":case"ClassPrivateMethod":case"PrivateName":case"StaticBlock":break;case"Placeholder":switch(node.expectedNode){case"Identifier":case"StringLiteral":case"BlockStatement":case"ClassBody":break;default:return !1}break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isExpression(node,opts){if(!node)return !1;switch(node.type){case"ArrayExpression":case"AssignmentExpression":case"BinaryExpression":case"CallExpression":case"ConditionalExpression":case"FunctionExpression":case"Identifier":case"StringLiteral":case"NumericLiteral":case"NullLiteral":case"BooleanLiteral":case"RegExpLiteral":case"LogicalExpression":case"MemberExpression":case"NewExpression":case"ObjectExpression":case"SequenceExpression":case"ParenthesizedExpression":case"ThisExpression":case"UnaryExpression":case"UpdateExpression":case"ArrowFunctionExpression":case"ClassExpression":case"ImportExpression":case"MetaProperty":case"Super":case"TaggedTemplateExpression":case"TemplateLiteral":case"YieldExpression":case"AwaitExpression":case"Import":case"BigIntLiteral":case"OptionalMemberExpression":case"OptionalCallExpression":case"TypeCastExpression":case"JSXElement":case"JSXFragment":case"BindExpression":case"DoExpression":case"RecordExpression":case"TupleExpression":case"DecimalLiteral":case"ModuleExpression":case"TopicReference":case"PipelineTopicExpression":case"PipelineBareFunction":case"PipelinePrimaryTopicReference":case"TSInstantiationExpression":case"TSAsExpression":case"TSSatisfiesExpression":case"TSTypeAssertion":case"TSNonNullExpression":break;case"Placeholder":switch(node.expectedNode){case"Expression":case"Identifier":case"StringLiteral":break;default:return !1}break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isBinary(node,opts){if(!node)return !1;switch(node.type){case"BinaryExpression":case"LogicalExpression":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isScopable(node,opts){if(!node)return !1;switch(node.type){case"BlockStatement":case"CatchClause":case"DoWhileStatement":case"ForInStatement":case"ForStatement":case"FunctionDeclaration":case"FunctionExpression":case"Program":case"ObjectMethod":case"SwitchStatement":case"WhileStatement":case"ArrowFunctionExpression":case"ClassExpression":case"ClassDeclaration":case"ForOfStatement":case"ClassMethod":case"ClassPrivateMethod":case"StaticBlock":case"TSModuleBlock":break;case"Placeholder":if(node.expectedNode==="BlockStatement")break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isBlockParent(node,opts){if(!node)return !1;switch(node.type){case"BlockStatement":case"CatchClause":case"DoWhileStatement":case"ForInStatement":case"ForStatement":case"FunctionDeclaration":case"FunctionExpression":case"Program":case"ObjectMethod":case"SwitchStatement":case"WhileStatement":case"ArrowFunctionExpression":case"ForOfStatement":case"ClassMethod":case"ClassPrivateMethod":case"StaticBlock":case"TSModuleBlock":break;case"Placeholder":if(node.expectedNode==="BlockStatement")break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isBlock(node,opts){if(!node)return !1;switch(node.type){case"BlockStatement":case"Program":case"TSModuleBlock":break;case"Placeholder":if(node.expectedNode==="BlockStatement")break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isStatement(node,opts){if(!node)return !1;switch(node.type){case"BlockStatement":case"BreakStatement":case"ContinueStatement":case"DebuggerStatement":case"DoWhileStatement":case"EmptyStatement":case"ExpressionStatement":case"ForInStatement":case"ForStatement":case"FunctionDeclaration":case"IfStatement":case"LabeledStatement":case"ReturnStatement":case"SwitchStatement":case"ThrowStatement":case"TryStatement":case"VariableDeclaration":case"WhileStatement":case"WithStatement":case"ClassDeclaration":case"ExportAllDeclaration":case"ExportDefaultDeclaration":case"ExportNamedDeclaration":case"ForOfStatement":case"ImportDeclaration":case"DeclareClass":case"DeclareFunction":case"DeclareInterface":case"DeclareModule":case"DeclareModuleExports":case"DeclareTypeAlias":case"DeclareOpaqueType":case"DeclareVariable":case"DeclareExportDeclaration":case"DeclareExportAllDeclaration":case"InterfaceDeclaration":case"OpaqueType":case"TypeAlias":case"EnumDeclaration":case"TSDeclareFunction":case"TSInterfaceDeclaration":case"TSTypeAliasDeclaration":case"TSEnumDeclaration":case"TSModuleDeclaration":case"TSImportEqualsDeclaration":case"TSExportAssignment":case"TSNamespaceExportDeclaration":break;case"Placeholder":switch(node.expectedNode){case"Statement":case"Declaration":case"BlockStatement":break;default:return !1}break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isTerminatorless(node,opts){if(!node)return !1;switch(node.type){case"BreakStatement":case"ContinueStatement":case"ReturnStatement":case"ThrowStatement":case"YieldExpression":case"AwaitExpression":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isCompletionStatement(node,opts){if(!node)return !1;switch(node.type){case"BreakStatement":case"ContinueStatement":case"ReturnStatement":case"ThrowStatement":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isConditional(node,opts){if(!node)return !1;switch(node.type){case"ConditionalExpression":case"IfStatement":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isLoop(node,opts){if(!node)return !1;switch(node.type){case"DoWhileStatement":case"ForInStatement":case"ForStatement":case"WhileStatement":case"ForOfStatement":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isWhile(node,opts){if(!node)return !1;switch(node.type){case"DoWhileStatement":case"WhileStatement":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isExpressionWrapper(node,opts){if(!node)return !1;switch(node.type){case"ExpressionStatement":case"ParenthesizedExpression":case"TypeCastExpression":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isFor(node,opts){if(!node)return !1;switch(node.type){case"ForInStatement":case"ForStatement":case"ForOfStatement":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isForXStatement(node,opts){if(!node)return !1;switch(node.type){case"ForInStatement":case"ForOfStatement":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isFunction(node,opts){if(!node)return !1;switch(node.type){case"FunctionDeclaration":case"FunctionExpression":case"ObjectMethod":case"ArrowFunctionExpression":case"ClassMethod":case"ClassPrivateMethod":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isFunctionParent(node,opts){if(!node)return !1;switch(node.type){case"FunctionDeclaration":case"FunctionExpression":case"ObjectMethod":case"ArrowFunctionExpression":case"ClassMethod":case"ClassPrivateMethod":case"StaticBlock":case"TSModuleBlock":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isPureish(node,opts){if(!node)return !1;switch(node.type){case"FunctionDeclaration":case"FunctionExpression":case"StringLiteral":case"NumericLiteral":case"NullLiteral":case"BooleanLiteral":case"RegExpLiteral":case"ArrowFunctionExpression":case"BigIntLiteral":case"DecimalLiteral":break;case"Placeholder":if(node.expectedNode==="StringLiteral")break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isDeclaration(node,opts){if(!node)return !1;switch(node.type){case"FunctionDeclaration":case"VariableDeclaration":case"ClassDeclaration":case"ExportAllDeclaration":case"ExportDefaultDeclaration":case"ExportNamedDeclaration":case"ImportDeclaration":case"DeclareClass":case"DeclareFunction":case"DeclareInterface":case"DeclareModule":case"DeclareModuleExports":case"DeclareTypeAlias":case"DeclareOpaqueType":case"DeclareVariable":case"DeclareExportDeclaration":case"DeclareExportAllDeclaration":case"InterfaceDeclaration":case"OpaqueType":case"TypeAlias":case"EnumDeclaration":case"TSDeclareFunction":case"TSInterfaceDeclaration":case"TSTypeAliasDeclaration":case"TSEnumDeclaration":case"TSModuleDeclaration":break;case"Placeholder":if(node.expectedNode==="Declaration")break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isPatternLike(node,opts){if(!node)return !1;switch(node.type){case"Identifier":case"RestElement":case"AssignmentPattern":case"ArrayPattern":case"ObjectPattern":case"TSAsExpression":case"TSSatisfiesExpression":case"TSTypeAssertion":case"TSNonNullExpression":break;case"Placeholder":switch(node.expectedNode){case"Pattern":case"Identifier":break;default:return !1}break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isLVal(node,opts){if(!node)return !1;switch(node.type){case"Identifier":case"MemberExpression":case"RestElement":case"AssignmentPattern":case"ArrayPattern":case"ObjectPattern":case"TSParameterProperty":case"TSAsExpression":case"TSSatisfiesExpression":case"TSTypeAssertion":case"TSNonNullExpression":break;case"Placeholder":switch(node.expectedNode){case"Pattern":case"Identifier":break;default:return !1}break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isTSEntityName(node,opts){if(!node)return !1;switch(node.type){case"Identifier":case"TSQualifiedName":break;case"Placeholder":if(node.expectedNode==="Identifier")break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isLiteral(node,opts){if(!node)return !1;switch(node.type){case"StringLiteral":case"NumericLiteral":case"NullLiteral":case"BooleanLiteral":case"RegExpLiteral":case"TemplateLiteral":case"BigIntLiteral":case"DecimalLiteral":break;case"Placeholder":if(node.expectedNode==="StringLiteral")break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isImmutable(node,opts){if(!node)return !1;switch(node.type){case"StringLiteral":case"NumericLiteral":case"NullLiteral":case"BooleanLiteral":case"BigIntLiteral":case"JSXAttribute":case"JSXClosingElement":case"JSXElement":case"JSXExpressionContainer":case"JSXSpreadChild":case"JSXOpeningElement":case"JSXText":case"JSXFragment":case"JSXOpeningFragment":case"JSXClosingFragment":case"DecimalLiteral":break;case"Placeholder":if(node.expectedNode==="StringLiteral")break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isUserWhitespacable(node,opts){if(!node)return !1;switch(node.type){case"ObjectMethod":case"ObjectProperty":case"ObjectTypeInternalSlot":case"ObjectTypeCallProperty":case"ObjectTypeIndexer":case"ObjectTypeProperty":case"ObjectTypeSpreadProperty":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isMethod(node,opts){if(!node)return !1;switch(node.type){case"ObjectMethod":case"ClassMethod":case"ClassPrivateMethod":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isObjectMember(node,opts){if(!node)return !1;switch(node.type){case"ObjectMethod":case"ObjectProperty":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isProperty(node,opts){if(!node)return !1;switch(node.type){case"ObjectProperty":case"ClassProperty":case"ClassAccessorProperty":case"ClassPrivateProperty":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isUnaryLike(node,opts){if(!node)return !1;switch(node.type){case"UnaryExpression":case"SpreadElement":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isPattern(node,opts){if(!node)return !1;switch(node.type){case"AssignmentPattern":case"ArrayPattern":case"ObjectPattern":break;case"Placeholder":if(node.expectedNode==="Pattern")break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isClass(node,opts){if(!node)return !1;switch(node.type){case"ClassExpression":case"ClassDeclaration":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isImportOrExportDeclaration(node,opts){if(!node)return !1;switch(node.type){case"ExportAllDeclaration":case"ExportDefaultDeclaration":case"ExportNamedDeclaration":case"ImportDeclaration":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isExportDeclaration(node,opts){if(!node)return !1;switch(node.type){case"ExportAllDeclaration":case"ExportDefaultDeclaration":case"ExportNamedDeclaration":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isModuleSpecifier(node,opts){if(!node)return !1;switch(node.type){case"ExportSpecifier":case"ImportDefaultSpecifier":case"ImportNamespaceSpecifier":case"ImportSpecifier":case"ExportNamespaceSpecifier":case"ExportDefaultSpecifier":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isAccessor(node,opts){if(!node)return !1;switch(node.type){case"ClassAccessorProperty":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isPrivate(node,opts){if(!node)return !1;switch(node.type){case"ClassPrivateProperty":case"ClassPrivateMethod":case"PrivateName":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isFlow(node,opts){if(!node)return !1;switch(node.type){case"AnyTypeAnnotation":case"ArrayTypeAnnotation":case"BooleanTypeAnnotation":case"BooleanLiteralTypeAnnotation":case"NullLiteralTypeAnnotation":case"ClassImplements":case"DeclareClass":case"DeclareFunction":case"DeclareInterface":case"DeclareModule":case"DeclareModuleExports":case"DeclareTypeAlias":case"DeclareOpaqueType":case"DeclareVariable":case"DeclareExportDeclaration":case"DeclareExportAllDeclaration":case"DeclaredPredicate":case"ExistsTypeAnnotation":case"FunctionTypeAnnotation":case"FunctionTypeParam":case"GenericTypeAnnotation":case"InferredPredicate":case"InterfaceExtends":case"InterfaceDeclaration":case"InterfaceTypeAnnotation":case"IntersectionTypeAnnotation":case"MixedTypeAnnotation":case"EmptyTypeAnnotation":case"NullableTypeAnnotation":case"NumberLiteralTypeAnnotation":case"NumberTypeAnnotation":case"ObjectTypeAnnotation":case"ObjectTypeInternalSlot":case"ObjectTypeCallProperty":case"ObjectTypeIndexer":case"ObjectTypeProperty":case"ObjectTypeSpreadProperty":case"OpaqueType":case"QualifiedTypeIdentifier":case"StringLiteralTypeAnnotation":case"StringTypeAnnotation":case"SymbolTypeAnnotation":case"ThisTypeAnnotation":case"TupleTypeAnnotation":case"TypeofTypeAnnotation":case"TypeAlias":case"TypeAnnotation":case"TypeCastExpression":case"TypeParameter":case"TypeParameterDeclaration":case"TypeParameterInstantiation":case"UnionTypeAnnotation":case"Variance":case"VoidTypeAnnotation":case"EnumDeclaration":case"EnumBooleanBody":case"EnumNumberBody":case"EnumStringBody":case"EnumSymbolBody":case"EnumBooleanMember":case"EnumNumberMember":case"EnumStringMember":case"EnumDefaultedMember":case"IndexedAccessType":case"OptionalIndexedAccessType":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isFlowType(node,opts){if(!node)return !1;switch(node.type){case"AnyTypeAnnotation":case"ArrayTypeAnnotation":case"BooleanTypeAnnotation":case"BooleanLiteralTypeAnnotation":case"NullLiteralTypeAnnotation":case"ExistsTypeAnnotation":case"FunctionTypeAnnotation":case"GenericTypeAnnotation":case"InterfaceTypeAnnotation":case"IntersectionTypeAnnotation":case"MixedTypeAnnotation":case"EmptyTypeAnnotation":case"NullableTypeAnnotation":case"NumberLiteralTypeAnnotation":case"NumberTypeAnnotation":case"ObjectTypeAnnotation":case"StringLiteralTypeAnnotation":case"StringTypeAnnotation":case"SymbolTypeAnnotation":case"ThisTypeAnnotation":case"TupleTypeAnnotation":case"TypeofTypeAnnotation":case"UnionTypeAnnotation":case"VoidTypeAnnotation":case"IndexedAccessType":case"OptionalIndexedAccessType":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isFlowBaseAnnotation(node,opts){if(!node)return !1;switch(node.type){case"AnyTypeAnnotation":case"BooleanTypeAnnotation":case"NullLiteralTypeAnnotation":case"MixedTypeAnnotation":case"EmptyTypeAnnotation":case"NumberTypeAnnotation":case"StringTypeAnnotation":case"SymbolTypeAnnotation":case"ThisTypeAnnotation":case"VoidTypeAnnotation":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isFlowDeclaration(node,opts){if(!node)return !1;switch(node.type){case"DeclareClass":case"DeclareFunction":case"DeclareInterface":case"DeclareModule":case"DeclareModuleExports":case"DeclareTypeAlias":case"DeclareOpaqueType":case"DeclareVariable":case"DeclareExportDeclaration":case"DeclareExportAllDeclaration":case"InterfaceDeclaration":case"OpaqueType":case"TypeAlias":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isFlowPredicate(node,opts){if(!node)return !1;switch(node.type){case"DeclaredPredicate":case"InferredPredicate":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isEnumBody(node,opts){if(!node)return !1;switch(node.type){case"EnumBooleanBody":case"EnumNumberBody":case"EnumStringBody":case"EnumSymbolBody":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isEnumMember(node,opts){if(!node)return !1;switch(node.type){case"EnumBooleanMember":case"EnumNumberMember":case"EnumStringMember":case"EnumDefaultedMember":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isJSX(node,opts){if(!node)return !1;switch(node.type){case"JSXAttribute":case"JSXClosingElement":case"JSXElement":case"JSXEmptyExpression":case"JSXExpressionContainer":case"JSXSpreadChild":case"JSXIdentifier":case"JSXMemberExpression":case"JSXNamespacedName":case"JSXOpeningElement":case"JSXSpreadAttribute":case"JSXText":case"JSXFragment":case"JSXOpeningFragment":case"JSXClosingFragment":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isMiscellaneous(node,opts){if(!node)return !1;switch(node.type){case"Noop":case"Placeholder":case"V8IntrinsicIdentifier":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isTypeScript(node,opts){if(!node)return !1;switch(node.type){case"TSParameterProperty":case"TSDeclareFunction":case"TSDeclareMethod":case"TSQualifiedName":case"TSCallSignatureDeclaration":case"TSConstructSignatureDeclaration":case"TSPropertySignature":case"TSMethodSignature":case"TSIndexSignature":case"TSAnyKeyword":case"TSBooleanKeyword":case"TSBigIntKeyword":case"TSIntrinsicKeyword":case"TSNeverKeyword":case"TSNullKeyword":case"TSNumberKeyword":case"TSObjectKeyword":case"TSStringKeyword":case"TSSymbolKeyword":case"TSUndefinedKeyword":case"TSUnknownKeyword":case"TSVoidKeyword":case"TSThisType":case"TSFunctionType":case"TSConstructorType":case"TSTypeReference":case"TSTypePredicate":case"TSTypeQuery":case"TSTypeLiteral":case"TSArrayType":case"TSTupleType":case"TSOptionalType":case"TSRestType":case"TSNamedTupleMember":case"TSUnionType":case"TSIntersectionType":case"TSConditionalType":case"TSInferType":case"TSParenthesizedType":case"TSTypeOperator":case"TSIndexedAccessType":case"TSMappedType":case"TSLiteralType":case"TSExpressionWithTypeArguments":case"TSInterfaceDeclaration":case"TSInterfaceBody":case"TSTypeAliasDeclaration":case"TSInstantiationExpression":case"TSAsExpression":case"TSSatisfiesExpression":case"TSTypeAssertion":case"TSEnumDeclaration":case"TSEnumMember":case"TSModuleDeclaration":case"TSModuleBlock":case"TSImportType":case"TSImportEqualsDeclaration":case"TSExternalModuleReference":case"TSNonNullExpression":case"TSExportAssignment":case"TSNamespaceExportDeclaration":case"TSTypeAnnotation":case"TSTypeParameterInstantiation":case"TSTypeParameterDeclaration":case"TSTypeParameter":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isTSTypeElement(node,opts){if(!node)return !1;switch(node.type){case"TSCallSignatureDeclaration":case"TSConstructSignatureDeclaration":case"TSPropertySignature":case"TSMethodSignature":case"TSIndexSignature":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isTSType(node,opts){if(!node)return !1;switch(node.type){case"TSAnyKeyword":case"TSBooleanKeyword":case"TSBigIntKeyword":case"TSIntrinsicKeyword":case"TSNeverKeyword":case"TSNullKeyword":case"TSNumberKeyword":case"TSObjectKeyword":case"TSStringKeyword":case"TSSymbolKeyword":case"TSUndefinedKeyword":case"TSUnknownKeyword":case"TSVoidKeyword":case"TSThisType":case"TSFunctionType":case"TSConstructorType":case"TSTypeReference":case"TSTypePredicate":case"TSTypeQuery":case"TSTypeLiteral":case"TSArrayType":case"TSTupleType":case"TSOptionalType":case"TSRestType":case"TSUnionType":case"TSIntersectionType":case"TSConditionalType":case"TSInferType":case"TSParenthesizedType":case"TSTypeOperator":case"TSIndexedAccessType":case"TSMappedType":case"TSLiteralType":case"TSExpressionWithTypeArguments":case"TSImportType":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isTSBaseType(node,opts){if(!node)return !1;switch(node.type){case"TSAnyKeyword":case"TSBooleanKeyword":case"TSBigIntKeyword":case"TSIntrinsicKeyword":case"TSNeverKeyword":case"TSNullKeyword":case"TSNumberKeyword":case"TSObjectKeyword":case"TSStringKeyword":case"TSSymbolKeyword":case"TSUndefinedKeyword":case"TSUnknownKeyword":case"TSVoidKeyword":case"TSThisType":case"TSLiteralType":break;default:return !1}return opts==null||(0, _shallowEqual.default)(node,opts)}function isNumberLiteral(node,opts){return (0, _deprecationWarning.default)("isNumberLiteral","isNumericLiteral"),!node||node.type!=="NumberLiteral"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isRegexLiteral(node,opts){return (0, _deprecationWarning.default)("isRegexLiteral","isRegExpLiteral"),!node||node.type!=="RegexLiteral"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isRestProperty(node,opts){return (0, _deprecationWarning.default)("isRestProperty","isRestElement"),!node||node.type!=="RestProperty"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isSpreadProperty(node,opts){return (0, _deprecationWarning.default)("isSpreadProperty","isSpreadElement"),!node||node.type!=="SpreadProperty"?!1:opts==null||(0, _shallowEqual.default)(node,opts)}function isModuleDeclaration(node,opts){return (0, _deprecationWarning.default)("isModuleDeclaration","isImportOrExportDeclaration"),isImportOrExportDeclaration(node,opts)}}});var require_matchesPattern=__commonJS({"../../node_modules/@babel/types/lib/validators/matchesPattern.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=matchesPattern;var _index=require_generated();function matchesPattern(member,match,allowPartial){if(!(0, _index.isMemberExpression)(member))return !1;let parts=Array.isArray(match)?match:match.split("."),nodes=[],node;for(node=member;(0, _index.isMemberExpression)(node);node=node.object)nodes.push(node.property);if(nodes.push(node),nodes.length<parts.length||!allowPartial&&nodes.length>parts.length)return !1;for(let i=0,j=nodes.length-1;i<parts.length;i++,j--){let node2=nodes[j],value;if((0, _index.isIdentifier)(node2))value=node2.name;else if((0, _index.isStringLiteral)(node2))value=node2.value;else if((0, _index.isThisExpression)(node2))value="this";else return !1;if(parts[i]!==value)return !1}return !0}}});var require_buildMatchMemberExpression=__commonJS({"../../node_modules/@babel/types/lib/validators/buildMatchMemberExpression.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=buildMatchMemberExpression;var _matchesPattern=require_matchesPattern();function buildMatchMemberExpression(match,allowPartial){let parts=match.split(".");return member=>(0, _matchesPattern.default)(member,parts,allowPartial)}}});var require_isReactComponent=__commonJS({"../../node_modules/@babel/types/lib/validators/react/isReactComponent.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=void 0;var _buildMatchMemberExpression=require_buildMatchMemberExpression(),isReactComponent=(0, _buildMatchMemberExpression.default)("React.Component");exports.default=isReactComponent;}});var require_isCompatTag=__commonJS({"../../node_modules/@babel/types/lib/validators/react/isCompatTag.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=isCompatTag;function isCompatTag(tagName){return !!tagName&&/^[a-z]/.test(tagName)}}});var require_to_fast_properties=__commonJS({"../../node_modules/to-fast-properties/index.js"(exports,module){var fastProto=null;function FastObject(o){if(fastProto!==null&&typeof fastProto.property){let result=fastProto;return fastProto=FastObject.prototype=null,result}return fastProto=FastObject.prototype=o??Object.create(null),new FastObject}FastObject();module.exports=function(o){return FastObject(o)};}});var require_isType=__commonJS({"../../node_modules/@babel/types/lib/validators/isType.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=isType;var _index=require_definitions();function isType(nodeType,targetType){if(nodeType===targetType)return !0;if(nodeType==null||_index.ALIAS_KEYS[targetType])return !1;let aliases=_index.FLIPPED_ALIAS_KEYS[targetType];if(aliases){if(aliases[0]===nodeType)return !0;for(let alias of aliases)if(nodeType===alias)return !0}return !1}}});var require_isPlaceholderType=__commonJS({"../../node_modules/@babel/types/lib/validators/isPlaceholderType.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=isPlaceholderType;var _index=require_definitions();function isPlaceholderType(placeholderType,targetType){if(placeholderType===targetType)return !0;let aliases=_index.PLACEHOLDERS_ALIAS[placeholderType];if(aliases){for(let alias of aliases)if(targetType===alias)return !0}return !1}}});var require_is=__commonJS({"../../node_modules/@babel/types/lib/validators/is.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=is;var _shallowEqual=require_shallowEqual(),_isType=require_isType(),_isPlaceholderType=require_isPlaceholderType(),_index=require_definitions();function is(type,node,opts){return node?(0, _isType.default)(node.type,type)?typeof opts>"u"?!0:(0, _shallowEqual.default)(node,opts):!opts&&node.type==="Placeholder"&&type in _index.FLIPPED_ALIAS_KEYS?(0, _isPlaceholderType.default)(node.expectedNode,type):!1:!1}}});var require_identifier=__commonJS({"../../node_modules/@babel/helper-validator-identifier/lib/identifier.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.isIdentifierChar=isIdentifierChar;exports.isIdentifierName=isIdentifierName;exports.isIdentifierStart=isIdentifierStart;var nonASCIIidentifierStartChars="\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1878\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u31A0-\u31BF\u31F0-\u31FF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC",nonASCIIidentifierChars="\u200C\u200D\xB7\u0300-\u036F\u0387\u0483-\u0487\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u064B-\u0669\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7\u06E8\u06EA-\u06ED\u06F0-\u06F9\u0711\u0730-\u074A\u07A6-\u07B0\u07C0-\u07C9\u07EB-\u07F3\u07FD\u0816-\u0819\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0859-\u085B\u0898-\u089F\u08CA-\u08E1\u08E3-\u0903\u093A-\u093C\u093E-\u094F\u0951-\u0957\u0962\u0963\u0966-\u096F\u0981-\u0983\u09BC\u09BE-\u09C4\u09C7\u09C8\u09CB-\u09CD\u09D7\u09E2\u09E3\u09E6-\u09EF\u09FE\u0A01-\u0A03\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A66-\u0A71\u0A75\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AE2\u0AE3\u0AE6-\u0AEF\u0AFA-\u0AFF\u0B01-\u0B03\u0B3C\u0B3E-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B55-\u0B57\u0B62\u0B63\u0B66-\u0B6F\u0B82\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0BE6-\u0BEF\u0C00-\u0C04\u0C3C\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62\u0C63\u0C66-\u0C6F\u0C81-\u0C83\u0CBC\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CE2\u0CE3\u0CE6-\u0CEF\u0CF3\u0D00-\u0D03\u0D3B\u0D3C\u0D3E-\u0D44\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0D62\u0D63\u0D66-\u0D6F\u0D81-\u0D83\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0E50-\u0E59\u0EB1\u0EB4-\u0EBC\u0EC8-\u0ECE\u0ED0-\u0ED9\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u102B-\u103E\u1040-\u1049\u1056-\u1059\u105E-\u1060\u1062-\u1064\u1067-\u106D\u1071-\u1074\u1082-\u108D\u108F-\u109D\u135D-\u135F\u1369-\u1371\u1712-\u1715\u1732-\u1734\u1752\u1753\u1772\u1773\u17B4-\u17D3\u17DD\u17E0-\u17E9\u180B-\u180D\u180F-\u1819\u18A9\u1920-\u192B\u1930-\u193B\u1946-\u194F\u19D0-\u19DA\u1A17-\u1A1B\u1A55-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AB0-\u1ABD\u1ABF-\u1ACE\u1B00-\u1B04\u1B34-\u1B44\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1B82\u1BA1-\u1BAD\u1BB0-\u1BB9\u1BE6-\u1BF3\u1C24-\u1C37\u1C40-\u1C49\u1C50-\u1C59\u1CD0-\u1CD2\u1CD4-\u1CE8\u1CED\u1CF4\u1CF7-\u1CF9\u1DC0-\u1DFF\u200C\u200D\u203F\u2040\u2054\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2CEF-\u2CF1\u2D7F\u2DE0-\u2DFF\u302A-\u302F\u3099\u309A\u30FB\uA620-\uA629\uA66F\uA674-\uA67D\uA69E\uA69F\uA6F0\uA6F1\uA802\uA806\uA80B\uA823-\uA827\uA82C\uA880\uA881\uA8B4-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F1\uA8FF-\uA909\uA926-\uA92D\uA947-\uA953\uA980-\uA983\uA9B3-\uA9C0\uA9D0-\uA9D9\uA9E5\uA9F0-\uA9F9\uAA29-\uAA36\uAA43\uAA4C\uAA4D\uAA50-\uAA59\uAA7B-\uAA7D\uAAB0\uAAB2-\uAAB4\uAAB7\uAAB8\uAABE\uAABF\uAAC1\uAAEB-\uAAEF\uAAF5\uAAF6\uABE3-\uABEA\uABEC\uABED\uABF0-\uABF9\uFB1E\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFF10-\uFF19\uFF3F\uFF65",nonASCIIidentifierStart=new RegExp("["+nonASCIIidentifierStartChars+"]"),nonASCIIidentifier=new RegExp("["+nonASCIIidentifierStartChars+nonASCIIidentifierChars+"]");nonASCIIidentifierStartChars=nonASCIIidentifierChars=null;var astralIdentifierStartCodes=[0,11,2,25,2,18,2,1,2,14,3,13,35,122,70,52,268,28,4,48,48,31,14,29,6,37,11,29,3,35,5,7,2,4,43,157,19,35,5,35,5,39,9,51,13,10,2,14,2,6,2,1,2,10,2,14,2,6,2,1,68,310,10,21,11,7,25,5,2,41,2,8,70,5,3,0,2,43,2,1,4,0,3,22,11,22,10,30,66,18,2,1,11,21,11,25,71,55,7,1,65,0,16,3,2,2,2,28,43,28,4,28,36,7,2,27,28,53,11,21,11,18,14,17,111,72,56,50,14,50,14,35,349,41,7,1,79,28,11,0,9,21,43,17,47,20,28,22,13,52,58,1,3,0,14,44,33,24,27,35,30,0,3,0,9,34,4,0,13,47,15,3,22,0,2,0,36,17,2,24,20,1,64,6,2,0,2,3,2,14,2,9,8,46,39,7,3,1,3,21,2,6,2,1,2,4,4,0,19,0,13,4,159,52,19,3,21,2,31,47,21,1,2,0,185,46,42,3,37,47,21,0,60,42,14,0,72,26,38,6,186,43,117,63,32,7,3,0,3,7,2,1,2,23,16,0,2,0,95,7,3,38,17,0,2,0,29,0,11,39,8,0,22,0,12,45,20,0,19,72,264,8,2,36,18,0,50,29,113,6,2,1,2,37,22,0,26,5,2,1,2,31,15,0,328,18,16,0,2,12,2,33,125,0,80,921,103,110,18,195,2637,96,16,1071,18,5,4026,582,8634,568,8,30,18,78,18,29,19,47,17,3,32,20,6,18,689,63,129,74,6,0,67,12,65,1,2,0,29,6135,9,1237,43,8,8936,3,2,6,2,1,2,290,16,0,30,2,3,0,15,3,9,395,2309,106,6,12,4,8,8,9,5991,84,2,70,2,1,3,0,3,1,3,3,2,11,2,0,2,6,2,64,2,3,3,7,2,6,2,27,2,3,2,4,2,0,4,6,2,339,3,24,2,24,2,30,2,24,2,30,2,24,2,30,2,24,2,30,2,24,2,7,1845,30,7,5,262,61,147,44,11,6,17,0,322,29,19,43,485,27,757,6,2,3,2,1,2,14,2,196,60,67,8,0,1205,3,2,26,2,1,2,0,3,0,2,9,2,3,2,0,2,0,7,0,5,0,2,0,2,0,2,2,2,1,2,0,3,0,2,0,2,0,2,0,2,0,2,1,2,0,3,3,2,6,2,3,2,3,2,0,2,9,2,16,6,2,2,4,2,16,4421,42719,33,4153,7,221,3,5761,15,7472,16,621,2467,541,1507,4938,6,4191],astralIdentifierCodes=[509,0,227,0,150,4,294,9,1368,2,2,1,6,3,41,2,5,0,166,1,574,3,9,9,370,1,81,2,71,10,50,3,123,2,54,14,32,10,3,1,11,3,46,10,8,0,46,9,7,2,37,13,2,9,6,1,45,0,13,2,49,13,9,3,2,11,83,11,7,0,3,0,158,11,6,9,7,3,56,1,2,6,3,1,3,2,10,0,11,1,3,6,4,4,193,17,10,9,5,0,82,19,13,9,214,6,3,8,28,1,83,16,16,9,82,12,9,9,84,14,5,9,243,14,166,9,71,5,2,1,3,3,2,0,2,1,13,9,120,6,3,6,4,0,29,9,41,6,2,3,9,0,10,10,47,15,406,7,2,7,17,9,57,21,2,13,123,5,4,0,2,1,2,6,2,0,9,9,49,4,2,1,2,4,9,9,330,3,10,1,2,0,49,6,4,4,14,9,5351,0,7,14,13835,9,87,9,39,4,60,6,26,9,1014,0,2,54,8,3,82,0,12,1,19628,1,4706,45,3,22,543,4,4,5,9,7,3,6,31,3,149,2,1418,49,513,54,5,49,9,0,15,0,23,4,2,14,1361,6,2,16,3,6,2,1,2,4,101,0,161,6,10,9,357,0,62,13,499,13,983,6,110,6,6,9,4759,9,787719,239];function isInAstralSet(code,set){let pos=65536;for(let i=0,length=set.length;i<length;i+=2){if(pos+=set[i],pos>code)return !1;if(pos+=set[i+1],pos>=code)return !0}return !1}function isIdentifierStart(code){return code<65?code===36:code<=90?!0:code<97?code===95:code<=122?!0:code<=65535?code>=170&&nonASCIIidentifierStart.test(String.fromCharCode(code)):isInAstralSet(code,astralIdentifierStartCodes)}function isIdentifierChar(code){return code<48?code===36:code<58?!0:code<65?!1:code<=90?!0:code<97?code===95:code<=122?!0:code<=65535?code>=170&&nonASCIIidentifier.test(String.fromCharCode(code)):isInAstralSet(code,astralIdentifierStartCodes)||isInAstralSet(code,astralIdentifierCodes)}function isIdentifierName(name){let isFirst=!0;for(let i=0;i<name.length;i++){let cp=name.charCodeAt(i);if((cp&64512)===55296&&i+1<name.length){let trail=name.charCodeAt(++i);(trail&64512)===56320&&(cp=65536+((cp&1023)<<10)+(trail&1023));}if(isFirst){if(isFirst=!1,!isIdentifierStart(cp))return !1}else if(!isIdentifierChar(cp))return !1}return !isFirst}}});var require_keyword=__commonJS({"../../node_modules/@babel/helper-validator-identifier/lib/keyword.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.isKeyword=isKeyword;exports.isReservedWord=isReservedWord;exports.isStrictBindOnlyReservedWord=isStrictBindOnlyReservedWord;exports.isStrictBindReservedWord=isStrictBindReservedWord;exports.isStrictReservedWord=isStrictReservedWord;var reservedWords={keyword:["break","case","catch","continue","debugger","default","do","else","finally","for","function","if","return","switch","throw","try","var","const","while","with","new","this","super","class","extends","export","import","null","true","false","in","instanceof","typeof","void","delete"],strict:["implements","interface","let","package","private","protected","public","static","yield"],strictBind:["eval","arguments"]},keywords=new Set(reservedWords.keyword),reservedWordsStrictSet=new Set(reservedWords.strict),reservedWordsStrictBindSet=new Set(reservedWords.strictBind);function isReservedWord(word,inModule){return inModule&&word==="await"||word==="enum"}function isStrictReservedWord(word,inModule){return isReservedWord(word,inModule)||reservedWordsStrictSet.has(word)}function isStrictBindOnlyReservedWord(word){return reservedWordsStrictBindSet.has(word)}function isStrictBindReservedWord(word,inModule){return isStrictReservedWord(word,inModule)||isStrictBindOnlyReservedWord(word)}function isKeyword(word){return keywords.has(word)}}});var require_lib=__commonJS({"../../node_modules/@babel/helper-validator-identifier/lib/index.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});Object.defineProperty(exports,"isIdentifierChar",{enumerable:!0,get:function(){return _identifier.isIdentifierChar}});Object.defineProperty(exports,"isIdentifierName",{enumerable:!0,get:function(){return _identifier.isIdentifierName}});Object.defineProperty(exports,"isIdentifierStart",{enumerable:!0,get:function(){return _identifier.isIdentifierStart}});Object.defineProperty(exports,"isKeyword",{enumerable:!0,get:function(){return _keyword.isKeyword}});Object.defineProperty(exports,"isReservedWord",{enumerable:!0,get:function(){return _keyword.isReservedWord}});Object.defineProperty(exports,"isStrictBindOnlyReservedWord",{enumerable:!0,get:function(){return _keyword.isStrictBindOnlyReservedWord}});Object.defineProperty(exports,"isStrictBindReservedWord",{enumerable:!0,get:function(){return _keyword.isStrictBindReservedWord}});Object.defineProperty(exports,"isStrictReservedWord",{enumerable:!0,get:function(){return _keyword.isStrictReservedWord}});var _identifier=require_identifier(),_keyword=require_keyword();}});var require_isValidIdentifier=__commonJS({"../../node_modules/@babel/types/lib/validators/isValidIdentifier.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=isValidIdentifier;var _helperValidatorIdentifier=require_lib();function isValidIdentifier(name,reserved=!0){return typeof name!="string"||reserved&&((0, _helperValidatorIdentifier.isKeyword)(name)||(0, _helperValidatorIdentifier.isStrictReservedWord)(name,!0))?!1:(0, _helperValidatorIdentifier.isIdentifierName)(name)}}});var require_lib2=__commonJS({"../../node_modules/@babel/helper-string-parser/lib/index.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.readCodePoint=readCodePoint;exports.readInt=readInt;exports.readStringContents=readStringContents;var _isDigit=function(code){return code>=48&&code<=57},forbiddenNumericSeparatorSiblings={decBinOct:new Set([46,66,69,79,95,98,101,111]),hex:new Set([46,88,95,120])},isAllowedNumericSeparatorSibling={bin:ch=>ch===48||ch===49,oct:ch=>ch>=48&&ch<=55,dec:ch=>ch>=48&&ch<=57,hex:ch=>ch>=48&&ch<=57||ch>=65&&ch<=70||ch>=97&&ch<=102};function readStringContents(type,input,pos,lineStart,curLine,errors){let initialPos=pos,initialLineStart=lineStart,initialCurLine=curLine,out="",firstInvalidLoc=null,chunkStart=pos,{length}=input;for(;;){if(pos>=length){errors.unterminated(initialPos,initialLineStart,initialCurLine),out+=input.slice(chunkStart,pos);break}let ch=input.charCodeAt(pos);if(isStringEnd(type,ch,input,pos)){out+=input.slice(chunkStart,pos);break}if(ch===92){out+=input.slice(chunkStart,pos);let res=readEscapedChar(input,pos,lineStart,curLine,type==="template",errors);res.ch===null&&!firstInvalidLoc?firstInvalidLoc={pos,lineStart,curLine}:out+=res.ch,{pos,lineStart,curLine}=res,chunkStart=pos;}else ch===8232||ch===8233?(++pos,++curLine,lineStart=pos):ch===10||ch===13?type==="template"?(out+=input.slice(chunkStart,pos)+`
`,++pos,ch===13&&input.charCodeAt(pos)===10&&++pos,++curLine,chunkStart=lineStart=pos):errors.unterminated(initialPos,initialLineStart,initialCurLine):++pos;}return {pos,str:out,firstInvalidLoc,lineStart,curLine,containsInvalid:!!firstInvalidLoc}}function isStringEnd(type,ch,input,pos){return type==="template"?ch===96||ch===36&&input.charCodeAt(pos+1)===123:ch===(type==="double"?34:39)}function readEscapedChar(input,pos,lineStart,curLine,inTemplate,errors){let throwOnInvalid=!inTemplate;pos++;let res=ch2=>({pos,ch:ch2,lineStart,curLine}),ch=input.charCodeAt(pos++);switch(ch){case 110:return res(`
`);case 114:return res("\r");case 120:{let code;return {code,pos}=readHexChar(input,pos,lineStart,curLine,2,!1,throwOnInvalid,errors),res(code===null?null:String.fromCharCode(code))}case 117:{let code;return {code,pos}=readCodePoint(input,pos,lineStart,curLine,throwOnInvalid,errors),res(code===null?null:String.fromCodePoint(code))}case 116:return res("	");case 98:return res("\b");case 118:return res("\v");case 102:return res("\f");case 13:input.charCodeAt(pos)===10&&++pos;case 10:lineStart=pos,++curLine;case 8232:case 8233:return res("");case 56:case 57:if(inTemplate)return res(null);errors.strictNumericEscape(pos-1,lineStart,curLine);default:if(ch>=48&&ch<=55){let startPos=pos-1,octalStr=input.slice(startPos,pos+2).match(/^[0-7]+/)[0],octal=parseInt(octalStr,8);octal>255&&(octalStr=octalStr.slice(0,-1),octal=parseInt(octalStr,8)),pos+=octalStr.length-1;let next=input.charCodeAt(pos);if(octalStr!=="0"||next===56||next===57){if(inTemplate)return res(null);errors.strictNumericEscape(startPos,lineStart,curLine);}return res(String.fromCharCode(octal))}return res(String.fromCharCode(ch))}}function readHexChar(input,pos,lineStart,curLine,len,forceLen,throwOnInvalid,errors){let initialPos=pos,n;return {n,pos}=readInt(input,pos,lineStart,curLine,16,len,forceLen,!1,errors,!throwOnInvalid),n===null&&(throwOnInvalid?errors.invalidEscapeSequence(initialPos,lineStart,curLine):pos=initialPos-1),{code:n,pos}}function readInt(input,pos,lineStart,curLine,radix,len,forceLen,allowNumSeparator,errors,bailOnError){let start=pos,forbiddenSiblings=radix===16?forbiddenNumericSeparatorSiblings.hex:forbiddenNumericSeparatorSiblings.decBinOct,isAllowedSibling=radix===16?isAllowedNumericSeparatorSibling.hex:radix===10?isAllowedNumericSeparatorSibling.dec:radix===8?isAllowedNumericSeparatorSibling.oct:isAllowedNumericSeparatorSibling.bin,invalid=!1,total=0;for(let i=0,e=len??1/0;i<e;++i){let code=input.charCodeAt(pos),val;if(code===95&&allowNumSeparator!=="bail"){let prev=input.charCodeAt(pos-1),next=input.charCodeAt(pos+1);if(allowNumSeparator){if(Number.isNaN(next)||!isAllowedSibling(next)||forbiddenSiblings.has(prev)||forbiddenSiblings.has(next)){if(bailOnError)return {n:null,pos};errors.unexpectedNumericSeparator(pos,lineStart,curLine);}}else {if(bailOnError)return {n:null,pos};errors.numericSeparatorInEscapeSequence(pos,lineStart,curLine);}++pos;continue}if(code>=97?val=code-97+10:code>=65?val=code-65+10:_isDigit(code)?val=code-48:val=1/0,val>=radix){if(val<=9&&bailOnError)return {n:null,pos};if(val<=9&&errors.invalidDigit(pos,lineStart,curLine,radix))val=0;else if(forceLen)val=0,invalid=!0;else break}++pos,total=total*radix+val;}return pos===start||len!=null&&pos-start!==len||invalid?{n:null,pos}:{n:total,pos}}function readCodePoint(input,pos,lineStart,curLine,throwOnInvalid,errors){let ch=input.charCodeAt(pos),code;if(ch===123){if(++pos,{code,pos}=readHexChar(input,pos,lineStart,curLine,input.indexOf("}",pos)-pos,!0,throwOnInvalid,errors),++pos,code!==null&&code>1114111)if(throwOnInvalid)errors.invalidCodePoint(pos,lineStart,curLine);else return {code:null,pos}}else ({code,pos}=readHexChar(input,pos,lineStart,curLine,4,!1,throwOnInvalid,errors));return {code,pos}}}});var require_constants=__commonJS({"../../node_modules/@babel/types/lib/constants/index.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.UPDATE_OPERATORS=exports.UNARY_OPERATORS=exports.STRING_UNARY_OPERATORS=exports.STATEMENT_OR_BLOCK_KEYS=exports.NUMBER_UNARY_OPERATORS=exports.NUMBER_BINARY_OPERATORS=exports.NOT_LOCAL_BINDING=exports.LOGICAL_OPERATORS=exports.INHERIT_KEYS=exports.FOR_INIT_KEYS=exports.FLATTENABLE_KEYS=exports.EQUALITY_BINARY_OPERATORS=exports.COMPARISON_BINARY_OPERATORS=exports.COMMENT_KEYS=exports.BOOLEAN_UNARY_OPERATORS=exports.BOOLEAN_NUMBER_BINARY_OPERATORS=exports.BOOLEAN_BINARY_OPERATORS=exports.BLOCK_SCOPED_SYMBOL=exports.BINARY_OPERATORS=exports.ASSIGNMENT_OPERATORS=void 0;exports.STATEMENT_OR_BLOCK_KEYS=["consequent","body","alternate"];exports.FLATTENABLE_KEYS=["body","expressions"];exports.FOR_INIT_KEYS=["left","init"];exports.COMMENT_KEYS=["leadingComments","trailingComments","innerComments"];var LOGICAL_OPERATORS=exports.LOGICAL_OPERATORS=["||","&&","??"];exports.UPDATE_OPERATORS=["++","--"];var BOOLEAN_NUMBER_BINARY_OPERATORS=exports.BOOLEAN_NUMBER_BINARY_OPERATORS=[">","<",">=","<="],EQUALITY_BINARY_OPERATORS=exports.EQUALITY_BINARY_OPERATORS=["==","===","!=","!=="],COMPARISON_BINARY_OPERATORS=exports.COMPARISON_BINARY_OPERATORS=[...EQUALITY_BINARY_OPERATORS,"in","instanceof"],BOOLEAN_BINARY_OPERATORS=exports.BOOLEAN_BINARY_OPERATORS=[...COMPARISON_BINARY_OPERATORS,...BOOLEAN_NUMBER_BINARY_OPERATORS],NUMBER_BINARY_OPERATORS=exports.NUMBER_BINARY_OPERATORS=["-","/","%","*","**","&","|",">>",">>>","<<","^"];exports.BINARY_OPERATORS=["+",...NUMBER_BINARY_OPERATORS,...BOOLEAN_BINARY_OPERATORS,"|>"];exports.ASSIGNMENT_OPERATORS=["=","+=",...NUMBER_BINARY_OPERATORS.map(op=>op+"="),...LOGICAL_OPERATORS.map(op=>op+"=")];var BOOLEAN_UNARY_OPERATORS=exports.BOOLEAN_UNARY_OPERATORS=["delete","!"],NUMBER_UNARY_OPERATORS=exports.NUMBER_UNARY_OPERATORS=["+","-","~"],STRING_UNARY_OPERATORS=exports.STRING_UNARY_OPERATORS=["typeof"];exports.UNARY_OPERATORS=["void","throw",...BOOLEAN_UNARY_OPERATORS,...NUMBER_UNARY_OPERATORS,...STRING_UNARY_OPERATORS];exports.INHERIT_KEYS={optional:["typeAnnotation","typeParameters","returnType"],force:["start","loc","end"]};exports.BLOCK_SCOPED_SYMBOL=Symbol.for("var used to be block scoped");exports.NOT_LOCAL_BINDING=Symbol.for("should not be considered a local binding");}});var require_utils=__commonJS({"../../node_modules/@babel/types/lib/definitions/utils.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.VISITOR_KEYS=exports.NODE_PARENT_VALIDATIONS=exports.NODE_FIELDS=exports.FLIPPED_ALIAS_KEYS=exports.DEPRECATED_KEYS=exports.BUILDER_KEYS=exports.ALIAS_KEYS=void 0;exports.arrayOf=arrayOf;exports.arrayOfType=arrayOfType;exports.assertEach=assertEach;exports.assertNodeOrValueType=assertNodeOrValueType;exports.assertNodeType=assertNodeType;exports.assertOneOf=assertOneOf;exports.assertOptionalChainStart=assertOptionalChainStart;exports.assertShape=assertShape;exports.assertValueType=assertValueType;exports.chain=chain;exports.default=defineType;exports.defineAliasedType=defineAliasedType;exports.typeIs=typeIs;exports.validate=validate;exports.validateArrayOfType=validateArrayOfType;exports.validateOptional=validateOptional;exports.validateOptionalType=validateOptionalType;exports.validateType=validateType;var _is=require_is(),_validate=require_validate(),VISITOR_KEYS=exports.VISITOR_KEYS={},ALIAS_KEYS=exports.ALIAS_KEYS={},FLIPPED_ALIAS_KEYS=exports.FLIPPED_ALIAS_KEYS={},NODE_FIELDS=exports.NODE_FIELDS={},BUILDER_KEYS=exports.BUILDER_KEYS={},DEPRECATED_KEYS=exports.DEPRECATED_KEYS={},NODE_PARENT_VALIDATIONS=exports.NODE_PARENT_VALIDATIONS={};function getType(val){return Array.isArray(val)?"array":val===null?"null":typeof val}function validate(validate2){return {validate:validate2}}function typeIs(typeName){return typeof typeName=="string"?assertNodeType(typeName):assertNodeType(...typeName)}function validateType(typeName){return validate(typeIs(typeName))}function validateOptional(validate2){return {validate:validate2,optional:!0}}function validateOptionalType(typeName){return {validate:typeIs(typeName),optional:!0}}function arrayOf(elementType){return chain(assertValueType("array"),assertEach(elementType))}function arrayOfType(typeName){return arrayOf(typeIs(typeName))}function validateArrayOfType(typeName){return validate(arrayOfType(typeName))}function assertEach(callback){function validator(node,key,val){if(Array.isArray(val))for(let i=0;i<val.length;i++){let subkey=`${key}[${i}]`,v=val[i];callback(node,subkey,v),process.env.BABEL_TYPES_8_BREAKING&&(0, _validate.validateChild)(node,subkey,v);}}return validator.each=callback,validator}function assertOneOf(...values){function validate2(node,key,val){if(values.indexOf(val)<0)throw new TypeError(`Property ${key} expected value to be one of ${JSON.stringify(values)} but got ${JSON.stringify(val)}`)}return validate2.oneOf=values,validate2}function assertNodeType(...types){function validate2(node,key,val){for(let type of types)if((0, _is.default)(type,val)){(0, _validate.validateChild)(node,key,val);return}throw new TypeError(`Property ${key} of ${node.type} expected node to be of a type ${JSON.stringify(types)} but instead got ${JSON.stringify(val?.type)}`)}return validate2.oneOfNodeTypes=types,validate2}function assertNodeOrValueType(...types){function validate2(node,key,val){for(let type of types)if(getType(val)===type||(0, _is.default)(type,val)){(0, _validate.validateChild)(node,key,val);return}throw new TypeError(`Property ${key} of ${node.type} expected node to be of a type ${JSON.stringify(types)} but instead got ${JSON.stringify(val?.type)}`)}return validate2.oneOfNodeOrValueTypes=types,validate2}function assertValueType(type){function validate2(node,key,val){if(!(getType(val)===type))throw new TypeError(`Property ${key} expected type of ${type} but got ${getType(val)}`)}return validate2.type=type,validate2}function assertShape(shape){function validate2(node,key,val){let errors=[];for(let property of Object.keys(shape))try{(0,_validate.validateField)(node,property,val[property],shape[property]);}catch(error){if(error instanceof TypeError){errors.push(error.message);continue}throw error}if(errors.length)throw new TypeError(`Property ${key} of ${node.type} expected to have the following:
${errors.join(`
`)}`)}return validate2.shapeOf=shape,validate2}function assertOptionalChainStart(){function validate2(node){var _current;let current=node;for(;node;){let{type}=current;if(type==="OptionalCallExpression"){if(current.optional)return;current=current.callee;continue}if(type==="OptionalMemberExpression"){if(current.optional)return;current=current.object;continue}break}throw new TypeError(`Non-optional ${node.type} must chain from an optional OptionalMemberExpression or OptionalCallExpression. Found chain from ${(_current=current)==null?void 0:_current.type}`)}return validate2}function chain(...fns){function validate2(...args2){for(let fn of fns)fn(...args2);}if(validate2.chainOf=fns,fns.length>=2&&"type"in fns[0]&&fns[0].type==="array"&&!("each"in fns[1]))throw new Error('An assertValueType("array") validator can only be followed by an assertEach(...) validator.');return validate2}var validTypeOpts=["aliases","builder","deprecatedAlias","fields","inherits","visitor","validate"],validFieldKeys=["default","optional","deprecated","validate"],store={};function defineAliasedType(...aliases){return (type,opts={})=>{let defined=opts.aliases;if(!defined){var _store$opts$inherits$;opts.inherits&&(defined=(_store$opts$inherits$=store[opts.inherits].aliases)==null?void 0:_store$opts$inherits$.slice()),(defined)!=null||(defined=[]),opts.aliases=defined;}let additional=aliases.filter(a=>!defined.includes(a));defined.unshift(...additional),defineType(type,opts);}}function defineType(type,opts={}){let inherits=opts.inherits&&store[opts.inherits]||{},fields=opts.fields;if(!fields&&(fields={},inherits.fields)){let keys=Object.getOwnPropertyNames(inherits.fields);for(let key of keys){let field=inherits.fields[key],def=field.default;if(Array.isArray(def)?def.length>0:def&&typeof def=="object")throw new Error("field defaults can only be primitives or empty arrays currently");fields[key]={default:Array.isArray(def)?[]:def,optional:field.optional,deprecated:field.deprecated,validate:field.validate};}}let visitor=opts.visitor||inherits.visitor||[],aliases=opts.aliases||inherits.aliases||[],builder=opts.builder||inherits.builder||opts.visitor||[];for(let k of Object.keys(opts))if(validTypeOpts.indexOf(k)===-1)throw new Error(`Unknown type option "${k}" on ${type}`);opts.deprecatedAlias&&(DEPRECATED_KEYS[opts.deprecatedAlias]=type);for(let key of visitor.concat(builder))fields[key]=fields[key]||{};for(let key of Object.keys(fields)){let field=fields[key];field.default!==void 0&&builder.indexOf(key)===-1&&(field.optional=!0),field.default===void 0?field.default=null:!field.validate&&field.default!=null&&(field.validate=assertValueType(getType(field.default)));for(let k of Object.keys(field))if(validFieldKeys.indexOf(k)===-1)throw new Error(`Unknown field key "${k}" on ${type}.${key}`)}VISITOR_KEYS[type]=opts.visitor=visitor,BUILDER_KEYS[type]=opts.builder=builder,NODE_FIELDS[type]=opts.fields=fields,ALIAS_KEYS[type]=opts.aliases=aliases,aliases.forEach(alias=>{FLIPPED_ALIAS_KEYS[alias]=FLIPPED_ALIAS_KEYS[alias]||[],FLIPPED_ALIAS_KEYS[alias].push(type);}),opts.validate&&(NODE_PARENT_VALIDATIONS[type]=opts.validate),store[type]=opts;}}});var require_core=__commonJS({"../../node_modules/@babel/types/lib/definitions/core.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.patternLikeCommon=exports.functionTypeAnnotationCommon=exports.functionDeclarationCommon=exports.functionCommon=exports.classMethodOrPropertyCommon=exports.classMethodOrDeclareMethodCommon=void 0;var _is=require_is(),_isValidIdentifier=require_isValidIdentifier(),_helperValidatorIdentifier=require_lib(),_helperStringParser=require_lib2(),_index=require_constants(),_utils=require_utils(),defineType=(0, _utils.defineAliasedType)("Standardized");defineType("ArrayExpression",{fields:{elements:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeOrValueType)("null","Expression","SpreadElement"))),default:process.env.BABEL_TYPES_8_BREAKING?void 0:[]}},visitor:["elements"],aliases:["Expression"]});defineType("AssignmentExpression",{fields:{operator:{validate:function(){if(!process.env.BABEL_TYPES_8_BREAKING)return (0, _utils.assertValueType)("string");let identifier2=(0, _utils.assertOneOf)(..._index.ASSIGNMENT_OPERATORS),pattern=(0, _utils.assertOneOf)("=");return function(node,key,val){((0, _is.default)("Pattern",node.left)?pattern:identifier2)(node,key,val);}}()},left:{validate:process.env.BABEL_TYPES_8_BREAKING?(0, _utils.assertNodeType)("Identifier","MemberExpression","OptionalMemberExpression","ArrayPattern","ObjectPattern","TSAsExpression","TSSatisfiesExpression","TSTypeAssertion","TSNonNullExpression"):(0, _utils.assertNodeType)("LVal","OptionalMemberExpression")},right:{validate:(0, _utils.assertNodeType)("Expression")}},builder:["operator","left","right"],visitor:["left","right"],aliases:["Expression"]});defineType("BinaryExpression",{builder:["operator","left","right"],fields:{operator:{validate:(0, _utils.assertOneOf)(..._index.BINARY_OPERATORS)},left:{validate:function(){let expression=(0, _utils.assertNodeType)("Expression"),inOp=(0, _utils.assertNodeType)("Expression","PrivateName");return Object.assign(function(node,key,val){(node.operator==="in"?inOp:expression)(node,key,val);},{oneOfNodeTypes:["Expression","PrivateName"]})}()},right:{validate:(0, _utils.assertNodeType)("Expression")}},visitor:["left","right"],aliases:["Binary","Expression"]});defineType("InterpreterDirective",{builder:["value"],fields:{value:{validate:(0, _utils.assertValueType)("string")}}});defineType("Directive",{visitor:["value"],fields:{value:{validate:(0, _utils.assertNodeType)("DirectiveLiteral")}}});defineType("DirectiveLiteral",{builder:["value"],fields:{value:{validate:(0, _utils.assertValueType)("string")}}});defineType("BlockStatement",{builder:["body","directives"],visitor:["directives","body"],fields:{directives:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("Directive"))),default:[]},body:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("Statement")))}},aliases:["Scopable","BlockParent","Block","Statement"]});defineType("BreakStatement",{visitor:["label"],fields:{label:{validate:(0, _utils.assertNodeType)("Identifier"),optional:!0}},aliases:["Statement","Terminatorless","CompletionStatement"]});defineType("CallExpression",{visitor:["callee","arguments","typeParameters","typeArguments"],builder:["callee","arguments"],aliases:["Expression"],fields:Object.assign({callee:{validate:(0, _utils.assertNodeType)("Expression","Super","V8IntrinsicIdentifier")},arguments:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("Expression","SpreadElement","JSXNamespacedName","ArgumentPlaceholder")))}},process.env.BABEL_TYPES_8_BREAKING?{}:{optional:{validate:(0, _utils.assertOneOf)(!0,!1),optional:!0}},{typeArguments:{validate:(0, _utils.assertNodeType)("TypeParameterInstantiation"),optional:!0},typeParameters:{validate:(0, _utils.assertNodeType)("TSTypeParameterInstantiation"),optional:!0}})});defineType("CatchClause",{visitor:["param","body"],fields:{param:{validate:(0, _utils.assertNodeType)("Identifier","ArrayPattern","ObjectPattern"),optional:!0},body:{validate:(0, _utils.assertNodeType)("BlockStatement")}},aliases:["Scopable","BlockParent"]});defineType("ConditionalExpression",{visitor:["test","consequent","alternate"],fields:{test:{validate:(0, _utils.assertNodeType)("Expression")},consequent:{validate:(0, _utils.assertNodeType)("Expression")},alternate:{validate:(0, _utils.assertNodeType)("Expression")}},aliases:["Expression","Conditional"]});defineType("ContinueStatement",{visitor:["label"],fields:{label:{validate:(0, _utils.assertNodeType)("Identifier"),optional:!0}},aliases:["Statement","Terminatorless","CompletionStatement"]});defineType("DebuggerStatement",{aliases:["Statement"]});defineType("DoWhileStatement",{visitor:["test","body"],fields:{test:{validate:(0, _utils.assertNodeType)("Expression")},body:{validate:(0, _utils.assertNodeType)("Statement")}},aliases:["Statement","BlockParent","Loop","While","Scopable"]});defineType("EmptyStatement",{aliases:["Statement"]});defineType("ExpressionStatement",{visitor:["expression"],fields:{expression:{validate:(0, _utils.assertNodeType)("Expression")}},aliases:["Statement","ExpressionWrapper"]});defineType("File",{builder:["program","comments","tokens"],visitor:["program"],fields:{program:{validate:(0, _utils.assertNodeType)("Program")},comments:{validate:process.env.BABEL_TYPES_8_BREAKING?(0, _utils.assertEach)((0, _utils.assertNodeType)("CommentBlock","CommentLine")):Object.assign(()=>{},{each:{oneOfNodeTypes:["CommentBlock","CommentLine"]}}),optional:!0},tokens:{validate:(0, _utils.assertEach)(Object.assign(()=>{},{type:"any"})),optional:!0}}});defineType("ForInStatement",{visitor:["left","right","body"],aliases:["Scopable","Statement","For","BlockParent","Loop","ForXStatement"],fields:{left:{validate:process.env.BABEL_TYPES_8_BREAKING?(0, _utils.assertNodeType)("VariableDeclaration","Identifier","MemberExpression","ArrayPattern","ObjectPattern","TSAsExpression","TSSatisfiesExpression","TSTypeAssertion","TSNonNullExpression"):(0, _utils.assertNodeType)("VariableDeclaration","LVal")},right:{validate:(0, _utils.assertNodeType)("Expression")},body:{validate:(0, _utils.assertNodeType)("Statement")}}});defineType("ForStatement",{visitor:["init","test","update","body"],aliases:["Scopable","Statement","For","BlockParent","Loop"],fields:{init:{validate:(0, _utils.assertNodeType)("VariableDeclaration","Expression"),optional:!0},test:{validate:(0, _utils.assertNodeType)("Expression"),optional:!0},update:{validate:(0, _utils.assertNodeType)("Expression"),optional:!0},body:{validate:(0, _utils.assertNodeType)("Statement")}}});var functionCommon=()=>({params:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("Identifier","Pattern","RestElement")))},generator:{default:!1},async:{default:!1}});exports.functionCommon=functionCommon;var functionTypeAnnotationCommon=()=>({returnType:{validate:(0, _utils.assertNodeType)("TypeAnnotation","TSTypeAnnotation","Noop"),optional:!0},typeParameters:{validate:(0, _utils.assertNodeType)("TypeParameterDeclaration","TSTypeParameterDeclaration","Noop"),optional:!0}});exports.functionTypeAnnotationCommon=functionTypeAnnotationCommon;var functionDeclarationCommon=()=>Object.assign({},functionCommon(),{declare:{validate:(0, _utils.assertValueType)("boolean"),optional:!0},id:{validate:(0, _utils.assertNodeType)("Identifier"),optional:!0}});exports.functionDeclarationCommon=functionDeclarationCommon;defineType("FunctionDeclaration",{builder:["id","params","body","generator","async"],visitor:["id","params","body","returnType","typeParameters"],fields:Object.assign({},functionDeclarationCommon(),functionTypeAnnotationCommon(),{body:{validate:(0, _utils.assertNodeType)("BlockStatement")},predicate:{validate:(0, _utils.assertNodeType)("DeclaredPredicate","InferredPredicate"),optional:!0}}),aliases:["Scopable","Function","BlockParent","FunctionParent","Statement","Pureish","Declaration"],validate:function(){if(!process.env.BABEL_TYPES_8_BREAKING)return ()=>{};let identifier2=(0, _utils.assertNodeType)("Identifier");return function(parent,key,node){(0, _is.default)("ExportDefaultDeclaration",parent)||identifier2(node,"id",node.id);}}()});defineType("FunctionExpression",{inherits:"FunctionDeclaration",aliases:["Scopable","Function","BlockParent","FunctionParent","Expression","Pureish"],fields:Object.assign({},functionCommon(),functionTypeAnnotationCommon(),{id:{validate:(0, _utils.assertNodeType)("Identifier"),optional:!0},body:{validate:(0, _utils.assertNodeType)("BlockStatement")},predicate:{validate:(0, _utils.assertNodeType)("DeclaredPredicate","InferredPredicate"),optional:!0}})});var patternLikeCommon=()=>({typeAnnotation:{validate:(0, _utils.assertNodeType)("TypeAnnotation","TSTypeAnnotation","Noop"),optional:!0},optional:{validate:(0, _utils.assertValueType)("boolean"),optional:!0},decorators:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("Decorator"))),optional:!0}});exports.patternLikeCommon=patternLikeCommon;defineType("Identifier",{builder:["name"],visitor:["typeAnnotation","decorators"],aliases:["Expression","PatternLike","LVal","TSEntityName"],fields:Object.assign({},patternLikeCommon(),{name:{validate:(0, _utils.chain)((0, _utils.assertValueType)("string"),Object.assign(function(node,key,val){if(process.env.BABEL_TYPES_8_BREAKING&&!(0, _isValidIdentifier.default)(val,!1))throw new TypeError(`"${val}" is not a valid identifier name`)},{type:"string"}))}}),validate(parent,key,node){if(!process.env.BABEL_TYPES_8_BREAKING)return;let match=/\.(\w+)$/.exec(key);if(!match)return;let[,parentKey]=match,nonComp={computed:!1};if(parentKey==="property"){if((0, _is.default)("MemberExpression",parent,nonComp)||(0, _is.default)("OptionalMemberExpression",parent,nonComp))return}else if(parentKey==="key"){if((0, _is.default)("Property",parent,nonComp)||(0, _is.default)("Method",parent,nonComp))return}else if(parentKey==="exported"){if((0, _is.default)("ExportSpecifier",parent))return}else if(parentKey==="imported"){if((0, _is.default)("ImportSpecifier",parent,{imported:node}))return}else if(parentKey==="meta"&&(0, _is.default)("MetaProperty",parent,{meta:node}))return;if(((0, _helperValidatorIdentifier.isKeyword)(node.name)||(0, _helperValidatorIdentifier.isReservedWord)(node.name,!1))&&node.name!=="this")throw new TypeError(`"${node.name}" is not a valid identifier`)}});defineType("IfStatement",{visitor:["test","consequent","alternate"],aliases:["Statement","Conditional"],fields:{test:{validate:(0, _utils.assertNodeType)("Expression")},consequent:{validate:(0, _utils.assertNodeType)("Statement")},alternate:{optional:!0,validate:(0, _utils.assertNodeType)("Statement")}}});defineType("LabeledStatement",{visitor:["label","body"],aliases:["Statement"],fields:{label:{validate:(0, _utils.assertNodeType)("Identifier")},body:{validate:(0, _utils.assertNodeType)("Statement")}}});defineType("StringLiteral",{builder:["value"],fields:{value:{validate:(0, _utils.assertValueType)("string")}},aliases:["Expression","Pureish","Literal","Immutable"]});defineType("NumericLiteral",{builder:["value"],deprecatedAlias:"NumberLiteral",fields:{value:{validate:(0, _utils.chain)((0, _utils.assertValueType)("number"),Object.assign(function(node,key,val){},{type:"number"}))}},aliases:["Expression","Pureish","Literal","Immutable"]});defineType("NullLiteral",{aliases:["Expression","Pureish","Literal","Immutable"]});defineType("BooleanLiteral",{builder:["value"],fields:{value:{validate:(0, _utils.assertValueType)("boolean")}},aliases:["Expression","Pureish","Literal","Immutable"]});defineType("RegExpLiteral",{builder:["pattern","flags"],deprecatedAlias:"RegexLiteral",aliases:["Expression","Pureish","Literal"],fields:{pattern:{validate:(0, _utils.assertValueType)("string")},flags:{validate:(0, _utils.chain)((0, _utils.assertValueType)("string"),Object.assign(function(node,key,val){if(!process.env.BABEL_TYPES_8_BREAKING)return;let invalid=/[^gimsuy]/.exec(val);if(invalid)throw new TypeError(`"${invalid[0]}" is not a valid RegExp flag`)},{type:"string"})),default:""}}});defineType("LogicalExpression",{builder:["operator","left","right"],visitor:["left","right"],aliases:["Binary","Expression"],fields:{operator:{validate:(0, _utils.assertOneOf)(..._index.LOGICAL_OPERATORS)},left:{validate:(0, _utils.assertNodeType)("Expression")},right:{validate:(0, _utils.assertNodeType)("Expression")}}});defineType("MemberExpression",{builder:["object","property","computed",...process.env.BABEL_TYPES_8_BREAKING?[]:["optional"]],visitor:["object","property"],aliases:["Expression","LVal"],fields:Object.assign({object:{validate:(0, _utils.assertNodeType)("Expression","Super")},property:{validate:function(){let normal2=(0, _utils.assertNodeType)("Identifier","PrivateName"),computed=(0, _utils.assertNodeType)("Expression"),validator=function(node,key,val){(node.computed?computed:normal2)(node,key,val);};return validator.oneOfNodeTypes=["Expression","Identifier","PrivateName"],validator}()},computed:{default:!1}},process.env.BABEL_TYPES_8_BREAKING?{}:{optional:{validate:(0, _utils.assertOneOf)(!0,!1),optional:!0}})});defineType("NewExpression",{inherits:"CallExpression"});defineType("Program",{visitor:["directives","body"],builder:["body","directives","sourceType","interpreter"],fields:{sourceType:{validate:(0, _utils.assertOneOf)("script","module"),default:"script"},interpreter:{validate:(0, _utils.assertNodeType)("InterpreterDirective"),default:null,optional:!0},directives:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("Directive"))),default:[]},body:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("Statement")))}},aliases:["Scopable","BlockParent","Block"]});defineType("ObjectExpression",{visitor:["properties"],aliases:["Expression"],fields:{properties:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("ObjectMethod","ObjectProperty","SpreadElement")))}}});defineType("ObjectMethod",{builder:["kind","key","params","body","computed","generator","async"],fields:Object.assign({},functionCommon(),functionTypeAnnotationCommon(),{kind:Object.assign({validate:(0, _utils.assertOneOf)("method","get","set")},process.env.BABEL_TYPES_8_BREAKING?{}:{default:"method"}),computed:{default:!1},key:{validate:function(){let normal2=(0, _utils.assertNodeType)("Identifier","StringLiteral","NumericLiteral","BigIntLiteral"),computed=(0, _utils.assertNodeType)("Expression"),validator=function(node,key,val){(node.computed?computed:normal2)(node,key,val);};return validator.oneOfNodeTypes=["Expression","Identifier","StringLiteral","NumericLiteral","BigIntLiteral"],validator}()},decorators:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("Decorator"))),optional:!0},body:{validate:(0, _utils.assertNodeType)("BlockStatement")}}),visitor:["key","params","body","decorators","returnType","typeParameters"],aliases:["UserWhitespacable","Function","Scopable","BlockParent","FunctionParent","Method","ObjectMember"]});defineType("ObjectProperty",{builder:["key","value","computed","shorthand",...process.env.BABEL_TYPES_8_BREAKING?[]:["decorators"]],fields:{computed:{default:!1},key:{validate:function(){let normal2=(0, _utils.assertNodeType)("Identifier","StringLiteral","NumericLiteral","BigIntLiteral","DecimalLiteral","PrivateName"),computed=(0, _utils.assertNodeType)("Expression");return Object.assign(function(node,key,val){(node.computed?computed:normal2)(node,key,val);},{oneOfNodeTypes:["Expression","Identifier","StringLiteral","NumericLiteral","BigIntLiteral","DecimalLiteral","PrivateName"]})}()},value:{validate:(0, _utils.assertNodeType)("Expression","PatternLike")},shorthand:{validate:(0, _utils.chain)((0, _utils.assertValueType)("boolean"),Object.assign(function(node,key,val){if(process.env.BABEL_TYPES_8_BREAKING&&val&&node.computed)throw new TypeError("Property shorthand of ObjectProperty cannot be true if computed is true")},{type:"boolean"}),function(node,key,val){if(process.env.BABEL_TYPES_8_BREAKING&&val&&!(0, _is.default)("Identifier",node.key))throw new TypeError("Property shorthand of ObjectProperty cannot be true if key is not an Identifier")}),default:!1},decorators:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("Decorator"))),optional:!0}},visitor:["key","value","decorators"],aliases:["UserWhitespacable","Property","ObjectMember"],validate:function(){let pattern=(0, _utils.assertNodeType)("Identifier","Pattern","TSAsExpression","TSSatisfiesExpression","TSNonNullExpression","TSTypeAssertion"),expression=(0, _utils.assertNodeType)("Expression");return function(parent,key,node){if(!process.env.BABEL_TYPES_8_BREAKING)return;((0, _is.default)("ObjectPattern",parent)?pattern:expression)(node,"value",node.value);}}()});defineType("RestElement",{visitor:["argument","typeAnnotation"],builder:["argument"],aliases:["LVal","PatternLike"],deprecatedAlias:"RestProperty",fields:Object.assign({},patternLikeCommon(),{argument:{validate:process.env.BABEL_TYPES_8_BREAKING?(0, _utils.assertNodeType)("Identifier","ArrayPattern","ObjectPattern","MemberExpression","TSAsExpression","TSSatisfiesExpression","TSTypeAssertion","TSNonNullExpression"):(0, _utils.assertNodeType)("LVal")}}),validate(parent,key){if(!process.env.BABEL_TYPES_8_BREAKING)return;let match=/(\w+)\[(\d+)\]/.exec(key);if(!match)throw new Error("Internal Babel error: malformed key.");let[,listKey,index]=match;if(parent[listKey].length>+index+1)throw new TypeError(`RestElement must be last element of ${listKey}`)}});defineType("ReturnStatement",{visitor:["argument"],aliases:["Statement","Terminatorless","CompletionStatement"],fields:{argument:{validate:(0, _utils.assertNodeType)("Expression"),optional:!0}}});defineType("SequenceExpression",{visitor:["expressions"],fields:{expressions:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("Expression")))}},aliases:["Expression"]});defineType("ParenthesizedExpression",{visitor:["expression"],aliases:["Expression","ExpressionWrapper"],fields:{expression:{validate:(0, _utils.assertNodeType)("Expression")}}});defineType("SwitchCase",{visitor:["test","consequent"],fields:{test:{validate:(0, _utils.assertNodeType)("Expression"),optional:!0},consequent:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("Statement")))}}});defineType("SwitchStatement",{visitor:["discriminant","cases"],aliases:["Statement","BlockParent","Scopable"],fields:{discriminant:{validate:(0, _utils.assertNodeType)("Expression")},cases:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("SwitchCase")))}}});defineType("ThisExpression",{aliases:["Expression"]});defineType("ThrowStatement",{visitor:["argument"],aliases:["Statement","Terminatorless","CompletionStatement"],fields:{argument:{validate:(0, _utils.assertNodeType)("Expression")}}});defineType("TryStatement",{visitor:["block","handler","finalizer"],aliases:["Statement"],fields:{block:{validate:(0, _utils.chain)((0, _utils.assertNodeType)("BlockStatement"),Object.assign(function(node){if(process.env.BABEL_TYPES_8_BREAKING&&!node.handler&&!node.finalizer)throw new TypeError("TryStatement expects either a handler or finalizer, or both")},{oneOfNodeTypes:["BlockStatement"]}))},handler:{optional:!0,validate:(0, _utils.assertNodeType)("CatchClause")},finalizer:{optional:!0,validate:(0, _utils.assertNodeType)("BlockStatement")}}});defineType("UnaryExpression",{builder:["operator","argument","prefix"],fields:{prefix:{default:!0},argument:{validate:(0, _utils.assertNodeType)("Expression")},operator:{validate:(0, _utils.assertOneOf)(..._index.UNARY_OPERATORS)}},visitor:["argument"],aliases:["UnaryLike","Expression"]});defineType("UpdateExpression",{builder:["operator","argument","prefix"],fields:{prefix:{default:!1},argument:{validate:process.env.BABEL_TYPES_8_BREAKING?(0, _utils.assertNodeType)("Identifier","MemberExpression"):(0, _utils.assertNodeType)("Expression")},operator:{validate:(0, _utils.assertOneOf)(..._index.UPDATE_OPERATORS)}},visitor:["argument"],aliases:["Expression"]});defineType("VariableDeclaration",{builder:["kind","declarations"],visitor:["declarations"],aliases:["Statement","Declaration"],fields:{declare:{validate:(0, _utils.assertValueType)("boolean"),optional:!0},kind:{validate:(0, _utils.assertOneOf)("var","let","const","using","await using")},declarations:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("VariableDeclarator")))}},validate(parent,key,node){if(process.env.BABEL_TYPES_8_BREAKING&&(0, _is.default)("ForXStatement",parent,{left:node})&&node.declarations.length!==1)throw new TypeError(`Exactly one VariableDeclarator is required in the VariableDeclaration of a ${parent.type}`)}});defineType("VariableDeclarator",{visitor:["id","init"],fields:{id:{validate:function(){if(!process.env.BABEL_TYPES_8_BREAKING)return (0, _utils.assertNodeType)("LVal");let normal2=(0, _utils.assertNodeType)("Identifier","ArrayPattern","ObjectPattern"),without=(0, _utils.assertNodeType)("Identifier");return function(node,key,val){(node.init?normal2:without)(node,key,val);}}()},definite:{optional:!0,validate:(0, _utils.assertValueType)("boolean")},init:{optional:!0,validate:(0, _utils.assertNodeType)("Expression")}}});defineType("WhileStatement",{visitor:["test","body"],aliases:["Statement","BlockParent","Loop","While","Scopable"],fields:{test:{validate:(0, _utils.assertNodeType)("Expression")},body:{validate:(0, _utils.assertNodeType)("Statement")}}});defineType("WithStatement",{visitor:["object","body"],aliases:["Statement"],fields:{object:{validate:(0, _utils.assertNodeType)("Expression")},body:{validate:(0, _utils.assertNodeType)("Statement")}}});defineType("AssignmentPattern",{visitor:["left","right","decorators"],builder:["left","right"],aliases:["Pattern","PatternLike","LVal"],fields:Object.assign({},patternLikeCommon(),{left:{validate:(0, _utils.assertNodeType)("Identifier","ObjectPattern","ArrayPattern","MemberExpression","TSAsExpression","TSSatisfiesExpression","TSTypeAssertion","TSNonNullExpression")},right:{validate:(0, _utils.assertNodeType)("Expression")},decorators:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("Decorator"))),optional:!0}})});defineType("ArrayPattern",{visitor:["elements","typeAnnotation"],builder:["elements"],aliases:["Pattern","PatternLike","LVal"],fields:Object.assign({},patternLikeCommon(),{elements:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeOrValueType)("null","PatternLike","LVal")))}})});defineType("ArrowFunctionExpression",{builder:["params","body","async"],visitor:["params","body","returnType","typeParameters"],aliases:["Scopable","Function","BlockParent","FunctionParent","Expression","Pureish"],fields:Object.assign({},functionCommon(),functionTypeAnnotationCommon(),{expression:{validate:(0, _utils.assertValueType)("boolean")},body:{validate:(0, _utils.assertNodeType)("BlockStatement","Expression")},predicate:{validate:(0, _utils.assertNodeType)("DeclaredPredicate","InferredPredicate"),optional:!0}})});defineType("ClassBody",{visitor:["body"],fields:{body:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("ClassMethod","ClassPrivateMethod","ClassProperty","ClassPrivateProperty","ClassAccessorProperty","TSDeclareMethod","TSIndexSignature","StaticBlock")))}}});defineType("ClassExpression",{builder:["id","superClass","body","decorators"],visitor:["id","body","superClass","mixins","typeParameters","superTypeParameters","implements","decorators"],aliases:["Scopable","Class","Expression"],fields:{id:{validate:(0, _utils.assertNodeType)("Identifier"),optional:!0},typeParameters:{validate:(0, _utils.assertNodeType)("TypeParameterDeclaration","TSTypeParameterDeclaration","Noop"),optional:!0},body:{validate:(0, _utils.assertNodeType)("ClassBody")},superClass:{optional:!0,validate:(0, _utils.assertNodeType)("Expression")},superTypeParameters:{validate:(0, _utils.assertNodeType)("TypeParameterInstantiation","TSTypeParameterInstantiation"),optional:!0},implements:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("TSExpressionWithTypeArguments","ClassImplements"))),optional:!0},decorators:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("Decorator"))),optional:!0},mixins:{validate:(0, _utils.assertNodeType)("InterfaceExtends"),optional:!0}}});defineType("ClassDeclaration",{inherits:"ClassExpression",aliases:["Scopable","Class","Statement","Declaration"],fields:{id:{validate:(0, _utils.assertNodeType)("Identifier"),optional:!0},typeParameters:{validate:(0, _utils.assertNodeType)("TypeParameterDeclaration","TSTypeParameterDeclaration","Noop"),optional:!0},body:{validate:(0, _utils.assertNodeType)("ClassBody")},superClass:{optional:!0,validate:(0, _utils.assertNodeType)("Expression")},superTypeParameters:{validate:(0, _utils.assertNodeType)("TypeParameterInstantiation","TSTypeParameterInstantiation"),optional:!0},implements:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("TSExpressionWithTypeArguments","ClassImplements"))),optional:!0},decorators:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("Decorator"))),optional:!0},mixins:{validate:(0, _utils.assertNodeType)("InterfaceExtends"),optional:!0},declare:{validate:(0, _utils.assertValueType)("boolean"),optional:!0},abstract:{validate:(0, _utils.assertValueType)("boolean"),optional:!0}},validate:function(){let identifier2=(0, _utils.assertNodeType)("Identifier");return function(parent,key,node){process.env.BABEL_TYPES_8_BREAKING&&((0, _is.default)("ExportDefaultDeclaration",parent)||identifier2(node,"id",node.id));}}()});defineType("ExportAllDeclaration",{builder:["source"],visitor:["source","attributes","assertions"],aliases:["Statement","Declaration","ImportOrExportDeclaration","ExportDeclaration"],fields:{source:{validate:(0, _utils.assertNodeType)("StringLiteral")},exportKind:(0, _utils.validateOptional)((0, _utils.assertOneOf)("type","value")),attributes:{optional:!0,validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("ImportAttribute")))},assertions:{optional:!0,validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("ImportAttribute")))}}});defineType("ExportDefaultDeclaration",{visitor:["declaration"],aliases:["Statement","Declaration","ImportOrExportDeclaration","ExportDeclaration"],fields:{declaration:{validate:(0, _utils.assertNodeType)("TSDeclareFunction","FunctionDeclaration","ClassDeclaration","Expression")},exportKind:(0, _utils.validateOptional)((0, _utils.assertOneOf)("value"))}});defineType("ExportNamedDeclaration",{builder:["declaration","specifiers","source"],visitor:["declaration","specifiers","source","attributes","assertions"],aliases:["Statement","Declaration","ImportOrExportDeclaration","ExportDeclaration"],fields:{declaration:{optional:!0,validate:(0, _utils.chain)((0, _utils.assertNodeType)("Declaration"),Object.assign(function(node,key,val){if(process.env.BABEL_TYPES_8_BREAKING&&val&&node.specifiers.length)throw new TypeError("Only declaration or specifiers is allowed on ExportNamedDeclaration")},{oneOfNodeTypes:["Declaration"]}),function(node,key,val){if(process.env.BABEL_TYPES_8_BREAKING&&val&&node.source)throw new TypeError("Cannot export a declaration from a source")})},attributes:{optional:!0,validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("ImportAttribute")))},assertions:{optional:!0,validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("ImportAttribute")))},specifiers:{default:[],validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)(function(){let sourced=(0, _utils.assertNodeType)("ExportSpecifier","ExportDefaultSpecifier","ExportNamespaceSpecifier"),sourceless=(0, _utils.assertNodeType)("ExportSpecifier");return process.env.BABEL_TYPES_8_BREAKING?function(node,key,val){(node.source?sourced:sourceless)(node,key,val);}:sourced}()))},source:{validate:(0, _utils.assertNodeType)("StringLiteral"),optional:!0},exportKind:(0, _utils.validateOptional)((0, _utils.assertOneOf)("type","value"))}});defineType("ExportSpecifier",{visitor:["local","exported"],aliases:["ModuleSpecifier"],fields:{local:{validate:(0, _utils.assertNodeType)("Identifier")},exported:{validate:(0, _utils.assertNodeType)("Identifier","StringLiteral")},exportKind:{validate:(0, _utils.assertOneOf)("type","value"),optional:!0}}});defineType("ForOfStatement",{visitor:["left","right","body"],builder:["left","right","body","await"],aliases:["Scopable","Statement","For","BlockParent","Loop","ForXStatement"],fields:{left:{validate:function(){if(!process.env.BABEL_TYPES_8_BREAKING)return (0, _utils.assertNodeType)("VariableDeclaration","LVal");let declaration=(0, _utils.assertNodeType)("VariableDeclaration"),lval=(0, _utils.assertNodeType)("Identifier","MemberExpression","ArrayPattern","ObjectPattern","TSAsExpression","TSSatisfiesExpression","TSTypeAssertion","TSNonNullExpression");return function(node,key,val){(0, _is.default)("VariableDeclaration",val)?declaration(node,key,val):lval(node,key,val);}}()},right:{validate:(0, _utils.assertNodeType)("Expression")},body:{validate:(0, _utils.assertNodeType)("Statement")},await:{default:!1}}});defineType("ImportDeclaration",{builder:["specifiers","source"],visitor:["specifiers","source","attributes","assertions"],aliases:["Statement","Declaration","ImportOrExportDeclaration"],fields:{attributes:{optional:!0,validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("ImportAttribute")))},assertions:{optional:!0,validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("ImportAttribute")))},module:{optional:!0,validate:(0, _utils.assertValueType)("boolean")},phase:{default:null,validate:(0, _utils.assertOneOf)("source","defer")},specifiers:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("ImportSpecifier","ImportDefaultSpecifier","ImportNamespaceSpecifier")))},source:{validate:(0, _utils.assertNodeType)("StringLiteral")},importKind:{validate:(0, _utils.assertOneOf)("type","typeof","value"),optional:!0}}});defineType("ImportDefaultSpecifier",{visitor:["local"],aliases:["ModuleSpecifier"],fields:{local:{validate:(0, _utils.assertNodeType)("Identifier")}}});defineType("ImportNamespaceSpecifier",{visitor:["local"],aliases:["ModuleSpecifier"],fields:{local:{validate:(0, _utils.assertNodeType)("Identifier")}}});defineType("ImportSpecifier",{visitor:["local","imported"],aliases:["ModuleSpecifier"],fields:{local:{validate:(0, _utils.assertNodeType)("Identifier")},imported:{validate:(0, _utils.assertNodeType)("Identifier","StringLiteral")},importKind:{validate:(0, _utils.assertOneOf)("type","typeof","value"),optional:!0}}});defineType("ImportExpression",{visitor:["source","options"],aliases:["Expression"],fields:{phase:{default:null,validate:(0, _utils.assertOneOf)("source","defer")},source:{validate:(0, _utils.assertNodeType)("Expression")},options:{validate:(0, _utils.assertNodeType)("Expression"),optional:!0}}});defineType("MetaProperty",{visitor:["meta","property"],aliases:["Expression"],fields:{meta:{validate:(0, _utils.chain)((0, _utils.assertNodeType)("Identifier"),Object.assign(function(node,key,val){if(!process.env.BABEL_TYPES_8_BREAKING)return;let property;switch(val.name){case"function":property="sent";break;case"new":property="target";break;case"import":property="meta";break}if(!(0, _is.default)("Identifier",node.property,{name:property}))throw new TypeError("Unrecognised MetaProperty")},{oneOfNodeTypes:["Identifier"]}))},property:{validate:(0, _utils.assertNodeType)("Identifier")}}});var classMethodOrPropertyCommon=()=>({abstract:{validate:(0, _utils.assertValueType)("boolean"),optional:!0},accessibility:{validate:(0, _utils.assertOneOf)("public","private","protected"),optional:!0},static:{default:!1},override:{default:!1},computed:{default:!1},optional:{validate:(0, _utils.assertValueType)("boolean"),optional:!0},key:{validate:(0, _utils.chain)(function(){let normal2=(0, _utils.assertNodeType)("Identifier","StringLiteral","NumericLiteral","BigIntLiteral"),computed=(0, _utils.assertNodeType)("Expression");return function(node,key,val){(node.computed?computed:normal2)(node,key,val);}}(),(0, _utils.assertNodeType)("Identifier","StringLiteral","NumericLiteral","BigIntLiteral","Expression"))}});exports.classMethodOrPropertyCommon=classMethodOrPropertyCommon;var classMethodOrDeclareMethodCommon=()=>Object.assign({},functionCommon(),classMethodOrPropertyCommon(),{params:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("Identifier","Pattern","RestElement","TSParameterProperty")))},kind:{validate:(0, _utils.assertOneOf)("get","set","method","constructor"),default:"method"},access:{validate:(0, _utils.chain)((0, _utils.assertValueType)("string"),(0, _utils.assertOneOf)("public","private","protected")),optional:!0},decorators:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("Decorator"))),optional:!0}});exports.classMethodOrDeclareMethodCommon=classMethodOrDeclareMethodCommon;defineType("ClassMethod",{aliases:["Function","Scopable","BlockParent","FunctionParent","Method"],builder:["kind","key","params","body","computed","static","generator","async"],visitor:["key","params","body","decorators","returnType","typeParameters"],fields:Object.assign({},classMethodOrDeclareMethodCommon(),functionTypeAnnotationCommon(),{body:{validate:(0, _utils.assertNodeType)("BlockStatement")}})});defineType("ObjectPattern",{visitor:["properties","typeAnnotation","decorators"],builder:["properties"],aliases:["Pattern","PatternLike","LVal"],fields:Object.assign({},patternLikeCommon(),{properties:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("RestElement","ObjectProperty")))}})});defineType("SpreadElement",{visitor:["argument"],aliases:["UnaryLike"],deprecatedAlias:"SpreadProperty",fields:{argument:{validate:(0, _utils.assertNodeType)("Expression")}}});defineType("Super",{aliases:["Expression"]});defineType("TaggedTemplateExpression",{visitor:["tag","quasi","typeParameters"],builder:["tag","quasi"],aliases:["Expression"],fields:{tag:{validate:(0, _utils.assertNodeType)("Expression")},quasi:{validate:(0, _utils.assertNodeType)("TemplateLiteral")},typeParameters:{validate:(0, _utils.assertNodeType)("TypeParameterInstantiation","TSTypeParameterInstantiation"),optional:!0}}});defineType("TemplateElement",{builder:["value","tail"],fields:{value:{validate:(0, _utils.chain)((0, _utils.assertShape)({raw:{validate:(0, _utils.assertValueType)("string")},cooked:{validate:(0, _utils.assertValueType)("string"),optional:!0}}),function(node){let raw=node.value.raw,unterminatedCalled=!1,error=()=>{throw new Error("Internal @babel/types error.")},{str,firstInvalidLoc}=(0, _helperStringParser.readStringContents)("template",raw,0,0,0,{unterminated(){unterminatedCalled=!0;},strictNumericEscape:error,invalidEscapeSequence:error,numericSeparatorInEscapeSequence:error,unexpectedNumericSeparator:error,invalidDigit:error,invalidCodePoint:error});if(!unterminatedCalled)throw new Error("Invalid raw");node.value.cooked=firstInvalidLoc?null:str;})},tail:{default:!1}}});defineType("TemplateLiteral",{visitor:["quasis","expressions"],aliases:["Expression","Literal"],fields:{quasis:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("TemplateElement")))},expressions:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("Expression","TSType")),function(node,key,val){if(node.quasis.length!==val.length+1)throw new TypeError(`Number of ${node.type} quasis should be exactly one more than the number of expressions.
Expected ${val.length+1} quasis but got ${node.quasis.length}`)})}}});defineType("YieldExpression",{builder:["argument","delegate"],visitor:["argument"],aliases:["Expression","Terminatorless"],fields:{delegate:{validate:(0, _utils.chain)((0, _utils.assertValueType)("boolean"),Object.assign(function(node,key,val){if(process.env.BABEL_TYPES_8_BREAKING&&val&&!node.argument)throw new TypeError("Property delegate of YieldExpression cannot be true if there is no argument")},{type:"boolean"})),default:!1},argument:{optional:!0,validate:(0, _utils.assertNodeType)("Expression")}}});defineType("AwaitExpression",{builder:["argument"],visitor:["argument"],aliases:["Expression","Terminatorless"],fields:{argument:{validate:(0, _utils.assertNodeType)("Expression")}}});defineType("Import",{aliases:["Expression"]});defineType("BigIntLiteral",{builder:["value"],fields:{value:{validate:(0, _utils.assertValueType)("string")}},aliases:["Expression","Pureish","Literal","Immutable"]});defineType("ExportNamespaceSpecifier",{visitor:["exported"],aliases:["ModuleSpecifier"],fields:{exported:{validate:(0, _utils.assertNodeType)("Identifier")}}});defineType("OptionalMemberExpression",{builder:["object","property","computed","optional"],visitor:["object","property"],aliases:["Expression"],fields:{object:{validate:(0, _utils.assertNodeType)("Expression")},property:{validate:function(){let normal2=(0, _utils.assertNodeType)("Identifier"),computed=(0, _utils.assertNodeType)("Expression");return Object.assign(function(node,key,val){(node.computed?computed:normal2)(node,key,val);},{oneOfNodeTypes:["Expression","Identifier"]})}()},computed:{default:!1},optional:{validate:process.env.BABEL_TYPES_8_BREAKING?(0, _utils.chain)((0, _utils.assertValueType)("boolean"),(0, _utils.assertOptionalChainStart)()):(0, _utils.assertValueType)("boolean")}}});defineType("OptionalCallExpression",{visitor:["callee","arguments","typeParameters","typeArguments"],builder:["callee","arguments","optional"],aliases:["Expression"],fields:{callee:{validate:(0, _utils.assertNodeType)("Expression")},arguments:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("Expression","SpreadElement","JSXNamespacedName","ArgumentPlaceholder")))},optional:{validate:process.env.BABEL_TYPES_8_BREAKING?(0, _utils.chain)((0, _utils.assertValueType)("boolean"),(0, _utils.assertOptionalChainStart)()):(0, _utils.assertValueType)("boolean")},typeArguments:{validate:(0, _utils.assertNodeType)("TypeParameterInstantiation"),optional:!0},typeParameters:{validate:(0, _utils.assertNodeType)("TSTypeParameterInstantiation"),optional:!0}}});defineType("ClassProperty",{visitor:["key","value","typeAnnotation","decorators"],builder:["key","value","typeAnnotation","decorators","computed","static"],aliases:["Property"],fields:Object.assign({},classMethodOrPropertyCommon(),{value:{validate:(0, _utils.assertNodeType)("Expression"),optional:!0},definite:{validate:(0, _utils.assertValueType)("boolean"),optional:!0},typeAnnotation:{validate:(0, _utils.assertNodeType)("TypeAnnotation","TSTypeAnnotation","Noop"),optional:!0},decorators:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("Decorator"))),optional:!0},readonly:{validate:(0, _utils.assertValueType)("boolean"),optional:!0},declare:{validate:(0, _utils.assertValueType)("boolean"),optional:!0},variance:{validate:(0, _utils.assertNodeType)("Variance"),optional:!0}})});defineType("ClassAccessorProperty",{visitor:["key","value","typeAnnotation","decorators"],builder:["key","value","typeAnnotation","decorators","computed","static"],aliases:["Property","Accessor"],fields:Object.assign({},classMethodOrPropertyCommon(),{key:{validate:(0, _utils.chain)(function(){let normal2=(0, _utils.assertNodeType)("Identifier","StringLiteral","NumericLiteral","BigIntLiteral","PrivateName"),computed=(0, _utils.assertNodeType)("Expression");return function(node,key,val){(node.computed?computed:normal2)(node,key,val);}}(),(0, _utils.assertNodeType)("Identifier","StringLiteral","NumericLiteral","BigIntLiteral","Expression","PrivateName"))},value:{validate:(0, _utils.assertNodeType)("Expression"),optional:!0},definite:{validate:(0, _utils.assertValueType)("boolean"),optional:!0},typeAnnotation:{validate:(0, _utils.assertNodeType)("TypeAnnotation","TSTypeAnnotation","Noop"),optional:!0},decorators:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("Decorator"))),optional:!0},readonly:{validate:(0, _utils.assertValueType)("boolean"),optional:!0},declare:{validate:(0, _utils.assertValueType)("boolean"),optional:!0},variance:{validate:(0, _utils.assertNodeType)("Variance"),optional:!0}})});defineType("ClassPrivateProperty",{visitor:["key","value","decorators","typeAnnotation"],builder:["key","value","decorators","static"],aliases:["Property","Private"],fields:{key:{validate:(0, _utils.assertNodeType)("PrivateName")},value:{validate:(0, _utils.assertNodeType)("Expression"),optional:!0},typeAnnotation:{validate:(0, _utils.assertNodeType)("TypeAnnotation","TSTypeAnnotation","Noop"),optional:!0},decorators:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("Decorator"))),optional:!0},static:{validate:(0, _utils.assertValueType)("boolean"),default:!1},readonly:{validate:(0, _utils.assertValueType)("boolean"),optional:!0},definite:{validate:(0, _utils.assertValueType)("boolean"),optional:!0},variance:{validate:(0, _utils.assertNodeType)("Variance"),optional:!0}}});defineType("ClassPrivateMethod",{builder:["kind","key","params","body","static"],visitor:["key","params","body","decorators","returnType","typeParameters"],aliases:["Function","Scopable","BlockParent","FunctionParent","Method","Private"],fields:Object.assign({},classMethodOrDeclareMethodCommon(),functionTypeAnnotationCommon(),{kind:{validate:(0, _utils.assertOneOf)("get","set","method"),default:"method"},key:{validate:(0, _utils.assertNodeType)("PrivateName")},body:{validate:(0, _utils.assertNodeType)("BlockStatement")}})});defineType("PrivateName",{visitor:["id"],aliases:["Private"],fields:{id:{validate:(0, _utils.assertNodeType)("Identifier")}}});defineType("StaticBlock",{visitor:["body"],fields:{body:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("Statement")))}},aliases:["Scopable","BlockParent","FunctionParent"]});}});var require_flow=__commonJS({"../../node_modules/@babel/types/lib/definitions/flow.js"(){var _utils=require_utils(),defineType=(0, _utils.defineAliasedType)("Flow"),defineInterfaceishType=name=>{let isDeclareClass=name==="DeclareClass";defineType(name,{builder:["id","typeParameters","extends","body"],visitor:["id","typeParameters","extends",...isDeclareClass?["mixins","implements"]:[],"body"],aliases:["FlowDeclaration","Statement","Declaration"],fields:Object.assign({id:(0, _utils.validateType)("Identifier"),typeParameters:(0, _utils.validateOptionalType)("TypeParameterDeclaration"),extends:(0, _utils.validateOptional)((0, _utils.arrayOfType)("InterfaceExtends"))},isDeclareClass?{mixins:(0, _utils.validateOptional)((0, _utils.arrayOfType)("InterfaceExtends")),implements:(0, _utils.validateOptional)((0, _utils.arrayOfType)("ClassImplements"))}:{},{body:(0, _utils.validateType)("ObjectTypeAnnotation")})});};defineType("AnyTypeAnnotation",{aliases:["FlowType","FlowBaseAnnotation"]});defineType("ArrayTypeAnnotation",{visitor:["elementType"],aliases:["FlowType"],fields:{elementType:(0, _utils.validateType)("FlowType")}});defineType("BooleanTypeAnnotation",{aliases:["FlowType","FlowBaseAnnotation"]});defineType("BooleanLiteralTypeAnnotation",{builder:["value"],aliases:["FlowType"],fields:{value:(0, _utils.validate)((0, _utils.assertValueType)("boolean"))}});defineType("NullLiteralTypeAnnotation",{aliases:["FlowType","FlowBaseAnnotation"]});defineType("ClassImplements",{visitor:["id","typeParameters"],fields:{id:(0, _utils.validateType)("Identifier"),typeParameters:(0, _utils.validateOptionalType)("TypeParameterInstantiation")}});defineInterfaceishType("DeclareClass");defineType("DeclareFunction",{visitor:["id"],aliases:["FlowDeclaration","Statement","Declaration"],fields:{id:(0, _utils.validateType)("Identifier"),predicate:(0, _utils.validateOptionalType)("DeclaredPredicate")}});defineInterfaceishType("DeclareInterface");defineType("DeclareModule",{builder:["id","body","kind"],visitor:["id","body"],aliases:["FlowDeclaration","Statement","Declaration"],fields:{id:(0, _utils.validateType)(["Identifier","StringLiteral"]),body:(0, _utils.validateType)("BlockStatement"),kind:(0, _utils.validateOptional)((0, _utils.assertOneOf)("CommonJS","ES"))}});defineType("DeclareModuleExports",{visitor:["typeAnnotation"],aliases:["FlowDeclaration","Statement","Declaration"],fields:{typeAnnotation:(0, _utils.validateType)("TypeAnnotation")}});defineType("DeclareTypeAlias",{visitor:["id","typeParameters","right"],aliases:["FlowDeclaration","Statement","Declaration"],fields:{id:(0, _utils.validateType)("Identifier"),typeParameters:(0, _utils.validateOptionalType)("TypeParameterDeclaration"),right:(0, _utils.validateType)("FlowType")}});defineType("DeclareOpaqueType",{visitor:["id","typeParameters","supertype"],aliases:["FlowDeclaration","Statement","Declaration"],fields:{id:(0, _utils.validateType)("Identifier"),typeParameters:(0, _utils.validateOptionalType)("TypeParameterDeclaration"),supertype:(0, _utils.validateOptionalType)("FlowType"),impltype:(0, _utils.validateOptionalType)("FlowType")}});defineType("DeclareVariable",{visitor:["id"],aliases:["FlowDeclaration","Statement","Declaration"],fields:{id:(0, _utils.validateType)("Identifier")}});defineType("DeclareExportDeclaration",{visitor:["declaration","specifiers","source"],aliases:["FlowDeclaration","Statement","Declaration"],fields:{declaration:(0, _utils.validateOptionalType)("Flow"),specifiers:(0, _utils.validateOptional)((0, _utils.arrayOfType)(["ExportSpecifier","ExportNamespaceSpecifier"])),source:(0, _utils.validateOptionalType)("StringLiteral"),default:(0, _utils.validateOptional)((0, _utils.assertValueType)("boolean"))}});defineType("DeclareExportAllDeclaration",{visitor:["source"],aliases:["FlowDeclaration","Statement","Declaration"],fields:{source:(0, _utils.validateType)("StringLiteral"),exportKind:(0, _utils.validateOptional)((0, _utils.assertOneOf)("type","value"))}});defineType("DeclaredPredicate",{visitor:["value"],aliases:["FlowPredicate"],fields:{value:(0, _utils.validateType)("Flow")}});defineType("ExistsTypeAnnotation",{aliases:["FlowType"]});defineType("FunctionTypeAnnotation",{visitor:["typeParameters","params","rest","returnType"],aliases:["FlowType"],fields:{typeParameters:(0, _utils.validateOptionalType)("TypeParameterDeclaration"),params:(0, _utils.validate)((0, _utils.arrayOfType)("FunctionTypeParam")),rest:(0, _utils.validateOptionalType)("FunctionTypeParam"),this:(0, _utils.validateOptionalType)("FunctionTypeParam"),returnType:(0, _utils.validateType)("FlowType")}});defineType("FunctionTypeParam",{visitor:["name","typeAnnotation"],fields:{name:(0, _utils.validateOptionalType)("Identifier"),typeAnnotation:(0, _utils.validateType)("FlowType"),optional:(0, _utils.validateOptional)((0, _utils.assertValueType)("boolean"))}});defineType("GenericTypeAnnotation",{visitor:["id","typeParameters"],aliases:["FlowType"],fields:{id:(0, _utils.validateType)(["Identifier","QualifiedTypeIdentifier"]),typeParameters:(0, _utils.validateOptionalType)("TypeParameterInstantiation")}});defineType("InferredPredicate",{aliases:["FlowPredicate"]});defineType("InterfaceExtends",{visitor:["id","typeParameters"],fields:{id:(0, _utils.validateType)(["Identifier","QualifiedTypeIdentifier"]),typeParameters:(0, _utils.validateOptionalType)("TypeParameterInstantiation")}});defineInterfaceishType("InterfaceDeclaration");defineType("InterfaceTypeAnnotation",{visitor:["extends","body"],aliases:["FlowType"],fields:{extends:(0, _utils.validateOptional)((0, _utils.arrayOfType)("InterfaceExtends")),body:(0, _utils.validateType)("ObjectTypeAnnotation")}});defineType("IntersectionTypeAnnotation",{visitor:["types"],aliases:["FlowType"],fields:{types:(0, _utils.validate)((0, _utils.arrayOfType)("FlowType"))}});defineType("MixedTypeAnnotation",{aliases:["FlowType","FlowBaseAnnotation"]});defineType("EmptyTypeAnnotation",{aliases:["FlowType","FlowBaseAnnotation"]});defineType("NullableTypeAnnotation",{visitor:["typeAnnotation"],aliases:["FlowType"],fields:{typeAnnotation:(0, _utils.validateType)("FlowType")}});defineType("NumberLiteralTypeAnnotation",{builder:["value"],aliases:["FlowType"],fields:{value:(0, _utils.validate)((0, _utils.assertValueType)("number"))}});defineType("NumberTypeAnnotation",{aliases:["FlowType","FlowBaseAnnotation"]});defineType("ObjectTypeAnnotation",{visitor:["properties","indexers","callProperties","internalSlots"],aliases:["FlowType"],builder:["properties","indexers","callProperties","internalSlots","exact"],fields:{properties:(0, _utils.validate)((0, _utils.arrayOfType)(["ObjectTypeProperty","ObjectTypeSpreadProperty"])),indexers:{validate:(0, _utils.arrayOfType)("ObjectTypeIndexer"),optional:!0,default:[]},callProperties:{validate:(0, _utils.arrayOfType)("ObjectTypeCallProperty"),optional:!0,default:[]},internalSlots:{validate:(0, _utils.arrayOfType)("ObjectTypeInternalSlot"),optional:!0,default:[]},exact:{validate:(0, _utils.assertValueType)("boolean"),default:!1},inexact:(0, _utils.validateOptional)((0, _utils.assertValueType)("boolean"))}});defineType("ObjectTypeInternalSlot",{visitor:["id","value","optional","static","method"],aliases:["UserWhitespacable"],fields:{id:(0, _utils.validateType)("Identifier"),value:(0, _utils.validateType)("FlowType"),optional:(0, _utils.validate)((0, _utils.assertValueType)("boolean")),static:(0, _utils.validate)((0, _utils.assertValueType)("boolean")),method:(0, _utils.validate)((0, _utils.assertValueType)("boolean"))}});defineType("ObjectTypeCallProperty",{visitor:["value"],aliases:["UserWhitespacable"],fields:{value:(0, _utils.validateType)("FlowType"),static:(0, _utils.validate)((0, _utils.assertValueType)("boolean"))}});defineType("ObjectTypeIndexer",{visitor:["id","key","value","variance"],aliases:["UserWhitespacable"],fields:{id:(0, _utils.validateOptionalType)("Identifier"),key:(0, _utils.validateType)("FlowType"),value:(0, _utils.validateType)("FlowType"),static:(0, _utils.validate)((0, _utils.assertValueType)("boolean")),variance:(0, _utils.validateOptionalType)("Variance")}});defineType("ObjectTypeProperty",{visitor:["key","value","variance"],aliases:["UserWhitespacable"],fields:{key:(0, _utils.validateType)(["Identifier","StringLiteral"]),value:(0, _utils.validateType)("FlowType"),kind:(0, _utils.validate)((0, _utils.assertOneOf)("init","get","set")),static:(0, _utils.validate)((0, _utils.assertValueType)("boolean")),proto:(0, _utils.validate)((0, _utils.assertValueType)("boolean")),optional:(0, _utils.validate)((0, _utils.assertValueType)("boolean")),variance:(0, _utils.validateOptionalType)("Variance"),method:(0, _utils.validate)((0, _utils.assertValueType)("boolean"))}});defineType("ObjectTypeSpreadProperty",{visitor:["argument"],aliases:["UserWhitespacable"],fields:{argument:(0, _utils.validateType)("FlowType")}});defineType("OpaqueType",{visitor:["id","typeParameters","supertype","impltype"],aliases:["FlowDeclaration","Statement","Declaration"],fields:{id:(0, _utils.validateType)("Identifier"),typeParameters:(0, _utils.validateOptionalType)("TypeParameterDeclaration"),supertype:(0, _utils.validateOptionalType)("FlowType"),impltype:(0, _utils.validateType)("FlowType")}});defineType("QualifiedTypeIdentifier",{visitor:["id","qualification"],fields:{id:(0, _utils.validateType)("Identifier"),qualification:(0, _utils.validateType)(["Identifier","QualifiedTypeIdentifier"])}});defineType("StringLiteralTypeAnnotation",{builder:["value"],aliases:["FlowType"],fields:{value:(0, _utils.validate)((0, _utils.assertValueType)("string"))}});defineType("StringTypeAnnotation",{aliases:["FlowType","FlowBaseAnnotation"]});defineType("SymbolTypeAnnotation",{aliases:["FlowType","FlowBaseAnnotation"]});defineType("ThisTypeAnnotation",{aliases:["FlowType","FlowBaseAnnotation"]});defineType("TupleTypeAnnotation",{visitor:["types"],aliases:["FlowType"],fields:{types:(0, _utils.validate)((0, _utils.arrayOfType)("FlowType"))}});defineType("TypeofTypeAnnotation",{visitor:["argument"],aliases:["FlowType"],fields:{argument:(0, _utils.validateType)("FlowType")}});defineType("TypeAlias",{visitor:["id","typeParameters","right"],aliases:["FlowDeclaration","Statement","Declaration"],fields:{id:(0, _utils.validateType)("Identifier"),typeParameters:(0, _utils.validateOptionalType)("TypeParameterDeclaration"),right:(0, _utils.validateType)("FlowType")}});defineType("TypeAnnotation",{visitor:["typeAnnotation"],fields:{typeAnnotation:(0, _utils.validateType)("FlowType")}});defineType("TypeCastExpression",{visitor:["expression","typeAnnotation"],aliases:["ExpressionWrapper","Expression"],fields:{expression:(0, _utils.validateType)("Expression"),typeAnnotation:(0, _utils.validateType)("TypeAnnotation")}});defineType("TypeParameter",{visitor:["bound","default","variance"],fields:{name:(0, _utils.validate)((0, _utils.assertValueType)("string")),bound:(0, _utils.validateOptionalType)("TypeAnnotation"),default:(0, _utils.validateOptionalType)("FlowType"),variance:(0, _utils.validateOptionalType)("Variance")}});defineType("TypeParameterDeclaration",{visitor:["params"],fields:{params:(0, _utils.validate)((0, _utils.arrayOfType)("TypeParameter"))}});defineType("TypeParameterInstantiation",{visitor:["params"],fields:{params:(0, _utils.validate)((0, _utils.arrayOfType)("FlowType"))}});defineType("UnionTypeAnnotation",{visitor:["types"],aliases:["FlowType"],fields:{types:(0, _utils.validate)((0, _utils.arrayOfType)("FlowType"))}});defineType("Variance",{builder:["kind"],fields:{kind:(0, _utils.validate)((0, _utils.assertOneOf)("minus","plus"))}});defineType("VoidTypeAnnotation",{aliases:["FlowType","FlowBaseAnnotation"]});defineType("EnumDeclaration",{aliases:["Statement","Declaration"],visitor:["id","body"],fields:{id:(0, _utils.validateType)("Identifier"),body:(0, _utils.validateType)(["EnumBooleanBody","EnumNumberBody","EnumStringBody","EnumSymbolBody"])}});defineType("EnumBooleanBody",{aliases:["EnumBody"],visitor:["members"],fields:{explicitType:(0, _utils.validate)((0, _utils.assertValueType)("boolean")),members:(0, _utils.validateArrayOfType)("EnumBooleanMember"),hasUnknownMembers:(0, _utils.validate)((0, _utils.assertValueType)("boolean"))}});defineType("EnumNumberBody",{aliases:["EnumBody"],visitor:["members"],fields:{explicitType:(0, _utils.validate)((0, _utils.assertValueType)("boolean")),members:(0, _utils.validateArrayOfType)("EnumNumberMember"),hasUnknownMembers:(0, _utils.validate)((0, _utils.assertValueType)("boolean"))}});defineType("EnumStringBody",{aliases:["EnumBody"],visitor:["members"],fields:{explicitType:(0, _utils.validate)((0, _utils.assertValueType)("boolean")),members:(0, _utils.validateArrayOfType)(["EnumStringMember","EnumDefaultedMember"]),hasUnknownMembers:(0, _utils.validate)((0, _utils.assertValueType)("boolean"))}});defineType("EnumSymbolBody",{aliases:["EnumBody"],visitor:["members"],fields:{members:(0, _utils.validateArrayOfType)("EnumDefaultedMember"),hasUnknownMembers:(0, _utils.validate)((0, _utils.assertValueType)("boolean"))}});defineType("EnumBooleanMember",{aliases:["EnumMember"],visitor:["id"],fields:{id:(0, _utils.validateType)("Identifier"),init:(0, _utils.validateType)("BooleanLiteral")}});defineType("EnumNumberMember",{aliases:["EnumMember"],visitor:["id","init"],fields:{id:(0, _utils.validateType)("Identifier"),init:(0, _utils.validateType)("NumericLiteral")}});defineType("EnumStringMember",{aliases:["EnumMember"],visitor:["id","init"],fields:{id:(0, _utils.validateType)("Identifier"),init:(0, _utils.validateType)("StringLiteral")}});defineType("EnumDefaultedMember",{aliases:["EnumMember"],visitor:["id"],fields:{id:(0, _utils.validateType)("Identifier")}});defineType("IndexedAccessType",{visitor:["objectType","indexType"],aliases:["FlowType"],fields:{objectType:(0, _utils.validateType)("FlowType"),indexType:(0, _utils.validateType)("FlowType")}});defineType("OptionalIndexedAccessType",{visitor:["objectType","indexType"],aliases:["FlowType"],fields:{objectType:(0, _utils.validateType)("FlowType"),indexType:(0, _utils.validateType)("FlowType"),optional:(0, _utils.validate)((0, _utils.assertValueType)("boolean"))}});}});var require_jsx=__commonJS({"../../node_modules/@babel/types/lib/definitions/jsx.js"(){var _utils=require_utils(),defineType=(0, _utils.defineAliasedType)("JSX");defineType("JSXAttribute",{visitor:["name","value"],aliases:["Immutable"],fields:{name:{validate:(0, _utils.assertNodeType)("JSXIdentifier","JSXNamespacedName")},value:{optional:!0,validate:(0, _utils.assertNodeType)("JSXElement","JSXFragment","StringLiteral","JSXExpressionContainer")}}});defineType("JSXClosingElement",{visitor:["name"],aliases:["Immutable"],fields:{name:{validate:(0, _utils.assertNodeType)("JSXIdentifier","JSXMemberExpression","JSXNamespacedName")}}});defineType("JSXElement",{builder:["openingElement","closingElement","children","selfClosing"],visitor:["openingElement","children","closingElement"],aliases:["Immutable","Expression"],fields:Object.assign({openingElement:{validate:(0, _utils.assertNodeType)("JSXOpeningElement")},closingElement:{optional:!0,validate:(0, _utils.assertNodeType)("JSXClosingElement")},children:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("JSXText","JSXExpressionContainer","JSXSpreadChild","JSXElement","JSXFragment")))}},{selfClosing:{validate:(0, _utils.assertValueType)("boolean"),optional:!0}})});defineType("JSXEmptyExpression",{});defineType("JSXExpressionContainer",{visitor:["expression"],aliases:["Immutable"],fields:{expression:{validate:(0, _utils.assertNodeType)("Expression","JSXEmptyExpression")}}});defineType("JSXSpreadChild",{visitor:["expression"],aliases:["Immutable"],fields:{expression:{validate:(0, _utils.assertNodeType)("Expression")}}});defineType("JSXIdentifier",{builder:["name"],fields:{name:{validate:(0, _utils.assertValueType)("string")}}});defineType("JSXMemberExpression",{visitor:["object","property"],fields:{object:{validate:(0, _utils.assertNodeType)("JSXMemberExpression","JSXIdentifier")},property:{validate:(0, _utils.assertNodeType)("JSXIdentifier")}}});defineType("JSXNamespacedName",{visitor:["namespace","name"],fields:{namespace:{validate:(0, _utils.assertNodeType)("JSXIdentifier")},name:{validate:(0, _utils.assertNodeType)("JSXIdentifier")}}});defineType("JSXOpeningElement",{builder:["name","attributes","selfClosing"],visitor:["name","attributes"],aliases:["Immutable"],fields:{name:{validate:(0, _utils.assertNodeType)("JSXIdentifier","JSXMemberExpression","JSXNamespacedName")},selfClosing:{default:!1},attributes:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("JSXAttribute","JSXSpreadAttribute")))},typeParameters:{validate:(0, _utils.assertNodeType)("TypeParameterInstantiation","TSTypeParameterInstantiation"),optional:!0}}});defineType("JSXSpreadAttribute",{visitor:["argument"],fields:{argument:{validate:(0, _utils.assertNodeType)("Expression")}}});defineType("JSXText",{aliases:["Immutable"],builder:["value"],fields:{value:{validate:(0, _utils.assertValueType)("string")}}});defineType("JSXFragment",{builder:["openingFragment","closingFragment","children"],visitor:["openingFragment","children","closingFragment"],aliases:["Immutable","Expression"],fields:{openingFragment:{validate:(0, _utils.assertNodeType)("JSXOpeningFragment")},closingFragment:{validate:(0, _utils.assertNodeType)("JSXClosingFragment")},children:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("JSXText","JSXExpressionContainer","JSXSpreadChild","JSXElement","JSXFragment")))}}});defineType("JSXOpeningFragment",{aliases:["Immutable"]});defineType("JSXClosingFragment",{aliases:["Immutable"]});}});var require_placeholders=__commonJS({"../../node_modules/@babel/types/lib/definitions/placeholders.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.PLACEHOLDERS_FLIPPED_ALIAS=exports.PLACEHOLDERS_ALIAS=exports.PLACEHOLDERS=void 0;var _utils=require_utils(),PLACEHOLDERS=exports.PLACEHOLDERS=["Identifier","StringLiteral","Expression","Statement","Declaration","BlockStatement","ClassBody","Pattern"],PLACEHOLDERS_ALIAS=exports.PLACEHOLDERS_ALIAS={Declaration:["Statement"],Pattern:["PatternLike","LVal"]};for(let type of PLACEHOLDERS){let alias=_utils.ALIAS_KEYS[type];alias!=null&&alias.length&&(PLACEHOLDERS_ALIAS[type]=alias);}var PLACEHOLDERS_FLIPPED_ALIAS=exports.PLACEHOLDERS_FLIPPED_ALIAS={};Object.keys(PLACEHOLDERS_ALIAS).forEach(type=>{PLACEHOLDERS_ALIAS[type].forEach(alias=>{hasOwnProperty.call(PLACEHOLDERS_FLIPPED_ALIAS,alias)||(PLACEHOLDERS_FLIPPED_ALIAS[alias]=[]),PLACEHOLDERS_FLIPPED_ALIAS[alias].push(type);});});}});var require_misc=__commonJS({"../../node_modules/@babel/types/lib/definitions/misc.js"(){var _utils=require_utils(),_placeholders=require_placeholders(),defineType=(0, _utils.defineAliasedType)("Miscellaneous");defineType("Noop",{visitor:[]});defineType("Placeholder",{visitor:[],builder:["expectedNode","name"],fields:{name:{validate:(0, _utils.assertNodeType)("Identifier")},expectedNode:{validate:(0, _utils.assertOneOf)(..._placeholders.PLACEHOLDERS)}}});defineType("V8IntrinsicIdentifier",{builder:["name"],fields:{name:{validate:(0, _utils.assertValueType)("string")}}});}});var require_experimental=__commonJS({"../../node_modules/@babel/types/lib/definitions/experimental.js"(){var _utils=require_utils();(0, _utils.default)("ArgumentPlaceholder",{});(0, _utils.default)("BindExpression",{visitor:["object","callee"],aliases:["Expression"],fields:process.env.BABEL_TYPES_8_BREAKING?{object:{validate:(0, _utils.assertNodeType)("Expression")},callee:{validate:(0, _utils.assertNodeType)("Expression")}}:{object:{validate:Object.assign(()=>{},{oneOfNodeTypes:["Expression"]})},callee:{validate:Object.assign(()=>{},{oneOfNodeTypes:["Expression"]})}}});(0, _utils.default)("ImportAttribute",{visitor:["key","value"],fields:{key:{validate:(0, _utils.assertNodeType)("Identifier","StringLiteral")},value:{validate:(0, _utils.assertNodeType)("StringLiteral")}}});(0, _utils.default)("Decorator",{visitor:["expression"],fields:{expression:{validate:(0, _utils.assertNodeType)("Expression")}}});(0, _utils.default)("DoExpression",{visitor:["body"],builder:["body","async"],aliases:["Expression"],fields:{body:{validate:(0, _utils.assertNodeType)("BlockStatement")},async:{validate:(0, _utils.assertValueType)("boolean"),default:!1}}});(0, _utils.default)("ExportDefaultSpecifier",{visitor:["exported"],aliases:["ModuleSpecifier"],fields:{exported:{validate:(0, _utils.assertNodeType)("Identifier")}}});(0, _utils.default)("RecordExpression",{visitor:["properties"],aliases:["Expression"],fields:{properties:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("ObjectProperty","SpreadElement")))}}});(0, _utils.default)("TupleExpression",{fields:{elements:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("Expression","SpreadElement"))),default:[]}},visitor:["elements"],aliases:["Expression"]});(0, _utils.default)("DecimalLiteral",{builder:["value"],fields:{value:{validate:(0, _utils.assertValueType)("string")}},aliases:["Expression","Pureish","Literal","Immutable"]});(0, _utils.default)("ModuleExpression",{visitor:["body"],fields:{body:{validate:(0, _utils.assertNodeType)("Program")}},aliases:["Expression"]});(0, _utils.default)("TopicReference",{aliases:["Expression"]});(0, _utils.default)("PipelineTopicExpression",{builder:["expression"],visitor:["expression"],fields:{expression:{validate:(0, _utils.assertNodeType)("Expression")}},aliases:["Expression"]});(0, _utils.default)("PipelineBareFunction",{builder:["callee"],visitor:["callee"],fields:{callee:{validate:(0, _utils.assertNodeType)("Expression")}},aliases:["Expression"]});(0, _utils.default)("PipelinePrimaryTopicReference",{aliases:["Expression"]});}});var require_typescript=__commonJS({"../../node_modules/@babel/types/lib/definitions/typescript.js"(){var _utils=require_utils(),_core=require_core(),_is=require_is(),defineType=(0, _utils.defineAliasedType)("TypeScript"),bool=(0, _utils.assertValueType)("boolean"),tSFunctionTypeAnnotationCommon=()=>({returnType:{validate:(0, _utils.assertNodeType)("TSTypeAnnotation","Noop"),optional:!0},typeParameters:{validate:(0, _utils.assertNodeType)("TSTypeParameterDeclaration","Noop"),optional:!0}});defineType("TSParameterProperty",{aliases:["LVal"],visitor:["parameter"],fields:{accessibility:{validate:(0, _utils.assertOneOf)("public","private","protected"),optional:!0},readonly:{validate:(0, _utils.assertValueType)("boolean"),optional:!0},parameter:{validate:(0, _utils.assertNodeType)("Identifier","AssignmentPattern")},override:{validate:(0, _utils.assertValueType)("boolean"),optional:!0},decorators:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("Decorator"))),optional:!0}}});defineType("TSDeclareFunction",{aliases:["Statement","Declaration"],visitor:["id","typeParameters","params","returnType"],fields:Object.assign({},(0, _core.functionDeclarationCommon)(),tSFunctionTypeAnnotationCommon())});defineType("TSDeclareMethod",{visitor:["decorators","key","typeParameters","params","returnType"],fields:Object.assign({},(0, _core.classMethodOrDeclareMethodCommon)(),tSFunctionTypeAnnotationCommon())});defineType("TSQualifiedName",{aliases:["TSEntityName"],visitor:["left","right"],fields:{left:(0, _utils.validateType)("TSEntityName"),right:(0, _utils.validateType)("Identifier")}});var signatureDeclarationCommon=()=>({typeParameters:(0, _utils.validateOptionalType)("TSTypeParameterDeclaration"),parameters:(0, _utils.validateArrayOfType)(["ArrayPattern","Identifier","ObjectPattern","RestElement"]),typeAnnotation:(0, _utils.validateOptionalType)("TSTypeAnnotation")}),callConstructSignatureDeclaration={aliases:["TSTypeElement"],visitor:["typeParameters","parameters","typeAnnotation"],fields:signatureDeclarationCommon()};defineType("TSCallSignatureDeclaration",callConstructSignatureDeclaration);defineType("TSConstructSignatureDeclaration",callConstructSignatureDeclaration);var namedTypeElementCommon=()=>({key:(0, _utils.validateType)("Expression"),computed:{default:!1},optional:(0, _utils.validateOptional)(bool)});defineType("TSPropertySignature",{aliases:["TSTypeElement"],visitor:["key","typeAnnotation"],fields:Object.assign({},namedTypeElementCommon(),{readonly:(0, _utils.validateOptional)(bool),typeAnnotation:(0, _utils.validateOptionalType)("TSTypeAnnotation"),kind:{validate:(0, _utils.assertOneOf)("get","set")}})});defineType("TSMethodSignature",{aliases:["TSTypeElement"],visitor:["key","typeParameters","parameters","typeAnnotation"],fields:Object.assign({},signatureDeclarationCommon(),namedTypeElementCommon(),{kind:{validate:(0, _utils.assertOneOf)("method","get","set")}})});defineType("TSIndexSignature",{aliases:["TSTypeElement"],visitor:["parameters","typeAnnotation"],fields:{readonly:(0, _utils.validateOptional)(bool),static:(0, _utils.validateOptional)(bool),parameters:(0, _utils.validateArrayOfType)("Identifier"),typeAnnotation:(0, _utils.validateOptionalType)("TSTypeAnnotation")}});var tsKeywordTypes=["TSAnyKeyword","TSBooleanKeyword","TSBigIntKeyword","TSIntrinsicKeyword","TSNeverKeyword","TSNullKeyword","TSNumberKeyword","TSObjectKeyword","TSStringKeyword","TSSymbolKeyword","TSUndefinedKeyword","TSUnknownKeyword","TSVoidKeyword"];for(let type of tsKeywordTypes)defineType(type,{aliases:["TSType","TSBaseType"],visitor:[],fields:{}});defineType("TSThisType",{aliases:["TSType","TSBaseType"],visitor:[],fields:{}});var fnOrCtrBase={aliases:["TSType"],visitor:["typeParameters","parameters","typeAnnotation"]};defineType("TSFunctionType",Object.assign({},fnOrCtrBase,{fields:signatureDeclarationCommon()}));defineType("TSConstructorType",Object.assign({},fnOrCtrBase,{fields:Object.assign({},signatureDeclarationCommon(),{abstract:(0, _utils.validateOptional)(bool)})}));defineType("TSTypeReference",{aliases:["TSType"],visitor:["typeName","typeParameters"],fields:{typeName:(0, _utils.validateType)("TSEntityName"),typeParameters:(0, _utils.validateOptionalType)("TSTypeParameterInstantiation")}});defineType("TSTypePredicate",{aliases:["TSType"],visitor:["parameterName","typeAnnotation"],builder:["parameterName","typeAnnotation","asserts"],fields:{parameterName:(0, _utils.validateType)(["Identifier","TSThisType"]),typeAnnotation:(0, _utils.validateOptionalType)("TSTypeAnnotation"),asserts:(0, _utils.validateOptional)(bool)}});defineType("TSTypeQuery",{aliases:["TSType"],visitor:["exprName","typeParameters"],fields:{exprName:(0, _utils.validateType)(["TSEntityName","TSImportType"]),typeParameters:(0, _utils.validateOptionalType)("TSTypeParameterInstantiation")}});defineType("TSTypeLiteral",{aliases:["TSType"],visitor:["members"],fields:{members:(0, _utils.validateArrayOfType)("TSTypeElement")}});defineType("TSArrayType",{aliases:["TSType"],visitor:["elementType"],fields:{elementType:(0, _utils.validateType)("TSType")}});defineType("TSTupleType",{aliases:["TSType"],visitor:["elementTypes"],fields:{elementTypes:(0, _utils.validateArrayOfType)(["TSType","TSNamedTupleMember"])}});defineType("TSOptionalType",{aliases:["TSType"],visitor:["typeAnnotation"],fields:{typeAnnotation:(0, _utils.validateType)("TSType")}});defineType("TSRestType",{aliases:["TSType"],visitor:["typeAnnotation"],fields:{typeAnnotation:(0, _utils.validateType)("TSType")}});defineType("TSNamedTupleMember",{visitor:["label","elementType"],builder:["label","elementType","optional"],fields:{label:(0, _utils.validateType)("Identifier"),optional:{validate:bool,default:!1},elementType:(0, _utils.validateType)("TSType")}});var unionOrIntersection={aliases:["TSType"],visitor:["types"],fields:{types:(0, _utils.validateArrayOfType)("TSType")}};defineType("TSUnionType",unionOrIntersection);defineType("TSIntersectionType",unionOrIntersection);defineType("TSConditionalType",{aliases:["TSType"],visitor:["checkType","extendsType","trueType","falseType"],fields:{checkType:(0, _utils.validateType)("TSType"),extendsType:(0, _utils.validateType)("TSType"),trueType:(0, _utils.validateType)("TSType"),falseType:(0, _utils.validateType)("TSType")}});defineType("TSInferType",{aliases:["TSType"],visitor:["typeParameter"],fields:{typeParameter:(0, _utils.validateType)("TSTypeParameter")}});defineType("TSParenthesizedType",{aliases:["TSType"],visitor:["typeAnnotation"],fields:{typeAnnotation:(0, _utils.validateType)("TSType")}});defineType("TSTypeOperator",{aliases:["TSType"],visitor:["typeAnnotation"],fields:{operator:(0, _utils.validate)((0, _utils.assertValueType)("string")),typeAnnotation:(0, _utils.validateType)("TSType")}});defineType("TSIndexedAccessType",{aliases:["TSType"],visitor:["objectType","indexType"],fields:{objectType:(0, _utils.validateType)("TSType"),indexType:(0, _utils.validateType)("TSType")}});defineType("TSMappedType",{aliases:["TSType"],visitor:["typeParameter","typeAnnotation","nameType"],fields:{readonly:(0, _utils.validateOptional)((0, _utils.assertOneOf)(!0,!1,"+","-")),typeParameter:(0, _utils.validateType)("TSTypeParameter"),optional:(0, _utils.validateOptional)((0, _utils.assertOneOf)(!0,!1,"+","-")),typeAnnotation:(0, _utils.validateOptionalType)("TSType"),nameType:(0, _utils.validateOptionalType)("TSType")}});defineType("TSLiteralType",{aliases:["TSType","TSBaseType"],visitor:["literal"],fields:{literal:{validate:function(){let unaryExpression=(0, _utils.assertNodeType)("NumericLiteral","BigIntLiteral"),unaryOperator=(0, _utils.assertOneOf)("-"),literal=(0, _utils.assertNodeType)("NumericLiteral","StringLiteral","BooleanLiteral","BigIntLiteral","TemplateLiteral");function validator(parent,key,node){(0, _is.default)("UnaryExpression",node)?(unaryOperator(node,"operator",node.operator),unaryExpression(node,"argument",node.argument)):literal(parent,key,node);}return validator.oneOfNodeTypes=["NumericLiteral","StringLiteral","BooleanLiteral","BigIntLiteral","TemplateLiteral","UnaryExpression"],validator}()}}});defineType("TSExpressionWithTypeArguments",{aliases:["TSType"],visitor:["expression","typeParameters"],fields:{expression:(0, _utils.validateType)("TSEntityName"),typeParameters:(0, _utils.validateOptionalType)("TSTypeParameterInstantiation")}});defineType("TSInterfaceDeclaration",{aliases:["Statement","Declaration"],visitor:["id","typeParameters","extends","body"],fields:{declare:(0, _utils.validateOptional)(bool),id:(0, _utils.validateType)("Identifier"),typeParameters:(0, _utils.validateOptionalType)("TSTypeParameterDeclaration"),extends:(0, _utils.validateOptional)((0, _utils.arrayOfType)("TSExpressionWithTypeArguments")),body:(0, _utils.validateType)("TSInterfaceBody")}});defineType("TSInterfaceBody",{visitor:["body"],fields:{body:(0, _utils.validateArrayOfType)("TSTypeElement")}});defineType("TSTypeAliasDeclaration",{aliases:["Statement","Declaration"],visitor:["id","typeParameters","typeAnnotation"],fields:{declare:(0, _utils.validateOptional)(bool),id:(0, _utils.validateType)("Identifier"),typeParameters:(0, _utils.validateOptionalType)("TSTypeParameterDeclaration"),typeAnnotation:(0, _utils.validateType)("TSType")}});defineType("TSInstantiationExpression",{aliases:["Expression"],visitor:["expression","typeParameters"],fields:{expression:(0, _utils.validateType)("Expression"),typeParameters:(0, _utils.validateOptionalType)("TSTypeParameterInstantiation")}});var TSTypeExpression={aliases:["Expression","LVal","PatternLike"],visitor:["expression","typeAnnotation"],fields:{expression:(0, _utils.validateType)("Expression"),typeAnnotation:(0, _utils.validateType)("TSType")}};defineType("TSAsExpression",TSTypeExpression);defineType("TSSatisfiesExpression",TSTypeExpression);defineType("TSTypeAssertion",{aliases:["Expression","LVal","PatternLike"],visitor:["typeAnnotation","expression"],fields:{typeAnnotation:(0, _utils.validateType)("TSType"),expression:(0, _utils.validateType)("Expression")}});defineType("TSEnumDeclaration",{aliases:["Statement","Declaration"],visitor:["id","members"],fields:{declare:(0, _utils.validateOptional)(bool),const:(0, _utils.validateOptional)(bool),id:(0, _utils.validateType)("Identifier"),members:(0, _utils.validateArrayOfType)("TSEnumMember"),initializer:(0, _utils.validateOptionalType)("Expression")}});defineType("TSEnumMember",{visitor:["id","initializer"],fields:{id:(0, _utils.validateType)(["Identifier","StringLiteral"]),initializer:(0, _utils.validateOptionalType)("Expression")}});defineType("TSModuleDeclaration",{aliases:["Statement","Declaration"],visitor:["id","body"],fields:{declare:(0, _utils.validateOptional)(bool),global:(0, _utils.validateOptional)(bool),id:(0, _utils.validateType)(["Identifier","StringLiteral"]),body:(0, _utils.validateType)(["TSModuleBlock","TSModuleDeclaration"])}});defineType("TSModuleBlock",{aliases:["Scopable","Block","BlockParent","FunctionParent"],visitor:["body"],fields:{body:(0, _utils.validateArrayOfType)("Statement")}});defineType("TSImportType",{aliases:["TSType"],visitor:["argument","qualifier","typeParameters"],fields:{argument:(0, _utils.validateType)("StringLiteral"),qualifier:(0, _utils.validateOptionalType)("TSEntityName"),typeParameters:(0, _utils.validateOptionalType)("TSTypeParameterInstantiation"),options:{validate:(0, _utils.assertNodeType)("Expression"),optional:!0}}});defineType("TSImportEqualsDeclaration",{aliases:["Statement"],visitor:["id","moduleReference"],fields:{isExport:(0, _utils.validate)(bool),id:(0, _utils.validateType)("Identifier"),moduleReference:(0, _utils.validateType)(["TSEntityName","TSExternalModuleReference"]),importKind:{validate:(0, _utils.assertOneOf)("type","value"),optional:!0}}});defineType("TSExternalModuleReference",{visitor:["expression"],fields:{expression:(0, _utils.validateType)("StringLiteral")}});defineType("TSNonNullExpression",{aliases:["Expression","LVal","PatternLike"],visitor:["expression"],fields:{expression:(0, _utils.validateType)("Expression")}});defineType("TSExportAssignment",{aliases:["Statement"],visitor:["expression"],fields:{expression:(0, _utils.validateType)("Expression")}});defineType("TSNamespaceExportDeclaration",{aliases:["Statement"],visitor:["id"],fields:{id:(0, _utils.validateType)("Identifier")}});defineType("TSTypeAnnotation",{visitor:["typeAnnotation"],fields:{typeAnnotation:{validate:(0, _utils.assertNodeType)("TSType")}}});defineType("TSTypeParameterInstantiation",{visitor:["params"],fields:{params:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("TSType")))}}});defineType("TSTypeParameterDeclaration",{visitor:["params"],fields:{params:{validate:(0, _utils.chain)((0, _utils.assertValueType)("array"),(0, _utils.assertEach)((0, _utils.assertNodeType)("TSTypeParameter")))}}});defineType("TSTypeParameter",{builder:["constraint","default","name"],visitor:["constraint","default"],fields:{name:{validate:(0, _utils.assertValueType)("string")},in:{validate:(0, _utils.assertValueType)("boolean"),optional:!0},out:{validate:(0, _utils.assertValueType)("boolean"),optional:!0},const:{validate:(0, _utils.assertValueType)("boolean"),optional:!0},constraint:{validate:(0, _utils.assertNodeType)("TSType"),optional:!0},default:{validate:(0, _utils.assertNodeType)("TSType"),optional:!0}}});}});var require_deprecated_aliases=__commonJS({"../../node_modules/@babel/types/lib/definitions/deprecated-aliases.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.DEPRECATED_ALIASES=void 0;exports.DEPRECATED_ALIASES={ModuleDeclaration:"ImportOrExportDeclaration"};}});var require_definitions=__commonJS({"../../node_modules/@babel/types/lib/definitions/index.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});Object.defineProperty(exports,"ALIAS_KEYS",{enumerable:!0,get:function(){return _utils.ALIAS_KEYS}});Object.defineProperty(exports,"BUILDER_KEYS",{enumerable:!0,get:function(){return _utils.BUILDER_KEYS}});Object.defineProperty(exports,"DEPRECATED_ALIASES",{enumerable:!0,get:function(){return _deprecatedAliases.DEPRECATED_ALIASES}});Object.defineProperty(exports,"DEPRECATED_KEYS",{enumerable:!0,get:function(){return _utils.DEPRECATED_KEYS}});Object.defineProperty(exports,"FLIPPED_ALIAS_KEYS",{enumerable:!0,get:function(){return _utils.FLIPPED_ALIAS_KEYS}});Object.defineProperty(exports,"NODE_FIELDS",{enumerable:!0,get:function(){return _utils.NODE_FIELDS}});Object.defineProperty(exports,"NODE_PARENT_VALIDATIONS",{enumerable:!0,get:function(){return _utils.NODE_PARENT_VALIDATIONS}});Object.defineProperty(exports,"PLACEHOLDERS",{enumerable:!0,get:function(){return _placeholders.PLACEHOLDERS}});Object.defineProperty(exports,"PLACEHOLDERS_ALIAS",{enumerable:!0,get:function(){return _placeholders.PLACEHOLDERS_ALIAS}});Object.defineProperty(exports,"PLACEHOLDERS_FLIPPED_ALIAS",{enumerable:!0,get:function(){return _placeholders.PLACEHOLDERS_FLIPPED_ALIAS}});exports.TYPES=void 0;Object.defineProperty(exports,"VISITOR_KEYS",{enumerable:!0,get:function(){return _utils.VISITOR_KEYS}});var _toFastProperties=require_to_fast_properties();require_core();require_flow();require_jsx();require_misc();require_experimental();require_typescript();var _utils=require_utils(),_placeholders=require_placeholders(),_deprecatedAliases=require_deprecated_aliases();Object.keys(_deprecatedAliases.DEPRECATED_ALIASES).forEach(deprecatedAlias=>{_utils.FLIPPED_ALIAS_KEYS[deprecatedAlias]=_utils.FLIPPED_ALIAS_KEYS[_deprecatedAliases.DEPRECATED_ALIASES[deprecatedAlias]];});_toFastProperties(_utils.VISITOR_KEYS);_toFastProperties(_utils.ALIAS_KEYS);_toFastProperties(_utils.FLIPPED_ALIAS_KEYS);_toFastProperties(_utils.NODE_FIELDS);_toFastProperties(_utils.BUILDER_KEYS);_toFastProperties(_utils.DEPRECATED_KEYS);_toFastProperties(_placeholders.PLACEHOLDERS_ALIAS);_toFastProperties(_placeholders.PLACEHOLDERS_FLIPPED_ALIAS);exports.TYPES=[].concat(Object.keys(_utils.VISITOR_KEYS),Object.keys(_utils.FLIPPED_ALIAS_KEYS),Object.keys(_utils.DEPRECATED_KEYS));}});var require_validate=__commonJS({"../../node_modules/@babel/types/lib/validators/validate.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=validate;exports.validateChild=validateChild;exports.validateField=validateField;var _index=require_definitions();function validate(node,key,val){if(!node)return;let fields=_index.NODE_FIELDS[node.type];if(!fields)return;let field=fields[key];validateField(node,key,val,field),validateChild(node,key,val);}function validateField(node,key,val,field){field!=null&&field.validate&&(field.optional&&val==null||field.validate(node,key,val));}function validateChild(node,key,val){if(val==null)return;let validate2=_index.NODE_PARENT_VALIDATIONS[val.type];validate2&&validate2(node,key,val);}}});var require_validateNode=__commonJS({"../../node_modules/@babel/types/lib/builders/validateNode.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=validateNode;var _validate=require_validate(),_index=require_lib3();function validateNode(node){let keys=_index.BUILDER_KEYS[node.type];for(let key of keys)(0, _validate.default)(node,key,node[key]);return node}}});var require_generated2=__commonJS({"../../node_modules/@babel/types/lib/builders/generated/index.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.anyTypeAnnotation=anyTypeAnnotation;exports.argumentPlaceholder=argumentPlaceholder;exports.arrayExpression=arrayExpression;exports.arrayPattern=arrayPattern;exports.arrayTypeAnnotation=arrayTypeAnnotation;exports.arrowFunctionExpression=arrowFunctionExpression;exports.assignmentExpression=assignmentExpression;exports.assignmentPattern=assignmentPattern;exports.awaitExpression=awaitExpression;exports.bigIntLiteral=bigIntLiteral;exports.binaryExpression=binaryExpression;exports.bindExpression=bindExpression;exports.blockStatement=blockStatement2;exports.booleanLiteral=booleanLiteral;exports.booleanLiteralTypeAnnotation=booleanLiteralTypeAnnotation;exports.booleanTypeAnnotation=booleanTypeAnnotation;exports.breakStatement=breakStatement;exports.callExpression=callExpression2;exports.catchClause=catchClause;exports.classAccessorProperty=classAccessorProperty;exports.classBody=classBody;exports.classDeclaration=classDeclaration;exports.classExpression=classExpression;exports.classImplements=classImplements;exports.classMethod=classMethod;exports.classPrivateMethod=classPrivateMethod;exports.classPrivateProperty=classPrivateProperty;exports.classProperty=classProperty;exports.conditionalExpression=conditionalExpression;exports.continueStatement=continueStatement;exports.debuggerStatement=debuggerStatement;exports.decimalLiteral=decimalLiteral;exports.declareClass=declareClass;exports.declareExportAllDeclaration=declareExportAllDeclaration;exports.declareExportDeclaration=declareExportDeclaration;exports.declareFunction=declareFunction;exports.declareInterface=declareInterface;exports.declareModule=declareModule;exports.declareModuleExports=declareModuleExports;exports.declareOpaqueType=declareOpaqueType;exports.declareTypeAlias=declareTypeAlias;exports.declareVariable=declareVariable;exports.declaredPredicate=declaredPredicate;exports.decorator=decorator;exports.directive=directive;exports.directiveLiteral=directiveLiteral;exports.doExpression=doExpression;exports.doWhileStatement=doWhileStatement;exports.emptyStatement=emptyStatement;exports.emptyTypeAnnotation=emptyTypeAnnotation;exports.enumBooleanBody=enumBooleanBody;exports.enumBooleanMember=enumBooleanMember;exports.enumDeclaration=enumDeclaration;exports.enumDefaultedMember=enumDefaultedMember;exports.enumNumberBody=enumNumberBody;exports.enumNumberMember=enumNumberMember;exports.enumStringBody=enumStringBody;exports.enumStringMember=enumStringMember;exports.enumSymbolBody=enumSymbolBody;exports.existsTypeAnnotation=existsTypeAnnotation;exports.exportAllDeclaration=exportAllDeclaration;exports.exportDefaultDeclaration=exportDefaultDeclaration;exports.exportDefaultSpecifier=exportDefaultSpecifier;exports.exportNamedDeclaration=exportNamedDeclaration;exports.exportNamespaceSpecifier=exportNamespaceSpecifier;exports.exportSpecifier=exportSpecifier;exports.expressionStatement=expressionStatement;exports.file=file;exports.forInStatement=forInStatement;exports.forOfStatement=forOfStatement;exports.forStatement=forStatement;exports.functionDeclaration=functionDeclaration2;exports.functionExpression=functionExpression;exports.functionTypeAnnotation=functionTypeAnnotation;exports.functionTypeParam=functionTypeParam;exports.genericTypeAnnotation=genericTypeAnnotation;exports.identifier=identifier2;exports.ifStatement=ifStatement;exports.import=_import;exports.importAttribute=importAttribute;exports.importDeclaration=importDeclaration;exports.importDefaultSpecifier=importDefaultSpecifier;exports.importExpression=importExpression;exports.importNamespaceSpecifier=importNamespaceSpecifier;exports.importSpecifier=importSpecifier;exports.indexedAccessType=indexedAccessType;exports.inferredPredicate=inferredPredicate;exports.interfaceDeclaration=interfaceDeclaration;exports.interfaceExtends=interfaceExtends;exports.interfaceTypeAnnotation=interfaceTypeAnnotation;exports.interpreterDirective=interpreterDirective;exports.intersectionTypeAnnotation=intersectionTypeAnnotation;exports.jSXAttribute=exports.jsxAttribute=jsxAttribute;exports.jSXClosingElement=exports.jsxClosingElement=jsxClosingElement;exports.jSXClosingFragment=exports.jsxClosingFragment=jsxClosingFragment;exports.jSXElement=exports.jsxElement=jsxElement;exports.jSXEmptyExpression=exports.jsxEmptyExpression=jsxEmptyExpression;exports.jSXExpressionContainer=exports.jsxExpressionContainer=jsxExpressionContainer;exports.jSXFragment=exports.jsxFragment=jsxFragment;exports.jSXIdentifier=exports.jsxIdentifier=jsxIdentifier;exports.jSXMemberExpression=exports.jsxMemberExpression=jsxMemberExpression;exports.jSXNamespacedName=exports.jsxNamespacedName=jsxNamespacedName;exports.jSXOpeningElement=exports.jsxOpeningElement=jsxOpeningElement;exports.jSXOpeningFragment=exports.jsxOpeningFragment=jsxOpeningFragment;exports.jSXSpreadAttribute=exports.jsxSpreadAttribute=jsxSpreadAttribute;exports.jSXSpreadChild=exports.jsxSpreadChild=jsxSpreadChild;exports.jSXText=exports.jsxText=jsxText;exports.labeledStatement=labeledStatement;exports.logicalExpression=logicalExpression;exports.memberExpression=memberExpression2;exports.metaProperty=metaProperty;exports.mixedTypeAnnotation=mixedTypeAnnotation;exports.moduleExpression=moduleExpression;exports.newExpression=newExpression;exports.noop=noop;exports.nullLiteral=nullLiteral;exports.nullLiteralTypeAnnotation=nullLiteralTypeAnnotation;exports.nullableTypeAnnotation=nullableTypeAnnotation;exports.numberLiteral=NumberLiteral;exports.numberLiteralTypeAnnotation=numberLiteralTypeAnnotation;exports.numberTypeAnnotation=numberTypeAnnotation;exports.numericLiteral=numericLiteral;exports.objectExpression=objectExpression;exports.objectMethod=objectMethod;exports.objectPattern=objectPattern;exports.objectProperty=objectProperty;exports.objectTypeAnnotation=objectTypeAnnotation;exports.objectTypeCallProperty=objectTypeCallProperty;exports.objectTypeIndexer=objectTypeIndexer;exports.objectTypeInternalSlot=objectTypeInternalSlot;exports.objectTypeProperty=objectTypeProperty;exports.objectTypeSpreadProperty=objectTypeSpreadProperty;exports.opaqueType=opaqueType;exports.optionalCallExpression=optionalCallExpression;exports.optionalIndexedAccessType=optionalIndexedAccessType;exports.optionalMemberExpression=optionalMemberExpression;exports.parenthesizedExpression=parenthesizedExpression;exports.pipelineBareFunction=pipelineBareFunction;exports.pipelinePrimaryTopicReference=pipelinePrimaryTopicReference;exports.pipelineTopicExpression=pipelineTopicExpression;exports.placeholder=placeholder;exports.privateName=privateName;exports.program=program2;exports.qualifiedTypeIdentifier=qualifiedTypeIdentifier;exports.recordExpression=recordExpression;exports.regExpLiteral=regExpLiteral;exports.regexLiteral=RegexLiteral;exports.restElement=restElement;exports.restProperty=RestProperty;exports.returnStatement=returnStatement2;exports.sequenceExpression=sequenceExpression;exports.spreadElement=spreadElement;exports.spreadProperty=SpreadProperty;exports.staticBlock=staticBlock;exports.stringLiteral=stringLiteral2;exports.stringLiteralTypeAnnotation=stringLiteralTypeAnnotation;exports.stringTypeAnnotation=stringTypeAnnotation;exports.super=_super;exports.switchCase=switchCase;exports.switchStatement=switchStatement;exports.symbolTypeAnnotation=symbolTypeAnnotation;exports.taggedTemplateExpression=taggedTemplateExpression;exports.templateElement=templateElement;exports.templateLiteral=templateLiteral;exports.thisExpression=thisExpression;exports.thisTypeAnnotation=thisTypeAnnotation;exports.throwStatement=throwStatement;exports.topicReference=topicReference;exports.tryStatement=tryStatement;exports.tSAnyKeyword=exports.tsAnyKeyword=tsAnyKeyword2;exports.tSArrayType=exports.tsArrayType=tsArrayType;exports.tSAsExpression=exports.tsAsExpression=tsAsExpression;exports.tSBigIntKeyword=exports.tsBigIntKeyword=tsBigIntKeyword;exports.tSBooleanKeyword=exports.tsBooleanKeyword=tsBooleanKeyword;exports.tSCallSignatureDeclaration=exports.tsCallSignatureDeclaration=tsCallSignatureDeclaration;exports.tSConditionalType=exports.tsConditionalType=tsConditionalType;exports.tSConstructSignatureDeclaration=exports.tsConstructSignatureDeclaration=tsConstructSignatureDeclaration;exports.tSConstructorType=exports.tsConstructorType=tsConstructorType;exports.tSDeclareFunction=exports.tsDeclareFunction=tsDeclareFunction;exports.tSDeclareMethod=exports.tsDeclareMethod=tsDeclareMethod;exports.tSEnumDeclaration=exports.tsEnumDeclaration=tsEnumDeclaration;exports.tSEnumMember=exports.tsEnumMember=tsEnumMember;exports.tSExportAssignment=exports.tsExportAssignment=tsExportAssignment;exports.tSExpressionWithTypeArguments=exports.tsExpressionWithTypeArguments=tsExpressionWithTypeArguments;exports.tSExternalModuleReference=exports.tsExternalModuleReference=tsExternalModuleReference;exports.tSFunctionType=exports.tsFunctionType=tsFunctionType;exports.tSImportEqualsDeclaration=exports.tsImportEqualsDeclaration=tsImportEqualsDeclaration;exports.tSImportType=exports.tsImportType=tsImportType;exports.tSIndexSignature=exports.tsIndexSignature=tsIndexSignature;exports.tSIndexedAccessType=exports.tsIndexedAccessType=tsIndexedAccessType;exports.tSInferType=exports.tsInferType=tsInferType;exports.tSInstantiationExpression=exports.tsInstantiationExpression=tsInstantiationExpression;exports.tSInterfaceBody=exports.tsInterfaceBody=tsInterfaceBody;exports.tSInterfaceDeclaration=exports.tsInterfaceDeclaration=tsInterfaceDeclaration;exports.tSIntersectionType=exports.tsIntersectionType=tsIntersectionType;exports.tSIntrinsicKeyword=exports.tsIntrinsicKeyword=tsIntrinsicKeyword;exports.tSLiteralType=exports.tsLiteralType=tsLiteralType;exports.tSMappedType=exports.tsMappedType=tsMappedType;exports.tSMethodSignature=exports.tsMethodSignature=tsMethodSignature;exports.tSModuleBlock=exports.tsModuleBlock=tsModuleBlock;exports.tSModuleDeclaration=exports.tsModuleDeclaration=tsModuleDeclaration;exports.tSNamedTupleMember=exports.tsNamedTupleMember=tsNamedTupleMember;exports.tSNamespaceExportDeclaration=exports.tsNamespaceExportDeclaration=tsNamespaceExportDeclaration;exports.tSNeverKeyword=exports.tsNeverKeyword=tsNeverKeyword;exports.tSNonNullExpression=exports.tsNonNullExpression=tsNonNullExpression;exports.tSNullKeyword=exports.tsNullKeyword=tsNullKeyword;exports.tSNumberKeyword=exports.tsNumberKeyword=tsNumberKeyword;exports.tSObjectKeyword=exports.tsObjectKeyword=tsObjectKeyword;exports.tSOptionalType=exports.tsOptionalType=tsOptionalType;exports.tSParameterProperty=exports.tsParameterProperty=tsParameterProperty;exports.tSParenthesizedType=exports.tsParenthesizedType=tsParenthesizedType;exports.tSPropertySignature=exports.tsPropertySignature=tsPropertySignature;exports.tSQualifiedName=exports.tsQualifiedName=tsQualifiedName;exports.tSRestType=exports.tsRestType=tsRestType;exports.tSSatisfiesExpression=exports.tsSatisfiesExpression=tsSatisfiesExpression;exports.tSStringKeyword=exports.tsStringKeyword=tsStringKeyword;exports.tSSymbolKeyword=exports.tsSymbolKeyword=tsSymbolKeyword;exports.tSThisType=exports.tsThisType=tsThisType;exports.tSTupleType=exports.tsTupleType=tsTupleType;exports.tSTypeAliasDeclaration=exports.tsTypeAliasDeclaration=tsTypeAliasDeclaration;exports.tSTypeAnnotation=exports.tsTypeAnnotation=tsTypeAnnotation2;exports.tSTypeAssertion=exports.tsTypeAssertion=tsTypeAssertion;exports.tSTypeLiteral=exports.tsTypeLiteral=tsTypeLiteral;exports.tSTypeOperator=exports.tsTypeOperator=tsTypeOperator;exports.tSTypeParameter=exports.tsTypeParameter=tsTypeParameter;exports.tSTypeParameterDeclaration=exports.tsTypeParameterDeclaration=tsTypeParameterDeclaration;exports.tSTypeParameterInstantiation=exports.tsTypeParameterInstantiation=tsTypeParameterInstantiation;exports.tSTypePredicate=exports.tsTypePredicate=tsTypePredicate;exports.tSTypeQuery=exports.tsTypeQuery=tsTypeQuery;exports.tSTypeReference=exports.tsTypeReference=tsTypeReference;exports.tSUndefinedKeyword=exports.tsUndefinedKeyword=tsUndefinedKeyword;exports.tSUnionType=exports.tsUnionType=tsUnionType;exports.tSUnknownKeyword=exports.tsUnknownKeyword=tsUnknownKeyword;exports.tSVoidKeyword=exports.tsVoidKeyword=tsVoidKeyword;exports.tupleExpression=tupleExpression;exports.tupleTypeAnnotation=tupleTypeAnnotation;exports.typeAlias=typeAlias;exports.typeAnnotation=typeAnnotation;exports.typeCastExpression=typeCastExpression;exports.typeParameter=typeParameter;exports.typeParameterDeclaration=typeParameterDeclaration;exports.typeParameterInstantiation=typeParameterInstantiation;exports.typeofTypeAnnotation=typeofTypeAnnotation;exports.unaryExpression=unaryExpression;exports.unionTypeAnnotation=unionTypeAnnotation;exports.updateExpression=updateExpression;exports.v8IntrinsicIdentifier=v8IntrinsicIdentifier;exports.variableDeclaration=variableDeclaration;exports.variableDeclarator=variableDeclarator;exports.variance=variance;exports.voidTypeAnnotation=voidTypeAnnotation;exports.whileStatement=whileStatement;exports.withStatement=withStatement;exports.yieldExpression=yieldExpression;var _validateNode=require_validateNode(),_deprecationWarning=require_deprecationWarning();function arrayExpression(elements=[]){return (0, _validateNode.default)({type:"ArrayExpression",elements})}function assignmentExpression(operator,left,right){return (0, _validateNode.default)({type:"AssignmentExpression",operator,left,right})}function binaryExpression(operator,left,right){return (0, _validateNode.default)({type:"BinaryExpression",operator,left,right})}function interpreterDirective(value){return (0, _validateNode.default)({type:"InterpreterDirective",value})}function directive(value){return (0, _validateNode.default)({type:"Directive",value})}function directiveLiteral(value){return (0, _validateNode.default)({type:"DirectiveLiteral",value})}function blockStatement2(body,directives=[]){return (0, _validateNode.default)({type:"BlockStatement",body,directives})}function breakStatement(label=null){return (0, _validateNode.default)({type:"BreakStatement",label})}function callExpression2(callee,_arguments){return (0, _validateNode.default)({type:"CallExpression",callee,arguments:_arguments})}function catchClause(param=null,body){return (0, _validateNode.default)({type:"CatchClause",param,body})}function conditionalExpression(test,consequent,alternate){return (0, _validateNode.default)({type:"ConditionalExpression",test,consequent,alternate})}function continueStatement(label=null){return (0, _validateNode.default)({type:"ContinueStatement",label})}function debuggerStatement(){return {type:"DebuggerStatement"}}function doWhileStatement(test,body){return (0, _validateNode.default)({type:"DoWhileStatement",test,body})}function emptyStatement(){return {type:"EmptyStatement"}}function expressionStatement(expression){return (0, _validateNode.default)({type:"ExpressionStatement",expression})}function file(program3,comments=null,tokens=null){return (0, _validateNode.default)({type:"File",program:program3,comments,tokens})}function forInStatement(left,right,body){return (0, _validateNode.default)({type:"ForInStatement",left,right,body})}function forStatement(init=null,test=null,update=null,body){return (0, _validateNode.default)({type:"ForStatement",init,test,update,body})}function functionDeclaration2(id=null,params,body,generator18=!1,async=!1){return (0, _validateNode.default)({type:"FunctionDeclaration",id,params,body,generator:generator18,async})}function functionExpression(id=null,params,body,generator18=!1,async=!1){return (0, _validateNode.default)({type:"FunctionExpression",id,params,body,generator:generator18,async})}function identifier2(name){return (0, _validateNode.default)({type:"Identifier",name})}function ifStatement(test,consequent,alternate=null){return (0, _validateNode.default)({type:"IfStatement",test,consequent,alternate})}function labeledStatement(label,body){return (0, _validateNode.default)({type:"LabeledStatement",label,body})}function stringLiteral2(value){return (0, _validateNode.default)({type:"StringLiteral",value})}function numericLiteral(value){return (0, _validateNode.default)({type:"NumericLiteral",value})}function nullLiteral(){return {type:"NullLiteral"}}function booleanLiteral(value){return (0, _validateNode.default)({type:"BooleanLiteral",value})}function regExpLiteral(pattern,flags=""){return (0, _validateNode.default)({type:"RegExpLiteral",pattern,flags})}function logicalExpression(operator,left,right){return (0, _validateNode.default)({type:"LogicalExpression",operator,left,right})}function memberExpression2(object,property,computed=!1,optional=null){return (0, _validateNode.default)({type:"MemberExpression",object,property,computed,optional})}function newExpression(callee,_arguments){return (0, _validateNode.default)({type:"NewExpression",callee,arguments:_arguments})}function program2(body,directives=[],sourceType="script",interpreter=null){return (0, _validateNode.default)({type:"Program",body,directives,sourceType,interpreter})}function objectExpression(properties){return (0, _validateNode.default)({type:"ObjectExpression",properties})}function objectMethod(kind="method",key,params,body,computed=!1,generator18=!1,async=!1){return (0, _validateNode.default)({type:"ObjectMethod",kind,key,params,body,computed,generator:generator18,async})}function objectProperty(key,value,computed=!1,shorthand=!1,decorators=null){return (0, _validateNode.default)({type:"ObjectProperty",key,value,computed,shorthand,decorators})}function restElement(argument){return (0, _validateNode.default)({type:"RestElement",argument})}function returnStatement2(argument=null){return (0, _validateNode.default)({type:"ReturnStatement",argument})}function sequenceExpression(expressions){return (0, _validateNode.default)({type:"SequenceExpression",expressions})}function parenthesizedExpression(expression){return (0, _validateNode.default)({type:"ParenthesizedExpression",expression})}function switchCase(test=null,consequent){return (0, _validateNode.default)({type:"SwitchCase",test,consequent})}function switchStatement(discriminant,cases){return (0, _validateNode.default)({type:"SwitchStatement",discriminant,cases})}function thisExpression(){return {type:"ThisExpression"}}function throwStatement(argument){return (0, _validateNode.default)({type:"ThrowStatement",argument})}function tryStatement(block,handler=null,finalizer=null){return (0, _validateNode.default)({type:"TryStatement",block,handler,finalizer})}function unaryExpression(operator,argument,prefix=!0){return (0, _validateNode.default)({type:"UnaryExpression",operator,argument,prefix})}function updateExpression(operator,argument,prefix=!1){return (0, _validateNode.default)({type:"UpdateExpression",operator,argument,prefix})}function variableDeclaration(kind,declarations){return (0, _validateNode.default)({type:"VariableDeclaration",kind,declarations})}function variableDeclarator(id,init=null){return (0, _validateNode.default)({type:"VariableDeclarator",id,init})}function whileStatement(test,body){return (0, _validateNode.default)({type:"WhileStatement",test,body})}function withStatement(object,body){return (0, _validateNode.default)({type:"WithStatement",object,body})}function assignmentPattern(left,right){return (0, _validateNode.default)({type:"AssignmentPattern",left,right})}function arrayPattern(elements){return (0, _validateNode.default)({type:"ArrayPattern",elements})}function arrowFunctionExpression(params,body,async=!1){return (0, _validateNode.default)({type:"ArrowFunctionExpression",params,body,async,expression:null})}function classBody(body){return (0, _validateNode.default)({type:"ClassBody",body})}function classExpression(id=null,superClass=null,body,decorators=null){return (0, _validateNode.default)({type:"ClassExpression",id,superClass,body,decorators})}function classDeclaration(id=null,superClass=null,body,decorators=null){return (0, _validateNode.default)({type:"ClassDeclaration",id,superClass,body,decorators})}function exportAllDeclaration(source){return (0, _validateNode.default)({type:"ExportAllDeclaration",source})}function exportDefaultDeclaration(declaration){return (0, _validateNode.default)({type:"ExportDefaultDeclaration",declaration})}function exportNamedDeclaration(declaration=null,specifiers=[],source=null){return (0, _validateNode.default)({type:"ExportNamedDeclaration",declaration,specifiers,source})}function exportSpecifier(local,exported){return (0, _validateNode.default)({type:"ExportSpecifier",local,exported})}function forOfStatement(left,right,body,_await=!1){return (0, _validateNode.default)({type:"ForOfStatement",left,right,body,await:_await})}function importDeclaration(specifiers,source){return (0, _validateNode.default)({type:"ImportDeclaration",specifiers,source})}function importDefaultSpecifier(local){return (0, _validateNode.default)({type:"ImportDefaultSpecifier",local})}function importNamespaceSpecifier(local){return (0, _validateNode.default)({type:"ImportNamespaceSpecifier",local})}function importSpecifier(local,imported){return (0, _validateNode.default)({type:"ImportSpecifier",local,imported})}function importExpression(source,options=null){return (0, _validateNode.default)({type:"ImportExpression",source,options})}function metaProperty(meta,property){return (0, _validateNode.default)({type:"MetaProperty",meta,property})}function classMethod(kind="method",key,params,body,computed=!1,_static=!1,generator18=!1,async=!1){return (0, _validateNode.default)({type:"ClassMethod",kind,key,params,body,computed,static:_static,generator:generator18,async})}function objectPattern(properties){return (0, _validateNode.default)({type:"ObjectPattern",properties})}function spreadElement(argument){return (0, _validateNode.default)({type:"SpreadElement",argument})}function _super(){return {type:"Super"}}function taggedTemplateExpression(tag,quasi){return (0, _validateNode.default)({type:"TaggedTemplateExpression",tag,quasi})}function templateElement(value,tail=!1){return (0, _validateNode.default)({type:"TemplateElement",value,tail})}function templateLiteral(quasis,expressions){return (0, _validateNode.default)({type:"TemplateLiteral",quasis,expressions})}function yieldExpression(argument=null,delegate=!1){return (0, _validateNode.default)({type:"YieldExpression",argument,delegate})}function awaitExpression(argument){return (0, _validateNode.default)({type:"AwaitExpression",argument})}function _import(){return {type:"Import"}}function bigIntLiteral(value){return (0, _validateNode.default)({type:"BigIntLiteral",value})}function exportNamespaceSpecifier(exported){return (0, _validateNode.default)({type:"ExportNamespaceSpecifier",exported})}function optionalMemberExpression(object,property,computed=!1,optional){return (0, _validateNode.default)({type:"OptionalMemberExpression",object,property,computed,optional})}function optionalCallExpression(callee,_arguments,optional){return (0, _validateNode.default)({type:"OptionalCallExpression",callee,arguments:_arguments,optional})}function classProperty(key,value=null,typeAnnotation2=null,decorators=null,computed=!1,_static=!1){return (0, _validateNode.default)({type:"ClassProperty",key,value,typeAnnotation:typeAnnotation2,decorators,computed,static:_static})}function classAccessorProperty(key,value=null,typeAnnotation2=null,decorators=null,computed=!1,_static=!1){return (0, _validateNode.default)({type:"ClassAccessorProperty",key,value,typeAnnotation:typeAnnotation2,decorators,computed,static:_static})}function classPrivateProperty(key,value=null,decorators=null,_static=!1){return (0, _validateNode.default)({type:"ClassPrivateProperty",key,value,decorators,static:_static})}function classPrivateMethod(kind="method",key,params,body,_static=!1){return (0, _validateNode.default)({type:"ClassPrivateMethod",kind,key,params,body,static:_static})}function privateName(id){return (0, _validateNode.default)({type:"PrivateName",id})}function staticBlock(body){return (0, _validateNode.default)({type:"StaticBlock",body})}function anyTypeAnnotation(){return {type:"AnyTypeAnnotation"}}function arrayTypeAnnotation(elementType){return (0, _validateNode.default)({type:"ArrayTypeAnnotation",elementType})}function booleanTypeAnnotation(){return {type:"BooleanTypeAnnotation"}}function booleanLiteralTypeAnnotation(value){return (0, _validateNode.default)({type:"BooleanLiteralTypeAnnotation",value})}function nullLiteralTypeAnnotation(){return {type:"NullLiteralTypeAnnotation"}}function classImplements(id,typeParameters=null){return (0, _validateNode.default)({type:"ClassImplements",id,typeParameters})}function declareClass(id,typeParameters=null,_extends=null,body){return (0, _validateNode.default)({type:"DeclareClass",id,typeParameters,extends:_extends,body})}function declareFunction(id){return (0, _validateNode.default)({type:"DeclareFunction",id})}function declareInterface(id,typeParameters=null,_extends=null,body){return (0, _validateNode.default)({type:"DeclareInterface",id,typeParameters,extends:_extends,body})}function declareModule(id,body,kind=null){return (0, _validateNode.default)({type:"DeclareModule",id,body,kind})}function declareModuleExports(typeAnnotation2){return (0, _validateNode.default)({type:"DeclareModuleExports",typeAnnotation:typeAnnotation2})}function declareTypeAlias(id,typeParameters=null,right){return (0, _validateNode.default)({type:"DeclareTypeAlias",id,typeParameters,right})}function declareOpaqueType(id,typeParameters=null,supertype=null){return (0, _validateNode.default)({type:"DeclareOpaqueType",id,typeParameters,supertype})}function declareVariable(id){return (0, _validateNode.default)({type:"DeclareVariable",id})}function declareExportDeclaration(declaration=null,specifiers=null,source=null){return (0, _validateNode.default)({type:"DeclareExportDeclaration",declaration,specifiers,source})}function declareExportAllDeclaration(source){return (0, _validateNode.default)({type:"DeclareExportAllDeclaration",source})}function declaredPredicate(value){return (0, _validateNode.default)({type:"DeclaredPredicate",value})}function existsTypeAnnotation(){return {type:"ExistsTypeAnnotation"}}function functionTypeAnnotation(typeParameters=null,params,rest=null,returnType){return (0, _validateNode.default)({type:"FunctionTypeAnnotation",typeParameters,params,rest,returnType})}function functionTypeParam(name=null,typeAnnotation2){return (0, _validateNode.default)({type:"FunctionTypeParam",name,typeAnnotation:typeAnnotation2})}function genericTypeAnnotation(id,typeParameters=null){return (0, _validateNode.default)({type:"GenericTypeAnnotation",id,typeParameters})}function inferredPredicate(){return {type:"InferredPredicate"}}function interfaceExtends(id,typeParameters=null){return (0, _validateNode.default)({type:"InterfaceExtends",id,typeParameters})}function interfaceDeclaration(id,typeParameters=null,_extends=null,body){return (0, _validateNode.default)({type:"InterfaceDeclaration",id,typeParameters,extends:_extends,body})}function interfaceTypeAnnotation(_extends=null,body){return (0, _validateNode.default)({type:"InterfaceTypeAnnotation",extends:_extends,body})}function intersectionTypeAnnotation(types){return (0, _validateNode.default)({type:"IntersectionTypeAnnotation",types})}function mixedTypeAnnotation(){return {type:"MixedTypeAnnotation"}}function emptyTypeAnnotation(){return {type:"EmptyTypeAnnotation"}}function nullableTypeAnnotation(typeAnnotation2){return (0, _validateNode.default)({type:"NullableTypeAnnotation",typeAnnotation:typeAnnotation2})}function numberLiteralTypeAnnotation(value){return (0, _validateNode.default)({type:"NumberLiteralTypeAnnotation",value})}function numberTypeAnnotation(){return {type:"NumberTypeAnnotation"}}function objectTypeAnnotation(properties,indexers=[],callProperties=[],internalSlots=[],exact=!1){return (0, _validateNode.default)({type:"ObjectTypeAnnotation",properties,indexers,callProperties,internalSlots,exact})}function objectTypeInternalSlot(id,value,optional,_static,method){return (0, _validateNode.default)({type:"ObjectTypeInternalSlot",id,value,optional,static:_static,method})}function objectTypeCallProperty(value){return (0, _validateNode.default)({type:"ObjectTypeCallProperty",value,static:null})}function objectTypeIndexer(id=null,key,value,variance2=null){return (0, _validateNode.default)({type:"ObjectTypeIndexer",id,key,value,variance:variance2,static:null})}function objectTypeProperty(key,value,variance2=null){return (0, _validateNode.default)({type:"ObjectTypeProperty",key,value,variance:variance2,kind:null,method:null,optional:null,proto:null,static:null})}function objectTypeSpreadProperty(argument){return (0, _validateNode.default)({type:"ObjectTypeSpreadProperty",argument})}function opaqueType(id,typeParameters=null,supertype=null,impltype){return (0, _validateNode.default)({type:"OpaqueType",id,typeParameters,supertype,impltype})}function qualifiedTypeIdentifier(id,qualification){return (0, _validateNode.default)({type:"QualifiedTypeIdentifier",id,qualification})}function stringLiteralTypeAnnotation(value){return (0, _validateNode.default)({type:"StringLiteralTypeAnnotation",value})}function stringTypeAnnotation(){return {type:"StringTypeAnnotation"}}function symbolTypeAnnotation(){return {type:"SymbolTypeAnnotation"}}function thisTypeAnnotation(){return {type:"ThisTypeAnnotation"}}function tupleTypeAnnotation(types){return (0, _validateNode.default)({type:"TupleTypeAnnotation",types})}function typeofTypeAnnotation(argument){return (0, _validateNode.default)({type:"TypeofTypeAnnotation",argument})}function typeAlias(id,typeParameters=null,right){return (0, _validateNode.default)({type:"TypeAlias",id,typeParameters,right})}function typeAnnotation(typeAnnotation2){return (0, _validateNode.default)({type:"TypeAnnotation",typeAnnotation:typeAnnotation2})}function typeCastExpression(expression,typeAnnotation2){return (0, _validateNode.default)({type:"TypeCastExpression",expression,typeAnnotation:typeAnnotation2})}function typeParameter(bound=null,_default=null,variance2=null){return (0, _validateNode.default)({type:"TypeParameter",bound,default:_default,variance:variance2,name:null})}function typeParameterDeclaration(params){return (0, _validateNode.default)({type:"TypeParameterDeclaration",params})}function typeParameterInstantiation(params){return (0, _validateNode.default)({type:"TypeParameterInstantiation",params})}function unionTypeAnnotation(types){return (0, _validateNode.default)({type:"UnionTypeAnnotation",types})}function variance(kind){return (0, _validateNode.default)({type:"Variance",kind})}function voidTypeAnnotation(){return {type:"VoidTypeAnnotation"}}function enumDeclaration(id,body){return (0, _validateNode.default)({type:"EnumDeclaration",id,body})}function enumBooleanBody(members){return (0, _validateNode.default)({type:"EnumBooleanBody",members,explicitType:null,hasUnknownMembers:null})}function enumNumberBody(members){return (0, _validateNode.default)({type:"EnumNumberBody",members,explicitType:null,hasUnknownMembers:null})}function enumStringBody(members){return (0, _validateNode.default)({type:"EnumStringBody",members,explicitType:null,hasUnknownMembers:null})}function enumSymbolBody(members){return (0, _validateNode.default)({type:"EnumSymbolBody",members,hasUnknownMembers:null})}function enumBooleanMember(id){return (0, _validateNode.default)({type:"EnumBooleanMember",id,init:null})}function enumNumberMember(id,init){return (0, _validateNode.default)({type:"EnumNumberMember",id,init})}function enumStringMember(id,init){return (0, _validateNode.default)({type:"EnumStringMember",id,init})}function enumDefaultedMember(id){return (0, _validateNode.default)({type:"EnumDefaultedMember",id})}function indexedAccessType(objectType,indexType){return (0, _validateNode.default)({type:"IndexedAccessType",objectType,indexType})}function optionalIndexedAccessType(objectType,indexType){return (0, _validateNode.default)({type:"OptionalIndexedAccessType",objectType,indexType,optional:null})}function jsxAttribute(name,value=null){return (0, _validateNode.default)({type:"JSXAttribute",name,value})}function jsxClosingElement(name){return (0, _validateNode.default)({type:"JSXClosingElement",name})}function jsxElement(openingElement,closingElement=null,children,selfClosing=null){return (0, _validateNode.default)({type:"JSXElement",openingElement,closingElement,children,selfClosing})}function jsxEmptyExpression(){return {type:"JSXEmptyExpression"}}function jsxExpressionContainer(expression){return (0, _validateNode.default)({type:"JSXExpressionContainer",expression})}function jsxSpreadChild(expression){return (0, _validateNode.default)({type:"JSXSpreadChild",expression})}function jsxIdentifier(name){return (0, _validateNode.default)({type:"JSXIdentifier",name})}function jsxMemberExpression(object,property){return (0, _validateNode.default)({type:"JSXMemberExpression",object,property})}function jsxNamespacedName(namespace,name){return (0, _validateNode.default)({type:"JSXNamespacedName",namespace,name})}function jsxOpeningElement(name,attributes,selfClosing=!1){return (0, _validateNode.default)({type:"JSXOpeningElement",name,attributes,selfClosing})}function jsxSpreadAttribute(argument){return (0, _validateNode.default)({type:"JSXSpreadAttribute",argument})}function jsxText(value){return (0, _validateNode.default)({type:"JSXText",value})}function jsxFragment(openingFragment,closingFragment,children){return (0, _validateNode.default)({type:"JSXFragment",openingFragment,closingFragment,children})}function jsxOpeningFragment(){return {type:"JSXOpeningFragment"}}function jsxClosingFragment(){return {type:"JSXClosingFragment"}}function noop(){return {type:"Noop"}}function placeholder(expectedNode,name){return (0, _validateNode.default)({type:"Placeholder",expectedNode,name})}function v8IntrinsicIdentifier(name){return (0, _validateNode.default)({type:"V8IntrinsicIdentifier",name})}function argumentPlaceholder(){return {type:"ArgumentPlaceholder"}}function bindExpression(object,callee){return (0, _validateNode.default)({type:"BindExpression",object,callee})}function importAttribute(key,value){return (0, _validateNode.default)({type:"ImportAttribute",key,value})}function decorator(expression){return (0, _validateNode.default)({type:"Decorator",expression})}function doExpression(body,async=!1){return (0, _validateNode.default)({type:"DoExpression",body,async})}function exportDefaultSpecifier(exported){return (0, _validateNode.default)({type:"ExportDefaultSpecifier",exported})}function recordExpression(properties){return (0, _validateNode.default)({type:"RecordExpression",properties})}function tupleExpression(elements=[]){return (0, _validateNode.default)({type:"TupleExpression",elements})}function decimalLiteral(value){return (0, _validateNode.default)({type:"DecimalLiteral",value})}function moduleExpression(body){return (0, _validateNode.default)({type:"ModuleExpression",body})}function topicReference(){return {type:"TopicReference"}}function pipelineTopicExpression(expression){return (0, _validateNode.default)({type:"PipelineTopicExpression",expression})}function pipelineBareFunction(callee){return (0, _validateNode.default)({type:"PipelineBareFunction",callee})}function pipelinePrimaryTopicReference(){return {type:"PipelinePrimaryTopicReference"}}function tsParameterProperty(parameter){return (0, _validateNode.default)({type:"TSParameterProperty",parameter})}function tsDeclareFunction(id=null,typeParameters=null,params,returnType=null){return (0, _validateNode.default)({type:"TSDeclareFunction",id,typeParameters,params,returnType})}function tsDeclareMethod(decorators=null,key,typeParameters=null,params,returnType=null){return (0, _validateNode.default)({type:"TSDeclareMethod",decorators,key,typeParameters,params,returnType})}function tsQualifiedName(left,right){return (0, _validateNode.default)({type:"TSQualifiedName",left,right})}function tsCallSignatureDeclaration(typeParameters=null,parameters,typeAnnotation2=null){return (0, _validateNode.default)({type:"TSCallSignatureDeclaration",typeParameters,parameters,typeAnnotation:typeAnnotation2})}function tsConstructSignatureDeclaration(typeParameters=null,parameters,typeAnnotation2=null){return (0, _validateNode.default)({type:"TSConstructSignatureDeclaration",typeParameters,parameters,typeAnnotation:typeAnnotation2})}function tsPropertySignature(key,typeAnnotation2=null){return (0, _validateNode.default)({type:"TSPropertySignature",key,typeAnnotation:typeAnnotation2,kind:null})}function tsMethodSignature(key,typeParameters=null,parameters,typeAnnotation2=null){return (0, _validateNode.default)({type:"TSMethodSignature",key,typeParameters,parameters,typeAnnotation:typeAnnotation2,kind:null})}function tsIndexSignature(parameters,typeAnnotation2=null){return (0, _validateNode.default)({type:"TSIndexSignature",parameters,typeAnnotation:typeAnnotation2})}function tsAnyKeyword2(){return {type:"TSAnyKeyword"}}function tsBooleanKeyword(){return {type:"TSBooleanKeyword"}}function tsBigIntKeyword(){return {type:"TSBigIntKeyword"}}function tsIntrinsicKeyword(){return {type:"TSIntrinsicKeyword"}}function tsNeverKeyword(){return {type:"TSNeverKeyword"}}function tsNullKeyword(){return {type:"TSNullKeyword"}}function tsNumberKeyword(){return {type:"TSNumberKeyword"}}function tsObjectKeyword(){return {type:"TSObjectKeyword"}}function tsStringKeyword(){return {type:"TSStringKeyword"}}function tsSymbolKeyword(){return {type:"TSSymbolKeyword"}}function tsUndefinedKeyword(){return {type:"TSUndefinedKeyword"}}function tsUnknownKeyword(){return {type:"TSUnknownKeyword"}}function tsVoidKeyword(){return {type:"TSVoidKeyword"}}function tsThisType(){return {type:"TSThisType"}}function tsFunctionType(typeParameters=null,parameters,typeAnnotation2=null){return (0, _validateNode.default)({type:"TSFunctionType",typeParameters,parameters,typeAnnotation:typeAnnotation2})}function tsConstructorType(typeParameters=null,parameters,typeAnnotation2=null){return (0, _validateNode.default)({type:"TSConstructorType",typeParameters,parameters,typeAnnotation:typeAnnotation2})}function tsTypeReference(typeName,typeParameters=null){return (0, _validateNode.default)({type:"TSTypeReference",typeName,typeParameters})}function tsTypePredicate(parameterName,typeAnnotation2=null,asserts=null){return (0, _validateNode.default)({type:"TSTypePredicate",parameterName,typeAnnotation:typeAnnotation2,asserts})}function tsTypeQuery(exprName,typeParameters=null){return (0, _validateNode.default)({type:"TSTypeQuery",exprName,typeParameters})}function tsTypeLiteral(members){return (0, _validateNode.default)({type:"TSTypeLiteral",members})}function tsArrayType(elementType){return (0, _validateNode.default)({type:"TSArrayType",elementType})}function tsTupleType(elementTypes){return (0, _validateNode.default)({type:"TSTupleType",elementTypes})}function tsOptionalType(typeAnnotation2){return (0, _validateNode.default)({type:"TSOptionalType",typeAnnotation:typeAnnotation2})}function tsRestType(typeAnnotation2){return (0, _validateNode.default)({type:"TSRestType",typeAnnotation:typeAnnotation2})}function tsNamedTupleMember(label,elementType,optional=!1){return (0, _validateNode.default)({type:"TSNamedTupleMember",label,elementType,optional})}function tsUnionType(types){return (0, _validateNode.default)({type:"TSUnionType",types})}function tsIntersectionType(types){return (0, _validateNode.default)({type:"TSIntersectionType",types})}function tsConditionalType(checkType,extendsType,trueType,falseType){return (0, _validateNode.default)({type:"TSConditionalType",checkType,extendsType,trueType,falseType})}function tsInferType(typeParameter2){return (0, _validateNode.default)({type:"TSInferType",typeParameter:typeParameter2})}function tsParenthesizedType(typeAnnotation2){return (0, _validateNode.default)({type:"TSParenthesizedType",typeAnnotation:typeAnnotation2})}function tsTypeOperator(typeAnnotation2){return (0, _validateNode.default)({type:"TSTypeOperator",typeAnnotation:typeAnnotation2,operator:null})}function tsIndexedAccessType(objectType,indexType){return (0, _validateNode.default)({type:"TSIndexedAccessType",objectType,indexType})}function tsMappedType(typeParameter2,typeAnnotation2=null,nameType=null){return (0, _validateNode.default)({type:"TSMappedType",typeParameter:typeParameter2,typeAnnotation:typeAnnotation2,nameType})}function tsLiteralType(literal){return (0, _validateNode.default)({type:"TSLiteralType",literal})}function tsExpressionWithTypeArguments(expression,typeParameters=null){return (0, _validateNode.default)({type:"TSExpressionWithTypeArguments",expression,typeParameters})}function tsInterfaceDeclaration(id,typeParameters=null,_extends=null,body){return (0, _validateNode.default)({type:"TSInterfaceDeclaration",id,typeParameters,extends:_extends,body})}function tsInterfaceBody(body){return (0, _validateNode.default)({type:"TSInterfaceBody",body})}function tsTypeAliasDeclaration(id,typeParameters=null,typeAnnotation2){return (0, _validateNode.default)({type:"TSTypeAliasDeclaration",id,typeParameters,typeAnnotation:typeAnnotation2})}function tsInstantiationExpression(expression,typeParameters=null){return (0, _validateNode.default)({type:"TSInstantiationExpression",expression,typeParameters})}function tsAsExpression(expression,typeAnnotation2){return (0, _validateNode.default)({type:"TSAsExpression",expression,typeAnnotation:typeAnnotation2})}function tsSatisfiesExpression(expression,typeAnnotation2){return (0, _validateNode.default)({type:"TSSatisfiesExpression",expression,typeAnnotation:typeAnnotation2})}function tsTypeAssertion(typeAnnotation2,expression){return (0, _validateNode.default)({type:"TSTypeAssertion",typeAnnotation:typeAnnotation2,expression})}function tsEnumDeclaration(id,members){return (0, _validateNode.default)({type:"TSEnumDeclaration",id,members})}function tsEnumMember(id,initializer=null){return (0, _validateNode.default)({type:"TSEnumMember",id,initializer})}function tsModuleDeclaration(id,body){return (0, _validateNode.default)({type:"TSModuleDeclaration",id,body})}function tsModuleBlock(body){return (0, _validateNode.default)({type:"TSModuleBlock",body})}function tsImportType(argument,qualifier=null,typeParameters=null){return (0, _validateNode.default)({type:"TSImportType",argument,qualifier,typeParameters})}function tsImportEqualsDeclaration(id,moduleReference){return (0, _validateNode.default)({type:"TSImportEqualsDeclaration",id,moduleReference,isExport:null})}function tsExternalModuleReference(expression){return (0, _validateNode.default)({type:"TSExternalModuleReference",expression})}function tsNonNullExpression(expression){return (0, _validateNode.default)({type:"TSNonNullExpression",expression})}function tsExportAssignment(expression){return (0, _validateNode.default)({type:"TSExportAssignment",expression})}function tsNamespaceExportDeclaration(id){return (0, _validateNode.default)({type:"TSNamespaceExportDeclaration",id})}function tsTypeAnnotation2(typeAnnotation2){return (0, _validateNode.default)({type:"TSTypeAnnotation",typeAnnotation:typeAnnotation2})}function tsTypeParameterInstantiation(params){return (0, _validateNode.default)({type:"TSTypeParameterInstantiation",params})}function tsTypeParameterDeclaration(params){return (0, _validateNode.default)({type:"TSTypeParameterDeclaration",params})}function tsTypeParameter(constraint=null,_default=null,name){return (0, _validateNode.default)({type:"TSTypeParameter",constraint,default:_default,name})}function NumberLiteral(value){return (0, _deprecationWarning.default)("NumberLiteral","NumericLiteral","The node type "),numericLiteral(value)}function RegexLiteral(pattern,flags=""){return (0, _deprecationWarning.default)("RegexLiteral","RegExpLiteral","The node type "),regExpLiteral(pattern,flags)}function RestProperty(argument){return (0, _deprecationWarning.default)("RestProperty","RestElement","The node type "),restElement(argument)}function SpreadProperty(argument){return (0, _deprecationWarning.default)("SpreadProperty","SpreadElement","The node type "),spreadElement(argument)}}});var require_cleanJSXElementLiteralChild=__commonJS({"../../node_modules/@babel/types/lib/utils/react/cleanJSXElementLiteralChild.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=cleanJSXElementLiteralChild;var _index=require_generated2(),_index2=require_lib3();function cleanJSXElementLiteralChild(child,args2){let lines=child.value.split(/\r\n|\n|\r/),lastNonEmptyLine=0;for(let i=0;i<lines.length;i++)lines[i].match(/[^ \t]/)&&(lastNonEmptyLine=i);let str="";for(let i=0;i<lines.length;i++){let line=lines[i],isFirstLine=i===0,isLastLine=i===lines.length-1,isLastNonEmptyLine=i===lastNonEmptyLine,trimmedLine=line.replace(/\t/g," ");isFirstLine||(trimmedLine=trimmedLine.replace(/^[ ]+/,"")),isLastLine||(trimmedLine=trimmedLine.replace(/[ ]+$/,"")),trimmedLine&&(isLastNonEmptyLine||(trimmedLine+=" "),str+=trimmedLine);}str&&args2.push((0, _index2.inherits)((0, _index.stringLiteral)(str),child));}}});var require_buildChildren=__commonJS({"../../node_modules/@babel/types/lib/builders/react/buildChildren.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=buildChildren;var _index=require_generated(),_cleanJSXElementLiteralChild=require_cleanJSXElementLiteralChild();function buildChildren(node){let elements=[];for(let i=0;i<node.children.length;i++){let child=node.children[i];if((0, _index.isJSXText)(child)){(0, _cleanJSXElementLiteralChild.default)(child,elements);continue}(0, _index.isJSXExpressionContainer)(child)&&(child=child.expression),!(0, _index.isJSXEmptyExpression)(child)&&elements.push(child);}return elements}}});var require_isNode=__commonJS({"../../node_modules/@babel/types/lib/validators/isNode.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=isNode;var _index=require_definitions();function isNode(node){return !!(node&&_index.VISITOR_KEYS[node.type])}}});var require_assertNode=__commonJS({"../../node_modules/@babel/types/lib/asserts/assertNode.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=assertNode;var _isNode=require_isNode();function assertNode(node){if(!(0, _isNode.default)(node)){var _node$type;let type=(_node$type=node?.type)!=null?_node$type:JSON.stringify(node);throw new TypeError(`Not a valid node of type "${type}"`)}}}});var require_generated3=__commonJS({"../../node_modules/@babel/types/lib/asserts/generated/index.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.assertAccessor=assertAccessor;exports.assertAnyTypeAnnotation=assertAnyTypeAnnotation;exports.assertArgumentPlaceholder=assertArgumentPlaceholder;exports.assertArrayExpression=assertArrayExpression;exports.assertArrayPattern=assertArrayPattern;exports.assertArrayTypeAnnotation=assertArrayTypeAnnotation;exports.assertArrowFunctionExpression=assertArrowFunctionExpression;exports.assertAssignmentExpression=assertAssignmentExpression;exports.assertAssignmentPattern=assertAssignmentPattern;exports.assertAwaitExpression=assertAwaitExpression;exports.assertBigIntLiteral=assertBigIntLiteral;exports.assertBinary=assertBinary;exports.assertBinaryExpression=assertBinaryExpression;exports.assertBindExpression=assertBindExpression;exports.assertBlock=assertBlock;exports.assertBlockParent=assertBlockParent;exports.assertBlockStatement=assertBlockStatement;exports.assertBooleanLiteral=assertBooleanLiteral;exports.assertBooleanLiteralTypeAnnotation=assertBooleanLiteralTypeAnnotation;exports.assertBooleanTypeAnnotation=assertBooleanTypeAnnotation;exports.assertBreakStatement=assertBreakStatement;exports.assertCallExpression=assertCallExpression;exports.assertCatchClause=assertCatchClause;exports.assertClass=assertClass;exports.assertClassAccessorProperty=assertClassAccessorProperty;exports.assertClassBody=assertClassBody;exports.assertClassDeclaration=assertClassDeclaration;exports.assertClassExpression=assertClassExpression;exports.assertClassImplements=assertClassImplements;exports.assertClassMethod=assertClassMethod;exports.assertClassPrivateMethod=assertClassPrivateMethod;exports.assertClassPrivateProperty=assertClassPrivateProperty;exports.assertClassProperty=assertClassProperty;exports.assertCompletionStatement=assertCompletionStatement;exports.assertConditional=assertConditional;exports.assertConditionalExpression=assertConditionalExpression;exports.assertContinueStatement=assertContinueStatement;exports.assertDebuggerStatement=assertDebuggerStatement;exports.assertDecimalLiteral=assertDecimalLiteral;exports.assertDeclaration=assertDeclaration;exports.assertDeclareClass=assertDeclareClass;exports.assertDeclareExportAllDeclaration=assertDeclareExportAllDeclaration;exports.assertDeclareExportDeclaration=assertDeclareExportDeclaration;exports.assertDeclareFunction=assertDeclareFunction;exports.assertDeclareInterface=assertDeclareInterface;exports.assertDeclareModule=assertDeclareModule;exports.assertDeclareModuleExports=assertDeclareModuleExports;exports.assertDeclareOpaqueType=assertDeclareOpaqueType;exports.assertDeclareTypeAlias=assertDeclareTypeAlias;exports.assertDeclareVariable=assertDeclareVariable;exports.assertDeclaredPredicate=assertDeclaredPredicate;exports.assertDecorator=assertDecorator;exports.assertDirective=assertDirective;exports.assertDirectiveLiteral=assertDirectiveLiteral;exports.assertDoExpression=assertDoExpression;exports.assertDoWhileStatement=assertDoWhileStatement;exports.assertEmptyStatement=assertEmptyStatement;exports.assertEmptyTypeAnnotation=assertEmptyTypeAnnotation;exports.assertEnumBody=assertEnumBody;exports.assertEnumBooleanBody=assertEnumBooleanBody;exports.assertEnumBooleanMember=assertEnumBooleanMember;exports.assertEnumDeclaration=assertEnumDeclaration;exports.assertEnumDefaultedMember=assertEnumDefaultedMember;exports.assertEnumMember=assertEnumMember;exports.assertEnumNumberBody=assertEnumNumberBody;exports.assertEnumNumberMember=assertEnumNumberMember;exports.assertEnumStringBody=assertEnumStringBody;exports.assertEnumStringMember=assertEnumStringMember;exports.assertEnumSymbolBody=assertEnumSymbolBody;exports.assertExistsTypeAnnotation=assertExistsTypeAnnotation;exports.assertExportAllDeclaration=assertExportAllDeclaration;exports.assertExportDeclaration=assertExportDeclaration;exports.assertExportDefaultDeclaration=assertExportDefaultDeclaration;exports.assertExportDefaultSpecifier=assertExportDefaultSpecifier;exports.assertExportNamedDeclaration=assertExportNamedDeclaration;exports.assertExportNamespaceSpecifier=assertExportNamespaceSpecifier;exports.assertExportSpecifier=assertExportSpecifier;exports.assertExpression=assertExpression;exports.assertExpressionStatement=assertExpressionStatement;exports.assertExpressionWrapper=assertExpressionWrapper;exports.assertFile=assertFile;exports.assertFlow=assertFlow;exports.assertFlowBaseAnnotation=assertFlowBaseAnnotation;exports.assertFlowDeclaration=assertFlowDeclaration;exports.assertFlowPredicate=assertFlowPredicate;exports.assertFlowType=assertFlowType;exports.assertFor=assertFor;exports.assertForInStatement=assertForInStatement;exports.assertForOfStatement=assertForOfStatement;exports.assertForStatement=assertForStatement;exports.assertForXStatement=assertForXStatement;exports.assertFunction=assertFunction;exports.assertFunctionDeclaration=assertFunctionDeclaration;exports.assertFunctionExpression=assertFunctionExpression;exports.assertFunctionParent=assertFunctionParent;exports.assertFunctionTypeAnnotation=assertFunctionTypeAnnotation;exports.assertFunctionTypeParam=assertFunctionTypeParam;exports.assertGenericTypeAnnotation=assertGenericTypeAnnotation;exports.assertIdentifier=assertIdentifier;exports.assertIfStatement=assertIfStatement;exports.assertImmutable=assertImmutable;exports.assertImport=assertImport;exports.assertImportAttribute=assertImportAttribute;exports.assertImportDeclaration=assertImportDeclaration;exports.assertImportDefaultSpecifier=assertImportDefaultSpecifier;exports.assertImportExpression=assertImportExpression;exports.assertImportNamespaceSpecifier=assertImportNamespaceSpecifier;exports.assertImportOrExportDeclaration=assertImportOrExportDeclaration;exports.assertImportSpecifier=assertImportSpecifier;exports.assertIndexedAccessType=assertIndexedAccessType;exports.assertInferredPredicate=assertInferredPredicate;exports.assertInterfaceDeclaration=assertInterfaceDeclaration;exports.assertInterfaceExtends=assertInterfaceExtends;exports.assertInterfaceTypeAnnotation=assertInterfaceTypeAnnotation;exports.assertInterpreterDirective=assertInterpreterDirective;exports.assertIntersectionTypeAnnotation=assertIntersectionTypeAnnotation;exports.assertJSX=assertJSX;exports.assertJSXAttribute=assertJSXAttribute;exports.assertJSXClosingElement=assertJSXClosingElement;exports.assertJSXClosingFragment=assertJSXClosingFragment;exports.assertJSXElement=assertJSXElement;exports.assertJSXEmptyExpression=assertJSXEmptyExpression;exports.assertJSXExpressionContainer=assertJSXExpressionContainer;exports.assertJSXFragment=assertJSXFragment;exports.assertJSXIdentifier=assertJSXIdentifier;exports.assertJSXMemberExpression=assertJSXMemberExpression;exports.assertJSXNamespacedName=assertJSXNamespacedName;exports.assertJSXOpeningElement=assertJSXOpeningElement;exports.assertJSXOpeningFragment=assertJSXOpeningFragment;exports.assertJSXSpreadAttribute=assertJSXSpreadAttribute;exports.assertJSXSpreadChild=assertJSXSpreadChild;exports.assertJSXText=assertJSXText;exports.assertLVal=assertLVal;exports.assertLabeledStatement=assertLabeledStatement;exports.assertLiteral=assertLiteral;exports.assertLogicalExpression=assertLogicalExpression;exports.assertLoop=assertLoop;exports.assertMemberExpression=assertMemberExpression;exports.assertMetaProperty=assertMetaProperty;exports.assertMethod=assertMethod;exports.assertMiscellaneous=assertMiscellaneous;exports.assertMixedTypeAnnotation=assertMixedTypeAnnotation;exports.assertModuleDeclaration=assertModuleDeclaration;exports.assertModuleExpression=assertModuleExpression;exports.assertModuleSpecifier=assertModuleSpecifier;exports.assertNewExpression=assertNewExpression;exports.assertNoop=assertNoop;exports.assertNullLiteral=assertNullLiteral;exports.assertNullLiteralTypeAnnotation=assertNullLiteralTypeAnnotation;exports.assertNullableTypeAnnotation=assertNullableTypeAnnotation;exports.assertNumberLiteral=assertNumberLiteral;exports.assertNumberLiteralTypeAnnotation=assertNumberLiteralTypeAnnotation;exports.assertNumberTypeAnnotation=assertNumberTypeAnnotation;exports.assertNumericLiteral=assertNumericLiteral;exports.assertObjectExpression=assertObjectExpression;exports.assertObjectMember=assertObjectMember;exports.assertObjectMethod=assertObjectMethod;exports.assertObjectPattern=assertObjectPattern;exports.assertObjectProperty=assertObjectProperty;exports.assertObjectTypeAnnotation=assertObjectTypeAnnotation;exports.assertObjectTypeCallProperty=assertObjectTypeCallProperty;exports.assertObjectTypeIndexer=assertObjectTypeIndexer;exports.assertObjectTypeInternalSlot=assertObjectTypeInternalSlot;exports.assertObjectTypeProperty=assertObjectTypeProperty;exports.assertObjectTypeSpreadProperty=assertObjectTypeSpreadProperty;exports.assertOpaqueType=assertOpaqueType;exports.assertOptionalCallExpression=assertOptionalCallExpression;exports.assertOptionalIndexedAccessType=assertOptionalIndexedAccessType;exports.assertOptionalMemberExpression=assertOptionalMemberExpression;exports.assertParenthesizedExpression=assertParenthesizedExpression;exports.assertPattern=assertPattern;exports.assertPatternLike=assertPatternLike;exports.assertPipelineBareFunction=assertPipelineBareFunction;exports.assertPipelinePrimaryTopicReference=assertPipelinePrimaryTopicReference;exports.assertPipelineTopicExpression=assertPipelineTopicExpression;exports.assertPlaceholder=assertPlaceholder;exports.assertPrivate=assertPrivate;exports.assertPrivateName=assertPrivateName;exports.assertProgram=assertProgram;exports.assertProperty=assertProperty;exports.assertPureish=assertPureish;exports.assertQualifiedTypeIdentifier=assertQualifiedTypeIdentifier;exports.assertRecordExpression=assertRecordExpression;exports.assertRegExpLiteral=assertRegExpLiteral;exports.assertRegexLiteral=assertRegexLiteral;exports.assertRestElement=assertRestElement;exports.assertRestProperty=assertRestProperty;exports.assertReturnStatement=assertReturnStatement;exports.assertScopable=assertScopable;exports.assertSequenceExpression=assertSequenceExpression;exports.assertSpreadElement=assertSpreadElement;exports.assertSpreadProperty=assertSpreadProperty;exports.assertStandardized=assertStandardized;exports.assertStatement=assertStatement;exports.assertStaticBlock=assertStaticBlock;exports.assertStringLiteral=assertStringLiteral;exports.assertStringLiteralTypeAnnotation=assertStringLiteralTypeAnnotation;exports.assertStringTypeAnnotation=assertStringTypeAnnotation;exports.assertSuper=assertSuper;exports.assertSwitchCase=assertSwitchCase;exports.assertSwitchStatement=assertSwitchStatement;exports.assertSymbolTypeAnnotation=assertSymbolTypeAnnotation;exports.assertTSAnyKeyword=assertTSAnyKeyword;exports.assertTSArrayType=assertTSArrayType;exports.assertTSAsExpression=assertTSAsExpression;exports.assertTSBaseType=assertTSBaseType;exports.assertTSBigIntKeyword=assertTSBigIntKeyword;exports.assertTSBooleanKeyword=assertTSBooleanKeyword;exports.assertTSCallSignatureDeclaration=assertTSCallSignatureDeclaration;exports.assertTSConditionalType=assertTSConditionalType;exports.assertTSConstructSignatureDeclaration=assertTSConstructSignatureDeclaration;exports.assertTSConstructorType=assertTSConstructorType;exports.assertTSDeclareFunction=assertTSDeclareFunction;exports.assertTSDeclareMethod=assertTSDeclareMethod;exports.assertTSEntityName=assertTSEntityName;exports.assertTSEnumDeclaration=assertTSEnumDeclaration;exports.assertTSEnumMember=assertTSEnumMember;exports.assertTSExportAssignment=assertTSExportAssignment;exports.assertTSExpressionWithTypeArguments=assertTSExpressionWithTypeArguments;exports.assertTSExternalModuleReference=assertTSExternalModuleReference;exports.assertTSFunctionType=assertTSFunctionType;exports.assertTSImportEqualsDeclaration=assertTSImportEqualsDeclaration;exports.assertTSImportType=assertTSImportType;exports.assertTSIndexSignature=assertTSIndexSignature;exports.assertTSIndexedAccessType=assertTSIndexedAccessType;exports.assertTSInferType=assertTSInferType;exports.assertTSInstantiationExpression=assertTSInstantiationExpression;exports.assertTSInterfaceBody=assertTSInterfaceBody;exports.assertTSInterfaceDeclaration=assertTSInterfaceDeclaration;exports.assertTSIntersectionType=assertTSIntersectionType;exports.assertTSIntrinsicKeyword=assertTSIntrinsicKeyword;exports.assertTSLiteralType=assertTSLiteralType;exports.assertTSMappedType=assertTSMappedType;exports.assertTSMethodSignature=assertTSMethodSignature;exports.assertTSModuleBlock=assertTSModuleBlock;exports.assertTSModuleDeclaration=assertTSModuleDeclaration;exports.assertTSNamedTupleMember=assertTSNamedTupleMember;exports.assertTSNamespaceExportDeclaration=assertTSNamespaceExportDeclaration;exports.assertTSNeverKeyword=assertTSNeverKeyword;exports.assertTSNonNullExpression=assertTSNonNullExpression;exports.assertTSNullKeyword=assertTSNullKeyword;exports.assertTSNumberKeyword=assertTSNumberKeyword;exports.assertTSObjectKeyword=assertTSObjectKeyword;exports.assertTSOptionalType=assertTSOptionalType;exports.assertTSParameterProperty=assertTSParameterProperty;exports.assertTSParenthesizedType=assertTSParenthesizedType;exports.assertTSPropertySignature=assertTSPropertySignature;exports.assertTSQualifiedName=assertTSQualifiedName;exports.assertTSRestType=assertTSRestType;exports.assertTSSatisfiesExpression=assertTSSatisfiesExpression;exports.assertTSStringKeyword=assertTSStringKeyword;exports.assertTSSymbolKeyword=assertTSSymbolKeyword;exports.assertTSThisType=assertTSThisType;exports.assertTSTupleType=assertTSTupleType;exports.assertTSType=assertTSType;exports.assertTSTypeAliasDeclaration=assertTSTypeAliasDeclaration;exports.assertTSTypeAnnotation=assertTSTypeAnnotation;exports.assertTSTypeAssertion=assertTSTypeAssertion;exports.assertTSTypeElement=assertTSTypeElement;exports.assertTSTypeLiteral=assertTSTypeLiteral;exports.assertTSTypeOperator=assertTSTypeOperator;exports.assertTSTypeParameter=assertTSTypeParameter;exports.assertTSTypeParameterDeclaration=assertTSTypeParameterDeclaration;exports.assertTSTypeParameterInstantiation=assertTSTypeParameterInstantiation;exports.assertTSTypePredicate=assertTSTypePredicate;exports.assertTSTypeQuery=assertTSTypeQuery;exports.assertTSTypeReference=assertTSTypeReference;exports.assertTSUndefinedKeyword=assertTSUndefinedKeyword;exports.assertTSUnionType=assertTSUnionType;exports.assertTSUnknownKeyword=assertTSUnknownKeyword;exports.assertTSVoidKeyword=assertTSVoidKeyword;exports.assertTaggedTemplateExpression=assertTaggedTemplateExpression;exports.assertTemplateElement=assertTemplateElement;exports.assertTemplateLiteral=assertTemplateLiteral;exports.assertTerminatorless=assertTerminatorless;exports.assertThisExpression=assertThisExpression;exports.assertThisTypeAnnotation=assertThisTypeAnnotation;exports.assertThrowStatement=assertThrowStatement;exports.assertTopicReference=assertTopicReference;exports.assertTryStatement=assertTryStatement;exports.assertTupleExpression=assertTupleExpression;exports.assertTupleTypeAnnotation=assertTupleTypeAnnotation;exports.assertTypeAlias=assertTypeAlias;exports.assertTypeAnnotation=assertTypeAnnotation;exports.assertTypeCastExpression=assertTypeCastExpression;exports.assertTypeParameter=assertTypeParameter;exports.assertTypeParameterDeclaration=assertTypeParameterDeclaration;exports.assertTypeParameterInstantiation=assertTypeParameterInstantiation;exports.assertTypeScript=assertTypeScript;exports.assertTypeofTypeAnnotation=assertTypeofTypeAnnotation;exports.assertUnaryExpression=assertUnaryExpression;exports.assertUnaryLike=assertUnaryLike;exports.assertUnionTypeAnnotation=assertUnionTypeAnnotation;exports.assertUpdateExpression=assertUpdateExpression;exports.assertUserWhitespacable=assertUserWhitespacable;exports.assertV8IntrinsicIdentifier=assertV8IntrinsicIdentifier;exports.assertVariableDeclaration=assertVariableDeclaration;exports.assertVariableDeclarator=assertVariableDeclarator;exports.assertVariance=assertVariance;exports.assertVoidTypeAnnotation=assertVoidTypeAnnotation;exports.assertWhile=assertWhile;exports.assertWhileStatement=assertWhileStatement;exports.assertWithStatement=assertWithStatement;exports.assertYieldExpression=assertYieldExpression;var _is=require_is(),_deprecationWarning=require_deprecationWarning();function assert(type,node,opts){if(!(0, _is.default)(type,node,opts))throw new Error(`Expected type "${type}" with option ${JSON.stringify(opts)}, but instead got "${node.type}".`)}function assertArrayExpression(node,opts){assert("ArrayExpression",node,opts);}function assertAssignmentExpression(node,opts){assert("AssignmentExpression",node,opts);}function assertBinaryExpression(node,opts){assert("BinaryExpression",node,opts);}function assertInterpreterDirective(node,opts){assert("InterpreterDirective",node,opts);}function assertDirective(node,opts){assert("Directive",node,opts);}function assertDirectiveLiteral(node,opts){assert("DirectiveLiteral",node,opts);}function assertBlockStatement(node,opts){assert("BlockStatement",node,opts);}function assertBreakStatement(node,opts){assert("BreakStatement",node,opts);}function assertCallExpression(node,opts){assert("CallExpression",node,opts);}function assertCatchClause(node,opts){assert("CatchClause",node,opts);}function assertConditionalExpression(node,opts){assert("ConditionalExpression",node,opts);}function assertContinueStatement(node,opts){assert("ContinueStatement",node,opts);}function assertDebuggerStatement(node,opts){assert("DebuggerStatement",node,opts);}function assertDoWhileStatement(node,opts){assert("DoWhileStatement",node,opts);}function assertEmptyStatement(node,opts){assert("EmptyStatement",node,opts);}function assertExpressionStatement(node,opts){assert("ExpressionStatement",node,opts);}function assertFile(node,opts){assert("File",node,opts);}function assertForInStatement(node,opts){assert("ForInStatement",node,opts);}function assertForStatement(node,opts){assert("ForStatement",node,opts);}function assertFunctionDeclaration(node,opts){assert("FunctionDeclaration",node,opts);}function assertFunctionExpression(node,opts){assert("FunctionExpression",node,opts);}function assertIdentifier(node,opts){assert("Identifier",node,opts);}function assertIfStatement(node,opts){assert("IfStatement",node,opts);}function assertLabeledStatement(node,opts){assert("LabeledStatement",node,opts);}function assertStringLiteral(node,opts){assert("StringLiteral",node,opts);}function assertNumericLiteral(node,opts){assert("NumericLiteral",node,opts);}function assertNullLiteral(node,opts){assert("NullLiteral",node,opts);}function assertBooleanLiteral(node,opts){assert("BooleanLiteral",node,opts);}function assertRegExpLiteral(node,opts){assert("RegExpLiteral",node,opts);}function assertLogicalExpression(node,opts){assert("LogicalExpression",node,opts);}function assertMemberExpression(node,opts){assert("MemberExpression",node,opts);}function assertNewExpression(node,opts){assert("NewExpression",node,opts);}function assertProgram(node,opts){assert("Program",node,opts);}function assertObjectExpression(node,opts){assert("ObjectExpression",node,opts);}function assertObjectMethod(node,opts){assert("ObjectMethod",node,opts);}function assertObjectProperty(node,opts){assert("ObjectProperty",node,opts);}function assertRestElement(node,opts){assert("RestElement",node,opts);}function assertReturnStatement(node,opts){assert("ReturnStatement",node,opts);}function assertSequenceExpression(node,opts){assert("SequenceExpression",node,opts);}function assertParenthesizedExpression(node,opts){assert("ParenthesizedExpression",node,opts);}function assertSwitchCase(node,opts){assert("SwitchCase",node,opts);}function assertSwitchStatement(node,opts){assert("SwitchStatement",node,opts);}function assertThisExpression(node,opts){assert("ThisExpression",node,opts);}function assertThrowStatement(node,opts){assert("ThrowStatement",node,opts);}function assertTryStatement(node,opts){assert("TryStatement",node,opts);}function assertUnaryExpression(node,opts){assert("UnaryExpression",node,opts);}function assertUpdateExpression(node,opts){assert("UpdateExpression",node,opts);}function assertVariableDeclaration(node,opts){assert("VariableDeclaration",node,opts);}function assertVariableDeclarator(node,opts){assert("VariableDeclarator",node,opts);}function assertWhileStatement(node,opts){assert("WhileStatement",node,opts);}function assertWithStatement(node,opts){assert("WithStatement",node,opts);}function assertAssignmentPattern(node,opts){assert("AssignmentPattern",node,opts);}function assertArrayPattern(node,opts){assert("ArrayPattern",node,opts);}function assertArrowFunctionExpression(node,opts){assert("ArrowFunctionExpression",node,opts);}function assertClassBody(node,opts){assert("ClassBody",node,opts);}function assertClassExpression(node,opts){assert("ClassExpression",node,opts);}function assertClassDeclaration(node,opts){assert("ClassDeclaration",node,opts);}function assertExportAllDeclaration(node,opts){assert("ExportAllDeclaration",node,opts);}function assertExportDefaultDeclaration(node,opts){assert("ExportDefaultDeclaration",node,opts);}function assertExportNamedDeclaration(node,opts){assert("ExportNamedDeclaration",node,opts);}function assertExportSpecifier(node,opts){assert("ExportSpecifier",node,opts);}function assertForOfStatement(node,opts){assert("ForOfStatement",node,opts);}function assertImportDeclaration(node,opts){assert("ImportDeclaration",node,opts);}function assertImportDefaultSpecifier(node,opts){assert("ImportDefaultSpecifier",node,opts);}function assertImportNamespaceSpecifier(node,opts){assert("ImportNamespaceSpecifier",node,opts);}function assertImportSpecifier(node,opts){assert("ImportSpecifier",node,opts);}function assertImportExpression(node,opts){assert("ImportExpression",node,opts);}function assertMetaProperty(node,opts){assert("MetaProperty",node,opts);}function assertClassMethod(node,opts){assert("ClassMethod",node,opts);}function assertObjectPattern(node,opts){assert("ObjectPattern",node,opts);}function assertSpreadElement(node,opts){assert("SpreadElement",node,opts);}function assertSuper(node,opts){assert("Super",node,opts);}function assertTaggedTemplateExpression(node,opts){assert("TaggedTemplateExpression",node,opts);}function assertTemplateElement(node,opts){assert("TemplateElement",node,opts);}function assertTemplateLiteral(node,opts){assert("TemplateLiteral",node,opts);}function assertYieldExpression(node,opts){assert("YieldExpression",node,opts);}function assertAwaitExpression(node,opts){assert("AwaitExpression",node,opts);}function assertImport(node,opts){assert("Import",node,opts);}function assertBigIntLiteral(node,opts){assert("BigIntLiteral",node,opts);}function assertExportNamespaceSpecifier(node,opts){assert("ExportNamespaceSpecifier",node,opts);}function assertOptionalMemberExpression(node,opts){assert("OptionalMemberExpression",node,opts);}function assertOptionalCallExpression(node,opts){assert("OptionalCallExpression",node,opts);}function assertClassProperty(node,opts){assert("ClassProperty",node,opts);}function assertClassAccessorProperty(node,opts){assert("ClassAccessorProperty",node,opts);}function assertClassPrivateProperty(node,opts){assert("ClassPrivateProperty",node,opts);}function assertClassPrivateMethod(node,opts){assert("ClassPrivateMethod",node,opts);}function assertPrivateName(node,opts){assert("PrivateName",node,opts);}function assertStaticBlock(node,opts){assert("StaticBlock",node,opts);}function assertAnyTypeAnnotation(node,opts){assert("AnyTypeAnnotation",node,opts);}function assertArrayTypeAnnotation(node,opts){assert("ArrayTypeAnnotation",node,opts);}function assertBooleanTypeAnnotation(node,opts){assert("BooleanTypeAnnotation",node,opts);}function assertBooleanLiteralTypeAnnotation(node,opts){assert("BooleanLiteralTypeAnnotation",node,opts);}function assertNullLiteralTypeAnnotation(node,opts){assert("NullLiteralTypeAnnotation",node,opts);}function assertClassImplements(node,opts){assert("ClassImplements",node,opts);}function assertDeclareClass(node,opts){assert("DeclareClass",node,opts);}function assertDeclareFunction(node,opts){assert("DeclareFunction",node,opts);}function assertDeclareInterface(node,opts){assert("DeclareInterface",node,opts);}function assertDeclareModule(node,opts){assert("DeclareModule",node,opts);}function assertDeclareModuleExports(node,opts){assert("DeclareModuleExports",node,opts);}function assertDeclareTypeAlias(node,opts){assert("DeclareTypeAlias",node,opts);}function assertDeclareOpaqueType(node,opts){assert("DeclareOpaqueType",node,opts);}function assertDeclareVariable(node,opts){assert("DeclareVariable",node,opts);}function assertDeclareExportDeclaration(node,opts){assert("DeclareExportDeclaration",node,opts);}function assertDeclareExportAllDeclaration(node,opts){assert("DeclareExportAllDeclaration",node,opts);}function assertDeclaredPredicate(node,opts){assert("DeclaredPredicate",node,opts);}function assertExistsTypeAnnotation(node,opts){assert("ExistsTypeAnnotation",node,opts);}function assertFunctionTypeAnnotation(node,opts){assert("FunctionTypeAnnotation",node,opts);}function assertFunctionTypeParam(node,opts){assert("FunctionTypeParam",node,opts);}function assertGenericTypeAnnotation(node,opts){assert("GenericTypeAnnotation",node,opts);}function assertInferredPredicate(node,opts){assert("InferredPredicate",node,opts);}function assertInterfaceExtends(node,opts){assert("InterfaceExtends",node,opts);}function assertInterfaceDeclaration(node,opts){assert("InterfaceDeclaration",node,opts);}function assertInterfaceTypeAnnotation(node,opts){assert("InterfaceTypeAnnotation",node,opts);}function assertIntersectionTypeAnnotation(node,opts){assert("IntersectionTypeAnnotation",node,opts);}function assertMixedTypeAnnotation(node,opts){assert("MixedTypeAnnotation",node,opts);}function assertEmptyTypeAnnotation(node,opts){assert("EmptyTypeAnnotation",node,opts);}function assertNullableTypeAnnotation(node,opts){assert("NullableTypeAnnotation",node,opts);}function assertNumberLiteralTypeAnnotation(node,opts){assert("NumberLiteralTypeAnnotation",node,opts);}function assertNumberTypeAnnotation(node,opts){assert("NumberTypeAnnotation",node,opts);}function assertObjectTypeAnnotation(node,opts){assert("ObjectTypeAnnotation",node,opts);}function assertObjectTypeInternalSlot(node,opts){assert("ObjectTypeInternalSlot",node,opts);}function assertObjectTypeCallProperty(node,opts){assert("ObjectTypeCallProperty",node,opts);}function assertObjectTypeIndexer(node,opts){assert("ObjectTypeIndexer",node,opts);}function assertObjectTypeProperty(node,opts){assert("ObjectTypeProperty",node,opts);}function assertObjectTypeSpreadProperty(node,opts){assert("ObjectTypeSpreadProperty",node,opts);}function assertOpaqueType(node,opts){assert("OpaqueType",node,opts);}function assertQualifiedTypeIdentifier(node,opts){assert("QualifiedTypeIdentifier",node,opts);}function assertStringLiteralTypeAnnotation(node,opts){assert("StringLiteralTypeAnnotation",node,opts);}function assertStringTypeAnnotation(node,opts){assert("StringTypeAnnotation",node,opts);}function assertSymbolTypeAnnotation(node,opts){assert("SymbolTypeAnnotation",node,opts);}function assertThisTypeAnnotation(node,opts){assert("ThisTypeAnnotation",node,opts);}function assertTupleTypeAnnotation(node,opts){assert("TupleTypeAnnotation",node,opts);}function assertTypeofTypeAnnotation(node,opts){assert("TypeofTypeAnnotation",node,opts);}function assertTypeAlias(node,opts){assert("TypeAlias",node,opts);}function assertTypeAnnotation(node,opts){assert("TypeAnnotation",node,opts);}function assertTypeCastExpression(node,opts){assert("TypeCastExpression",node,opts);}function assertTypeParameter(node,opts){assert("TypeParameter",node,opts);}function assertTypeParameterDeclaration(node,opts){assert("TypeParameterDeclaration",node,opts);}function assertTypeParameterInstantiation(node,opts){assert("TypeParameterInstantiation",node,opts);}function assertUnionTypeAnnotation(node,opts){assert("UnionTypeAnnotation",node,opts);}function assertVariance(node,opts){assert("Variance",node,opts);}function assertVoidTypeAnnotation(node,opts){assert("VoidTypeAnnotation",node,opts);}function assertEnumDeclaration(node,opts){assert("EnumDeclaration",node,opts);}function assertEnumBooleanBody(node,opts){assert("EnumBooleanBody",node,opts);}function assertEnumNumberBody(node,opts){assert("EnumNumberBody",node,opts);}function assertEnumStringBody(node,opts){assert("EnumStringBody",node,opts);}function assertEnumSymbolBody(node,opts){assert("EnumSymbolBody",node,opts);}function assertEnumBooleanMember(node,opts){assert("EnumBooleanMember",node,opts);}function assertEnumNumberMember(node,opts){assert("EnumNumberMember",node,opts);}function assertEnumStringMember(node,opts){assert("EnumStringMember",node,opts);}function assertEnumDefaultedMember(node,opts){assert("EnumDefaultedMember",node,opts);}function assertIndexedAccessType(node,opts){assert("IndexedAccessType",node,opts);}function assertOptionalIndexedAccessType(node,opts){assert("OptionalIndexedAccessType",node,opts);}function assertJSXAttribute(node,opts){assert("JSXAttribute",node,opts);}function assertJSXClosingElement(node,opts){assert("JSXClosingElement",node,opts);}function assertJSXElement(node,opts){assert("JSXElement",node,opts);}function assertJSXEmptyExpression(node,opts){assert("JSXEmptyExpression",node,opts);}function assertJSXExpressionContainer(node,opts){assert("JSXExpressionContainer",node,opts);}function assertJSXSpreadChild(node,opts){assert("JSXSpreadChild",node,opts);}function assertJSXIdentifier(node,opts){assert("JSXIdentifier",node,opts);}function assertJSXMemberExpression(node,opts){assert("JSXMemberExpression",node,opts);}function assertJSXNamespacedName(node,opts){assert("JSXNamespacedName",node,opts);}function assertJSXOpeningElement(node,opts){assert("JSXOpeningElement",node,opts);}function assertJSXSpreadAttribute(node,opts){assert("JSXSpreadAttribute",node,opts);}function assertJSXText(node,opts){assert("JSXText",node,opts);}function assertJSXFragment(node,opts){assert("JSXFragment",node,opts);}function assertJSXOpeningFragment(node,opts){assert("JSXOpeningFragment",node,opts);}function assertJSXClosingFragment(node,opts){assert("JSXClosingFragment",node,opts);}function assertNoop(node,opts){assert("Noop",node,opts);}function assertPlaceholder(node,opts){assert("Placeholder",node,opts);}function assertV8IntrinsicIdentifier(node,opts){assert("V8IntrinsicIdentifier",node,opts);}function assertArgumentPlaceholder(node,opts){assert("ArgumentPlaceholder",node,opts);}function assertBindExpression(node,opts){assert("BindExpression",node,opts);}function assertImportAttribute(node,opts){assert("ImportAttribute",node,opts);}function assertDecorator(node,opts){assert("Decorator",node,opts);}function assertDoExpression(node,opts){assert("DoExpression",node,opts);}function assertExportDefaultSpecifier(node,opts){assert("ExportDefaultSpecifier",node,opts);}function assertRecordExpression(node,opts){assert("RecordExpression",node,opts);}function assertTupleExpression(node,opts){assert("TupleExpression",node,opts);}function assertDecimalLiteral(node,opts){assert("DecimalLiteral",node,opts);}function assertModuleExpression(node,opts){assert("ModuleExpression",node,opts);}function assertTopicReference(node,opts){assert("TopicReference",node,opts);}function assertPipelineTopicExpression(node,opts){assert("PipelineTopicExpression",node,opts);}function assertPipelineBareFunction(node,opts){assert("PipelineBareFunction",node,opts);}function assertPipelinePrimaryTopicReference(node,opts){assert("PipelinePrimaryTopicReference",node,opts);}function assertTSParameterProperty(node,opts){assert("TSParameterProperty",node,opts);}function assertTSDeclareFunction(node,opts){assert("TSDeclareFunction",node,opts);}function assertTSDeclareMethod(node,opts){assert("TSDeclareMethod",node,opts);}function assertTSQualifiedName(node,opts){assert("TSQualifiedName",node,opts);}function assertTSCallSignatureDeclaration(node,opts){assert("TSCallSignatureDeclaration",node,opts);}function assertTSConstructSignatureDeclaration(node,opts){assert("TSConstructSignatureDeclaration",node,opts);}function assertTSPropertySignature(node,opts){assert("TSPropertySignature",node,opts);}function assertTSMethodSignature(node,opts){assert("TSMethodSignature",node,opts);}function assertTSIndexSignature(node,opts){assert("TSIndexSignature",node,opts);}function assertTSAnyKeyword(node,opts){assert("TSAnyKeyword",node,opts);}function assertTSBooleanKeyword(node,opts){assert("TSBooleanKeyword",node,opts);}function assertTSBigIntKeyword(node,opts){assert("TSBigIntKeyword",node,opts);}function assertTSIntrinsicKeyword(node,opts){assert("TSIntrinsicKeyword",node,opts);}function assertTSNeverKeyword(node,opts){assert("TSNeverKeyword",node,opts);}function assertTSNullKeyword(node,opts){assert("TSNullKeyword",node,opts);}function assertTSNumberKeyword(node,opts){assert("TSNumberKeyword",node,opts);}function assertTSObjectKeyword(node,opts){assert("TSObjectKeyword",node,opts);}function assertTSStringKeyword(node,opts){assert("TSStringKeyword",node,opts);}function assertTSSymbolKeyword(node,opts){assert("TSSymbolKeyword",node,opts);}function assertTSUndefinedKeyword(node,opts){assert("TSUndefinedKeyword",node,opts);}function assertTSUnknownKeyword(node,opts){assert("TSUnknownKeyword",node,opts);}function assertTSVoidKeyword(node,opts){assert("TSVoidKeyword",node,opts);}function assertTSThisType(node,opts){assert("TSThisType",node,opts);}function assertTSFunctionType(node,opts){assert("TSFunctionType",node,opts);}function assertTSConstructorType(node,opts){assert("TSConstructorType",node,opts);}function assertTSTypeReference(node,opts){assert("TSTypeReference",node,opts);}function assertTSTypePredicate(node,opts){assert("TSTypePredicate",node,opts);}function assertTSTypeQuery(node,opts){assert("TSTypeQuery",node,opts);}function assertTSTypeLiteral(node,opts){assert("TSTypeLiteral",node,opts);}function assertTSArrayType(node,opts){assert("TSArrayType",node,opts);}function assertTSTupleType(node,opts){assert("TSTupleType",node,opts);}function assertTSOptionalType(node,opts){assert("TSOptionalType",node,opts);}function assertTSRestType(node,opts){assert("TSRestType",node,opts);}function assertTSNamedTupleMember(node,opts){assert("TSNamedTupleMember",node,opts);}function assertTSUnionType(node,opts){assert("TSUnionType",node,opts);}function assertTSIntersectionType(node,opts){assert("TSIntersectionType",node,opts);}function assertTSConditionalType(node,opts){assert("TSConditionalType",node,opts);}function assertTSInferType(node,opts){assert("TSInferType",node,opts);}function assertTSParenthesizedType(node,opts){assert("TSParenthesizedType",node,opts);}function assertTSTypeOperator(node,opts){assert("TSTypeOperator",node,opts);}function assertTSIndexedAccessType(node,opts){assert("TSIndexedAccessType",node,opts);}function assertTSMappedType(node,opts){assert("TSMappedType",node,opts);}function assertTSLiteralType(node,opts){assert("TSLiteralType",node,opts);}function assertTSExpressionWithTypeArguments(node,opts){assert("TSExpressionWithTypeArguments",node,opts);}function assertTSInterfaceDeclaration(node,opts){assert("TSInterfaceDeclaration",node,opts);}function assertTSInterfaceBody(node,opts){assert("TSInterfaceBody",node,opts);}function assertTSTypeAliasDeclaration(node,opts){assert("TSTypeAliasDeclaration",node,opts);}function assertTSInstantiationExpression(node,opts){assert("TSInstantiationExpression",node,opts);}function assertTSAsExpression(node,opts){assert("TSAsExpression",node,opts);}function assertTSSatisfiesExpression(node,opts){assert("TSSatisfiesExpression",node,opts);}function assertTSTypeAssertion(node,opts){assert("TSTypeAssertion",node,opts);}function assertTSEnumDeclaration(node,opts){assert("TSEnumDeclaration",node,opts);}function assertTSEnumMember(node,opts){assert("TSEnumMember",node,opts);}function assertTSModuleDeclaration(node,opts){assert("TSModuleDeclaration",node,opts);}function assertTSModuleBlock(node,opts){assert("TSModuleBlock",node,opts);}function assertTSImportType(node,opts){assert("TSImportType",node,opts);}function assertTSImportEqualsDeclaration(node,opts){assert("TSImportEqualsDeclaration",node,opts);}function assertTSExternalModuleReference(node,opts){assert("TSExternalModuleReference",node,opts);}function assertTSNonNullExpression(node,opts){assert("TSNonNullExpression",node,opts);}function assertTSExportAssignment(node,opts){assert("TSExportAssignment",node,opts);}function assertTSNamespaceExportDeclaration(node,opts){assert("TSNamespaceExportDeclaration",node,opts);}function assertTSTypeAnnotation(node,opts){assert("TSTypeAnnotation",node,opts);}function assertTSTypeParameterInstantiation(node,opts){assert("TSTypeParameterInstantiation",node,opts);}function assertTSTypeParameterDeclaration(node,opts){assert("TSTypeParameterDeclaration",node,opts);}function assertTSTypeParameter(node,opts){assert("TSTypeParameter",node,opts);}function assertStandardized(node,opts){assert("Standardized",node,opts);}function assertExpression(node,opts){assert("Expression",node,opts);}function assertBinary(node,opts){assert("Binary",node,opts);}function assertScopable(node,opts){assert("Scopable",node,opts);}function assertBlockParent(node,opts){assert("BlockParent",node,opts);}function assertBlock(node,opts){assert("Block",node,opts);}function assertStatement(node,opts){assert("Statement",node,opts);}function assertTerminatorless(node,opts){assert("Terminatorless",node,opts);}function assertCompletionStatement(node,opts){assert("CompletionStatement",node,opts);}function assertConditional(node,opts){assert("Conditional",node,opts);}function assertLoop(node,opts){assert("Loop",node,opts);}function assertWhile(node,opts){assert("While",node,opts);}function assertExpressionWrapper(node,opts){assert("ExpressionWrapper",node,opts);}function assertFor(node,opts){assert("For",node,opts);}function assertForXStatement(node,opts){assert("ForXStatement",node,opts);}function assertFunction(node,opts){assert("Function",node,opts);}function assertFunctionParent(node,opts){assert("FunctionParent",node,opts);}function assertPureish(node,opts){assert("Pureish",node,opts);}function assertDeclaration(node,opts){assert("Declaration",node,opts);}function assertPatternLike(node,opts){assert("PatternLike",node,opts);}function assertLVal(node,opts){assert("LVal",node,opts);}function assertTSEntityName(node,opts){assert("TSEntityName",node,opts);}function assertLiteral(node,opts){assert("Literal",node,opts);}function assertImmutable(node,opts){assert("Immutable",node,opts);}function assertUserWhitespacable(node,opts){assert("UserWhitespacable",node,opts);}function assertMethod(node,opts){assert("Method",node,opts);}function assertObjectMember(node,opts){assert("ObjectMember",node,opts);}function assertProperty(node,opts){assert("Property",node,opts);}function assertUnaryLike(node,opts){assert("UnaryLike",node,opts);}function assertPattern(node,opts){assert("Pattern",node,opts);}function assertClass(node,opts){assert("Class",node,opts);}function assertImportOrExportDeclaration(node,opts){assert("ImportOrExportDeclaration",node,opts);}function assertExportDeclaration(node,opts){assert("ExportDeclaration",node,opts);}function assertModuleSpecifier(node,opts){assert("ModuleSpecifier",node,opts);}function assertAccessor(node,opts){assert("Accessor",node,opts);}function assertPrivate(node,opts){assert("Private",node,opts);}function assertFlow(node,opts){assert("Flow",node,opts);}function assertFlowType(node,opts){assert("FlowType",node,opts);}function assertFlowBaseAnnotation(node,opts){assert("FlowBaseAnnotation",node,opts);}function assertFlowDeclaration(node,opts){assert("FlowDeclaration",node,opts);}function assertFlowPredicate(node,opts){assert("FlowPredicate",node,opts);}function assertEnumBody(node,opts){assert("EnumBody",node,opts);}function assertEnumMember(node,opts){assert("EnumMember",node,opts);}function assertJSX(node,opts){assert("JSX",node,opts);}function assertMiscellaneous(node,opts){assert("Miscellaneous",node,opts);}function assertTypeScript(node,opts){assert("TypeScript",node,opts);}function assertTSTypeElement(node,opts){assert("TSTypeElement",node,opts);}function assertTSType(node,opts){assert("TSType",node,opts);}function assertTSBaseType(node,opts){assert("TSBaseType",node,opts);}function assertNumberLiteral(node,opts){(0, _deprecationWarning.default)("assertNumberLiteral","assertNumericLiteral"),assert("NumberLiteral",node,opts);}function assertRegexLiteral(node,opts){(0, _deprecationWarning.default)("assertRegexLiteral","assertRegExpLiteral"),assert("RegexLiteral",node,opts);}function assertRestProperty(node,opts){(0, _deprecationWarning.default)("assertRestProperty","assertRestElement"),assert("RestProperty",node,opts);}function assertSpreadProperty(node,opts){(0, _deprecationWarning.default)("assertSpreadProperty","assertSpreadElement"),assert("SpreadProperty",node,opts);}function assertModuleDeclaration(node,opts){(0, _deprecationWarning.default)("assertModuleDeclaration","assertImportOrExportDeclaration"),assert("ModuleDeclaration",node,opts);}}});var require_createTypeAnnotationBasedOnTypeof=__commonJS({"../../node_modules/@babel/types/lib/builders/flow/createTypeAnnotationBasedOnTypeof.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=void 0;var _index=require_generated2();exports.default=createTypeAnnotationBasedOnTypeof;function createTypeAnnotationBasedOnTypeof(type){switch(type){case"string":return (0, _index.stringTypeAnnotation)();case"number":return (0, _index.numberTypeAnnotation)();case"undefined":return (0, _index.voidTypeAnnotation)();case"boolean":return (0, _index.booleanTypeAnnotation)();case"function":return (0, _index.genericTypeAnnotation)((0, _index.identifier)("Function"));case"object":return (0, _index.genericTypeAnnotation)((0, _index.identifier)("Object"));case"symbol":return (0, _index.genericTypeAnnotation)((0, _index.identifier)("Symbol"));case"bigint":return (0, _index.anyTypeAnnotation)()}throw new Error("Invalid typeof value: "+type)}}});var require_removeTypeDuplicates=__commonJS({"../../node_modules/@babel/types/lib/modifications/flow/removeTypeDuplicates.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=removeTypeDuplicates;var _index=require_generated();function getQualifiedName(node){return (0, _index.isIdentifier)(node)?node.name:`${node.id.name}.${getQualifiedName(node.qualification)}`}function removeTypeDuplicates(nodesIn){let nodes=Array.from(nodesIn),generics=new Map,bases=new Map,typeGroups=new Set,types=[];for(let i=0;i<nodes.length;i++){let node=nodes[i];if(node&&!(types.indexOf(node)>=0)){if((0, _index.isAnyTypeAnnotation)(node))return [node];if((0, _index.isFlowBaseAnnotation)(node)){bases.set(node.type,node);continue}if((0, _index.isUnionTypeAnnotation)(node)){typeGroups.has(node.types)||(nodes.push(...node.types),typeGroups.add(node.types));continue}if((0, _index.isGenericTypeAnnotation)(node)){let name=getQualifiedName(node.id);if(generics.has(name)){let existing=generics.get(name);existing.typeParameters?node.typeParameters&&(existing.typeParameters.params.push(...node.typeParameters.params),existing.typeParameters.params=removeTypeDuplicates(existing.typeParameters.params)):existing=node.typeParameters;}else generics.set(name,node);continue}types.push(node);}}for(let[,baseType]of bases)types.push(baseType);for(let[,genericName]of generics)types.push(genericName);return types}}});var require_createFlowUnionType=__commonJS({"../../node_modules/@babel/types/lib/builders/flow/createFlowUnionType.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=createFlowUnionType;var _index=require_generated2(),_removeTypeDuplicates=require_removeTypeDuplicates();function createFlowUnionType(types){let flattened=(0, _removeTypeDuplicates.default)(types);return flattened.length===1?flattened[0]:(0, _index.unionTypeAnnotation)(flattened)}}});var require_removeTypeDuplicates2=__commonJS({"../../node_modules/@babel/types/lib/modifications/typescript/removeTypeDuplicates.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=removeTypeDuplicates;var _index=require_generated();function getQualifiedName(node){return (0, _index.isIdentifier)(node)?node.name:`${node.right.name}.${getQualifiedName(node.left)}`}function removeTypeDuplicates(nodesIn){let nodes=Array.from(nodesIn),generics=new Map,bases=new Map,typeGroups=new Set,types=[];for(let i=0;i<nodes.length;i++){let node=nodes[i];if(node&&!(types.indexOf(node)>=0)){if((0, _index.isTSAnyKeyword)(node))return [node];if((0, _index.isTSBaseType)(node)){bases.set(node.type,node);continue}if((0, _index.isTSUnionType)(node)){typeGroups.has(node.types)||(nodes.push(...node.types),typeGroups.add(node.types));continue}if((0, _index.isTSTypeReference)(node)&&node.typeParameters){let name=getQualifiedName(node.typeName);if(generics.has(name)){let existing=generics.get(name);existing.typeParameters?node.typeParameters&&(existing.typeParameters.params.push(...node.typeParameters.params),existing.typeParameters.params=removeTypeDuplicates(existing.typeParameters.params)):existing=node.typeParameters;}else generics.set(name,node);continue}types.push(node);}}for(let[,baseType]of bases)types.push(baseType);for(let[,genericName]of generics)types.push(genericName);return types}}});var require_createTSUnionType=__commonJS({"../../node_modules/@babel/types/lib/builders/typescript/createTSUnionType.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=createTSUnionType;var _index=require_generated2(),_removeTypeDuplicates=require_removeTypeDuplicates2(),_index2=require_generated();function createTSUnionType(typeAnnotations){let types=typeAnnotations.map(type=>(0, _index2.isTSTypeAnnotation)(type)?type.typeAnnotation:type),flattened=(0, _removeTypeDuplicates.default)(types);return flattened.length===1?flattened[0]:(0, _index.tsUnionType)(flattened)}}});var require_uppercase=__commonJS({"../../node_modules/@babel/types/lib/builders/generated/uppercase.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});Object.defineProperty(exports,"AnyTypeAnnotation",{enumerable:!0,get:function(){return _index.anyTypeAnnotation}});Object.defineProperty(exports,"ArgumentPlaceholder",{enumerable:!0,get:function(){return _index.argumentPlaceholder}});Object.defineProperty(exports,"ArrayExpression",{enumerable:!0,get:function(){return _index.arrayExpression}});Object.defineProperty(exports,"ArrayPattern",{enumerable:!0,get:function(){return _index.arrayPattern}});Object.defineProperty(exports,"ArrayTypeAnnotation",{enumerable:!0,get:function(){return _index.arrayTypeAnnotation}});Object.defineProperty(exports,"ArrowFunctionExpression",{enumerable:!0,get:function(){return _index.arrowFunctionExpression}});Object.defineProperty(exports,"AssignmentExpression",{enumerable:!0,get:function(){return _index.assignmentExpression}});Object.defineProperty(exports,"AssignmentPattern",{enumerable:!0,get:function(){return _index.assignmentPattern}});Object.defineProperty(exports,"AwaitExpression",{enumerable:!0,get:function(){return _index.awaitExpression}});Object.defineProperty(exports,"BigIntLiteral",{enumerable:!0,get:function(){return _index.bigIntLiteral}});Object.defineProperty(exports,"BinaryExpression",{enumerable:!0,get:function(){return _index.binaryExpression}});Object.defineProperty(exports,"BindExpression",{enumerable:!0,get:function(){return _index.bindExpression}});Object.defineProperty(exports,"BlockStatement",{enumerable:!0,get:function(){return _index.blockStatement}});Object.defineProperty(exports,"BooleanLiteral",{enumerable:!0,get:function(){return _index.booleanLiteral}});Object.defineProperty(exports,"BooleanLiteralTypeAnnotation",{enumerable:!0,get:function(){return _index.booleanLiteralTypeAnnotation}});Object.defineProperty(exports,"BooleanTypeAnnotation",{enumerable:!0,get:function(){return _index.booleanTypeAnnotation}});Object.defineProperty(exports,"BreakStatement",{enumerable:!0,get:function(){return _index.breakStatement}});Object.defineProperty(exports,"CallExpression",{enumerable:!0,get:function(){return _index.callExpression}});Object.defineProperty(exports,"CatchClause",{enumerable:!0,get:function(){return _index.catchClause}});Object.defineProperty(exports,"ClassAccessorProperty",{enumerable:!0,get:function(){return _index.classAccessorProperty}});Object.defineProperty(exports,"ClassBody",{enumerable:!0,get:function(){return _index.classBody}});Object.defineProperty(exports,"ClassDeclaration",{enumerable:!0,get:function(){return _index.classDeclaration}});Object.defineProperty(exports,"ClassExpression",{enumerable:!0,get:function(){return _index.classExpression}});Object.defineProperty(exports,"ClassImplements",{enumerable:!0,get:function(){return _index.classImplements}});Object.defineProperty(exports,"ClassMethod",{enumerable:!0,get:function(){return _index.classMethod}});Object.defineProperty(exports,"ClassPrivateMethod",{enumerable:!0,get:function(){return _index.classPrivateMethod}});Object.defineProperty(exports,"ClassPrivateProperty",{enumerable:!0,get:function(){return _index.classPrivateProperty}});Object.defineProperty(exports,"ClassProperty",{enumerable:!0,get:function(){return _index.classProperty}});Object.defineProperty(exports,"ConditionalExpression",{enumerable:!0,get:function(){return _index.conditionalExpression}});Object.defineProperty(exports,"ContinueStatement",{enumerable:!0,get:function(){return _index.continueStatement}});Object.defineProperty(exports,"DebuggerStatement",{enumerable:!0,get:function(){return _index.debuggerStatement}});Object.defineProperty(exports,"DecimalLiteral",{enumerable:!0,get:function(){return _index.decimalLiteral}});Object.defineProperty(exports,"DeclareClass",{enumerable:!0,get:function(){return _index.declareClass}});Object.defineProperty(exports,"DeclareExportAllDeclaration",{enumerable:!0,get:function(){return _index.declareExportAllDeclaration}});Object.defineProperty(exports,"DeclareExportDeclaration",{enumerable:!0,get:function(){return _index.declareExportDeclaration}});Object.defineProperty(exports,"DeclareFunction",{enumerable:!0,get:function(){return _index.declareFunction}});Object.defineProperty(exports,"DeclareInterface",{enumerable:!0,get:function(){return _index.declareInterface}});Object.defineProperty(exports,"DeclareModule",{enumerable:!0,get:function(){return _index.declareModule}});Object.defineProperty(exports,"DeclareModuleExports",{enumerable:!0,get:function(){return _index.declareModuleExports}});Object.defineProperty(exports,"DeclareOpaqueType",{enumerable:!0,get:function(){return _index.declareOpaqueType}});Object.defineProperty(exports,"DeclareTypeAlias",{enumerable:!0,get:function(){return _index.declareTypeAlias}});Object.defineProperty(exports,"DeclareVariable",{enumerable:!0,get:function(){return _index.declareVariable}});Object.defineProperty(exports,"DeclaredPredicate",{enumerable:!0,get:function(){return _index.declaredPredicate}});Object.defineProperty(exports,"Decorator",{enumerable:!0,get:function(){return _index.decorator}});Object.defineProperty(exports,"Directive",{enumerable:!0,get:function(){return _index.directive}});Object.defineProperty(exports,"DirectiveLiteral",{enumerable:!0,get:function(){return _index.directiveLiteral}});Object.defineProperty(exports,"DoExpression",{enumerable:!0,get:function(){return _index.doExpression}});Object.defineProperty(exports,"DoWhileStatement",{enumerable:!0,get:function(){return _index.doWhileStatement}});Object.defineProperty(exports,"EmptyStatement",{enumerable:!0,get:function(){return _index.emptyStatement}});Object.defineProperty(exports,"EmptyTypeAnnotation",{enumerable:!0,get:function(){return _index.emptyTypeAnnotation}});Object.defineProperty(exports,"EnumBooleanBody",{enumerable:!0,get:function(){return _index.enumBooleanBody}});Object.defineProperty(exports,"EnumBooleanMember",{enumerable:!0,get:function(){return _index.enumBooleanMember}});Object.defineProperty(exports,"EnumDeclaration",{enumerable:!0,get:function(){return _index.enumDeclaration}});Object.defineProperty(exports,"EnumDefaultedMember",{enumerable:!0,get:function(){return _index.enumDefaultedMember}});Object.defineProperty(exports,"EnumNumberBody",{enumerable:!0,get:function(){return _index.enumNumberBody}});Object.defineProperty(exports,"EnumNumberMember",{enumerable:!0,get:function(){return _index.enumNumberMember}});Object.defineProperty(exports,"EnumStringBody",{enumerable:!0,get:function(){return _index.enumStringBody}});Object.defineProperty(exports,"EnumStringMember",{enumerable:!0,get:function(){return _index.enumStringMember}});Object.defineProperty(exports,"EnumSymbolBody",{enumerable:!0,get:function(){return _index.enumSymbolBody}});Object.defineProperty(exports,"ExistsTypeAnnotation",{enumerable:!0,get:function(){return _index.existsTypeAnnotation}});Object.defineProperty(exports,"ExportAllDeclaration",{enumerable:!0,get:function(){return _index.exportAllDeclaration}});Object.defineProperty(exports,"ExportDefaultDeclaration",{enumerable:!0,get:function(){return _index.exportDefaultDeclaration}});Object.defineProperty(exports,"ExportDefaultSpecifier",{enumerable:!0,get:function(){return _index.exportDefaultSpecifier}});Object.defineProperty(exports,"ExportNamedDeclaration",{enumerable:!0,get:function(){return _index.exportNamedDeclaration}});Object.defineProperty(exports,"ExportNamespaceSpecifier",{enumerable:!0,get:function(){return _index.exportNamespaceSpecifier}});Object.defineProperty(exports,"ExportSpecifier",{enumerable:!0,get:function(){return _index.exportSpecifier}});Object.defineProperty(exports,"ExpressionStatement",{enumerable:!0,get:function(){return _index.expressionStatement}});Object.defineProperty(exports,"File",{enumerable:!0,get:function(){return _index.file}});Object.defineProperty(exports,"ForInStatement",{enumerable:!0,get:function(){return _index.forInStatement}});Object.defineProperty(exports,"ForOfStatement",{enumerable:!0,get:function(){return _index.forOfStatement}});Object.defineProperty(exports,"ForStatement",{enumerable:!0,get:function(){return _index.forStatement}});Object.defineProperty(exports,"FunctionDeclaration",{enumerable:!0,get:function(){return _index.functionDeclaration}});Object.defineProperty(exports,"FunctionExpression",{enumerable:!0,get:function(){return _index.functionExpression}});Object.defineProperty(exports,"FunctionTypeAnnotation",{enumerable:!0,get:function(){return _index.functionTypeAnnotation}});Object.defineProperty(exports,"FunctionTypeParam",{enumerable:!0,get:function(){return _index.functionTypeParam}});Object.defineProperty(exports,"GenericTypeAnnotation",{enumerable:!0,get:function(){return _index.genericTypeAnnotation}});Object.defineProperty(exports,"Identifier",{enumerable:!0,get:function(){return _index.identifier}});Object.defineProperty(exports,"IfStatement",{enumerable:!0,get:function(){return _index.ifStatement}});Object.defineProperty(exports,"Import",{enumerable:!0,get:function(){return _index.import}});Object.defineProperty(exports,"ImportAttribute",{enumerable:!0,get:function(){return _index.importAttribute}});Object.defineProperty(exports,"ImportDeclaration",{enumerable:!0,get:function(){return _index.importDeclaration}});Object.defineProperty(exports,"ImportDefaultSpecifier",{enumerable:!0,get:function(){return _index.importDefaultSpecifier}});Object.defineProperty(exports,"ImportExpression",{enumerable:!0,get:function(){return _index.importExpression}});Object.defineProperty(exports,"ImportNamespaceSpecifier",{enumerable:!0,get:function(){return _index.importNamespaceSpecifier}});Object.defineProperty(exports,"ImportSpecifier",{enumerable:!0,get:function(){return _index.importSpecifier}});Object.defineProperty(exports,"IndexedAccessType",{enumerable:!0,get:function(){return _index.indexedAccessType}});Object.defineProperty(exports,"InferredPredicate",{enumerable:!0,get:function(){return _index.inferredPredicate}});Object.defineProperty(exports,"InterfaceDeclaration",{enumerable:!0,get:function(){return _index.interfaceDeclaration}});Object.defineProperty(exports,"InterfaceExtends",{enumerable:!0,get:function(){return _index.interfaceExtends}});Object.defineProperty(exports,"InterfaceTypeAnnotation",{enumerable:!0,get:function(){return _index.interfaceTypeAnnotation}});Object.defineProperty(exports,"InterpreterDirective",{enumerable:!0,get:function(){return _index.interpreterDirective}});Object.defineProperty(exports,"IntersectionTypeAnnotation",{enumerable:!0,get:function(){return _index.intersectionTypeAnnotation}});Object.defineProperty(exports,"JSXAttribute",{enumerable:!0,get:function(){return _index.jsxAttribute}});Object.defineProperty(exports,"JSXClosingElement",{enumerable:!0,get:function(){return _index.jsxClosingElement}});Object.defineProperty(exports,"JSXClosingFragment",{enumerable:!0,get:function(){return _index.jsxClosingFragment}});Object.defineProperty(exports,"JSXElement",{enumerable:!0,get:function(){return _index.jsxElement}});Object.defineProperty(exports,"JSXEmptyExpression",{enumerable:!0,get:function(){return _index.jsxEmptyExpression}});Object.defineProperty(exports,"JSXExpressionContainer",{enumerable:!0,get:function(){return _index.jsxExpressionContainer}});Object.defineProperty(exports,"JSXFragment",{enumerable:!0,get:function(){return _index.jsxFragment}});Object.defineProperty(exports,"JSXIdentifier",{enumerable:!0,get:function(){return _index.jsxIdentifier}});Object.defineProperty(exports,"JSXMemberExpression",{enumerable:!0,get:function(){return _index.jsxMemberExpression}});Object.defineProperty(exports,"JSXNamespacedName",{enumerable:!0,get:function(){return _index.jsxNamespacedName}});Object.defineProperty(exports,"JSXOpeningElement",{enumerable:!0,get:function(){return _index.jsxOpeningElement}});Object.defineProperty(exports,"JSXOpeningFragment",{enumerable:!0,get:function(){return _index.jsxOpeningFragment}});Object.defineProperty(exports,"JSXSpreadAttribute",{enumerable:!0,get:function(){return _index.jsxSpreadAttribute}});Object.defineProperty(exports,"JSXSpreadChild",{enumerable:!0,get:function(){return _index.jsxSpreadChild}});Object.defineProperty(exports,"JSXText",{enumerable:!0,get:function(){return _index.jsxText}});Object.defineProperty(exports,"LabeledStatement",{enumerable:!0,get:function(){return _index.labeledStatement}});Object.defineProperty(exports,"LogicalExpression",{enumerable:!0,get:function(){return _index.logicalExpression}});Object.defineProperty(exports,"MemberExpression",{enumerable:!0,get:function(){return _index.memberExpression}});Object.defineProperty(exports,"MetaProperty",{enumerable:!0,get:function(){return _index.metaProperty}});Object.defineProperty(exports,"MixedTypeAnnotation",{enumerable:!0,get:function(){return _index.mixedTypeAnnotation}});Object.defineProperty(exports,"ModuleExpression",{enumerable:!0,get:function(){return _index.moduleExpression}});Object.defineProperty(exports,"NewExpression",{enumerable:!0,get:function(){return _index.newExpression}});Object.defineProperty(exports,"Noop",{enumerable:!0,get:function(){return _index.noop}});Object.defineProperty(exports,"NullLiteral",{enumerable:!0,get:function(){return _index.nullLiteral}});Object.defineProperty(exports,"NullLiteralTypeAnnotation",{enumerable:!0,get:function(){return _index.nullLiteralTypeAnnotation}});Object.defineProperty(exports,"NullableTypeAnnotation",{enumerable:!0,get:function(){return _index.nullableTypeAnnotation}});Object.defineProperty(exports,"NumberLiteral",{enumerable:!0,get:function(){return _index.numberLiteral}});Object.defineProperty(exports,"NumberLiteralTypeAnnotation",{enumerable:!0,get:function(){return _index.numberLiteralTypeAnnotation}});Object.defineProperty(exports,"NumberTypeAnnotation",{enumerable:!0,get:function(){return _index.numberTypeAnnotation}});Object.defineProperty(exports,"NumericLiteral",{enumerable:!0,get:function(){return _index.numericLiteral}});Object.defineProperty(exports,"ObjectExpression",{enumerable:!0,get:function(){return _index.objectExpression}});Object.defineProperty(exports,"ObjectMethod",{enumerable:!0,get:function(){return _index.objectMethod}});Object.defineProperty(exports,"ObjectPattern",{enumerable:!0,get:function(){return _index.objectPattern}});Object.defineProperty(exports,"ObjectProperty",{enumerable:!0,get:function(){return _index.objectProperty}});Object.defineProperty(exports,"ObjectTypeAnnotation",{enumerable:!0,get:function(){return _index.objectTypeAnnotation}});Object.defineProperty(exports,"ObjectTypeCallProperty",{enumerable:!0,get:function(){return _index.objectTypeCallProperty}});Object.defineProperty(exports,"ObjectTypeIndexer",{enumerable:!0,get:function(){return _index.objectTypeIndexer}});Object.defineProperty(exports,"ObjectTypeInternalSlot",{enumerable:!0,get:function(){return _index.objectTypeInternalSlot}});Object.defineProperty(exports,"ObjectTypeProperty",{enumerable:!0,get:function(){return _index.objectTypeProperty}});Object.defineProperty(exports,"ObjectTypeSpreadProperty",{enumerable:!0,get:function(){return _index.objectTypeSpreadProperty}});Object.defineProperty(exports,"OpaqueType",{enumerable:!0,get:function(){return _index.opaqueType}});Object.defineProperty(exports,"OptionalCallExpression",{enumerable:!0,get:function(){return _index.optionalCallExpression}});Object.defineProperty(exports,"OptionalIndexedAccessType",{enumerable:!0,get:function(){return _index.optionalIndexedAccessType}});Object.defineProperty(exports,"OptionalMemberExpression",{enumerable:!0,get:function(){return _index.optionalMemberExpression}});Object.defineProperty(exports,"ParenthesizedExpression",{enumerable:!0,get:function(){return _index.parenthesizedExpression}});Object.defineProperty(exports,"PipelineBareFunction",{enumerable:!0,get:function(){return _index.pipelineBareFunction}});Object.defineProperty(exports,"PipelinePrimaryTopicReference",{enumerable:!0,get:function(){return _index.pipelinePrimaryTopicReference}});Object.defineProperty(exports,"PipelineTopicExpression",{enumerable:!0,get:function(){return _index.pipelineTopicExpression}});Object.defineProperty(exports,"Placeholder",{enumerable:!0,get:function(){return _index.placeholder}});Object.defineProperty(exports,"PrivateName",{enumerable:!0,get:function(){return _index.privateName}});Object.defineProperty(exports,"Program",{enumerable:!0,get:function(){return _index.program}});Object.defineProperty(exports,"QualifiedTypeIdentifier",{enumerable:!0,get:function(){return _index.qualifiedTypeIdentifier}});Object.defineProperty(exports,"RecordExpression",{enumerable:!0,get:function(){return _index.recordExpression}});Object.defineProperty(exports,"RegExpLiteral",{enumerable:!0,get:function(){return _index.regExpLiteral}});Object.defineProperty(exports,"RegexLiteral",{enumerable:!0,get:function(){return _index.regexLiteral}});Object.defineProperty(exports,"RestElement",{enumerable:!0,get:function(){return _index.restElement}});Object.defineProperty(exports,"RestProperty",{enumerable:!0,get:function(){return _index.restProperty}});Object.defineProperty(exports,"ReturnStatement",{enumerable:!0,get:function(){return _index.returnStatement}});Object.defineProperty(exports,"SequenceExpression",{enumerable:!0,get:function(){return _index.sequenceExpression}});Object.defineProperty(exports,"SpreadElement",{enumerable:!0,get:function(){return _index.spreadElement}});Object.defineProperty(exports,"SpreadProperty",{enumerable:!0,get:function(){return _index.spreadProperty}});Object.defineProperty(exports,"StaticBlock",{enumerable:!0,get:function(){return _index.staticBlock}});Object.defineProperty(exports,"StringLiteral",{enumerable:!0,get:function(){return _index.stringLiteral}});Object.defineProperty(exports,"StringLiteralTypeAnnotation",{enumerable:!0,get:function(){return _index.stringLiteralTypeAnnotation}});Object.defineProperty(exports,"StringTypeAnnotation",{enumerable:!0,get:function(){return _index.stringTypeAnnotation}});Object.defineProperty(exports,"Super",{enumerable:!0,get:function(){return _index.super}});Object.defineProperty(exports,"SwitchCase",{enumerable:!0,get:function(){return _index.switchCase}});Object.defineProperty(exports,"SwitchStatement",{enumerable:!0,get:function(){return _index.switchStatement}});Object.defineProperty(exports,"SymbolTypeAnnotation",{enumerable:!0,get:function(){return _index.symbolTypeAnnotation}});Object.defineProperty(exports,"TSAnyKeyword",{enumerable:!0,get:function(){return _index.tsAnyKeyword}});Object.defineProperty(exports,"TSArrayType",{enumerable:!0,get:function(){return _index.tsArrayType}});Object.defineProperty(exports,"TSAsExpression",{enumerable:!0,get:function(){return _index.tsAsExpression}});Object.defineProperty(exports,"TSBigIntKeyword",{enumerable:!0,get:function(){return _index.tsBigIntKeyword}});Object.defineProperty(exports,"TSBooleanKeyword",{enumerable:!0,get:function(){return _index.tsBooleanKeyword}});Object.defineProperty(exports,"TSCallSignatureDeclaration",{enumerable:!0,get:function(){return _index.tsCallSignatureDeclaration}});Object.defineProperty(exports,"TSConditionalType",{enumerable:!0,get:function(){return _index.tsConditionalType}});Object.defineProperty(exports,"TSConstructSignatureDeclaration",{enumerable:!0,get:function(){return _index.tsConstructSignatureDeclaration}});Object.defineProperty(exports,"TSConstructorType",{enumerable:!0,get:function(){return _index.tsConstructorType}});Object.defineProperty(exports,"TSDeclareFunction",{enumerable:!0,get:function(){return _index.tsDeclareFunction}});Object.defineProperty(exports,"TSDeclareMethod",{enumerable:!0,get:function(){return _index.tsDeclareMethod}});Object.defineProperty(exports,"TSEnumDeclaration",{enumerable:!0,get:function(){return _index.tsEnumDeclaration}});Object.defineProperty(exports,"TSEnumMember",{enumerable:!0,get:function(){return _index.tsEnumMember}});Object.defineProperty(exports,"TSExportAssignment",{enumerable:!0,get:function(){return _index.tsExportAssignment}});Object.defineProperty(exports,"TSExpressionWithTypeArguments",{enumerable:!0,get:function(){return _index.tsExpressionWithTypeArguments}});Object.defineProperty(exports,"TSExternalModuleReference",{enumerable:!0,get:function(){return _index.tsExternalModuleReference}});Object.defineProperty(exports,"TSFunctionType",{enumerable:!0,get:function(){return _index.tsFunctionType}});Object.defineProperty(exports,"TSImportEqualsDeclaration",{enumerable:!0,get:function(){return _index.tsImportEqualsDeclaration}});Object.defineProperty(exports,"TSImportType",{enumerable:!0,get:function(){return _index.tsImportType}});Object.defineProperty(exports,"TSIndexSignature",{enumerable:!0,get:function(){return _index.tsIndexSignature}});Object.defineProperty(exports,"TSIndexedAccessType",{enumerable:!0,get:function(){return _index.tsIndexedAccessType}});Object.defineProperty(exports,"TSInferType",{enumerable:!0,get:function(){return _index.tsInferType}});Object.defineProperty(exports,"TSInstantiationExpression",{enumerable:!0,get:function(){return _index.tsInstantiationExpression}});Object.defineProperty(exports,"TSInterfaceBody",{enumerable:!0,get:function(){return _index.tsInterfaceBody}});Object.defineProperty(exports,"TSInterfaceDeclaration",{enumerable:!0,get:function(){return _index.tsInterfaceDeclaration}});Object.defineProperty(exports,"TSIntersectionType",{enumerable:!0,get:function(){return _index.tsIntersectionType}});Object.defineProperty(exports,"TSIntrinsicKeyword",{enumerable:!0,get:function(){return _index.tsIntrinsicKeyword}});Object.defineProperty(exports,"TSLiteralType",{enumerable:!0,get:function(){return _index.tsLiteralType}});Object.defineProperty(exports,"TSMappedType",{enumerable:!0,get:function(){return _index.tsMappedType}});Object.defineProperty(exports,"TSMethodSignature",{enumerable:!0,get:function(){return _index.tsMethodSignature}});Object.defineProperty(exports,"TSModuleBlock",{enumerable:!0,get:function(){return _index.tsModuleBlock}});Object.defineProperty(exports,"TSModuleDeclaration",{enumerable:!0,get:function(){return _index.tsModuleDeclaration}});Object.defineProperty(exports,"TSNamedTupleMember",{enumerable:!0,get:function(){return _index.tsNamedTupleMember}});Object.defineProperty(exports,"TSNamespaceExportDeclaration",{enumerable:!0,get:function(){return _index.tsNamespaceExportDeclaration}});Object.defineProperty(exports,"TSNeverKeyword",{enumerable:!0,get:function(){return _index.tsNeverKeyword}});Object.defineProperty(exports,"TSNonNullExpression",{enumerable:!0,get:function(){return _index.tsNonNullExpression}});Object.defineProperty(exports,"TSNullKeyword",{enumerable:!0,get:function(){return _index.tsNullKeyword}});Object.defineProperty(exports,"TSNumberKeyword",{enumerable:!0,get:function(){return _index.tsNumberKeyword}});Object.defineProperty(exports,"TSObjectKeyword",{enumerable:!0,get:function(){return _index.tsObjectKeyword}});Object.defineProperty(exports,"TSOptionalType",{enumerable:!0,get:function(){return _index.tsOptionalType}});Object.defineProperty(exports,"TSParameterProperty",{enumerable:!0,get:function(){return _index.tsParameterProperty}});Object.defineProperty(exports,"TSParenthesizedType",{enumerable:!0,get:function(){return _index.tsParenthesizedType}});Object.defineProperty(exports,"TSPropertySignature",{enumerable:!0,get:function(){return _index.tsPropertySignature}});Object.defineProperty(exports,"TSQualifiedName",{enumerable:!0,get:function(){return _index.tsQualifiedName}});Object.defineProperty(exports,"TSRestType",{enumerable:!0,get:function(){return _index.tsRestType}});Object.defineProperty(exports,"TSSatisfiesExpression",{enumerable:!0,get:function(){return _index.tsSatisfiesExpression}});Object.defineProperty(exports,"TSStringKeyword",{enumerable:!0,get:function(){return _index.tsStringKeyword}});Object.defineProperty(exports,"TSSymbolKeyword",{enumerable:!0,get:function(){return _index.tsSymbolKeyword}});Object.defineProperty(exports,"TSThisType",{enumerable:!0,get:function(){return _index.tsThisType}});Object.defineProperty(exports,"TSTupleType",{enumerable:!0,get:function(){return _index.tsTupleType}});Object.defineProperty(exports,"TSTypeAliasDeclaration",{enumerable:!0,get:function(){return _index.tsTypeAliasDeclaration}});Object.defineProperty(exports,"TSTypeAnnotation",{enumerable:!0,get:function(){return _index.tsTypeAnnotation}});Object.defineProperty(exports,"TSTypeAssertion",{enumerable:!0,get:function(){return _index.tsTypeAssertion}});Object.defineProperty(exports,"TSTypeLiteral",{enumerable:!0,get:function(){return _index.tsTypeLiteral}});Object.defineProperty(exports,"TSTypeOperator",{enumerable:!0,get:function(){return _index.tsTypeOperator}});Object.defineProperty(exports,"TSTypeParameter",{enumerable:!0,get:function(){return _index.tsTypeParameter}});Object.defineProperty(exports,"TSTypeParameterDeclaration",{enumerable:!0,get:function(){return _index.tsTypeParameterDeclaration}});Object.defineProperty(exports,"TSTypeParameterInstantiation",{enumerable:!0,get:function(){return _index.tsTypeParameterInstantiation}});Object.defineProperty(exports,"TSTypePredicate",{enumerable:!0,get:function(){return _index.tsTypePredicate}});Object.defineProperty(exports,"TSTypeQuery",{enumerable:!0,get:function(){return _index.tsTypeQuery}});Object.defineProperty(exports,"TSTypeReference",{enumerable:!0,get:function(){return _index.tsTypeReference}});Object.defineProperty(exports,"TSUndefinedKeyword",{enumerable:!0,get:function(){return _index.tsUndefinedKeyword}});Object.defineProperty(exports,"TSUnionType",{enumerable:!0,get:function(){return _index.tsUnionType}});Object.defineProperty(exports,"TSUnknownKeyword",{enumerable:!0,get:function(){return _index.tsUnknownKeyword}});Object.defineProperty(exports,"TSVoidKeyword",{enumerable:!0,get:function(){return _index.tsVoidKeyword}});Object.defineProperty(exports,"TaggedTemplateExpression",{enumerable:!0,get:function(){return _index.taggedTemplateExpression}});Object.defineProperty(exports,"TemplateElement",{enumerable:!0,get:function(){return _index.templateElement}});Object.defineProperty(exports,"TemplateLiteral",{enumerable:!0,get:function(){return _index.templateLiteral}});Object.defineProperty(exports,"ThisExpression",{enumerable:!0,get:function(){return _index.thisExpression}});Object.defineProperty(exports,"ThisTypeAnnotation",{enumerable:!0,get:function(){return _index.thisTypeAnnotation}});Object.defineProperty(exports,"ThrowStatement",{enumerable:!0,get:function(){return _index.throwStatement}});Object.defineProperty(exports,"TopicReference",{enumerable:!0,get:function(){return _index.topicReference}});Object.defineProperty(exports,"TryStatement",{enumerable:!0,get:function(){return _index.tryStatement}});Object.defineProperty(exports,"TupleExpression",{enumerable:!0,get:function(){return _index.tupleExpression}});Object.defineProperty(exports,"TupleTypeAnnotation",{enumerable:!0,get:function(){return _index.tupleTypeAnnotation}});Object.defineProperty(exports,"TypeAlias",{enumerable:!0,get:function(){return _index.typeAlias}});Object.defineProperty(exports,"TypeAnnotation",{enumerable:!0,get:function(){return _index.typeAnnotation}});Object.defineProperty(exports,"TypeCastExpression",{enumerable:!0,get:function(){return _index.typeCastExpression}});Object.defineProperty(exports,"TypeParameter",{enumerable:!0,get:function(){return _index.typeParameter}});Object.defineProperty(exports,"TypeParameterDeclaration",{enumerable:!0,get:function(){return _index.typeParameterDeclaration}});Object.defineProperty(exports,"TypeParameterInstantiation",{enumerable:!0,get:function(){return _index.typeParameterInstantiation}});Object.defineProperty(exports,"TypeofTypeAnnotation",{enumerable:!0,get:function(){return _index.typeofTypeAnnotation}});Object.defineProperty(exports,"UnaryExpression",{enumerable:!0,get:function(){return _index.unaryExpression}});Object.defineProperty(exports,"UnionTypeAnnotation",{enumerable:!0,get:function(){return _index.unionTypeAnnotation}});Object.defineProperty(exports,"UpdateExpression",{enumerable:!0,get:function(){return _index.updateExpression}});Object.defineProperty(exports,"V8IntrinsicIdentifier",{enumerable:!0,get:function(){return _index.v8IntrinsicIdentifier}});Object.defineProperty(exports,"VariableDeclaration",{enumerable:!0,get:function(){return _index.variableDeclaration}});Object.defineProperty(exports,"VariableDeclarator",{enumerable:!0,get:function(){return _index.variableDeclarator}});Object.defineProperty(exports,"Variance",{enumerable:!0,get:function(){return _index.variance}});Object.defineProperty(exports,"VoidTypeAnnotation",{enumerable:!0,get:function(){return _index.voidTypeAnnotation}});Object.defineProperty(exports,"WhileStatement",{enumerable:!0,get:function(){return _index.whileStatement}});Object.defineProperty(exports,"WithStatement",{enumerable:!0,get:function(){return _index.withStatement}});Object.defineProperty(exports,"YieldExpression",{enumerable:!0,get:function(){return _index.yieldExpression}});var _index=require_generated2();}});var require_productions=__commonJS({"../../node_modules/@babel/types/lib/builders/productions.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.buildUndefinedNode=buildUndefinedNode;var _index=require_generated2();function buildUndefinedNode(){return (0, _index.unaryExpression)("void",(0, _index.numericLiteral)(0),!0)}}});var require_cloneNode=__commonJS({"../../node_modules/@babel/types/lib/clone/cloneNode.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=cloneNode;var _index=require_definitions(),_index2=require_generated(),{hasOwn}={hasOwn:Function.call.bind(Object.prototype.hasOwnProperty)};function cloneIfNode(obj,deep,withoutLoc,commentsCache){return obj&&typeof obj.type=="string"?cloneNodeInternal(obj,deep,withoutLoc,commentsCache):obj}function cloneIfNodeOrArray(obj,deep,withoutLoc,commentsCache){return Array.isArray(obj)?obj.map(node=>cloneIfNode(node,deep,withoutLoc,commentsCache)):cloneIfNode(obj,deep,withoutLoc,commentsCache)}function cloneNode(node,deep=!0,withoutLoc=!1){return cloneNodeInternal(node,deep,withoutLoc,new Map)}function cloneNodeInternal(node,deep=!0,withoutLoc=!1,commentsCache){if(!node)return node;let{type}=node,newNode={type:node.type};if((0, _index2.isIdentifier)(node))newNode.name=node.name,hasOwn(node,"optional")&&typeof node.optional=="boolean"&&(newNode.optional=node.optional),hasOwn(node,"typeAnnotation")&&(newNode.typeAnnotation=deep?cloneIfNodeOrArray(node.typeAnnotation,!0,withoutLoc,commentsCache):node.typeAnnotation);else if(hasOwn(_index.NODE_FIELDS,type))for(let field of Object.keys(_index.NODE_FIELDS[type]))hasOwn(node,field)&&(deep?newNode[field]=(0, _index2.isFile)(node)&&field==="comments"?maybeCloneComments(node.comments,deep,withoutLoc,commentsCache):cloneIfNodeOrArray(node[field],!0,withoutLoc,commentsCache):newNode[field]=node[field]);else throw new Error(`Unknown node type: "${type}"`);return hasOwn(node,"loc")&&(withoutLoc?newNode.loc=null:newNode.loc=node.loc),hasOwn(node,"leadingComments")&&(newNode.leadingComments=maybeCloneComments(node.leadingComments,deep,withoutLoc,commentsCache)),hasOwn(node,"innerComments")&&(newNode.innerComments=maybeCloneComments(node.innerComments,deep,withoutLoc,commentsCache)),hasOwn(node,"trailingComments")&&(newNode.trailingComments=maybeCloneComments(node.trailingComments,deep,withoutLoc,commentsCache)),hasOwn(node,"extra")&&(newNode.extra=Object.assign({},node.extra)),newNode}function maybeCloneComments(comments,deep,withoutLoc,commentsCache){return !comments||!deep?comments:comments.map(comment=>{let cache3=commentsCache.get(comment);if(cache3)return cache3;let{type,value,loc}=comment,ret={type,value,loc};return withoutLoc&&(ret.loc=null),commentsCache.set(comment,ret),ret})}}});var require_clone=__commonJS({"../../node_modules/@babel/types/lib/clone/clone.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=clone;var _cloneNode=require_cloneNode();function clone(node){return (0, _cloneNode.default)(node,!1)}}});var require_cloneDeep=__commonJS({"../../node_modules/@babel/types/lib/clone/cloneDeep.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=cloneDeep;var _cloneNode=require_cloneNode();function cloneDeep(node){return (0, _cloneNode.default)(node)}}});var require_cloneDeepWithoutLoc=__commonJS({"../../node_modules/@babel/types/lib/clone/cloneDeepWithoutLoc.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=cloneDeepWithoutLoc;var _cloneNode=require_cloneNode();function cloneDeepWithoutLoc(node){return (0, _cloneNode.default)(node,!0,!0)}}});var require_cloneWithoutLoc=__commonJS({"../../node_modules/@babel/types/lib/clone/cloneWithoutLoc.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=cloneWithoutLoc;var _cloneNode=require_cloneNode();function cloneWithoutLoc(node){return (0, _cloneNode.default)(node,!1,!0)}}});var require_addComments=__commonJS({"../../node_modules/@babel/types/lib/comments/addComments.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=addComments;function addComments(node,type,comments){if(!comments||!node)return node;let key=`${type}Comments`;return node[key]?type==="leading"?node[key]=comments.concat(node[key]):node[key].push(...comments):node[key]=comments,node}}});var require_addComment=__commonJS({"../../node_modules/@babel/types/lib/comments/addComment.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=addComment2;var _addComments=require_addComments();function addComment2(node,type,content,line){return (0, _addComments.default)(node,type,[{type:line?"CommentLine":"CommentBlock",value:content}])}}});var require_inherit=__commonJS({"../../node_modules/@babel/types/lib/utils/inherit.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=inherit;function inherit(key,child,parent){child&&parent&&(child[key]=Array.from(new Set([].concat(child[key],parent[key]).filter(Boolean))));}}});var require_inheritInnerComments=__commonJS({"../../node_modules/@babel/types/lib/comments/inheritInnerComments.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=inheritInnerComments;var _inherit=require_inherit();function inheritInnerComments(child,parent){(0, _inherit.default)("innerComments",child,parent);}}});var require_inheritLeadingComments=__commonJS({"../../node_modules/@babel/types/lib/comments/inheritLeadingComments.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=inheritLeadingComments;var _inherit=require_inherit();function inheritLeadingComments(child,parent){(0, _inherit.default)("leadingComments",child,parent);}}});var require_inheritTrailingComments=__commonJS({"../../node_modules/@babel/types/lib/comments/inheritTrailingComments.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=inheritTrailingComments;var _inherit=require_inherit();function inheritTrailingComments(child,parent){(0, _inherit.default)("trailingComments",child,parent);}}});var require_inheritsComments=__commonJS({"../../node_modules/@babel/types/lib/comments/inheritsComments.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=inheritsComments;var _inheritTrailingComments=require_inheritTrailingComments(),_inheritLeadingComments=require_inheritLeadingComments(),_inheritInnerComments=require_inheritInnerComments();function inheritsComments(child,parent){return (0, _inheritTrailingComments.default)(child,parent),(0, _inheritLeadingComments.default)(child,parent),(0, _inheritInnerComments.default)(child,parent),child}}});var require_removeComments=__commonJS({"../../node_modules/@babel/types/lib/comments/removeComments.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=removeComments;var _index=require_constants();function removeComments(node){return _index.COMMENT_KEYS.forEach(key=>{node[key]=null;}),node}}});var require_generated4=__commonJS({"../../node_modules/@babel/types/lib/constants/generated/index.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.WHILE_TYPES=exports.USERWHITESPACABLE_TYPES=exports.UNARYLIKE_TYPES=exports.TYPESCRIPT_TYPES=exports.TSTYPE_TYPES=exports.TSTYPEELEMENT_TYPES=exports.TSENTITYNAME_TYPES=exports.TSBASETYPE_TYPES=exports.TERMINATORLESS_TYPES=exports.STATEMENT_TYPES=exports.STANDARDIZED_TYPES=exports.SCOPABLE_TYPES=exports.PUREISH_TYPES=exports.PROPERTY_TYPES=exports.PRIVATE_TYPES=exports.PATTERN_TYPES=exports.PATTERNLIKE_TYPES=exports.OBJECTMEMBER_TYPES=exports.MODULESPECIFIER_TYPES=exports.MODULEDECLARATION_TYPES=exports.MISCELLANEOUS_TYPES=exports.METHOD_TYPES=exports.LVAL_TYPES=exports.LOOP_TYPES=exports.LITERAL_TYPES=exports.JSX_TYPES=exports.IMPORTOREXPORTDECLARATION_TYPES=exports.IMMUTABLE_TYPES=exports.FUNCTION_TYPES=exports.FUNCTIONPARENT_TYPES=exports.FOR_TYPES=exports.FORXSTATEMENT_TYPES=exports.FLOW_TYPES=exports.FLOWTYPE_TYPES=exports.FLOWPREDICATE_TYPES=exports.FLOWDECLARATION_TYPES=exports.FLOWBASEANNOTATION_TYPES=exports.EXPRESSION_TYPES=exports.EXPRESSIONWRAPPER_TYPES=exports.EXPORTDECLARATION_TYPES=exports.ENUMMEMBER_TYPES=exports.ENUMBODY_TYPES=exports.DECLARATION_TYPES=exports.CONDITIONAL_TYPES=exports.COMPLETIONSTATEMENT_TYPES=exports.CLASS_TYPES=exports.BLOCK_TYPES=exports.BLOCKPARENT_TYPES=exports.BINARY_TYPES=exports.ACCESSOR_TYPES=void 0;var _index=require_definitions();exports.STANDARDIZED_TYPES=_index.FLIPPED_ALIAS_KEYS.Standardized;exports.EXPRESSION_TYPES=_index.FLIPPED_ALIAS_KEYS.Expression;exports.BINARY_TYPES=_index.FLIPPED_ALIAS_KEYS.Binary;exports.SCOPABLE_TYPES=_index.FLIPPED_ALIAS_KEYS.Scopable;exports.BLOCKPARENT_TYPES=_index.FLIPPED_ALIAS_KEYS.BlockParent;exports.BLOCK_TYPES=_index.FLIPPED_ALIAS_KEYS.Block;exports.STATEMENT_TYPES=_index.FLIPPED_ALIAS_KEYS.Statement;exports.TERMINATORLESS_TYPES=_index.FLIPPED_ALIAS_KEYS.Terminatorless;exports.COMPLETIONSTATEMENT_TYPES=_index.FLIPPED_ALIAS_KEYS.CompletionStatement;exports.CONDITIONAL_TYPES=_index.FLIPPED_ALIAS_KEYS.Conditional;exports.LOOP_TYPES=_index.FLIPPED_ALIAS_KEYS.Loop;exports.WHILE_TYPES=_index.FLIPPED_ALIAS_KEYS.While;exports.EXPRESSIONWRAPPER_TYPES=_index.FLIPPED_ALIAS_KEYS.ExpressionWrapper;exports.FOR_TYPES=_index.FLIPPED_ALIAS_KEYS.For;exports.FORXSTATEMENT_TYPES=_index.FLIPPED_ALIAS_KEYS.ForXStatement;exports.FUNCTION_TYPES=_index.FLIPPED_ALIAS_KEYS.Function;exports.FUNCTIONPARENT_TYPES=_index.FLIPPED_ALIAS_KEYS.FunctionParent;exports.PUREISH_TYPES=_index.FLIPPED_ALIAS_KEYS.Pureish;exports.DECLARATION_TYPES=_index.FLIPPED_ALIAS_KEYS.Declaration;exports.PATTERNLIKE_TYPES=_index.FLIPPED_ALIAS_KEYS.PatternLike;exports.LVAL_TYPES=_index.FLIPPED_ALIAS_KEYS.LVal;exports.TSENTITYNAME_TYPES=_index.FLIPPED_ALIAS_KEYS.TSEntityName;exports.LITERAL_TYPES=_index.FLIPPED_ALIAS_KEYS.Literal;exports.IMMUTABLE_TYPES=_index.FLIPPED_ALIAS_KEYS.Immutable;exports.USERWHITESPACABLE_TYPES=_index.FLIPPED_ALIAS_KEYS.UserWhitespacable;exports.METHOD_TYPES=_index.FLIPPED_ALIAS_KEYS.Method;exports.OBJECTMEMBER_TYPES=_index.FLIPPED_ALIAS_KEYS.ObjectMember;exports.PROPERTY_TYPES=_index.FLIPPED_ALIAS_KEYS.Property;exports.UNARYLIKE_TYPES=_index.FLIPPED_ALIAS_KEYS.UnaryLike;exports.PATTERN_TYPES=_index.FLIPPED_ALIAS_KEYS.Pattern;exports.CLASS_TYPES=_index.FLIPPED_ALIAS_KEYS.Class;var IMPORTOREXPORTDECLARATION_TYPES=exports.IMPORTOREXPORTDECLARATION_TYPES=_index.FLIPPED_ALIAS_KEYS.ImportOrExportDeclaration;exports.EXPORTDECLARATION_TYPES=_index.FLIPPED_ALIAS_KEYS.ExportDeclaration;exports.MODULESPECIFIER_TYPES=_index.FLIPPED_ALIAS_KEYS.ModuleSpecifier;exports.ACCESSOR_TYPES=_index.FLIPPED_ALIAS_KEYS.Accessor;exports.PRIVATE_TYPES=_index.FLIPPED_ALIAS_KEYS.Private;exports.FLOW_TYPES=_index.FLIPPED_ALIAS_KEYS.Flow;exports.FLOWTYPE_TYPES=_index.FLIPPED_ALIAS_KEYS.FlowType;exports.FLOWBASEANNOTATION_TYPES=_index.FLIPPED_ALIAS_KEYS.FlowBaseAnnotation;exports.FLOWDECLARATION_TYPES=_index.FLIPPED_ALIAS_KEYS.FlowDeclaration;exports.FLOWPREDICATE_TYPES=_index.FLIPPED_ALIAS_KEYS.FlowPredicate;exports.ENUMBODY_TYPES=_index.FLIPPED_ALIAS_KEYS.EnumBody;exports.ENUMMEMBER_TYPES=_index.FLIPPED_ALIAS_KEYS.EnumMember;exports.JSX_TYPES=_index.FLIPPED_ALIAS_KEYS.JSX;exports.MISCELLANEOUS_TYPES=_index.FLIPPED_ALIAS_KEYS.Miscellaneous;exports.TYPESCRIPT_TYPES=_index.FLIPPED_ALIAS_KEYS.TypeScript;exports.TSTYPEELEMENT_TYPES=_index.FLIPPED_ALIAS_KEYS.TSTypeElement;exports.TSTYPE_TYPES=_index.FLIPPED_ALIAS_KEYS.TSType;exports.TSBASETYPE_TYPES=_index.FLIPPED_ALIAS_KEYS.TSBaseType;exports.MODULEDECLARATION_TYPES=IMPORTOREXPORTDECLARATION_TYPES;}});var require_toBlock=__commonJS({"../../node_modules/@babel/types/lib/converters/toBlock.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=toBlock;var _index=require_generated(),_index2=require_generated2();function toBlock(node,parent){if((0, _index.isBlockStatement)(node))return node;let blockNodes=[];return (0, _index.isEmptyStatement)(node)?blockNodes=[]:((0, _index.isStatement)(node)||((0, _index.isFunction)(parent)?node=(0, _index2.returnStatement)(node):node=(0, _index2.expressionStatement)(node)),blockNodes=[node]),(0, _index2.blockStatement)(blockNodes)}}});var require_ensureBlock=__commonJS({"../../node_modules/@babel/types/lib/converters/ensureBlock.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=ensureBlock;var _toBlock=require_toBlock();function ensureBlock(node,key="body"){let result=(0, _toBlock.default)(node[key],node);return node[key]=result,result}}});var require_toIdentifier=__commonJS({"../../node_modules/@babel/types/lib/converters/toIdentifier.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=toIdentifier;var _isValidIdentifier=require_isValidIdentifier(),_helperValidatorIdentifier=require_lib();function toIdentifier(input){input=input+"";let name="";for(let c of input)name+=(0, _helperValidatorIdentifier.isIdentifierChar)(c.codePointAt(0))?c:"-";return name=name.replace(/^[-0-9]+/,""),name=name.replace(/[-\s]+(.)?/g,function(match,c){return c?c.toUpperCase():""}),(0, _isValidIdentifier.default)(name)||(name=`_${name}`),name||"_"}}});var require_toBindingIdentifierName=__commonJS({"../../node_modules/@babel/types/lib/converters/toBindingIdentifierName.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=toBindingIdentifierName;var _toIdentifier=require_toIdentifier();function toBindingIdentifierName(name){return name=(0, _toIdentifier.default)(name),(name==="eval"||name==="arguments")&&(name="_"+name),name}}});var require_toComputedKey=__commonJS({"../../node_modules/@babel/types/lib/converters/toComputedKey.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=toComputedKey;var _index=require_generated(),_index2=require_generated2();function toComputedKey(node,key=node.key||node.property){return !node.computed&&(0, _index.isIdentifier)(key)&&(key=(0, _index2.stringLiteral)(key.name)),key}}});var require_toExpression=__commonJS({"../../node_modules/@babel/types/lib/converters/toExpression.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=void 0;var _index=require_generated();exports.default=toExpression;function toExpression(node){if((0, _index.isExpressionStatement)(node)&&(node=node.expression),(0, _index.isExpression)(node))return node;if((0, _index.isClass)(node)?node.type="ClassExpression":(0, _index.isFunction)(node)&&(node.type="FunctionExpression"),!(0, _index.isExpression)(node))throw new Error(`cannot turn ${node.type} to an expression`);return node}}});var require_traverseFast=__commonJS({"../../node_modules/@babel/types/lib/traverse/traverseFast.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=traverseFast;var _index=require_definitions();function traverseFast(node,enter,opts){if(!node)return;let keys=_index.VISITOR_KEYS[node.type];if(keys){opts=opts||{},enter(node,opts);for(let key of keys){let subNode=node[key];if(Array.isArray(subNode))for(let node2 of subNode)traverseFast(node2,enter,opts);else traverseFast(subNode,enter,opts);}}}}});var require_removeProperties=__commonJS({"../../node_modules/@babel/types/lib/modifications/removeProperties.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=removeProperties;var _index=require_constants(),CLEAR_KEYS=["tokens","start","end","loc","raw","rawValue"],CLEAR_KEYS_PLUS_COMMENTS=[..._index.COMMENT_KEYS,"comments",...CLEAR_KEYS];function removeProperties(node,opts={}){let map=opts.preserveComments?CLEAR_KEYS:CLEAR_KEYS_PLUS_COMMENTS;for(let key of map)node[key]!=null&&(node[key]=void 0);for(let key of Object.keys(node))key[0]==="_"&&node[key]!=null&&(node[key]=void 0);let symbols=Object.getOwnPropertySymbols(node);for(let sym of symbols)node[sym]=null;}}});var require_removePropertiesDeep=__commonJS({"../../node_modules/@babel/types/lib/modifications/removePropertiesDeep.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=removePropertiesDeep;var _traverseFast=require_traverseFast(),_removeProperties=require_removeProperties();function removePropertiesDeep(tree,opts){return (0, _traverseFast.default)(tree,_removeProperties.default,opts),tree}}});var require_toKeyAlias=__commonJS({"../../node_modules/@babel/types/lib/converters/toKeyAlias.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=toKeyAlias;var _index=require_generated(),_cloneNode=require_cloneNode(),_removePropertiesDeep=require_removePropertiesDeep();function toKeyAlias(node,key=node.key){let alias;return node.kind==="method"?toKeyAlias.increment()+"":((0, _index.isIdentifier)(key)?alias=key.name:(0, _index.isStringLiteral)(key)?alias=JSON.stringify(key.value):alias=JSON.stringify((0, _removePropertiesDeep.default)((0, _cloneNode.default)(key))),node.computed&&(alias=`[${alias}]`),node.static&&(alias=`static:${alias}`),alias)}toKeyAlias.uid=0;toKeyAlias.increment=function(){return toKeyAlias.uid>=Number.MAX_SAFE_INTEGER?toKeyAlias.uid=0:toKeyAlias.uid++};}});var require_toStatement=__commonJS({"../../node_modules/@babel/types/lib/converters/toStatement.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=void 0;var _index=require_generated(),_index2=require_generated2();exports.default=toStatement;function toStatement(node,ignore){if((0, _index.isStatement)(node))return node;let mustHaveId=!1,newType;if((0, _index.isClass)(node))mustHaveId=!0,newType="ClassDeclaration";else if((0, _index.isFunction)(node))mustHaveId=!0,newType="FunctionDeclaration";else if((0, _index.isAssignmentExpression)(node))return (0, _index2.expressionStatement)(node);if(mustHaveId&&!node.id&&(newType=!1),!newType){if(ignore)return !1;throw new Error(`cannot turn ${node.type} to a statement`)}return node.type=newType,node}}});var require_valueToNode=__commonJS({"../../node_modules/@babel/types/lib/converters/valueToNode.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=void 0;var _isValidIdentifier=require_isValidIdentifier(),_index=require_generated2();exports.default=valueToNode;var objectToString=Function.call.bind(Object.prototype.toString);function isRegExp(value){return objectToString(value)==="[object RegExp]"}function isPlainObject(value){if(typeof value!="object"||value===null||Object.prototype.toString.call(value)!=="[object Object]")return !1;let proto=Object.getPrototypeOf(value);return proto===null||Object.getPrototypeOf(proto)===null}function valueToNode(value){if(value===void 0)return (0, _index.identifier)("undefined");if(value===!0||value===!1)return (0, _index.booleanLiteral)(value);if(value===null)return (0, _index.nullLiteral)();if(typeof value=="string")return (0, _index.stringLiteral)(value);if(typeof value=="number"){let result;if(Number.isFinite(value))result=(0, _index.numericLiteral)(Math.abs(value));else {let numerator;Number.isNaN(value)?numerator=(0, _index.numericLiteral)(0):numerator=(0, _index.numericLiteral)(1),result=(0, _index.binaryExpression)("/",numerator,(0, _index.numericLiteral)(0));}return (value<0||Object.is(value,-0))&&(result=(0, _index.unaryExpression)("-",result)),result}if(isRegExp(value)){let pattern=value.source,flags=value.toString().match(/\/([a-z]+|)$/)[1];return (0, _index.regExpLiteral)(pattern,flags)}if(Array.isArray(value))return (0, _index.arrayExpression)(value.map(valueToNode));if(isPlainObject(value)){let props=[];for(let key of Object.keys(value)){let nodeKey;(0, _isValidIdentifier.default)(key)?nodeKey=(0, _index.identifier)(key):nodeKey=(0, _index.stringLiteral)(key),props.push((0, _index.objectProperty)(nodeKey,valueToNode(value[key])));}return (0, _index.objectExpression)(props)}throw new Error("don't know how to turn this value into a node")}}});var require_appendToMemberExpression=__commonJS({"../../node_modules/@babel/types/lib/modifications/appendToMemberExpression.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=appendToMemberExpression;var _index=require_generated2();function appendToMemberExpression(member,append,computed=!1){return member.object=(0, _index.memberExpression)(member.object,member.property,member.computed),member.property=append,member.computed=!!computed,member}}});var require_inherits=__commonJS({"../../node_modules/@babel/types/lib/modifications/inherits.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=inherits;var _index=require_constants(),_inheritsComments=require_inheritsComments();function inherits(child,parent){if(!child||!parent)return child;for(let key of _index.INHERIT_KEYS.optional)child[key]==null&&(child[key]=parent[key]);for(let key of Object.keys(parent))key[0]==="_"&&key!=="__clone"&&(child[key]=parent[key]);for(let key of _index.INHERIT_KEYS.force)child[key]=parent[key];return (0, _inheritsComments.default)(child,parent),child}}});var require_prependToMemberExpression=__commonJS({"../../node_modules/@babel/types/lib/modifications/prependToMemberExpression.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=prependToMemberExpression;var _index=require_generated2(),_index2=require_lib3();function prependToMemberExpression(member,prepend){if((0, _index2.isSuper)(member.object))throw new Error("Cannot prepend node to super property access (`super.foo`).");return member.object=(0, _index.memberExpression)(prepend,member.object),member}}});var require_getBindingIdentifiers=__commonJS({"../../node_modules/@babel/types/lib/retrievers/getBindingIdentifiers.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=getBindingIdentifiers;var _index=require_generated();function getBindingIdentifiers(node,duplicates,outerOnly,newBindingsOnly){let search=[].concat(node),ids=Object.create(null);for(;search.length;){let id=search.shift();if(!id||newBindingsOnly&&((0, _index.isAssignmentExpression)(id)||(0, _index.isUnaryExpression)(id)))continue;let keys=getBindingIdentifiers.keys[id.type];if((0, _index.isIdentifier)(id)){duplicates?(ids[id.name]=ids[id.name]||[]).push(id):ids[id.name]=id;continue}if((0, _index.isExportDeclaration)(id)&&!(0, _index.isExportAllDeclaration)(id)){(0, _index.isDeclaration)(id.declaration)&&search.push(id.declaration);continue}if(outerOnly){if((0, _index.isFunctionDeclaration)(id)){search.push(id.id);continue}if((0, _index.isFunctionExpression)(id))continue}if(keys)for(let i=0;i<keys.length;i++){let key=keys[i],nodes=id[key];nodes&&(Array.isArray(nodes)?search.push(...nodes):search.push(nodes));}}return ids}getBindingIdentifiers.keys={DeclareClass:["id"],DeclareFunction:["id"],DeclareModule:["id"],DeclareVariable:["id"],DeclareInterface:["id"],DeclareTypeAlias:["id"],DeclareOpaqueType:["id"],InterfaceDeclaration:["id"],TypeAlias:["id"],OpaqueType:["id"],CatchClause:["param"],LabeledStatement:["label"],UnaryExpression:["argument"],AssignmentExpression:["left"],ImportSpecifier:["local"],ImportNamespaceSpecifier:["local"],ImportDefaultSpecifier:["local"],ImportDeclaration:["specifiers"],ExportSpecifier:["exported"],ExportNamespaceSpecifier:["exported"],ExportDefaultSpecifier:["exported"],FunctionDeclaration:["id","params"],FunctionExpression:["id","params"],ArrowFunctionExpression:["params"],ObjectMethod:["params"],ClassMethod:["params"],ClassPrivateMethod:["params"],ForInStatement:["left"],ForOfStatement:["left"],ClassDeclaration:["id"],ClassExpression:["id"],RestElement:["argument"],UpdateExpression:["argument"],ObjectProperty:["value"],AssignmentPattern:["left"],ArrayPattern:["elements"],ObjectPattern:["properties"],VariableDeclaration:["declarations"],VariableDeclarator:["id"]};}});var require_getOuterBindingIdentifiers=__commonJS({"../../node_modules/@babel/types/lib/retrievers/getOuterBindingIdentifiers.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=void 0;var _getBindingIdentifiers=require_getBindingIdentifiers();exports.default=getOuterBindingIdentifiers;function getOuterBindingIdentifiers(node,duplicates){return (0, _getBindingIdentifiers.default)(node,duplicates,!0)}}});var require_traverse=__commonJS({"../../node_modules/@babel/types/lib/traverse/traverse.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=traverse;var _index=require_definitions();function traverse(node,handlers,state){typeof handlers=="function"&&(handlers={enter:handlers});let{enter,exit}=handlers;traverseSimpleImpl(node,enter,exit,state,[]);}function traverseSimpleImpl(node,enter,exit,state,ancestors){let keys=_index.VISITOR_KEYS[node.type];if(keys){enter&&enter(node,ancestors,state);for(let key of keys){let subNode=node[key];if(Array.isArray(subNode))for(let i=0;i<subNode.length;i++){let child=subNode[i];child&&(ancestors.push({node,key,index:i}),traverseSimpleImpl(child,enter,exit,state,ancestors),ancestors.pop());}else subNode&&(ancestors.push({node,key}),traverseSimpleImpl(subNode,enter,exit,state,ancestors),ancestors.pop());}exit&&exit(node,ancestors,state);}}}});var require_isBinding=__commonJS({"../../node_modules/@babel/types/lib/validators/isBinding.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=isBinding;var _getBindingIdentifiers=require_getBindingIdentifiers();function isBinding(node,parent,grandparent){if(grandparent&&node.type==="Identifier"&&parent.type==="ObjectProperty"&&grandparent.type==="ObjectExpression")return !1;let keys=_getBindingIdentifiers.default.keys[parent.type];if(keys)for(let i=0;i<keys.length;i++){let key=keys[i],val=parent[key];if(Array.isArray(val)){if(val.indexOf(node)>=0)return !0}else if(val===node)return !0}return !1}}});var require_isLet=__commonJS({"../../node_modules/@babel/types/lib/validators/isLet.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=isLet;var _index=require_generated(),_index2=require_constants();function isLet(node){return (0, _index.isVariableDeclaration)(node)&&(node.kind!=="var"||node[_index2.BLOCK_SCOPED_SYMBOL])}}});var require_isBlockScoped=__commonJS({"../../node_modules/@babel/types/lib/validators/isBlockScoped.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=isBlockScoped;var _index=require_generated(),_isLet=require_isLet();function isBlockScoped(node){return (0, _index.isFunctionDeclaration)(node)||(0, _index.isClassDeclaration)(node)||(0, _isLet.default)(node)}}});var require_isImmutable=__commonJS({"../../node_modules/@babel/types/lib/validators/isImmutable.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=isImmutable;var _isType=require_isType(),_index=require_generated();function isImmutable(node){return (0, _isType.default)(node.type,"Immutable")?!0:(0, _index.isIdentifier)(node)?node.name==="undefined":!1}}});var require_isNodesEquivalent=__commonJS({"../../node_modules/@babel/types/lib/validators/isNodesEquivalent.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=isNodesEquivalent;var _index=require_definitions();function isNodesEquivalent(a,b){if(typeof a!="object"||typeof b!="object"||a==null||b==null)return a===b;if(a.type!==b.type)return !1;let fields=Object.keys(_index.NODE_FIELDS[a.type]||a.type),visitorKeys=_index.VISITOR_KEYS[a.type];for(let field of fields){let val_a=a[field],val_b=b[field];if(typeof val_a!=typeof val_b)return !1;if(!(val_a==null&&val_b==null)){if(val_a==null||val_b==null)return !1;if(Array.isArray(val_a)){if(!Array.isArray(val_b)||val_a.length!==val_b.length)return !1;for(let i=0;i<val_a.length;i++)if(!isNodesEquivalent(val_a[i],val_b[i]))return !1;continue}if(typeof val_a=="object"&&!(visitorKeys!=null&&visitorKeys.includes(field))){for(let key of Object.keys(val_a))if(val_a[key]!==val_b[key])return !1;continue}if(!isNodesEquivalent(val_a,val_b))return !1}}return !0}}});var require_isReferenced=__commonJS({"../../node_modules/@babel/types/lib/validators/isReferenced.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=isReferenced;function isReferenced(node,parent,grandparent){switch(parent.type){case"MemberExpression":case"OptionalMemberExpression":return parent.property===node?!!parent.computed:parent.object===node;case"JSXMemberExpression":return parent.object===node;case"VariableDeclarator":return parent.init===node;case"ArrowFunctionExpression":return parent.body===node;case"PrivateName":return !1;case"ClassMethod":case"ClassPrivateMethod":case"ObjectMethod":return parent.key===node?!!parent.computed:!1;case"ObjectProperty":return parent.key===node?!!parent.computed:!grandparent||grandparent.type!=="ObjectPattern";case"ClassProperty":case"ClassAccessorProperty":return parent.key===node?!!parent.computed:!0;case"ClassPrivateProperty":return parent.key!==node;case"ClassDeclaration":case"ClassExpression":return parent.superClass===node;case"AssignmentExpression":return parent.right===node;case"AssignmentPattern":return parent.right===node;case"LabeledStatement":return !1;case"CatchClause":return !1;case"RestElement":return !1;case"BreakStatement":case"ContinueStatement":return !1;case"FunctionDeclaration":case"FunctionExpression":return !1;case"ExportNamespaceSpecifier":case"ExportDefaultSpecifier":return !1;case"ExportSpecifier":return grandparent!=null&&grandparent.source?!1:parent.local===node;case"ImportDefaultSpecifier":case"ImportNamespaceSpecifier":case"ImportSpecifier":return !1;case"ImportAttribute":return !1;case"JSXAttribute":return !1;case"ObjectPattern":case"ArrayPattern":return !1;case"MetaProperty":return !1;case"ObjectTypeProperty":return parent.key!==node;case"TSEnumMember":return parent.id!==node;case"TSPropertySignature":return parent.key===node?!!parent.computed:!0}return !0}}});var require_isScope=__commonJS({"../../node_modules/@babel/types/lib/validators/isScope.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=isScope;var _index=require_generated();function isScope(node,parent){return (0, _index.isBlockStatement)(node)&&((0, _index.isFunction)(parent)||(0, _index.isCatchClause)(parent))?!1:(0, _index.isPattern)(node)&&((0, _index.isFunction)(parent)||(0, _index.isCatchClause)(parent))?!0:(0, _index.isScopable)(node)}}});var require_isSpecifierDefault=__commonJS({"../../node_modules/@babel/types/lib/validators/isSpecifierDefault.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=isSpecifierDefault;var _index=require_generated();function isSpecifierDefault(specifier){return (0, _index.isImportDefaultSpecifier)(specifier)||(0, _index.isIdentifier)(specifier.imported||specifier.exported,{name:"default"})}}});var require_isValidES3Identifier=__commonJS({"../../node_modules/@babel/types/lib/validators/isValidES3Identifier.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=isValidES3Identifier;var _isValidIdentifier=require_isValidIdentifier(),RESERVED_WORDS_ES3_ONLY=new Set(["abstract","boolean","byte","char","double","enum","final","float","goto","implements","int","interface","long","native","package","private","protected","public","short","static","synchronized","throws","transient","volatile"]);function isValidES3Identifier(name){return (0, _isValidIdentifier.default)(name)&&!RESERVED_WORDS_ES3_ONLY.has(name)}}});var require_isVar=__commonJS({"../../node_modules/@babel/types/lib/validators/isVar.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=isVar;var _index=require_generated(),_index2=require_constants();function isVar(node){return (0, _index.isVariableDeclaration)(node,{kind:"var"})&&!node[_index2.BLOCK_SCOPED_SYMBOL]}}});var require_gatherSequenceExpressions=__commonJS({"../../node_modules/@babel/types/lib/converters/gatherSequenceExpressions.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=gatherSequenceExpressions;var _getBindingIdentifiers=require_getBindingIdentifiers(),_index=require_generated(),_index2=require_generated2(),_cloneNode=require_cloneNode();function gatherSequenceExpressions(nodes,scope,declars){let exprs=[],ensureLastUndefined=!0;for(let node of nodes)if((0, _index.isEmptyStatement)(node)||(ensureLastUndefined=!1),(0, _index.isExpression)(node))exprs.push(node);else if((0, _index.isExpressionStatement)(node))exprs.push(node.expression);else if((0, _index.isVariableDeclaration)(node)){if(node.kind!=="var")return;for(let declar of node.declarations){let bindings=(0, _getBindingIdentifiers.default)(declar);for(let key of Object.keys(bindings))declars.push({kind:node.kind,id:(0, _cloneNode.default)(bindings[key])});declar.init&&exprs.push((0, _index2.assignmentExpression)("=",declar.id,declar.init));}ensureLastUndefined=!0;}else if((0, _index.isIfStatement)(node)){let consequent=node.consequent?gatherSequenceExpressions([node.consequent],scope,declars):scope.buildUndefinedNode(),alternate=node.alternate?gatherSequenceExpressions([node.alternate],scope,declars):scope.buildUndefinedNode();if(!consequent||!alternate)return;exprs.push((0, _index2.conditionalExpression)(node.test,consequent,alternate));}else if((0, _index.isBlockStatement)(node)){let body=gatherSequenceExpressions(node.body,scope,declars);if(!body)return;exprs.push(body);}else if((0, _index.isEmptyStatement)(node))nodes.indexOf(node)===0&&(ensureLastUndefined=!0);else return;return ensureLastUndefined&&exprs.push(scope.buildUndefinedNode()),exprs.length===1?exprs[0]:(0, _index2.sequenceExpression)(exprs)}}});var require_toSequenceExpression=__commonJS({"../../node_modules/@babel/types/lib/converters/toSequenceExpression.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});exports.default=toSequenceExpression;var _gatherSequenceExpressions=require_gatherSequenceExpressions();function toSequenceExpression(nodes,scope){if(!(nodes!=null&&nodes.length))return;let declars=[],result=(0, _gatherSequenceExpressions.default)(nodes,scope,declars);if(result){for(let declar of declars)scope.push(declar);return result}}}});var require_lib3=__commonJS({"../../node_modules/@babel/types/lib/index.js"(exports){Object.defineProperty(exports,"__esModule",{value:!0});var _exportNames={react:!0,assertNode:!0,createTypeAnnotationBasedOnTypeof:!0,createUnionTypeAnnotation:!0,createFlowUnionType:!0,createTSUnionType:!0,cloneNode:!0,clone:!0,cloneDeep:!0,cloneDeepWithoutLoc:!0,cloneWithoutLoc:!0,addComment:!0,addComments:!0,inheritInnerComments:!0,inheritLeadingComments:!0,inheritsComments:!0,inheritTrailingComments:!0,removeComments:!0,ensureBlock:!0,toBindingIdentifierName:!0,toBlock:!0,toComputedKey:!0,toExpression:!0,toIdentifier:!0,toKeyAlias:!0,toStatement:!0,valueToNode:!0,appendToMemberExpression:!0,inherits:!0,prependToMemberExpression:!0,removeProperties:!0,removePropertiesDeep:!0,removeTypeDuplicates:!0,getBindingIdentifiers:!0,getOuterBindingIdentifiers:!0,traverse:!0,traverseFast:!0,shallowEqual:!0,is:!0,isBinding:!0,isBlockScoped:!0,isImmutable:!0,isLet:!0,isNode:!0,isNodesEquivalent:!0,isPlaceholderType:!0,isReferenced:!0,isScope:!0,isSpecifierDefault:!0,isType:!0,isValidES3Identifier:!0,isValidIdentifier:!0,isVar:!0,matchesPattern:!0,validate:!0,buildMatchMemberExpression:!0,__internal__deprecationWarning:!0};Object.defineProperty(exports,"__internal__deprecationWarning",{enumerable:!0,get:function(){return _deprecationWarning.default}});Object.defineProperty(exports,"addComment",{enumerable:!0,get:function(){return _addComment.default}});Object.defineProperty(exports,"addComments",{enumerable:!0,get:function(){return _addComments.default}});Object.defineProperty(exports,"appendToMemberExpression",{enumerable:!0,get:function(){return _appendToMemberExpression.default}});Object.defineProperty(exports,"assertNode",{enumerable:!0,get:function(){return _assertNode.default}});Object.defineProperty(exports,"buildMatchMemberExpression",{enumerable:!0,get:function(){return _buildMatchMemberExpression.default}});Object.defineProperty(exports,"clone",{enumerable:!0,get:function(){return _clone.default}});Object.defineProperty(exports,"cloneDeep",{enumerable:!0,get:function(){return _cloneDeep.default}});Object.defineProperty(exports,"cloneDeepWithoutLoc",{enumerable:!0,get:function(){return _cloneDeepWithoutLoc.default}});Object.defineProperty(exports,"cloneNode",{enumerable:!0,get:function(){return _cloneNode.default}});Object.defineProperty(exports,"cloneWithoutLoc",{enumerable:!0,get:function(){return _cloneWithoutLoc.default}});Object.defineProperty(exports,"createFlowUnionType",{enumerable:!0,get:function(){return _createFlowUnionType.default}});Object.defineProperty(exports,"createTSUnionType",{enumerable:!0,get:function(){return _createTSUnionType.default}});Object.defineProperty(exports,"createTypeAnnotationBasedOnTypeof",{enumerable:!0,get:function(){return _createTypeAnnotationBasedOnTypeof.default}});Object.defineProperty(exports,"createUnionTypeAnnotation",{enumerable:!0,get:function(){return _createFlowUnionType.default}});Object.defineProperty(exports,"ensureBlock",{enumerable:!0,get:function(){return _ensureBlock.default}});Object.defineProperty(exports,"getBindingIdentifiers",{enumerable:!0,get:function(){return _getBindingIdentifiers.default}});Object.defineProperty(exports,"getOuterBindingIdentifiers",{enumerable:!0,get:function(){return _getOuterBindingIdentifiers.default}});Object.defineProperty(exports,"inheritInnerComments",{enumerable:!0,get:function(){return _inheritInnerComments.default}});Object.defineProperty(exports,"inheritLeadingComments",{enumerable:!0,get:function(){return _inheritLeadingComments.default}});Object.defineProperty(exports,"inheritTrailingComments",{enumerable:!0,get:function(){return _inheritTrailingComments.default}});Object.defineProperty(exports,"inherits",{enumerable:!0,get:function(){return _inherits.default}});Object.defineProperty(exports,"inheritsComments",{enumerable:!0,get:function(){return _inheritsComments.default}});Object.defineProperty(exports,"is",{enumerable:!0,get:function(){return _is.default}});Object.defineProperty(exports,"isBinding",{enumerable:!0,get:function(){return _isBinding.default}});Object.defineProperty(exports,"isBlockScoped",{enumerable:!0,get:function(){return _isBlockScoped.default}});Object.defineProperty(exports,"isImmutable",{enumerable:!0,get:function(){return _isImmutable.default}});Object.defineProperty(exports,"isLet",{enumerable:!0,get:function(){return _isLet.default}});Object.defineProperty(exports,"isNode",{enumerable:!0,get:function(){return _isNode.default}});Object.defineProperty(exports,"isNodesEquivalent",{enumerable:!0,get:function(){return _isNodesEquivalent.default}});Object.defineProperty(exports,"isPlaceholderType",{enumerable:!0,get:function(){return _isPlaceholderType.default}});Object.defineProperty(exports,"isReferenced",{enumerable:!0,get:function(){return _isReferenced.default}});Object.defineProperty(exports,"isScope",{enumerable:!0,get:function(){return _isScope.default}});Object.defineProperty(exports,"isSpecifierDefault",{enumerable:!0,get:function(){return _isSpecifierDefault.default}});Object.defineProperty(exports,"isType",{enumerable:!0,get:function(){return _isType.default}});Object.defineProperty(exports,"isValidES3Identifier",{enumerable:!0,get:function(){return _isValidES3Identifier.default}});Object.defineProperty(exports,"isValidIdentifier",{enumerable:!0,get:function(){return _isValidIdentifier.default}});Object.defineProperty(exports,"isVar",{enumerable:!0,get:function(){return _isVar.default}});Object.defineProperty(exports,"matchesPattern",{enumerable:!0,get:function(){return _matchesPattern.default}});Object.defineProperty(exports,"prependToMemberExpression",{enumerable:!0,get:function(){return _prependToMemberExpression.default}});exports.react=void 0;Object.defineProperty(exports,"removeComments",{enumerable:!0,get:function(){return _removeComments.default}});Object.defineProperty(exports,"removeProperties",{enumerable:!0,get:function(){return _removeProperties.default}});Object.defineProperty(exports,"removePropertiesDeep",{enumerable:!0,get:function(){return _removePropertiesDeep.default}});Object.defineProperty(exports,"removeTypeDuplicates",{enumerable:!0,get:function(){return _removeTypeDuplicates.default}});Object.defineProperty(exports,"shallowEqual",{enumerable:!0,get:function(){return _shallowEqual.default}});Object.defineProperty(exports,"toBindingIdentifierName",{enumerable:!0,get:function(){return _toBindingIdentifierName.default}});Object.defineProperty(exports,"toBlock",{enumerable:!0,get:function(){return _toBlock.default}});Object.defineProperty(exports,"toComputedKey",{enumerable:!0,get:function(){return _toComputedKey.default}});Object.defineProperty(exports,"toExpression",{enumerable:!0,get:function(){return _toExpression.default}});Object.defineProperty(exports,"toIdentifier",{enumerable:!0,get:function(){return _toIdentifier.default}});Object.defineProperty(exports,"toKeyAlias",{enumerable:!0,get:function(){return _toKeyAlias.default}});Object.defineProperty(exports,"toStatement",{enumerable:!0,get:function(){return _toStatement.default}});Object.defineProperty(exports,"traverse",{enumerable:!0,get:function(){return _traverse.default}});Object.defineProperty(exports,"traverseFast",{enumerable:!0,get:function(){return _traverseFast.default}});Object.defineProperty(exports,"validate",{enumerable:!0,get:function(){return _validate.default}});Object.defineProperty(exports,"valueToNode",{enumerable:!0,get:function(){return _valueToNode.default}});var _isReactComponent=require_isReactComponent(),_isCompatTag=require_isCompatTag(),_buildChildren=require_buildChildren(),_assertNode=require_assertNode(),_index=require_generated3();Object.keys(_index).forEach(function(key){key==="default"||key==="__esModule"||Object.prototype.hasOwnProperty.call(_exportNames,key)||key in exports&&exports[key]===_index[key]||Object.defineProperty(exports,key,{enumerable:!0,get:function(){return _index[key]}});});var _createTypeAnnotationBasedOnTypeof=require_createTypeAnnotationBasedOnTypeof(),_createFlowUnionType=require_createFlowUnionType(),_createTSUnionType=require_createTSUnionType(),_index2=require_generated2();Object.keys(_index2).forEach(function(key){key==="default"||key==="__esModule"||Object.prototype.hasOwnProperty.call(_exportNames,key)||key in exports&&exports[key]===_index2[key]||Object.defineProperty(exports,key,{enumerable:!0,get:function(){return _index2[key]}});});var _uppercase=require_uppercase();Object.keys(_uppercase).forEach(function(key){key==="default"||key==="__esModule"||Object.prototype.hasOwnProperty.call(_exportNames,key)||key in exports&&exports[key]===_uppercase[key]||Object.defineProperty(exports,key,{enumerable:!0,get:function(){return _uppercase[key]}});});var _productions=require_productions();Object.keys(_productions).forEach(function(key){key==="default"||key==="__esModule"||Object.prototype.hasOwnProperty.call(_exportNames,key)||key in exports&&exports[key]===_productions[key]||Object.defineProperty(exports,key,{enumerable:!0,get:function(){return _productions[key]}});});var _cloneNode=require_cloneNode(),_clone=require_clone(),_cloneDeep=require_cloneDeep(),_cloneDeepWithoutLoc=require_cloneDeepWithoutLoc(),_cloneWithoutLoc=require_cloneWithoutLoc(),_addComment=require_addComment(),_addComments=require_addComments(),_inheritInnerComments=require_inheritInnerComments(),_inheritLeadingComments=require_inheritLeadingComments(),_inheritsComments=require_inheritsComments(),_inheritTrailingComments=require_inheritTrailingComments(),_removeComments=require_removeComments(),_index3=require_generated4();Object.keys(_index3).forEach(function(key){key==="default"||key==="__esModule"||Object.prototype.hasOwnProperty.call(_exportNames,key)||key in exports&&exports[key]===_index3[key]||Object.defineProperty(exports,key,{enumerable:!0,get:function(){return _index3[key]}});});var _index4=require_constants();Object.keys(_index4).forEach(function(key){key==="default"||key==="__esModule"||Object.prototype.hasOwnProperty.call(_exportNames,key)||key in exports&&exports[key]===_index4[key]||Object.defineProperty(exports,key,{enumerable:!0,get:function(){return _index4[key]}});});var _ensureBlock=require_ensureBlock(),_toBindingIdentifierName=require_toBindingIdentifierName(),_toBlock=require_toBlock(),_toComputedKey=require_toComputedKey(),_toExpression=require_toExpression(),_toIdentifier=require_toIdentifier(),_toKeyAlias=require_toKeyAlias(),_toStatement=require_toStatement(),_valueToNode=require_valueToNode(),_index5=require_definitions();Object.keys(_index5).forEach(function(key){key==="default"||key==="__esModule"||Object.prototype.hasOwnProperty.call(_exportNames,key)||key in exports&&exports[key]===_index5[key]||Object.defineProperty(exports,key,{enumerable:!0,get:function(){return _index5[key]}});});var _appendToMemberExpression=require_appendToMemberExpression(),_inherits=require_inherits(),_prependToMemberExpression=require_prependToMemberExpression(),_removeProperties=require_removeProperties(),_removePropertiesDeep=require_removePropertiesDeep(),_removeTypeDuplicates=require_removeTypeDuplicates(),_getBindingIdentifiers=require_getBindingIdentifiers(),_getOuterBindingIdentifiers=require_getOuterBindingIdentifiers(),_traverse=require_traverse();Object.keys(_traverse).forEach(function(key){key==="default"||key==="__esModule"||Object.prototype.hasOwnProperty.call(_exportNames,key)||key in exports&&exports[key]===_traverse[key]||Object.defineProperty(exports,key,{enumerable:!0,get:function(){return _traverse[key]}});});var _traverseFast=require_traverseFast(),_shallowEqual=require_shallowEqual(),_is=require_is(),_isBinding=require_isBinding(),_isBlockScoped=require_isBlockScoped(),_isImmutable=require_isImmutable(),_isLet=require_isLet(),_isNode=require_isNode(),_isNodesEquivalent=require_isNodesEquivalent(),_isPlaceholderType=require_isPlaceholderType(),_isReferenced=require_isReferenced(),_isScope=require_isScope(),_isSpecifierDefault=require_isSpecifierDefault(),_isType=require_isType(),_isValidES3Identifier=require_isValidES3Identifier(),_isValidIdentifier=require_isValidIdentifier(),_isVar=require_isVar(),_matchesPattern=require_matchesPattern(),_validate=require_validate(),_buildMatchMemberExpression=require_buildMatchMemberExpression(),_index6=require_generated();Object.keys(_index6).forEach(function(key){key==="default"||key==="__esModule"||Object.prototype.hasOwnProperty.call(_exportNames,key)||key in exports&&exports[key]===_index6[key]||Object.defineProperty(exports,key,{enumerable:!0,get:function(){return _index6[key]}});});var _deprecationWarning=require_deprecationWarning();exports.react={isReactComponent:_isReactComponent.default,isCompatTag:_isCompatTag.default,buildChildren:_buildChildren.default};exports.toSequenceExpression=require_toSequenceExpression().default;}});function ansiRegex({onlyFirst=!1}={}){let pattern=["[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)","(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))"].join("|");return new RegExp(pattern,onlyFirst?void 0:"g")}var regex=ansiRegex();function stripAnsi(string){if(typeof string!="string")throw new TypeError(`Expected a \`string\`, got \`${typeof string}\``);return string.replace(regex,"")}var import_eastasianwidth=__toESM(require_eastasianwidth(),1),import_emoji_regex=__toESM(require_emoji_regex(),1);function stringWidth(string,options={}){if(typeof string!="string"||string.length===0||(options={ambiguousIsNarrow:!0,...options},string=stripAnsi(string),string.length===0))return 0;string=string.replace((0, import_emoji_regex.default)(),"  ");let ambiguousCharacterWidth=options.ambiguousIsNarrow?1:2,width=0;for(let character of string){let codePoint=character.codePointAt(0);if(codePoint<=31||codePoint>=127&&codePoint<=159||codePoint>=768&&codePoint<=879)continue;switch(import_eastasianwidth.default.eastAsianWidth(character)){case"F":case"W":width+=2;break;case"A":width+=ambiguousCharacterWidth;break;default:width+=1;}}return width}var import_eastasianwidth2=__toESM(require_eastasianwidth(),1),import_emoji_regex2=__toESM(require_emoji_regex(),1);function stringWidth2(string,options={}){if(typeof string!="string"||string.length===0||(options={ambiguousIsNarrow:!0,...options},string=stripAnsi(string),string.length===0))return 0;string=string.replace((0, import_emoji_regex2.default)(),"  ");let ambiguousCharacterWidth=options.ambiguousIsNarrow?1:2,width=0;for(let character of string){let codePoint=character.codePointAt(0);if(codePoint<=31||codePoint>=127&&codePoint<=159||codePoint>=768&&codePoint<=879)continue;switch(import_eastasianwidth2.default.eastAsianWidth(character)){case"F":case"W":width+=2;break;case"A":width+=ambiguousCharacterWidth;break;default:width+=1;}}return width}function widestLine(string){let lineWidth=0;for(let line of string.split(`
`))lineWidth=Math.max(lineWidth,stringWidth2(line));return lineWidth}var import_cli_boxes=__toESM(require_cli_boxes(),1);var UPPERCASE=/[\p{Lu}]/u,LOWERCASE=/[\p{Ll}]/u,LEADING_CAPITAL=/^[\p{Lu}](?![\p{Lu}])/gu,IDENTIFIER=/([\p{Alpha}\p{N}_]|$)/u,SEPARATORS=/[_.\- ]+/,LEADING_SEPARATORS=new RegExp("^"+SEPARATORS.source),SEPARATORS_AND_IDENTIFIER=new RegExp(SEPARATORS.source+IDENTIFIER.source,"gu"),NUMBERS_AND_IDENTIFIER=new RegExp("\\d+"+IDENTIFIER.source,"gu"),preserveCamelCase=(string,toLowerCase,toUpperCase,preserveConsecutiveUppercase2)=>{let isLastCharLower=!1,isLastCharUpper=!1,isLastLastCharUpper=!1,isLastLastCharPreserved=!1;for(let index=0;index<string.length;index++){let character=string[index];isLastLastCharPreserved=index>2?string[index-3]==="-":!0,isLastCharLower&&UPPERCASE.test(character)?(string=string.slice(0,index)+"-"+string.slice(index),isLastCharLower=!1,isLastLastCharUpper=isLastCharUpper,isLastCharUpper=!0,index++):isLastCharUpper&&isLastLastCharUpper&&LOWERCASE.test(character)&&(!isLastLastCharPreserved||preserveConsecutiveUppercase2)?(string=string.slice(0,index-1)+"-"+string.slice(index-1),isLastLastCharUpper=isLastCharUpper,isLastCharUpper=!1,isLastCharLower=!0):(isLastCharLower=toLowerCase(character)===character&&toUpperCase(character)!==character,isLastLastCharUpper=isLastCharUpper,isLastCharUpper=toUpperCase(character)===character&&toLowerCase(character)!==character);}return string},preserveConsecutiveUppercase=(input,toLowerCase)=>(LEADING_CAPITAL.lastIndex=0,input.replace(LEADING_CAPITAL,m1=>toLowerCase(m1))),postProcess=(input,toUpperCase)=>(SEPARATORS_AND_IDENTIFIER.lastIndex=0,NUMBERS_AND_IDENTIFIER.lastIndex=0,input.replace(SEPARATORS_AND_IDENTIFIER,(_,identifier2)=>toUpperCase(identifier2)).replace(NUMBERS_AND_IDENTIFIER,m=>toUpperCase(m)));function camelCase(input,options){if(!(typeof input=="string"||Array.isArray(input)))throw new TypeError("Expected the input to be `string | string[]`");if(options={pascalCase:!1,preserveConsecutiveUppercase:!1,...options},Array.isArray(input)?input=input.map(x=>x.trim()).filter(x=>x.length).join("-"):input=input.trim(),input.length===0)return "";let toLowerCase=options.locale===!1?string=>string.toLowerCase():string=>string.toLocaleLowerCase(options.locale),toUpperCase=options.locale===!1?string=>string.toUpperCase():string=>string.toLocaleUpperCase(options.locale);return input.length===1?SEPARATORS.test(input)?"":options.pascalCase?toUpperCase(input):toLowerCase(input):(input!==toLowerCase(input)&&(input=preserveCamelCase(input,toLowerCase,toUpperCase,options.preserveConsecutiveUppercase)),input=input.replace(LEADING_SEPARATORS,""),input=options.preserveConsecutiveUppercase?preserveConsecutiveUppercase(input,toLowerCase):toLowerCase(input),options.pascalCase&&(input=toUpperCase(input.charAt(0))+input.slice(1)),postProcess(input,toUpperCase))}var import_ansi_align=__toESM(require_ansi_align(),1);var import_eastasianwidth3=__toESM(require_eastasianwidth(),1),import_emoji_regex3=__toESM(require_emoji_regex(),1);function stringWidth3(string,options={}){if(typeof string!="string"||string.length===0||(options={ambiguousIsNarrow:!0,...options},string=stripAnsi(string),string.length===0))return 0;string=string.replace((0, import_emoji_regex3.default)(),"  ");let ambiguousCharacterWidth=options.ambiguousIsNarrow?1:2,width=0;for(let character of string){let codePoint=character.codePointAt(0);if(codePoint<=31||codePoint>=127&&codePoint<=159||codePoint>=768&&codePoint<=879)continue;switch(import_eastasianwidth3.default.eastAsianWidth(character)){case"F":case"W":width+=2;break;case"A":width+=ambiguousCharacterWidth;break;default:width+=1;}}return width}var wrapAnsi16=(offset=0)=>code=>`\x1B[${code+offset}m`,wrapAnsi256=(offset=0)=>code=>`\x1B[${38+offset};5;${code}m`,wrapAnsi16m=(offset=0)=>(red,green,blue)=>`\x1B[${38+offset};2;${red};${green};${blue}m`,styles={modifier:{reset:[0,0],bold:[1,22],dim:[2,22],italic:[3,23],underline:[4,24],overline:[53,55],inverse:[7,27],hidden:[8,28],strikethrough:[9,29]},color:{black:[30,39],red:[31,39],green:[32,39],yellow:[33,39],blue:[34,39],magenta:[35,39],cyan:[36,39],white:[37,39],blackBright:[90,39],gray:[90,39],grey:[90,39],redBright:[91,39],greenBright:[92,39],yellowBright:[93,39],blueBright:[94,39],magentaBright:[95,39],cyanBright:[96,39],whiteBright:[97,39]},bgColor:{bgBlack:[40,49],bgRed:[41,49],bgGreen:[42,49],bgYellow:[43,49],bgBlue:[44,49],bgMagenta:[45,49],bgCyan:[46,49],bgWhite:[47,49],bgBlackBright:[100,49],bgGray:[100,49],bgGrey:[100,49],bgRedBright:[101,49],bgGreenBright:[102,49],bgYellowBright:[103,49],bgBlueBright:[104,49],bgMagentaBright:[105,49],bgCyanBright:[106,49],bgWhiteBright:[107,49]}};Object.keys(styles.modifier);var foregroundColorNames=Object.keys(styles.color),backgroundColorNames=Object.keys(styles.bgColor);[...foregroundColorNames,...backgroundColorNames];function assembleStyles(){let codes=new Map;for(let[groupName,group]of Object.entries(styles)){for(let[styleName,style]of Object.entries(group))styles[styleName]={open:`\x1B[${style[0]}m`,close:`\x1B[${style[1]}m`},group[styleName]=styles[styleName],codes.set(style[0],style[1]);Object.defineProperty(styles,groupName,{value:group,enumerable:!1});}return Object.defineProperty(styles,"codes",{value:codes,enumerable:!1}),styles.color.close="\x1B[39m",styles.bgColor.close="\x1B[49m",styles.color.ansi=wrapAnsi16(),styles.color.ansi256=wrapAnsi256(),styles.color.ansi16m=wrapAnsi16m(),styles.bgColor.ansi=wrapAnsi16(10),styles.bgColor.ansi256=wrapAnsi256(10),styles.bgColor.ansi16m=wrapAnsi16m(10),Object.defineProperties(styles,{rgbToAnsi256:{value:(red,green,blue)=>red===green&&green===blue?red<8?16:red>248?231:Math.round((red-8)/247*24)+232:16+36*Math.round(red/255*5)+6*Math.round(green/255*5)+Math.round(blue/255*5),enumerable:!1},hexToRgb:{value:hex=>{let matches=/[a-f\d]{6}|[a-f\d]{3}/i.exec(hex.toString(16));if(!matches)return [0,0,0];let[colorString]=matches;colorString.length===3&&(colorString=[...colorString].map(character=>character+character).join(""));let integer=Number.parseInt(colorString,16);return [integer>>16&255,integer>>8&255,integer&255]},enumerable:!1},hexToAnsi256:{value:hex=>styles.rgbToAnsi256(...styles.hexToRgb(hex)),enumerable:!1},ansi256ToAnsi:{value:code=>{if(code<8)return 30+code;if(code<16)return 90+(code-8);let red,green,blue;if(code>=232)red=((code-232)*10+8)/255,green=red,blue=red;else {code-=16;let remainder=code%36;red=Math.floor(code/36)/5,green=Math.floor(remainder/6)/5,blue=remainder%6/5;}let value=Math.max(red,green,blue)*2;if(value===0)return 30;let result=30+(Math.round(blue)<<2|Math.round(green)<<1|Math.round(red));return value===2&&(result+=60),result},enumerable:!1},rgbToAnsi:{value:(red,green,blue)=>styles.ansi256ToAnsi(styles.rgbToAnsi256(red,green,blue)),enumerable:!1},hexToAnsi:{value:hex=>styles.ansi256ToAnsi(styles.hexToAnsi256(hex)),enumerable:!1}}),styles}var ansiStyles=assembleStyles(),ansi_styles_default=ansiStyles;var ESCAPES=new Set(["\x1B","\x9B"]),END_CODE=39,ANSI_ESCAPE_BELL="\x07",ANSI_CSI="[",ANSI_OSC="]",ANSI_SGR_TERMINATOR="m",ANSI_ESCAPE_LINK=`${ANSI_OSC}8;;`,wrapAnsiCode=code=>`${ESCAPES.values().next().value}${ANSI_CSI}${code}${ANSI_SGR_TERMINATOR}`,wrapAnsiHyperlink=uri=>`${ESCAPES.values().next().value}${ANSI_ESCAPE_LINK}${uri}${ANSI_ESCAPE_BELL}`,wordLengths=string=>string.split(" ").map(character=>stringWidth3(character)),wrapWord=(rows,word,columns)=>{let characters=[...word],isInsideEscape=!1,isInsideLinkEscape=!1,visible=stringWidth3(stripAnsi(rows[rows.length-1]));for(let[index,character]of characters.entries()){let characterLength=stringWidth3(character);if(visible+characterLength<=columns?rows[rows.length-1]+=character:(rows.push(character),visible=0),ESCAPES.has(character)&&(isInsideEscape=!0,isInsideLinkEscape=characters.slice(index+1).join("").startsWith(ANSI_ESCAPE_LINK)),isInsideEscape){isInsideLinkEscape?character===ANSI_ESCAPE_BELL&&(isInsideEscape=!1,isInsideLinkEscape=!1):character===ANSI_SGR_TERMINATOR&&(isInsideEscape=!1);continue}visible+=characterLength,visible===columns&&index<characters.length-1&&(rows.push(""),visible=0);}!visible&&rows[rows.length-1].length>0&&rows.length>1&&(rows[rows.length-2]+=rows.pop());},stringVisibleTrimSpacesRight=string=>{let words=string.split(" "),last=words.length;for(;last>0&&!(stringWidth3(words[last-1])>0);)last--;return last===words.length?string:words.slice(0,last).join(" ")+words.slice(last).join("")},exec=(string,columns,options={})=>{if(options.trim!==!1&&string.trim()==="")return "";let returnValue="",escapeCode,escapeUrl,lengths=wordLengths(string),rows=[""];for(let[index,word]of string.split(" ").entries()){options.trim!==!1&&(rows[rows.length-1]=rows[rows.length-1].trimStart());let rowLength=stringWidth3(rows[rows.length-1]);if(index!==0&&(rowLength>=columns&&(options.wordWrap===!1||options.trim===!1)&&(rows.push(""),rowLength=0),(rowLength>0||options.trim===!1)&&(rows[rows.length-1]+=" ",rowLength++)),options.hard&&lengths[index]>columns){let remainingColumns=columns-rowLength,breaksStartingThisLine=1+Math.floor((lengths[index]-remainingColumns-1)/columns);Math.floor((lengths[index]-1)/columns)<breaksStartingThisLine&&rows.push(""),wrapWord(rows,word,columns);continue}if(rowLength+lengths[index]>columns&&rowLength>0&&lengths[index]>0){if(options.wordWrap===!1&&rowLength<columns){wrapWord(rows,word,columns);continue}rows.push("");}if(rowLength+lengths[index]>columns&&options.wordWrap===!1){wrapWord(rows,word,columns);continue}rows[rows.length-1]+=word;}options.trim!==!1&&(rows=rows.map(row=>stringVisibleTrimSpacesRight(row)));let pre=[...rows.join(`
`)];for(let[index,character]of pre.entries()){if(returnValue+=character,ESCAPES.has(character)){let{groups}=new RegExp(`(?:\\${ANSI_CSI}(?<code>\\d+)m|\\${ANSI_ESCAPE_LINK}(?<uri>.*)${ANSI_ESCAPE_BELL})`).exec(pre.slice(index).join(""))||{groups:{}};if(groups.code!==void 0){let code2=Number.parseFloat(groups.code);escapeCode=code2===END_CODE?void 0:code2;}else groups.uri!==void 0&&(escapeUrl=groups.uri.length===0?void 0:groups.uri);}let code=ansi_styles_default.codes.get(Number(escapeCode));pre[index+1]===`
`?(escapeUrl&&(returnValue+=wrapAnsiHyperlink("")),escapeCode&&code&&(returnValue+=wrapAnsiCode(code))):character===`
`&&(escapeCode&&code&&(returnValue+=wrapAnsiCode(escapeCode)),escapeUrl&&(returnValue+=wrapAnsiHyperlink(escapeUrl)));}return returnValue};function wrapAnsi(string,columns,options){return String(string).normalize().replace(/\r\n/g,`
`).split(`
`).map(line=>exec(line,columns,options)).join(`
`)}__toESM(require_cli_boxes(),1);var NEWLINE=`
`,PAD=" ",NONE="none",terminalColumns=()=>{let{env,stdout,stderr}=process2;return stdout?.columns?stdout.columns:stderr?.columns?stderr.columns:env.COLUMNS?Number.parseInt(env.COLUMNS,10):80},getObject=detail=>typeof detail=="number"?{top:detail,right:detail*3,bottom:detail,left:detail*3}:{top:0,right:0,bottom:0,left:0,...detail},getBorderWidth=borderStyle=>borderStyle===NONE?0:2,getBorderChars=borderStyle=>{let sides=["topLeft","topRight","bottomRight","bottomLeft","left","right","top","bottom"],characters;if(borderStyle===NONE){borderStyle={};for(let side of sides)borderStyle[side]="";}if(typeof borderStyle=="string"){if(characters=import_cli_boxes.default[borderStyle],!characters)throw new TypeError(`Invalid border style: ${borderStyle}`)}else {typeof borderStyle?.vertical=="string"&&(borderStyle.left=borderStyle.vertical,borderStyle.right=borderStyle.vertical),typeof borderStyle?.horizontal=="string"&&(borderStyle.top=borderStyle.horizontal,borderStyle.bottom=borderStyle.horizontal);for(let side of sides)if(borderStyle[side]===null||typeof borderStyle[side]!="string")throw new TypeError(`Invalid border style: ${side}`);characters=borderStyle;}return characters},makeTitle=(text,horizontal,alignment)=>{let title="",textWidth=stringWidth(text);switch(alignment){case"left":{title=text+horizontal.slice(textWidth);break}case"right":{title=horizontal.slice(textWidth)+text;break}default:{horizontal=horizontal.slice(textWidth),horizontal.length%2===1?(horizontal=horizontal.slice(Math.floor(horizontal.length/2)),title=horizontal.slice(1)+text+horizontal):(horizontal=horizontal.slice(horizontal.length/2),title=horizontal+text+horizontal);break}}return title},makeContentText=(text,{padding,width,textAlignment,height})=>{text=(0, import_ansi_align.default)(text,{align:textAlignment});let lines=text.split(NEWLINE),textWidth=widestLine(text),max=width-padding.left-padding.right;if(textWidth>max){let newLines=[];for(let line of lines){let createdLines=wrapAnsi(line,max,{hard:!0}),alignedLinesArray=(0, import_ansi_align.default)(createdLines,{align:textAlignment}).split(`
`),longestLength=Math.max(...alignedLinesArray.map(s=>stringWidth(s)));for(let alignedLine of alignedLinesArray){let paddedLine;switch(textAlignment){case"center":{paddedLine=PAD.repeat((max-longestLength)/2)+alignedLine;break}case"right":{paddedLine=PAD.repeat(max-longestLength)+alignedLine;break}default:{paddedLine=alignedLine;break}}newLines.push(paddedLine);}}lines=newLines;}textAlignment==="center"&&textWidth<max?lines=lines.map(line=>PAD.repeat((max-textWidth)/2)+line):textAlignment==="right"&&textWidth<max&&(lines=lines.map(line=>PAD.repeat(max-textWidth)+line));let paddingLeft=PAD.repeat(padding.left),paddingRight=PAD.repeat(padding.right);return lines=lines.map(line=>paddingLeft+line+paddingRight),lines=lines.map(line=>{if(width-stringWidth(line)>0)switch(textAlignment){case"center":return line+PAD.repeat(width-stringWidth(line));case"right":return line+PAD.repeat(width-stringWidth(line));default:return line+PAD.repeat(width-stringWidth(line))}return line}),padding.top>0&&(lines=[...Array.from({length:padding.top}).fill(PAD.repeat(width)),...lines]),padding.bottom>0&&(lines=[...lines,...Array.from({length:padding.bottom}).fill(PAD.repeat(width))]),height&&lines.length>height?lines=lines.slice(0,height):height&&lines.length<height&&(lines=[...lines,...Array.from({length:height-lines.length}).fill(PAD.repeat(width))]),lines.join(NEWLINE)},boxContent=(content,contentWidth,options)=>{let colorizeBorder=border=>{let newBorder=options.borderColor?getColorFn(options.borderColor)(border):border;return options.dimBorder?chalk15.dim(newBorder):newBorder},colorizeContent=content2=>options.backgroundColor?getBGColorFn(options.backgroundColor)(content2):content2,chars=getBorderChars(options.borderStyle),columns=terminalColumns(),marginLeft=PAD.repeat(options.margin.left);if(options.float==="center"){let marginWidth=Math.max((columns-contentWidth-getBorderWidth(options.borderStyle))/2,0);marginLeft=PAD.repeat(marginWidth);}else if(options.float==="right"){let marginWidth=Math.max(columns-contentWidth-options.margin.right-getBorderWidth(options.borderStyle),0);marginLeft=PAD.repeat(marginWidth);}let result="";options.margin.top&&(result+=NEWLINE.repeat(options.margin.top)),(options.borderStyle!==NONE||options.title)&&(result+=colorizeBorder(marginLeft+chars.topLeft+(options.title?makeTitle(options.title,chars.top.repeat(contentWidth),options.titleAlignment):chars.top.repeat(contentWidth))+chars.topRight)+NEWLINE);let lines=content.split(NEWLINE);return result+=lines.map(line=>marginLeft+colorizeBorder(chars.left)+colorizeContent(line)+colorizeBorder(chars.right)).join(NEWLINE),options.borderStyle!==NONE&&(result+=NEWLINE+colorizeBorder(marginLeft+chars.bottomLeft+chars.bottom.repeat(contentWidth)+chars.bottomRight)),options.margin.bottom&&(result+=NEWLINE.repeat(options.margin.bottom)),result},sanitizeOptions=options=>{if(options.fullscreen&&process2?.stdout){let newDimensions=[process2.stdout.columns,process2.stdout.rows];typeof options.fullscreen=="function"&&(newDimensions=options.fullscreen(...newDimensions)),options.width||(options.width=newDimensions[0]),options.height||(options.height=newDimensions[1]);}return options.width&&(options.width=Math.max(1,options.width-getBorderWidth(options.borderStyle))),options.height&&(options.height=Math.max(1,options.height-getBorderWidth(options.borderStyle))),options},formatTitle=(title,borderStyle)=>borderStyle===NONE?title:` ${title} `,determineDimensions=(text,options)=>{options=sanitizeOptions(options);let widthOverride=options.width!==void 0,columns=terminalColumns(),borderWidth=getBorderWidth(options.borderStyle),maxWidth=columns-options.margin.left-options.margin.right-borderWidth,widest=widestLine(wrapAnsi(text,columns-borderWidth,{hard:!0,trim:!1}))+options.padding.left+options.padding.right;if(options.title&&widthOverride?(options.title=options.title.slice(0,Math.max(0,options.width-2)),options.title&&(options.title=formatTitle(options.title,options.borderStyle))):options.title&&(options.title=options.title.slice(0,Math.max(0,maxWidth-2)),options.title&&(options.title=formatTitle(options.title,options.borderStyle),stringWidth(options.title)>widest&&(options.width=stringWidth(options.title)))),options.width=options.width?options.width:widest,!widthOverride){if(options.margin.left&&options.margin.right&&options.width>maxWidth){let multiplier=(columns-options.width-borderWidth)/(options.margin.left+options.margin.right);options.margin.left=Math.max(0,Math.floor(options.margin.left*multiplier)),options.margin.right=Math.max(0,Math.floor(options.margin.right*multiplier));}options.width=Math.min(options.width,columns-borderWidth-options.margin.left-options.margin.right);}return options.width-(options.padding.left+options.padding.right)<=0&&(options.padding.left=0,options.padding.right=0),options.height&&options.height-(options.padding.top+options.padding.bottom)<=0&&(options.padding.top=0,options.padding.bottom=0),options},isHex=color=>color.match(/^#(?:[0-f]{3}){1,2}$/i),isColorValid=color=>typeof color=="string"&&(chalk15[color]??isHex(color)),getColorFn=color=>isHex(color)?chalk15.hex(color):chalk15[color],getBGColorFn=color=>isHex(color)?chalk15.bgHex(color):chalk15[camelCase(["bg",color])];function boxen(text,options){if(options={padding:0,borderStyle:"single",dimBorder:!1,textAlignment:"left",float:"left",titleAlignment:"left",...options},options.align&&(options.textAlignment=options.align),options.borderColor&&!isColorValid(options.borderColor))throw new Error(`${options.borderColor} is not a valid borderColor`);if(options.backgroundColor&&!isColorValid(options.backgroundColor))throw new Error(`${options.backgroundColor} is not a valid backgroundColor`);return options.padding=getObject(options.padding),options.margin=getObject(options.margin),options=determineDimensions(text,options),text=makeContentText(text,options),boxContent(text,options.width,options)}function eqMajor(versionRange,major){return validRange(versionRange)?minVersion(versionRange)?.major===major:!1}var externalFrameworks=[{name:"qwik",packageName:"storybook-framework-qwik"},{name:"solid",frameworks:["storybook-solidjs-vite"],renderer:"storybook-solidjs"},{name:"nuxt",packageName:"@storybook-vue/nuxt"}];var ProjectType=(ProjectType2=>(ProjectType2.UNDETECTED="UNDETECTED",ProjectType2.UNSUPPORTED="UNSUPPORTED",ProjectType2.REACT="REACT",ProjectType2.REACT_SCRIPTS="REACT_SCRIPTS",ProjectType2.REACT_NATIVE="REACT_NATIVE",ProjectType2.REACT_PROJECT="REACT_PROJECT",ProjectType2.WEBPACK_REACT="WEBPACK_REACT",ProjectType2.NEXTJS="NEXTJS",ProjectType2.VUE3="VUE3",ProjectType2.NUXT="NUXT",ProjectType2.ANGULAR="ANGULAR",ProjectType2.EMBER="EMBER",ProjectType2.WEB_COMPONENTS="WEB_COMPONENTS",ProjectType2.HTML="HTML",ProjectType2.QWIK="QWIK",ProjectType2.PREACT="PREACT",ProjectType2.SVELTE="SVELTE",ProjectType2.SVELTEKIT="SVELTEKIT",ProjectType2.SERVER="SERVER",ProjectType2.NX="NX",ProjectType2.SOLID="SOLID",ProjectType2))(ProjectType||{});var compilerNameToCoreCompiler={"@storybook/addon-webpack5-compiler-babel":"babel","@storybook/addon-webpack5-compiler-swc":"swc"},builderNameToCoreBuilder={"@storybook/builder-webpack5":"webpack5","@storybook/builder-vite":"vite"};var supportedTemplates=[{preset:"NUXT",dependencies:["nuxt"],matcherFunction:({dependencies})=>dependencies?.every(Boolean)??!0},{preset:"VUE3",dependencies:{vue:versionRange=>versionRange==="next"||eqMajor(versionRange,3)},matcherFunction:({dependencies})=>dependencies?.some(Boolean)??!1},{preset:"EMBER",dependencies:["ember-cli"],matcherFunction:({dependencies})=>dependencies?.every(Boolean)??!0},{preset:"NEXTJS",dependencies:["next"],matcherFunction:({dependencies})=>dependencies?.every(Boolean)??!0},{preset:"QWIK",dependencies:["@builder.io/qwik"],matcherFunction:({dependencies})=>dependencies?.every(Boolean)??!0},{preset:"REACT_PROJECT",peerDependencies:["react"],matcherFunction:({peerDependencies})=>peerDependencies?.every(Boolean)??!0},{preset:"REACT_NATIVE",dependencies:["react-native","react-native-scripts"],matcherFunction:({dependencies})=>dependencies?.some(Boolean)??!1},{preset:"REACT_SCRIPTS",files:["/node_modules/.bin/react-scripts"],dependencies:["react-scripts"],matcherFunction:({dependencies,files})=>(dependencies?.every(Boolean)||files?.every(Boolean))??!1},{preset:"ANGULAR",dependencies:["@angular/core"],matcherFunction:({dependencies})=>dependencies?.every(Boolean)??!0},{preset:"WEB_COMPONENTS",dependencies:["lit-element","lit-html","lit"],matcherFunction:({dependencies})=>dependencies?.some(Boolean)??!1},{preset:"PREACT",dependencies:["preact"],matcherFunction:({dependencies})=>dependencies?.every(Boolean)??!0},{preset:"SVELTEKIT",dependencies:["@sveltejs/kit"],matcherFunction:({dependencies})=>dependencies?.every(Boolean)??!0},{preset:"SVELTE",dependencies:["svelte"],matcherFunction:({dependencies})=>dependencies?.every(Boolean)??!0},{preset:"SOLID",dependencies:["solid-js"],matcherFunction:({dependencies})=>dependencies?.every(Boolean)??!0},{preset:"WEBPACK_REACT",dependencies:["react","webpack"],matcherFunction:({dependencies})=>dependencies?.every(Boolean)??!0},{preset:"REACT",dependencies:["react"],matcherFunction:({dependencies})=>dependencies?.every(Boolean)??!0}],unsupportedTemplate={preset:"UNSUPPORTED",dependencies:{},matcherFunction:({dependencies})=>dependencies?.some(Boolean)??!1},notInstallableProjectTypes=["UNDETECTED","UNSUPPORTED","NX"],installableProjectTypes=Object.values(ProjectType).filter(type=>!notInstallableProjectTypes.includes(type)).map(type=>type.toLowerCase());function getCliDir(){return dirname(__require.resolve("storybook/package.json"))}var resolveUsingBranchInstall=async(packageManager,request)=>{let{temporaryDirectory}=await import('tempy'),tempDirectory=temporaryDirectory(),version=versions[request]||await packageManager.latestVersion(request),url=getNpmTarballUrl(request,version,{registry:await packageManager.getRegistryURL()});return await downloadTarball({url,dir:tempDirectory}),join(tempDirectory,"package")};async function getRendererDir(packageManager,renderer){let externalFramework=externalFrameworks.find(framework=>framework.name===renderer),frameworkPackageName=externalFramework?.renderer||externalFramework?.packageName||`@storybook/${renderer}`,packageJsonPath=join(frameworkPackageName,"package.json"),errors=[];try{return dirname(__require.resolve(packageJsonPath,{paths:[process.cwd()]}))}catch(e){invariant5(e instanceof Error),errors.push(e);}try{return await resolveUsingBranchInstall(packageManager,frameworkPackageName)}catch(e){invariant5(e instanceof Error),errors.push(e);}throw new Error(`Cannot find ${packageJsonPath}, ${errors.map(e=>e.stack).join(`

`)}`)}async function getBabelDependencies(packageManager,packageJson){let dependenciesToAdd=[],babelLoaderVersion="^8.0.0-0",babelCoreVersion=packageJson.dependencies["babel-core"]||packageJson.devDependencies["babel-core"];if(babelCoreVersion){let latestCompatibleBabelVersion=await packageManager.latestVersion("babel-core",babelCoreVersion);satisfies(latestCompatibleBabelVersion,"^6.0.0")&&(babelLoaderVersion="^7.0.0");}else if(!packageJson.dependencies["@babel/core"]&&!packageJson.devDependencies["@babel/core"]){let babelCoreInstallVersion=await packageManager.getVersion("@babel/core");dependenciesToAdd.push(`@babel/core@${babelCoreInstallVersion}`);}if(!packageJson.dependencies["babel-loader"]&&!packageJson.devDependencies["babel-loader"]){let babelLoaderInstallVersion=await packageManager.getVersion("babel-loader",babelLoaderVersion);dependenciesToAdd.push(`babel-loader@${babelLoaderInstallVersion}`);}return dependenciesToAdd}function copyTemplate(templateRoot,destination="."){let templateDir=path8.resolve(templateRoot,"template-csf/");if(!fs2__default.existsSync(templateDir))throw new Error("Couldn't find template dir");fse.copySync(templateDir,destination,{overwrite:!0});}var frameworkToRenderer=frameworkToRenderer$1,frameworkToDefaultBuilder={angular:"webpack5",ember:"webpack5","html-vite":"vite","html-webpack5":"webpack5",nextjs:"webpack5",nuxt:"vite","preact-vite":"vite","preact-webpack5":"webpack5",qwik:"vite","react-vite":"vite","react-webpack5":"webpack5","server-webpack5":"webpack5",solid:"vite","svelte-vite":"vite","svelte-webpack5":"webpack5",sveltekit:"vite","vue3-vite":"vite","vue3-webpack5":"webpack5","web-components-vite":"vite","web-components-webpack5":"webpack5"};async function copyTemplateFiles({packageManager,renderer,language,destination,includeCommonAssets=!0}){let languageFolderMapping={typescript:"ts",javascript:"js","typescript-3-8":"ts-3-8","typescript-4-9":"ts-4-9"},templatePath=async()=>{let baseDir=await getRendererDir(packageManager,renderer),assetsDir=join(baseDir,"template","cli"),assetsLanguage=join(assetsDir,languageFolderMapping[language]),assetsJS=join(assetsDir,languageFolderMapping.javascript),assetsTS=join(assetsDir,languageFolderMapping.typescript),assetsTS38=join(assetsDir,languageFolderMapping["typescript-3-8"]);if(await fse.pathExists(assetsLanguage))return assetsLanguage;if(language==="typescript-4-9"&&await fse.pathExists(assetsTS38))return assetsTS38;if(await fse.pathExists(assetsTS))return assetsTS;if(await fse.pathExists(assetsJS))return assetsJS;if(await fse.pathExists(assetsDir))return assetsDir;throw new Error(`Unsupported renderer: ${renderer} (${baseDir})`)},destinationPath=destination??await(async()=>await fse.pathExists("./src")?"./src/stories":"./stories")();if(includeCommonAssets&&await fse.copy(join(getCliDir(),"rendererAssets","common"),destinationPath,{overwrite:!0}),await fse.copy(await templatePath(),destinationPath,{overwrite:!0}),includeCommonAssets){let rendererType=frameworkToRenderer[renderer]||"react";await adjustTemplate(join(destinationPath,"Configure.mdx"),{renderer:rendererType});}}async function adjustTemplate(templatePath,templateData){let template=await fse.readFile(templatePath,"utf8");Object.keys(templateData).forEach(key=>{template=template.replaceAll(`{{${key}}}`,`${templateData[key]}`);}),await fse.writeFile(templatePath,template);}function getStorybookVersionSpecifier(packageJson){let allDeps={...packageJson.dependencies,...packageJson.devDependencies,...packageJson.optionalDependencies},storybookPackage=Object.keys(allDeps).find(name=>versions[name]);if(!storybookPackage)throw new Error("Couldn't find any official storybook packages in package.json");return allDeps[storybookPackage]}async function isNxProject(){return findUp2.sync("nx.json")}async function hasStorybookDependencies(packageManager){let currentPackageDeps=await packageManager.getAllDependencies();return Object.keys(currentPackageDeps).some(dep=>dep.includes("storybook"))}var viteConfigFiles=["vite.config.ts","vite.config.js","vite.config.mjs"],webpackConfigFiles=["webpack.config.js"],hasDependency=(packageJson,name,matcher)=>{let version=packageJson.dependencies?.[name]||packageJson.devDependencies?.[name];return version&&typeof matcher=="function"?matcher(version):!!version},hasPeerDependency=(packageJson,name,matcher)=>{let version=packageJson.peerDependencies?.[name];return version&&typeof matcher=="function"?matcher(version):!!version},getFrameworkPreset=(packageJson,framework)=>{let matcher={dependencies:[!1],peerDependencies:[!1],files:[!1]},{preset,files,dependencies,peerDependencies,matcherFunction}=framework,dependencySearches=[];Array.isArray(dependencies)?dependencySearches=dependencies.map(name=>[name,void 0]):typeof dependencies=="object"&&(dependencySearches=Object.entries(dependencies)),dependencySearches.length>0&&(matcher.dependencies=dependencySearches.map(([name,matchFn])=>hasDependency(packageJson,name,matchFn)));let peerDependencySearches=[];return Array.isArray(peerDependencies)?peerDependencySearches=peerDependencies.map(name=>[name,void 0]):typeof peerDependencies=="object"&&(peerDependencySearches=Object.entries(peerDependencies)),peerDependencySearches.length>0&&(matcher.peerDependencies=peerDependencySearches.map(([name,matchFn])=>hasPeerDependency(packageJson,name,matchFn))),Array.isArray(files)&&files.length>0&&(matcher.files=files.map(name=>fs2.existsSync(name))),matcherFunction(matcher)?preset:null};function detectFrameworkPreset(packageJson={}){let result=[...supportedTemplates,unsupportedTemplate].find(framework=>getFrameworkPreset(packageJson,framework)!==null);return result?result.preset:"UNDETECTED"}async function detectBuilder(packageManager,projectType){let viteConfig=findUp2.sync(viteConfigFiles),webpackConfig=findUp2.sync(webpackConfigFiles),dependencies=await packageManager.getAllDependencies();if(viteConfig||dependencies.vite&&dependencies.webpack===void 0)return commandLog("Detected Vite project. Setting builder to Vite")(),"vite";if(webpackConfig||(dependencies.webpack||dependencies["@nuxt/webpack-builder"])&&dependencies.vite!==void 0)return commandLog("Detected webpack project. Setting builder to webpack")(),"webpack5";switch(projectType){case"REACT_SCRIPTS":case"ANGULAR":case"REACT_NATIVE":case"NEXTJS":case"EMBER":return "webpack5";case"NUXT":return "vite";default:let{builder}=await prompts5({type:"select",name:"builder",message:`
We were not able to detect the right builder for your project. Please select one:`,choices:[{title:"Vite",value:"vite"},{title:"Webpack 5",value:"webpack5"}]},{onCancel:()=>{throw new HandledError("Canceled by the user")}});return builder}}function isStorybookInstantiated(configDir=resolve(process.cwd(),".storybook")){return fs2.existsSync(configDir)}async function detectPnp(){return !!findUp2.sync([".pnp.js",".pnp.cjs"])}async function detectLanguage(packageManager){let language="javascript";if(fs2.existsSync("jsconfig.json"))return language;let isTypescriptDirectDependency=await packageManager.getAllDependencies().then(deps=>!!deps.typescript),typescriptVersion=await packageManager.getPackageVersion("typescript"),prettierVersion=await packageManager.getPackageVersion("prettier"),babelPluginTransformTypescriptVersion=await packageManager.getPackageVersion("@babel/plugin-transform-typescript"),typescriptEslintParserVersion=await packageManager.getPackageVersion("@typescript-eslint/parser"),eslintPluginStorybookVersion=await packageManager.getPackageVersion("eslint-plugin-storybook");return isTypescriptDirectDependency&&typescriptVersion?semver.gte(typescriptVersion,"4.9.0")&&(!prettierVersion||semver.gte(prettierVersion,"2.8.0"))&&(!babelPluginTransformTypescriptVersion||semver.gte(babelPluginTransformTypescriptVersion,"7.20.0"))&&(!typescriptEslintParserVersion||semver.gte(typescriptEslintParserVersion,"5.44.0"))&&(!eslintPluginStorybookVersion||semver.gte(eslintPluginStorybookVersion,"0.6.8"))?language="typescript-4-9":semver.gte(typescriptVersion,"3.8.0")?language="typescript-3-8":semver.lt(typescriptVersion,"3.8.0")&&logger.warn("Detected TypeScript < 3.8, populating with JavaScript examples"):fs2.existsSync("tsconfig.json")&&(language="typescript-4-9"),language}async function detect(packageManager,options={}){let packageJson=await packageManager.retrievePackageJson();return packageJson?await isNxProject()?"NX":options.html?"HTML":detectFrameworkPreset(packageJson):"UNDETECTED"}var sanitizeFramework=framework=>{let matches=framework.match(/(@storybook\/\w+(?:-\w+)*)|(storybook-(\w+(?:-\w+)*))/g);if(matches)return matches[0]};async function configureMain({addons,extensions=["js","jsx","mjs","ts","tsx"],storybookConfigFolder,language,prefixes=[],...custom}){let srcPath=path8.resolve(storybookConfigFolder,"../src"),prefix=await fse.pathExists(srcPath)?"../src":"../stories",config={stories:[`${prefix}/**/*.mdx`,`${prefix}/**/*.stories.@(${extensions.join("|")})`],addons,...custom},isTypescript=language==="typescript-4-9"||language==="typescript-3-8",mainConfigTemplate=dedent`<<import>><<prefix>>const config<<type>> = <<mainContents>>;
    export default config;`,frameworkPackage=sanitizeFramework(custom.framework?.name);frameworkPackage||(mainConfigTemplate=mainConfigTemplate.replace("<<import>>","").replace("<<type>>",""),logger.warn("Could not find framework package name"));let mainContents=JSON.stringify(config,null,2).replace(/['"]%%/g,"").replace(/%%['"]/g,""),imports=[],finalPrefixes=[...prefixes];custom.framework?.name.includes("path.dirname(")&&imports.push("import path from 'path';"),isTypescript?imports.push(`import type { StorybookConfig } from '${frameworkPackage}';`):finalPrefixes.push(`/** @type { import('${frameworkPackage}').StorybookConfig } */`);let mainJsContents=mainConfigTemplate.replace("<<import>>",`${imports.join(`

`)}

`).replace("<<prefix>>",finalPrefixes.length>0?`${finalPrefixes.join(`

`)}
`:"").replace("<<type>>",isTypescript?": StorybookConfig":"").replace("<<mainContents>>",mainContents),mainPath=`./${storybookConfigFolder}/main.${isTypescript?"ts":"js"}`;try{let prettier=(await import('prettier')).default;mainJsContents=await prettier.format(dedent(mainJsContents),{...await prettier.resolveConfig(mainPath),filepath:mainPath});}catch{logger.verbose(`Failed to prettify ${mainPath}`);}await fse.writeFile(mainPath,mainJsContents,{encoding:"utf8"});}async function configurePreview(options){let{prefix:frameworkPrefix=""}=options.frameworkPreviewParts||{},isTypescript=options.language==="typescript-4-9"||options.language==="typescript-3-8",rendererPackage=options.rendererId&&!externalFrameworks.map(({name})=>name).includes(options.rendererId)?`@storybook/${options.rendererId}`:null,previewPath=`./${options.storybookConfigFolder}/preview.${isTypescript?"ts":"js"}`;if(await fse.pathExists(previewPath))return;let prefix=[isTypescript&&rendererPackage?`import type { Preview } from '${rendererPackage}'`:"",frameworkPrefix].filter(Boolean).join(`
`),preview=dedent`
    ${prefix}${prefix.length>0?`
`:""}
    ${!isTypescript&&rendererPackage?`/** @type { import('${rendererPackage}').Preview } */
`:""}const preview${isTypescript?": Preview":""} = {
      parameters: {
        controls: {
          matchers: {
           color: /(background|color)$/i,
           date: /Date$/i,
          },
        },
      },
    };
    
    export default preview;
    `.replace(`  
`,"").trim();try{let prettier=(await import('prettier')).default;preview=await prettier.format(preview,{...await prettier.resolveConfig(previewPath),filepath:previewPath});}catch{logger.verbose(`Failed to prettify ${previewPath}`);}await fse.writeFile(previewPath,preview,{encoding:"utf8"});}var SUPPORTED_ESLINT_EXTENSIONS=["js","cjs","json"],UNSUPPORTED_ESLINT_EXTENSIONS=["yaml","yml"],findEslintFile=()=>{let filePrefix=".eslintrc",unsupportedExtension=UNSUPPORTED_ESLINT_EXTENSIONS.find(ext=>fse.existsSync(`${filePrefix}.${ext}`));if(unsupportedExtension)throw new Error(unsupportedExtension);let extension=SUPPORTED_ESLINT_EXTENSIONS.find(ext=>fse.existsSync(`${filePrefix}.${ext}`));return extension?`${filePrefix}.${extension}`:null};async function extractEslintInfo(packageManager){let allDependencies=await packageManager.getAllDependencies(),packageJson=await packageManager.retrievePackageJson(),eslintConfigFile=null;try{eslintConfigFile=findEslintFile();}catch{}let isStorybookPluginInstalled=!!allDependencies["eslint-plugin-storybook"];return {hasEslint:allDependencies.eslint||eslintConfigFile||packageJson.eslintConfig,isStorybookPluginInstalled,eslintConfigFile}}var normalizeExtends=existingExtends=>{if(!existingExtends)return [];if(typeof existingExtends=="string")return [existingExtends];if(Array.isArray(existingExtends))return existingExtends;throw new Error(`Invalid eslint extends ${existingExtends}`)};async function configureEslintPlugin(eslintFile,packageManager){if(eslintFile)if(paddedLog(`Configuring Storybook ESLint plugin at ${eslintFile}`),eslintFile.endsWith("json")){let eslintConfig=await readJson(eslintFile),existingExtends=normalizeExtends(eslintConfig.extends).filter(Boolean);eslintConfig.extends=[...existingExtends,"plugin:storybook/recommended"];let eslintFileContents=await readFile$1(eslintFile,"utf8"),spaces=detectIndent(eslintFileContents).amount||2;await writeJson(eslintFile,eslintConfig,{spaces});}else {let eslint=await readConfig(eslintFile),existingExtends=normalizeExtends(eslint.getFieldValue(["extends"])).filter(Boolean);eslint.setFieldValue(["extends"],[...existingExtends,"plugin:storybook/recommended"]),await writeConfig(eslint);}else {paddedLog("Configuring eslint-plugin-storybook in your package.json");let packageJson=await packageManager.retrievePackageJson(),existingExtends=normalizeExtends(packageJson.eslintConfig?.extends).filter(Boolean);await packageManager.writePackageJson({...packageJson,eslintConfig:{...packageJson.eslintConfig,extends:[...existingExtends,"plugin:storybook/recommended"]}});}}var logger3=console,defaultOptions={extraPackages:[],extraAddons:[],staticDir:void 0,addScripts:!0,addMainFile:!0,addPreviewFile:!0,addComponents:!0,webpackCompiler:()=>{},extraMain:void 0,framework:void 0,extensions:void 0,componentsDestinationPath:void 0,storybookConfigFolder:".storybook",installFrameworkPackages:!0},getBuilderDetails=builder=>{let map=versions;if(map[builder])return builder;let builderPackage=`@storybook/${builder}`;return map[builderPackage]?builderPackage:builder},getExternalFramework=framework=>externalFrameworks.find(exFramework=>framework!==void 0&&(exFramework.name===framework||exFramework.packageName===framework||exFramework?.frameworks?.some?.(item=>item===framework))),getFrameworkPackage=(framework,renderer,builder)=>{let externalFramework=getExternalFramework(framework),storybookBuilder=builder?.replace(/^@storybook\/builder-/,""),storybookFramework=framework?.replace(/^@storybook\//,"");if(externalFramework===void 0){let frameworkPackage=framework?`@storybook/${storybookFramework}`:`@storybook/${renderer}-${storybookBuilder}`;if(versions[frameworkPackage])return frameworkPackage;throw new Error(dedent`
        Could not find framework package: ${frameworkPackage}.
        Make sure this package exists, and if it does, please file an issue as this might be a bug in Storybook.
      `)}return externalFramework.frameworks!==void 0?externalFramework.frameworks.find(item=>item.match(new RegExp(`-${storybookBuilder}`))):externalFramework.packageName},getRendererPackage=(framework,renderer)=>{let externalFramework=getExternalFramework(framework);return externalFramework!==void 0?externalFramework.renderer||externalFramework.packageName:`@storybook/${renderer}`},applyRequireWrapper=packageName=>`%%getAbsolutePath('${packageName}')%%`,getFrameworkDetails=(renderer,builder,pnp,language,framework,shouldApplyRequireWrapperOnPackageNames)=>{let frameworkPackage=getFrameworkPackage(framework,renderer,builder);invariant5(frameworkPackage,"Missing framework package.");let frameworkPackagePath=shouldApplyRequireWrapperOnPackageNames?applyRequireWrapper(frameworkPackage):frameworkPackage,rendererPackage=getRendererPackage(framework,renderer),rendererPackagePath=shouldApplyRequireWrapperOnPackageNames?applyRequireWrapper(rendererPackage):rendererPackage,builderPackage=getBuilderDetails(builder),builderPackagePath=shouldApplyRequireWrapperOnPackageNames?applyRequireWrapper(builderPackage):builderPackage,isKnownFramework=!!getExternalFramework(frameworkPackage)||!!versions[frameworkPackage],isKnownRenderer=!!versions[rendererPackage];if(isKnownFramework)return {packages:[rendererPackage,frameworkPackage],framework:frameworkPackagePath,rendererId:renderer,type:"framework"};if(isKnownRenderer)return {packages:[rendererPackage,builderPackage],builder:builderPackagePath,renderer:rendererPackagePath,rendererId:renderer,type:"renderer"};throw new Error(`Could not find the framework (${frameworkPackage}) or renderer (${rendererPackage}) package`)},stripVersions=addons=>addons.map(addon=>getPackageDetails(addon)[0]),hasInteractiveStories=rendererId=>["react","angular","preact","svelte","vue3","html","solid","qwik"].includes(rendererId),hasFrameworkTemplates=framework=>framework?["angular","nextjs"].includes(framework):!1;async function baseGenerator(packageManager,npmOptions,{language,builder,pnp,frameworkPreviewParts,projectType},renderer,options=defaultOptions,framework){let shouldApplyRequireWrapperOnPackageNames=packageManager.isStorybookInMonorepo()||pnp;builder||(builder=await detectBuilder(packageManager,projectType));let{packages:frameworkPackages8,type,rendererId,framework:frameworkInclude,builder:builderInclude}=getFrameworkDetails(renderer,builder,pnp,language,framework,shouldApplyRequireWrapperOnPackageNames),{extraAddons:extraAddonPackages=[],extraPackages,staticDir,addScripts,addMainFile,addPreviewFile,addComponents,extraMain,extensions,storybookConfigFolder,componentsDestinationPath,webpackCompiler,installFrameworkPackages}={...defaultOptions,...options},compiler=webpackCompiler?webpackCompiler({builder}):void 0,extraAddonsToInstall=typeof extraAddonPackages=="function"?await extraAddonPackages({builder:builder||builderInclude,framework:framework||frameworkInclude}):extraAddonPackages;extraAddonsToInstall.push("@storybook/addon-links","@storybook/addon-essentials","@chromatic-com/storybook@^1");let addons=[...compiler?[`@storybook/addon-webpack5-compiler-${compiler}`]:[],...stripVersions(extraAddonsToInstall)].filter(Boolean),addonPackages=["@storybook/blocks",...compiler?[`@storybook/addon-webpack5-compiler-${compiler}`]:[],...extraAddonsToInstall].filter(Boolean);["solid","qwik"].includes(rendererId)?addonPackages.push("@storybook/testing-library"):addonPackages.push("@storybook/test"),hasInteractiveStories(rendererId)&&(addons.push("@storybook/addon-interactions"),addonPackages.push("@storybook/addon-interactions"));let packageJson=await packageManager.retrievePackageJson(),installedDependencies=new Set(Object.keys({...packageJson.dependencies,...packageJson.devDependencies}));if(type==="renderer")throw new Error(dedent`
        Sorry, for now, you can not do this, please use a framework such as @storybook/react-webpack5

        https://github.com/storybookjs/storybook/issues/18360
      `);let extraPackagesToInstall=typeof extraPackages=="function"?await extraPackages({builder:builder||builderInclude,framework:framework||frameworkInclude}):extraPackages,allPackages=["storybook",getExternalFramework(rendererId)?void 0:`@storybook/${rendererId}`,...installFrameworkPackages?frameworkPackages8:[],...addonPackages,...extraPackagesToInstall||[]].filter(Boolean),packages=[...new Set(allPackages)].filter(packageToInstall=>!installedDependencies.has(getPackageDetails(packageToInstall)[0]));logger3.log();let versionedPackagesSpinner=ora({indent:2,text:`Getting the correct version of ${packages.length} packages`}).start(),versionedPackages=await packageManager.getVersionedPackages(packages);versionedPackagesSpinner.succeed();try{if(process.env.CI!=="true"){let{hasEslint,isStorybookPluginInstalled,eslintConfigFile}=await extractEslintInfo(packageManager);hasEslint&&!isStorybookPluginInstalled&&(versionedPackages.push("eslint-plugin-storybook"),await configureEslintPlugin(eslintConfigFile??void 0,packageManager));}}catch{}if(versionedPackages.length>0){let addDependenciesSpinner=ora({indent:2,text:"Installing Storybook dependencies"}).start();await packageManager.addDependencies({...npmOptions,packageJson},versionedPackages),addDependenciesSpinner.succeed();}if((addMainFile||addPreviewFile)&&await fse.ensureDir(`./${storybookConfigFolder}`),addMainFile){let prefixes=shouldApplyRequireWrapperOnPackageNames?['import { join, dirname } from "path"',language==="javascript"?dedent`/**
            * This function is used to resolve the absolute path of a package.
            * It is needed in projects that use Yarn PnP or are set up within a monorepo.
            */ 
            function getAbsolutePath(value) {
              return dirname(require.resolve(join(value, 'package.json')))
            }`:dedent`/**
          * This function is used to resolve the absolute path of a package.
          * It is needed in projects that use Yarn PnP or are set up within a monorepo.
          */ 
          function getAbsolutePath(value: string): any {
            return dirname(require.resolve(join(value, 'package.json')))
          }`]:[];await configureMain({framework:{name:frameworkInclude,options:options.framework||{}},prefixes,storybookConfigFolder,addons:shouldApplyRequireWrapperOnPackageNames?addons.map(addon=>applyRequireWrapper(addon)):addons,extensions,language,...staticDir?{staticDirs:[path8.join("..",staticDir)]}:null,...extraMain,...type!=="framework"?{core:{builder:builderInclude}}:{}});}if(addPreviewFile&&await configurePreview({frameworkPreviewParts,storybookConfigFolder,language,rendererId}),addScripts&&await packageManager.addStorybookCommandInScripts({port:6006}),addComponents){let templateLocation=hasFrameworkTemplates(framework)?framework:rendererId;if(!templateLocation)throw new Error(`Could not find template location for ${framework} or ${rendererId}`);await copyTemplateFiles({renderer:templateLocation,packageManager,language,destination:componentsDestinationPath});}}var ANGULAR_JSON_PATH="angular.json",compoDocPreviewPrefix=dedent`
  import { setCompodocJson } from "@storybook/addon-docs/angular";
  import docJson from "../documentation.json";
  setCompodocJson(docJson);
`.trimStart(),promptForCompoDocs=async()=>{logger.plain(boxen(dedent`
      Compodoc is a great tool to generate documentation for your Angular projects.
      Storybook can use the documentation generated by Compodoc to extract argument definitions
      and JSDOC comments to display them in the Storybook UI. We highly recommend using Compodoc for
      your Angular projects to get the best experience out of Storybook.
    `,{title:"Compodoc",borderStyle:"round",padding:1,borderColor:"#F1618C"}));let{useCompoDoc}=await prompts5({type:"confirm",name:"useCompoDoc",message:"Do you want to use Compodoc for documentation?"});return useCompoDoc},AngularJSON=class{constructor(){if(!fs2__default.existsSync(ANGULAR_JSON_PATH))throw new MissingAngularJsonError({path:join(process.cwd(),ANGULAR_JSON_PATH)});let jsonContent=fs2__default.readFileSync(ANGULAR_JSON_PATH,"utf8");this.json=JSON.parse(jsonContent);}get projects(){return this.json.projects}get projectsWithoutStorybook(){return Object.keys(this.projects).filter(projectName=>{let{architect}=this.projects[projectName];return !architect.storybook})}get hasStorybookBuilder(){return Object.keys(this.projects).some(projectName=>{let{architect}=this.projects[projectName];return Object.keys(architect).some(key=>architect[key].builder==="@storybook/angular:start-storybook")})}get rootProject(){let rootProjectName=Object.keys(this.projects).find(projectName=>{let{root}=this.projects[projectName];return root===""||root==="."});return rootProjectName?this.projects[rootProjectName]:null}getProjectSettingsByName(projectName){return this.projects[projectName]}async getProjectName(){if(this.projectsWithoutStorybook.length>1){let{projectName}=await prompts5({type:"select",name:"projectName",message:"For which project do you want to generate Storybook configuration?",choices:this.projectsWithoutStorybook.map(name=>({title:name,value:name}))});return projectName}return this.projectsWithoutStorybook[0]}addStorybookEntries({angularProjectName,storybookFolder,useCompodoc,root}){let{architect}=this.projects[angularProjectName],baseOptions={configDir:storybookFolder,browserTarget:`${angularProjectName}:build`,compodoc:useCompodoc,...useCompodoc&&{compodocArgs:["-e","json","-d",root||"."]}};architect.storybook||(architect.storybook={builder:"@storybook/angular:start-storybook",options:{...baseOptions,port:6006}}),architect["build-storybook"]||(architect["build-storybook"]={builder:"@storybook/angular:build-storybook",options:{...baseOptions,outputDir:Object.keys(this.projects).length===1?"storybook-static":`dist/storybook/${angularProjectName}`}});}write(){fs2__default.writeFileSync(ANGULAR_JSON_PATH,JSON.stringify(this.json,null,2));}};var generator=async(packageManager,npmOptions,options,commandOptions)=>{let angularJSON=new AngularJSON;if(!angularJSON.projects||angularJSON.projects&&Object.keys(angularJSON.projects).length===0)throw new Error("Storybook was not able to find any projects in your angular.json file. Are you sure this is an Angular CLI project?");if(angularJSON.projectsWithoutStorybook.length===0)throw new Error("Every project in your workspace is already set up with Storybook. There is nothing to do!");let angularProjectName=await angularJSON.getProjectName();commandLog(`Adding Storybook support to your "${angularProjectName}" project`);let angularProject=angularJSON.getProjectSettingsByName(angularProjectName);if(!angularProject)throw new Error(`Somehow we were not able to retrieve the "${angularProjectName}" project in your angular.json file. This is likely a bug in Storybook, please file an issue.`);let{root,projectType}=angularProject,{projects}=angularJSON,useCompodoc=commandOptions?.yes?!0:await promptForCompoDocs(),storybookFolder=root?`${root}/.storybook`:".storybook";angularJSON.addStorybookEntries({angularProjectName,storybookFolder,useCompodoc,root}),angularJSON.write(),await baseGenerator(packageManager,npmOptions,{...options,builder:"webpack5",...useCompodoc&&{frameworkPreviewParts:{prefix:compoDocPreviewPrefix}}},"angular",{extraAddons:["@storybook/addon-onboarding"],...useCompodoc&&{extraPackages:["@compodoc/compodoc","@storybook/addon-docs"]},addScripts:!1,componentsDestinationPath:root?`${root}/src/stories`:void 0,storybookConfigFolder:storybookFolder,webpackCompiler:()=>{}},"angular"),Object.keys(projects).length===1&&packageManager.addScripts({storybook:`ng run ${angularProjectName}:storybook`,"build-storybook":`ng run ${angularProjectName}:build-storybook`});let projectTypeValue=projectType||"application";projectTypeValue!=="application"&&projectTypeValue!=="library"&&(projectTypeValue="application");let templateDir=join(getCliDir(),"templates","angular",projectTypeValue);return templateDir&&copyTemplate(templateDir,root||void 0),{projectName:angularProjectName,configDir:storybookFolder}},ANGULAR_default=generator;var generator2=async(packageManager,npmOptions,options)=>{await baseGenerator(packageManager,npmOptions,{...options,builder:"webpack5"},"ember",{staticDir:"dist"},"ember");},EMBER_default=generator2;var generator3=async(packageManager,npmOptions,options)=>{let extraPackages=await detectLanguage(packageManager)==="javascript"?["prop-types"]:[];await baseGenerator(packageManager,npmOptions,options,"react",{extraPackages,webpackCompiler:({builder})=>builder==="webpack5"?"swc":void 0,extraAddons:["@storybook/addon-onboarding"]});},REACT_default=generator3;var generator4=async(packageManager,npmOptions)=>{let packageJson=await packageManager.retrievePackageJson(),missingReactDom=!packageJson.dependencies["react-dom"]&&!packageJson.devDependencies["react-dom"],reactVersion=packageJson.dependencies.react,packagesToResolve=[...["react-native-safe-area-context","@react-native-async-storage/async-storage","@react-native-community/datetimepicker","@react-native-community/slider"].filter(dep=>!packageJson.dependencies[dep]&&!packageJson.devDependencies[dep]),"@storybook/addon-ondevice-controls","@storybook/addon-ondevice-actions","@storybook/react-native"],packagesWithFixedVersion=[],versionedPackages=await packageManager.getVersionedPackages(packagesToResolve),babelDependencies=await getBabelDependencies(packageManager,packageJson),packages=[];packages.push(...babelDependencies),packages.push(...packagesWithFixedVersion),packages.push(...versionedPackages),missingReactDom&&reactVersion&&packages.push(`react-dom@${reactVersion}`),await packageManager.addDependencies({...npmOptions,packageJson},packages),packageManager.addScripts({"storybook-generate":"sb-rn-get-stories"}),await copyTemplateFiles({packageManager,renderer:"react-native",language:"typescript-3-8",destination:".storybook",includeCommonAssets:!1});},REACT_NATIVE_default=generator4;var generator5=async(packageManager,npmOptions,options)=>{let monorepoRootPath=path8.join(__dirname,"..","..","..","..","..",".."),extraMain=options.linkable?{webpackFinal:`%%(config) => {
      // add monorepo root as a valid directory to import modules from
      config.resolve.plugins.forEach((p) => {
        if (Array.isArray(p.appSrcs)) {
          p.appSrcs.push('${monorepoRootPath}');
              }
            });
          return config;
          }
    %%`}:{},craVersion=await packageManager.getPackageVersion("react-scripts");if(craVersion===null)throw new Error(dedent`
      It looks like you're trying to initialize Storybook in a CRA project that does not have react-scripts installed.
      Please install it and make sure it's of version 5 or higher, which are the versions supported by Storybook 7.0+.
    `);if(!craVersion&&semver.gte(craVersion,"5.0.0"))throw new Error(dedent`
      Storybook 7.0+ doesn't support react-scripts@<5.0.0.

      https://github.com/storybookjs/storybook/blob/next/MIGRATION.md#create-react-app-dropped-cra4-support
    `);let extraPackages=[];extraPackages.push("webpack"),extraPackages.push("prop-types");let extraAddons=["@storybook/preset-create-react-app","@storybook/addon-onboarding"];await baseGenerator(packageManager,npmOptions,{...options,builder:"webpack5"},"react",{webpackCompiler:()=>{},extraAddons,extraPackages,staticDir:fs2__default.existsSync(path8.resolve("./public"))?"public":void 0,extraMain});},REACT_SCRIPTS_default=generator5;var generator6=async(packageManager,npmOptions,options)=>{let staticDir;existsSync$1(join(process.cwd(),"public"))&&(staticDir="public"),await baseGenerator(packageManager,npmOptions,{...options,builder:"webpack5"},"react",{staticDir,extraAddons:["@storybook/addon-onboarding"],webpackCompiler:({builder})=>{}},"nextjs");},NEXTJS_default=generator6;var generator7=async(packageManager,npmOptions,options)=>{await baseGenerator(packageManager,npmOptions,options,"vue3",{extraAddons:["@storybook/addon-onboarding"],extraPackages:async({builder})=>builder==="webpack5"?["vue-loader@^17.0.0","@vue/compiler-sfc@^3.2.0"]:[],webpackCompiler:({builder})=>builder==="webpack5"?"swc":void 0});},VUE3_default=generator7;var generator8=async(packageManager,npmOptions,options)=>{await baseGenerator(packageManager,npmOptions,options,"nuxt",{extraPackages:async({builder})=>["@nuxtjs/storybook"],installFrameworkPackages:!1,componentsDestinationPath:"./components",extraMain:{stories:["../components/**/*.mdx","../components/**/*.stories.@(js|jsx|ts|tsx|mdx)"]}},"nuxt"),await packageManager.runPackageCommand("nuxi",["module","add","@nuxtjs/storybook","--skipInstall"]);},NUXT_default=generator8;var generator9=async(packageManager,npmOptions,options)=>{await baseGenerator(packageManager,npmOptions,options,"react",{extraAddons:["@storybook/addon-onboarding"],webpackCompiler:({builder})=>builder==="webpack5"?"swc":void 0});},WEBPACK_REACT_default=generator9;var generator10=async(packageManager,npmOptions,options)=>{await baseGenerator(packageManager,npmOptions,options,"html",{webpackCompiler:({builder})=>builder==="webpack5"?"swc":void 0});},HTML_default=generator10;var generator11=async(packageManager,npmOptions,options)=>baseGenerator(packageManager,npmOptions,options,"web-components",{extraPackages:["lit"],webpackCompiler:({builder})=>builder==="webpack5"?"swc":void 0}),WEB_COMPONENTS_default=generator11;var generator12=async(packageManager,npmOptions,options)=>{await baseGenerator(packageManager,npmOptions,options,"preact",{webpackCompiler:({builder})=>builder==="webpack5"?"swc":void 0});},PREACT_default=generator12;var generator13=async(packageManager,npmOptions,options)=>{await baseGenerator(packageManager,npmOptions,options,"svelte",{extensions:["js","ts","svelte"],extraAddons:["@storybook/addon-svelte-csf"]});},SVELTE_default=generator13;var generator14=async(packageManager,npmOptions,options)=>{await baseGenerator(packageManager,npmOptions,options,"qwik",{},"qwik");},QWIK_default=generator14;var generator15=async(packageManager,npmOptions,options)=>{await baseGenerator(packageManager,npmOptions,{...options,builder:"vite"},"svelte",{extensions:["js","ts","svelte"],extraAddons:["@storybook/addon-svelte-csf"]},"sveltekit");},SVELTEKIT_default=generator15;var generator16=async(packageManager,npmOptions,options)=>{await baseGenerator(packageManager,npmOptions,{...options,builder:"vite"},"solid",{},"solid");},SOLID_default=generator16;var generator17=async(packageManager,npmOptions,options)=>{await baseGenerator(packageManager,npmOptions,{...options,builder:"webpack5"},"server",{webpackCompiler:()=>"swc",extensions:["json","yaml","yml"]});},SERVER_default=generator17;var SUPPORTED_PROJECTS={"react-vite-ts":{displayName:{type:"React",builder:"Vite",language:"TS"},createScript:{npm:"npm create vite@latest . -- --template react-ts",yarn:"yarn create vite@latest . --template react-ts",pnpm:"pnpm create vite@latest . --template react-ts"}},"nextjs-ts":{displayName:{type:"Next.js",language:"TS"},createScript:{npm:'npm create next-app . -- --typescript --use-npm --eslint --tailwind --no-app --import-alias="@/*" --src-dir',yarn:'yarn create next-app . --typescript --use-yarn --eslint --tailwind --no-app --import-alias="@/*" --src-dir',pnpm:'pnpm create next-app . --typescript --use-pnpm --eslint --tailwind --no-app --import-alias="@/*" --src-dir'}},"vue-vite-ts":{displayName:{type:"Vue 3",builder:"Vite",language:"TS"},createScript:{npm:"npm create vite@latest . -- --template vue-ts",yarn:"yarn create vite@latest . --template vue-ts",pnpm:"pnpm create vite@latest . --template vue-ts"}},"angular-cli":{displayName:{type:"Angular",language:"TS"},createScript:{npm:"npx -p @angular/cli@latest ng new angular-latest --directory . --routing=true --minimal=true --style=scss --strict --skip-git --skip-install",yarn:"yarn dlx -p @angular/cli ng new angular-latest --directory . --routing=true --minimal=true --style=scss --strict --skip-git --package-manager=yarn --skip-install && touch yarn.lock && yarn set version berry && yarn config set nodeLinker node-modules",pnpm:"pnpm --package @angular/cli dlx ng new angular-latest --directory . --routing=true --minimal=true --style=scss --strict --skip-git --package-manager=pnpm --skip-install"}},"lit-vite-ts":{displayName:{type:"Lit",builder:"Vite",language:"TS"},createScript:{npm:"npm create vite@latest . -- --template lit-ts",yarn:"yarn create vite@latest . --template lit-ts && touch yarn.lock && yarn set version berry && yarn config set nodeLinker pnp",pnpm:"pnpm create vite@latest . --template lit-ts"}}},packageManagerToCoercedName=packageManager=>{switch(packageManager){case"npm":return "npm";case"pnpm":return "pnpm";default:return "yarn"}},buildProjectDisplayNameForPrint=({displayName})=>{let{type,builder,language}=displayName;return `${chalk15.bold.blue(type)} ${builder?`+ ${builder} `:""}(${language})`},scaffoldNewProject=async(packageManager,{disableTelemetry})=>{let packageManagerName=packageManagerToCoercedName(packageManager);logger.plain(boxen(dedent`
        Would you like to generate a new project from the following list?

        ${chalk15.bold("Note:")}
        Storybook supports many more frameworks and bundlers than listed below. If you don't see your
        preferred setup, you can still generate a project then rerun this command to add Storybook.

        ${chalk15.bold("Press ^C at any time to quit.")}
      `,{title:chalk15.bold("\u{1F50E} Empty directory detected"),padding:1,borderStyle:"double",borderColor:"yellow"})),logger.line(1);let projectStrategy;if(process.env.STORYBOOK_INIT_EMPTY_TYPE&&(projectStrategy=process.env.STORYBOOK_INIT_EMPTY_TYPE),!projectStrategy){let{project}=await prompts5({type:"select",name:"project",message:"Choose a project template",choices:Object.entries(SUPPORTED_PROJECTS).map(([key,value])=>({title:buildProjectDisplayNameForPrint(value),value:key}))},{onCancel:()=>process.exit(0)});projectStrategy=project;}let projectStrategyConfig=SUPPORTED_PROJECTS[projectStrategy],projectDisplayName=buildProjectDisplayNameForPrint(projectStrategyConfig),createScript=projectStrategyConfig.createScript[packageManagerName];logger.line(1),logger.plain(`Creating a new "${projectDisplayName}" project with ${chalk15.bold(packageManagerName)}...`),logger.line(1);let targetDir=process.cwd();try{await remove(`${targetDir}/.cache`),await execa.command(createScript,{stdio:"pipe",shell:!0,cwd:targetDir,cleanup:!0});}catch(e){throw new GenerateNewProjectOnInitError({error:e,packageManager:packageManagerName,projectType:projectStrategy})}disableTelemetry||telemetry$1("scaffolded-empty",{packageManager:packageManagerName,projectType:projectStrategy}),logger.plain(boxen(dedent`
      "${projectDisplayName}" project with ${chalk15.bold(packageManagerName)} created successfully!

      Continuing with Storybook installation...
    `,{title:chalk15.bold("\u2705 Success!"),padding:1,borderStyle:"double",borderColor:"green"})),logger.line(1);},BASE_IGNORED_FILES=[".git",".gitignore",".DS_Store",".cache"],IGNORED_FILES_BY_PACKAGE_MANAGER={npm:[...BASE_IGNORED_FILES],yarn:[...BASE_IGNORED_FILES,".yarnrc.yml",".yarn"],pnpm:[...BASE_IGNORED_FILES]},currentDirectoryIsEmpty=packageManager=>{let packageManagerName=packageManagerToCoercedName(packageManager),cwdFolderEntries=readdirSync(process.cwd()),filesToIgnore=IGNORED_FILES_BY_PACKAGE_MANAGER[packageManagerName];return cwdFolderEntries.length===0||cwdFolderEntries.every(entry=>filesToIgnore.includes(entry))};var logger6=console,installStorybook=async(projectType,packageManager,options)=>{let npmOptions={installAsDevDependencies:!0,skipInstall:options.skipInstall},language=await detectLanguage(packageManager),pnp=await detectPnp(),generatorOptions={language,builder:options.builder,linkable:!!options.linkable,pnp:pnp||options.usePnp,yes:options.yes,projectType},runGenerator=async()=>{switch(projectType){case"REACT_SCRIPTS":return REACT_SCRIPTS_default(packageManager,npmOptions,generatorOptions).then(commandLog('Adding Storybook support to your "Create React App" based project'));case"REACT":return REACT_default(packageManager,npmOptions,generatorOptions).then(commandLog('Adding Storybook support to your "React" app'));case"REACT_NATIVE":return REACT_NATIVE_default(packageManager,npmOptions).then(commandLog('Adding Storybook support to your "React Native" app'));case"QWIK":return QWIK_default(packageManager,npmOptions,generatorOptions).then(commandLog('Adding Storybook support to your "Qwik" app'));case"WEBPACK_REACT":return WEBPACK_REACT_default(packageManager,npmOptions,generatorOptions).then(commandLog('Adding Storybook support to your "Webpack React" app'));case"REACT_PROJECT":return REACT_default(packageManager,npmOptions,generatorOptions).then(commandLog('Adding Storybook support to your "React" library'));case"NEXTJS":return NEXTJS_default(packageManager,npmOptions,generatorOptions).then(commandLog('Adding Storybook support to your "Next" app'));case"VUE3":return VUE3_default(packageManager,npmOptions,generatorOptions).then(commandLog('Adding Storybook support to your "Vue 3" app'));case"NUXT":return NUXT_default(packageManager,npmOptions,generatorOptions).then(commandLog('Adding Storybook support to your "Nuxt" app'));case"ANGULAR":return commandLog('Adding Storybook support to your "Angular" app'),ANGULAR_default(packageManager,npmOptions,generatorOptions,options);case"EMBER":return EMBER_default(packageManager,npmOptions,generatorOptions).then(commandLog('Adding Storybook support to your "Ember" app'));case"HTML":return HTML_default(packageManager,npmOptions,generatorOptions).then(commandLog('Adding Storybook support to your "HTML" app'));case"WEB_COMPONENTS":return WEB_COMPONENTS_default(packageManager,npmOptions,generatorOptions).then(commandLog('Adding Storybook support to your "web components" app'));case"PREACT":return PREACT_default(packageManager,npmOptions,generatorOptions).then(commandLog('Adding Storybook support to your "Preact" app'));case"SVELTE":return SVELTE_default(packageManager,npmOptions,generatorOptions).then(commandLog('Adding Storybook support to your "Svelte" app'));case"SVELTEKIT":return SVELTEKIT_default(packageManager,npmOptions,generatorOptions).then(commandLog('Adding Storybook support to your "SvelteKit" app'));case"SERVER":return SERVER_default(packageManager,npmOptions,generatorOptions).then(commandLog('Adding Storybook support to your "Server" app'));case"NX":throw new NxProjectDetectedError;case"SOLID":return SOLID_default(packageManager,npmOptions,generatorOptions).then(commandLog('Adding Storybook support to your "SolidJS" app'));case"UNSUPPORTED":return paddedLog("We detected a project type that we don't support yet."),paddedLog("If you'd like your framework to be supported, please let use know about it at https://github.com/storybookjs/storybook/issues"),logger6.log(),Promise.resolve();default:return paddedLog(`We couldn't detect your project type. (code: ${projectType})`),paddedLog("You can specify a project type explicitly via `storybook init --type <type>`, see our docs on how to configure Storybook for your framework: https://storybook.js.org/docs/react/get-started/install"),logger6.log(),projectTypeInquirer(options,packageManager)}};try{return await runGenerator()}catch(err){throw err?.message!=="Canceled by the user"&&err?.stack&&logger6.error(`
     ${chalk15.red(err.stack)}`),new HandledError(err)}},projectTypeInquirer=async(options,packageManager)=>{let manualAnswer=options.yes?!0:await prompts5([{type:"confirm",name:"manual",message:"Do you want to manually choose a Storybook project type to install?"}]);if(manualAnswer!==!0&&manualAnswer.manual){let{manualFramework}=await prompts5([{type:"select",name:"manualFramework",message:"Please choose a project type from the following list:",choices:installableProjectTypes.map(type=>({title:type,value:type.toUpperCase()}))}]);if(manualFramework)return installStorybook(manualFramework,packageManager,options)}logger6.log(),logger6.log("For more information about installing Storybook: https://storybook.js.org/docs"),process.exit(0);};async function doInitiate(options){let{packageManager:pkgMgr}=options,packageManager=JsPackageManagerFactory.getPackageManager({force:pkgMgr}),latestVersion=await packageManager.latestVersion("storybook"),currentVersion=versions.storybook,isPrerelease=prerelease(currentVersion),isOutdated=lt(currentVersion,latestVersion),borderColor=isOutdated?"#FC521F":"#F1618C",messages={welcome:`Adding Storybook version ${chalk15.bold(currentVersion)} to your project..`,notLatest:chalk15.red(dedent`
      This version is behind the latest release, which is: ${chalk15.bold(latestVersion)}!
      You likely ran the init command through npx, which can use a locally cached version, to get the latest please run:
      ${chalk15.bold("npx storybook@latest init")}
      
      You may want to CTRL+C to stop, and run with the latest version instead.
    `),prelease:chalk15.yellow("This is a pre-release version.")};logger6.log(boxen([messages.welcome].concat(isOutdated&&!isPrerelease?[messages.notLatest]:[]).concat(isPrerelease?[messages.prelease]:[]).join(`
`),{borderStyle:"round",padding:1,borderColor})),options.force!==!0&&currentDirectoryIsEmpty(packageManager.type)&&(packageManager.type==="yarn1"&&(packageManager=JsPackageManagerFactory.getPackageManager({force:"npm"})),await scaffoldNewProject(packageManager.type,options));let projectType,projectTypeProvided=options.type,infoText=projectTypeProvided?`Installing Storybook for user specified project type: ${projectTypeProvided}`:"Detecting project type",done=commandLog(infoText);if(projectTypeProvided)if(installableProjectTypes.includes(projectTypeProvided))projectType=projectTypeProvided.toUpperCase();else throw done(`The provided project type was not recognized by Storybook: ${projectTypeProvided}`),logger6.log(`
The project types currently supported by Storybook are:
`),installableProjectTypes.sort().forEach(framework=>paddedLog(`- ${framework}`)),logger6.log(),new HandledError(`Unknown project type supplied: ${projectTypeProvided}`);else try{projectType=await detect(packageManager,options);}catch(err){throw done(String(err)),new HandledError(err)}done();let storybookInstantiated=isStorybookInstantiated();if(options.force===!1&&storybookInstantiated&&projectType!=="ANGULAR"){logger6.log();let{force}=await prompts5([{type:"confirm",name:"force",message:"We found a .storybook config directory in your project. Therefore we assume that Storybook is already instantiated for your project. Do you still want to continue and force the initialization?"}]);logger6.log(),force?options.force=!0:process.exit(0);}options.skipInstall||await packageManager.installDependencies();let installResult=await installStorybook(projectType,packageManager,options);if(options.skipInstall||await packageManager.installDependencies(),options.disableTelemetry||await telemetry$1("init",{projectType}),projectType==="REACT_NATIVE")return logger6.log(dedent`
      ${chalk15.yellow("NOTE: installation is not 100% automated.")}

      To run Storybook, you will need to:

      1. Replace the contents of your app entry with the following
      
      ${chalk15.inverse(" export {default} from './.storybook'; ")}
      
      2. Enable transformer.unstable_allowRequireContext in your metro config
      
      For a more detailed guide go to:
      ${chalk15.cyan("https://github.com/storybookjs/react-native#existing-project")}
      
      Then to run your Storybook, type:

      ${chalk15.inverse(" "+packageManager.getRunCommand("start")+" ")}

    `),{shouldRunDev:!1};let foundGitIgnoreFile=await findUp2(".gitignore"),rootDirectory=getProjectRoot();foundGitIgnoreFile&&foundGitIgnoreFile.includes(rootDirectory)&&((await readFile(foundGitIgnoreFile,"utf-8")).includes("*storybook.log")||await appendFile(foundGitIgnoreFile,`
*storybook.log`));let storybookCommand=projectType==="ANGULAR"?`ng run ${installResult.projectName}:storybook`:packageManager.getRunStorybookCommand();return logger6.log(boxen(dedent`
          Storybook was successfully installed in your project! 🎉
          To run Storybook manually, run ${chalk15.yellow(chalk15.bold(storybookCommand))}. CTRL+C to stop.
          
          Wanna know more about Storybook? Check out ${chalk15.cyan("https://storybook.js.org/")}
          Having trouble or want to chat? Join us at ${chalk15.cyan("https://discord.gg/storybook/")}
        `,{borderStyle:"round",padding:1,borderColor:"#F1618C"})),{shouldRunDev:!!options.dev&&!options.skipInstall,projectType,packageManager,storybookCommand}}async function initiate(options){let initiateResult=await withTelemetry("init",{cliOptions:options,printError:err=>!err.handled&&logger6.error(err)},()=>doInitiate(options));if(initiateResult?.shouldRunDev){let{projectType,packageManager,storybookCommand}=initiateResult;logger6.log(`
Running Storybook`);try{let isReactWebProject=projectType==="REACT_SCRIPTS"||projectType==="REACT"||projectType==="WEBPACK_REACT"||projectType==="REACT_PROJECT"||projectType==="NEXTJS",flags=[];packageManager.type==="npm"&&projectType!=="ANGULAR"&&flags.push("--"),isReactWebProject&&flags.push("--initial-path=/onboarding"),flags.push("--quiet"),packageManager.runPackageCommandSync(storybookCommand.replace(/^yarn /,""),flags,void 0,"inherit");}catch{}}}var postinstallAddon=async(addonName,options)=>{try{let modulePath=__require.resolve(`${addonName}/postinstall`,{paths:[process.cwd()]}),postinstall=__require(modulePath);try{console.log(`Running postinstall script for ${addonName}`),await postinstall(options);}catch(e){console.error(`Error running postinstall script for ${addonName}`),console.error(e);}}catch{}};var getVersionSpecifier=addon=>{let groups=/^(@{0,1}[^@]+)(?:@(.+))?$/.exec(addon);return groups?[groups[1],groups[2]]:[addon,void 0]},requireMain=configDir=>{let absoluteConfigDir=isAbsolute(configDir)?configDir:join(process.cwd(),configDir),mainFile=join(absoluteConfigDir,"main");return serverRequire(mainFile)??{}},checkInstalled=(addonName,main)=>!!main.addons?.find(entry=>(typeof entry=="string"?entry:entry.name)?.endsWith(addonName)),isCoreAddon=addonName=>Object.hasOwn(versions,addonName);async function add(addon,{packageManager:pkgMgr,skipPostinstall,configDir:userSpecifiedConfigDir},logger31=console){let[addonName,inputVersion]=getVersionSpecifier(addon),packageManager=JsPackageManagerFactory.getPackageManager({force:pkgMgr}),packageJson=await packageManager.retrievePackageJson(),{mainConfig,configDir:inferredConfigDir}=getStorybookInfo(packageJson,userSpecifiedConfigDir),configDir=userSpecifiedConfigDir||inferredConfigDir||".storybook";if(typeof configDir>"u")throw new Error(dedent`
      Unable to find storybook config directory
    `);if(!mainConfig){logger31.error("Unable to find storybook main.js config");return}if(checkInstalled(addonName,requireMain(configDir)))throw new Error(dedent`
      Addon ${addonName} is already installed; we skipped adding it to your ${mainConfig}.
    `);let main=await readConfig(mainConfig);logger31.log(`Verifying ${addonName}`);let storybookVersion=await getCoercedStorybookVersion(packageManager),version=inputVersion;!version&&isCoreAddon(addonName)&&storybookVersion&&(version=storybookVersion),version||(version=await packageManager.latestVersion(addonName)),isCoreAddon(addonName)&&version!==storybookVersion&&logger31.warn(`The version of ${addonName} you are installing is not the same as the version of Storybook you are using. This may lead to unexpected behavior.`);let addonWithVersion=isValidVersion(version)?`${addonName}@^${version}`:`${addonName}@${version}`;logger31.log(`Installing ${addonWithVersion}`),await packageManager.addDependencies({installAsDevDependencies:!0},[addonWithVersion]),logger31.log(`Adding '${addon}' to main.js addons field.`),main.appendValueToArray(["addons"],addonName),await writeConfig(main),!skipPostinstall&&isCoreAddon(addonName)&&await postinstallAddon(addonName,{packageManager:packageManager.type});}function isValidVersion(version){return semver.valid(version)||version.match(/^\d+$/)}var logger7=console,getFrameworkPackageName=mainConfig=>{let packageNameOrPath=typeof mainConfig?.framework=="string"?mainConfig.framework:mainConfig?.framework?.name;return packageNameOrPath?extractProperFrameworkName(packageNameOrPath):null},getRendererName=mainConfig=>{let frameworkPackageName=getFrameworkPackageName(mainConfig);if(!frameworkPackageName)return null;let frameworkName=frameworkPackages[frameworkPackageName];return frameworkToRenderer[frameworkName]},getBuilderPackageName=mainConfig=>{let frameworkBuilder=getFrameworkOptions(mainConfig)?.builder,frameworkBuilderName=typeof frameworkBuilder=="string"?frameworkBuilder:frameworkBuilder?.options?.name,packageNameOrPath=(typeof mainConfig?.core?.builder=="string"?mainConfig.core.builder:mainConfig?.core?.builder?.name)??frameworkBuilderName;if(!packageNameOrPath)return null;let normalizedPath=path8.normalize(packageNameOrPath).replace(new RegExp(/\\/,"g"),"/");return builderPackages.find(pkg=>normalizedPath.endsWith(pkg))||packageNameOrPath},getFrameworkOptions=mainConfig=>typeof mainConfig?.framework=="string"?null:mainConfig?.framework?.options??null,getRendererPackageNameFromFramework=frameworkPackageName=>{if(frameworkPackageName){if(Object.keys(rendererPackages).includes(frameworkPackageName))return frameworkPackageName;if(Object.values(rendererPackages).includes(frameworkPackageName))return Object.keys(rendererPackages).find(k=>rendererPackages[k]===frameworkPackageName)}return null},getStorybookData=async({packageManager,configDir:userDefinedConfigDir})=>{let packageJson=await packageManager.retrievePackageJson(),{mainConfig:mainConfigPath,version:storybookVersionSpecifier,configDir:configDirFromScript,previewConfig:previewConfigPath}=getStorybookInfo(packageJson,userDefinedConfigDir),storybookVersion=await getCoercedStorybookVersion(packageManager),configDir=userDefinedConfigDir||configDirFromScript||".storybook",mainConfig;try{mainConfig=await loadMainConfig({configDir,noCache:!0});}catch(err){throw new Error(dedent`Unable to find or evaluate ${chalk15.blue(mainConfigPath)}: ${String(err)}`)}return {configDir,mainConfig,storybookVersionSpecifier,storybookVersion,mainConfigPath,previewConfigPath}},updateMainConfig=async({mainConfigPath,dryRun},callback)=>{try{let main=await readConfig(mainConfigPath);await callback(main),dryRun||await writeConfig(main);}catch(e){logger7.info(`\u274C The migration failed to update your ${chalk15.blue(mainConfigPath)} on your behalf because of the following error:
        ${e}
`),logger7.info(`\u26A0\uFE0F Storybook automigrations are based on AST parsing and it's possible that your ${chalk15.blue(mainConfigPath)} file contains a non-standard format (e.g. your export is not an object) or that there was an error when parsing dynamic values (e.g. "require" calls, or usage of environment variables). When your main config is non-standard, automigrations are unfortunately not possible. Please follow the instructions given previously and follow the documentation to make the updates manually.`);}},getAddonNames=mainConfig=>(mainConfig.addons||[]).map(addon=>{let name="";if(typeof addon=="string"?name=addon:typeof addon=="object"&&(name=addon.name),!name.startsWith("."))return name.replace(/\/dist\/.*/,"").replace(/\.[mc]?[tj]?s[x]?$/,"").replace(/\/register$/,"").replace(/\/manager$/,"").replace(/\/preset$/,"")}).filter(item=>item!=null);var logger8=console,checkWebpack5Builder=async({mainConfig,storybookVersion})=>{if(semver.lt(storybookVersion,"6.3.0"))return logger8.warn(dedent`
        Detected SB 6.3 or below, please upgrade storybook to use webpack5.

        To upgrade to the latest stable release, run this from your project directory:

        ${chalk15.cyan("npx storybook@latest upgrade")}

        To upgrade to the latest pre-release, run this from your project directory:

        ${chalk15.cyan("npx storybook@next upgrade")}
      `.trim()),null;if(semver.gte(storybookVersion,"7.0.0"))return null;if(!mainConfig)return logger8.warn("Unable to find storybook main.js config"),null;let builderPackageName=getBuilderPackageName(mainConfig);return builderPackageName&&builderPackageName!=="webpack4"?(logger8.info(`Found builder ${builderPackageName}, skipping`),null):{storybookVersion}};var logger9=console,webpack5={id:"webpack5",versionRange:["<7",">=7"],async check({packageManager,mainConfig,storybookVersion}){let webpackVersion=await packageManager.getPackageVersion("webpack");if(!webpackVersion||semver.lt(webpackVersion,"5.0.0")||semver.gte(webpackVersion,"6.0.0"))return null;let builderInfo=await checkWebpack5Builder({mainConfig,storybookVersion});return builderInfo?{webpackVersion,...builderInfo}:null},prompt({webpackVersion}){let webpackFormatted=chalk15.cyan(`webpack ${webpackVersion}`);return dedent`
      We've detected you're running ${webpackFormatted}.
      Your Storybook's main.js files specifies webpack4, which is incompatible.
      
      To run Storybook in webpack5-mode, we can install Storybook's ${chalk15.cyan("@storybook/builder-webpack5")} for you.

      More info: ${chalk15.yellow("https://github.com/storybookjs/storybook/blob/next/MIGRATION.md#webpack-5-manager-build")}
    `},async run({result:{storybookVersion,webpackVersion},packageManager,dryRun,mainConfigPath}){let deps=[`@storybook/builder-webpack5@${storybookVersion}`];webpackVersion||deps.push("webpack@5"),logger9.info(`\u2705 Adding dependencies: ${deps}`),dryRun||await packageManager.addDependencies({installAsDevDependencies:!0},deps),logger9.info("\u2705 Setting `core.builder` to `@storybook/builder-webpack5` in main.js"),dryRun||await updateMainConfig({mainConfigPath,dryRun:!!dryRun},async main=>{main.setFieldValue(["core","builder"],"@storybook/builder-webpack5");});}};var cra5={id:"cra5",versionRange:["<7",">=7"],async check({packageManager,mainConfig,storybookVersion}){let craVersion=await packageManager.getPackageVersion("react-scripts");if(!craVersion||semver.lt(craVersion,"5.0.0"))return null;let builderInfo=await checkWebpack5Builder({mainConfig,storybookVersion});return builderInfo?{craVersion,...builderInfo}:null},prompt({craVersion}){let craFormatted=chalk15.cyan(`Create React App (CRA) ${craVersion}`);return dedent`
      We've detected you are running ${craFormatted} which is powered by webpack5.
      Your Storybook's main.js files specifies webpack4, which is incompatible.

      In order to work with your version of CRA, we need to install Storybook's ${chalk15.cyan("@storybook/builder-webpack5")}.

      More info: ${chalk15.yellow("https://github.com/storybookjs/storybook/blob/next/MIGRATION.md#cra5-upgrade")}
    `},async run(options){return webpack5.run({...options,result:{webpackVersion:null,...options.result}})}};var vue3={id:"vue3",versionRange:["<7",">=7"],async check({packageManager,mainConfig,storybookVersion}){let vueVersion=await packageManager.getPackageVersion("vue");if(!vueVersion||semver.lt(vueVersion,"3.0.0"))return null;let builderInfo=await checkWebpack5Builder({mainConfig,storybookVersion});return builderInfo?{vueVersion,...builderInfo}:null},prompt({vueVersion,storybookVersion}){let vueFormatted=chalk15.cyan(`Vue ${vueVersion}`),sbFormatted=chalk15.cyan(`Storybook ${storybookVersion}`);return dedent`
      We've detected you are running ${vueFormatted} with Storybook.
      ${sbFormatted} runs webpack4 by default, which is incompatible.

      In order to work with your version of Vue, we need to install Storybook's ${chalk15.cyan("webpack5 builder")}.

      More info: ${chalk15.yellow("https://github.com/storybookjs/storybook/blob/next/MIGRATION.md#vue3-upgrade")}
    `},async run(options){return webpack5.run({...options,result:{webpackVersion:null,...options.result}})}};function slash(path9){return path9.startsWith("\\\\?\\")?path9:path9.replace(/\\/g,"/")}var logger10=console,mdxgfm={id:"github-flavored-markdown-mdx",versionRange:["<7",">=7"],async check({configDir,mainConfig}){let hasMDXFiles=await mainConfig?.stories?.reduce(async(acc,item)=>{if(await acc===!0)return !0;let pattern;if(typeof configDir>"u")return !1;if(typeof item=="string")pattern=slash(join(configDir,item));else if(typeof item=="object"){let directory=item.directory||"..",files2=item.files||"**/*.@(mdx|stories.@(mdx|js|jsx|mjs|ts|tsx))";pattern=slash(join(configDir,directory,files2));}if(!pattern)return !1;let{globby}=await import('globby');return (await globby(pattern,commonGlobOptions(pattern))).some(f=>f.endsWith(".mdx"))},Promise.resolve(!1));return mainConfig?.features?.legacyMdx1===!0||!1||!hasMDXFiles||!!mainConfig.addons?.find(item=>item==="@storybook/addon-mdx-gfm"?!0:typeof item=="string"?!1:item.name==="@storybook/addon-docs"?item.options?.mdxPluginOptions?.mdxCompileOptions?.remarkPlugins?.length>0:!1)?null:{}},prompt(){return dedent`
      In MDX1 you had the option of using GitHub flavored markdown.

      Storybook >= 8.0 uses MDX3 for compiling MDX, and thus no longer supports GFM out of the box.
      Because of this you need to explicitly add the GFM plugin in the addon-docs options:
      https://storybook.js.org/docs/writing-docs/mdx#markdown-tables-arent-rendering-correctly

      We recommend that you follow the guide in the link above; however, we can add a temporary Storybook addon to help make this migration easier.
      We'll install the addon and add it to your storybook config.
    `},async run({packageManager,dryRun,mainConfigPath,skipInstall}){if(!dryRun){let packageJson=await packageManager.retrievePackageJson(),versionToInstall=getStorybookVersionSpecifier(await packageManager.retrievePackageJson());await packageManager.addDependencies({installAsDevDependencies:!0,skipInstall,packageJson},[`@storybook/addon-mdx-gfm@${versionToInstall}`]),await updateMainConfig({mainConfigPath,dryRun:!!dryRun},async main=>{logger10.info('\u2705 Adding "@storybook/addon-mdx-gfm" addon'),dryRun||main.appendValueToArray(["addons"],"@storybook/addon-mdx-gfm");});}}};var logger11=console,removeLegacyMDX1={id:"remove-legacy-mdx1",versionRange:["<8.0.0-alpha.0",">=8.0.0-alpha.0"],async check({mainConfig}){return mainConfig.features&&Object.hasOwn(mainConfig.features,"legacyMdx1")?{hasFeature:!0}:null},prompt({}){return dedent`
      You have features.legacyMdx1 in your Storybook main config file. This feature has been removed. Shall we remove it from your Storybook main config file?

      Link: https://storybook.js.org/docs/8.0/migration-guide
    `},async run({dryRun,mainConfigPath,skipInstall,packageManager}){if(logger11.info("\u2705 Removing legacyMdx1 feature"),!dryRun){await updateMainConfig({dryRun:!!dryRun,mainConfigPath},async main=>{main.removeField(["features","legacyMdx1"]),await writeConfig(main);});let packageJson=await packageManager.retrievePackageJson();await packageManager.removeDependencies({skipInstall,packageJson},["@storybook/mdx1-csf"]);}}};var logger12=console,eslintPlugin={id:"eslintPlugin",versionRange:["<8",">=7"],async check({packageManager}){let{hasEslint,isStorybookPluginInstalled}=await extractEslintInfo(packageManager);if(isStorybookPluginInstalled||!hasEslint)return null;let eslintFile=null,unsupportedExtension;try{eslintFile=findEslintFile();}catch(err){unsupportedExtension=String(err);}return !eslintFile||!unsupportedExtension?(logger12.warn("Unable to find .eslintrc config file, skipping"),null):{eslintFile,unsupportedExtension}},prompt(){return dedent`
      We've detected you are not using our eslint-plugin.

      In order to have the best experience with Storybook and follow best practices, we advise you to install eslint-plugin-storybook.

      More info: ${chalk15.yellow("https://github.com/storybookjs/eslint-plugin-storybook#readme")}
    `},async run({result:{eslintFile,unsupportedExtension},packageManager,dryRun,skipInstall}){let deps=["eslint-plugin-storybook"];if(logger12.info(`\u2705 Adding dependencies: ${deps}`),dryRun||await packageManager.addDependencies({installAsDevDependencies:!0,skipInstall},deps),!dryRun&&unsupportedExtension){logger12.info(dedent`
          ⚠️ The plugin was successfully installed but failed to configure.
          
          Found an eslint config file with an unsupported automigration format: .eslintrc.${unsupportedExtension}.
          The supported formats for this automigration are: ${SUPPORTED_ESLINT_EXTENSIONS.join(", ")}.

          Please refer to https://github.com/storybookjs/eslint-plugin-storybook#usage to finish setting up the plugin manually.
      `);return}dryRun||await configureEslintPlugin(eslintFile,packageManager);}};var logger13=console,builderVite={id:"builder-vite",versionRange:["<7",">=7"],async check({packageManager,mainConfig}){let packageJson=await packageManager.retrievePackageJson(),builder=mainConfig.core?.builder;return (typeof builder=="string"?builder:builder?.name)!=="storybook-builder-vite"?null:{builder,packageJson}},prompt({builder}){let builderFormatted=chalk15.cyan(JSON.stringify(builder,null,2));return dedent`
      We've detected you're using the community vite builder: ${builderFormatted}
      
      'storybook-builder-vite' is deprecated and now located at ${chalk15.cyan("@storybook/builder-vite")}.

      We can upgrade your project to use the new builder automatically.
      
      More info: ${chalk15.yellow("https://github.com/storybookjs/storybook/blob/next/MIGRATION.md#vite-builder-renamed")}
    `},async run({result:{builder,packageJson},packageManager,dryRun,mainConfigPath}){let{dependencies={},devDependencies={}}=packageJson;if(logger13.info("\u2705 Removing existing 'storybook-builder-vite' dependency"),dryRun||(delete dependencies["storybook-builder-vite"],delete devDependencies["storybook-builder-vite"],await packageManager.writePackageJson(packageJson)),logger13.info("\u2705 Adding '@storybook/builder-vite' as dev dependency"),!dryRun){let versionToInstall=getStorybookVersionSpecifier(await packageManager.retrievePackageJson());await packageManager.addDependencies({installAsDevDependencies:!0},[`@storybook/builder-vite@${versionToInstall}`]);}logger13.info("\u2705 Updating main.js to use vite builder"),dryRun||await updateMainConfig({dryRun:!!dryRun,mainConfigPath},async main=>{let updatedBuilder=typeof builder=="string"?"@storybook/builder-vite":{name:"@storybook/builder-vite",options:builder.options};main.setFieldValue(["core","builder"],updatedBuilder),await writeConfig(main);});}};var viteConfigFile={id:"viteConfigFile",versionRange:["<8.0.0-beta.3",">=8.0.0-beta.3"],promptType:"notification",async check({mainConfig,packageManager,mainConfigPath}){let isViteConfigFileFound=!!await findUp2(["vite.config.js","vite.config.mjs","vite.config.cjs","vite.config.ts","vite.config.mts"],{cwd:mainConfigPath?path8.join(mainConfigPath,".."):process.cwd()}),rendererToVitePluginMap={preact:"@preact/preset-vite",qwik:"vite-plugin-qwik",react:"@vitejs/plugin-react",solid:"vite-plugin-solid",svelte:"@sveltejs/vite-plugin-svelte",sveltekit:"@sveltejs/kit/vite",vue:"@vitejs/plugin-vue"},frameworkPackageName=getFrameworkPackageName(mainConfig);if(!frameworkPackageName)return null;let frameworkName=frameworkPackages[frameworkPackageName],isUsingViteBuilder=mainConfig.core?.builder==="vite"||frameworkPackageName?.includes("vite")||frameworkPackageName==="qwik"||frameworkPackageName==="solid"||frameworkPackageName==="sveltekit",rendererName=frameworkToRenderer[frameworkName];if(!isViteConfigFileFound&&mainConfig.core?.builder&&typeof mainConfig.core?.builder!="string"&&mainConfig.core?.builder.options&&(isViteConfigFileFound=!!mainConfig.core?.builder.options.viteConfigPath),!isViteConfigFileFound&&isUsingViteBuilder){let plugins=[];return rendererToVitePluginMap[rendererName]&&plugins.push(rendererToVitePluginMap[rendererName]),{plugins,existed:isViteConfigFileFound}}let plugin=rendererToVitePluginMap[rendererName];if(!plugin)return null;let pluginVersion=await packageManager.getPackageVersion(plugin);if(isViteConfigFileFound&&isUsingViteBuilder&&!pluginVersion){let plugins=[];return plugin&&plugins.push(plugin),{plugins,existed:!isViteConfigFileFound}}return null},prompt({existed,plugins}){return existed?dedent`
        Since version 8.0.0, Storybook no longer ships with an in-built Vite config.
        We've detected you do have a Vite config, but you may be missing the following plugins in it.

        ${plugins.map(plugin=>`  - ${plugin}`).join(`
`)}

        If you already have these plugins, you can ignore this message.

        You can find more information on how to do this here:
        https://storybook.js.org/docs/8.0/migration-guide/#missing-viteconfigjs-file

        This change was necessary to support newer versions of Vite.
      `:dedent`
      Since version 8.0.0, Storybook no longer ships with an in-built Vite config.
      Please add a vite.config.js file to your project root.

      You can find more information on how to do this here:
      https://storybook.js.org/docs/8.0/migration-guide/#missing-viteconfigjs-file

      This change was necessary to support newer versions of Vite.
    `}};var logger14=console,getStorybookScripts=allScripts=>Object.keys(allScripts).reduce((acc,key)=>{let currentScript=allScripts[key];if(currentScript==null)return acc;let isStorybookScript=!1,allWordsFromScript=currentScript.split(" "),newScript=allWordsFromScript.map((currentWord,index)=>{let previousWord=allWordsFromScript[index-1],isSbBinary=currentWord==="build-storybook"||currentWord==="start-storybook"||currentWord==="sb",isPrependedByPkgManager=previousWord&&["npx","run","yarn","pnpx","pnpm dlx"].some(cmd=>previousWord.includes(cmd));return isSbBinary&&!isPrependedByPkgManager?(isStorybookScript=!0,currentWord.replace("sb","storybook").replace("start-storybook","storybook dev").replace("build-storybook","storybook build")):currentWord}).join(" ");return isStorybookScript&&(acc[key]={before:currentScript,after:newScript}),acc},{}),sbScripts={id:"sb-scripts",versionRange:["<7",">=7"],async check({packageManager,storybookVersion}){let packageJson=await packageManager.retrievePackageJson(),{scripts={}}=packageJson;if(semver.lt(storybookVersion,"7.0.0"))return null;let storybookScripts=getStorybookScripts(scripts);return Object.keys(storybookScripts).length===0?null:{packageJson,storybookScripts,storybookVersion}},prompt({storybookVersion,storybookScripts}){let sbFormatted=chalk15.cyan(`Storybook ${storybookVersion}`),newScriptsMessage=Object.keys(storybookScripts).reduce((acc,scriptKey)=>(acc.push([chalk15.bold(scriptKey),"from:",chalk15.cyan(storybookScripts[scriptKey].before),"to:",chalk15.cyan(storybookScripts[scriptKey].after)].join(`
`)),acc),[]);return dedent`
      We've detected you are using ${sbFormatted} with scripts from previous versions of Storybook.
      Starting in Storybook 7, the ${chalk15.yellow("start-storybook")} and ${chalk15.yellow("build-storybook")} binaries have changed to ${chalk15.magenta("storybook dev")} and ${chalk15.magenta("storybook build")} respectively.
      In order to work with ${sbFormatted}, your storybook scripts have to be adjusted to use the binary. We can adjust them for you:

      ${newScriptsMessage.join(`

`)}

      In case this migration did not cover all of your scripts, or you'd like more info: ${chalk15.yellow("https://github.com/storybookjs/storybook/blob/next/MIGRATION.md#start-storybook--build-storybook-binaries-removed")}
      `},async run({result:{storybookScripts},packageManager,dryRun}){if(logger14.info("\u2705 Updating scripts in package.json"),logger14.log(),!dryRun){let newScripts=Object.keys(storybookScripts).reduce((acc,scriptKey)=>(acc[scriptKey]=storybookScripts[scriptKey].after,acc),{});logger14.log(),await packageManager.addScripts(newScripts);}}};var logger15=console,sbBinary={id:"storybook-binary",versionRange:["<7",">=7"],async check({packageManager,storybookVersion}){let packageJson=await packageManager.retrievePackageJson(),nrwlStorybookVersion=await packageManager.getPackageVersion("@nrwl/storybook"),sbBinaryVersion=await packageManager.getPackageVersion("sb"),storybookBinaryVersion=await packageManager.getPackageVersion("storybook");if(nrwlStorybookVersion)return null;let hasSbBinary=!!sbBinaryVersion,hasStorybookBinary=!!storybookBinaryVersion;return !hasSbBinary&&hasStorybookBinary?null:{hasSbBinary,hasStorybookBinary,storybookVersion,packageJson}},prompt({storybookVersion,hasSbBinary,hasStorybookBinary}){let sbFormatted=chalk15.cyan(`Storybook ${storybookVersion}`),storybookBinaryMessage=hasStorybookBinary?"":`We've detected you are using ${sbFormatted} without Storybook's ${chalk15.magenta("storybook")} binary. Starting in Storybook 7.0, it has to be installed.`;return dedent`
      ${storybookBinaryMessage}
      ${hasSbBinary?`You're using the 'sb' binary and it should be replaced, as 'storybook' is the recommended way to run Storybook.
`:""}

      More info: ${chalk15.yellow("https://github.com/storybookjs/storybook/blob/next/MIGRATION.md#start-storybook--build-storybook-binaries-removed")}
      `},async run({result:{packageJson,hasSbBinary,hasStorybookBinary},packageManager,dryRun,skipInstall}){if(hasSbBinary&&(logger15.info("\u2705 Removing 'sb' dependency"),dryRun||await packageManager.removeDependencies({skipInstall:skipInstall||!hasStorybookBinary,packageJson},["sb"])),!hasStorybookBinary&&(logger15.log(),logger15.info("\u2705 Adding 'storybook' as dev dependency"),logger15.log(),!dryRun)){let versionToInstall=getStorybookVersionSpecifier(packageJson);await packageManager.addDependencies({installAsDevDependencies:!0,packageJson,skipInstall},[`storybook@${versionToInstall}`]);}}};var logger16=console,packagesMap={"@storybook/react":{webpack5:"@storybook/react-webpack5",vite:"@storybook/react-vite"},"@storybook/preact":{webpack5:"@storybook/preact-webpack5",vite:"@storybook/preact-vite"},"@storybook/server":{webpack5:"@storybook/server-webpack5"},"@storybook/ember":{webpack5:"@storybook/ember"},"@storybook/angular":{webpack5:"@storybook/angular"},"@storybook/vue3":{webpack5:"@storybook/vue3-webpack5",vite:"@storybook/vue3-vite"},"@storybook/svelte":{webpack5:"@storybook/svelte-webpack5",vite:"@storybook/svelte-vite"},"@storybook/web-components":{webpack5:"@storybook/web-components-webpack5",vite:"@storybook/web-components-vite"},"@storybook/html":{webpack5:"@storybook/html-webpack5",vite:"@storybook/html-vite"}},communityFrameworks={vite:["storybook-framework-qwik","storybook-solidjs-vite"],webpack5:[]},viteConfigFiles2=["vite.config.js","vite.config.cjs","vite.config.mjs","vite.config.ts"],webpackConfigFiles2=["webpack.config.js","webpack.config.cjs","webpack.config.mjs","webpack.config.ts"],detectBuilderInfo=async({mainConfig,configDir,packageManager})=>{let builderName,builderOrFrameworkName,{core={},framework}=mainConfig,{builder}=core,builderPackageName=getBuilderPackageName(mainConfig),frameworkPackageName=getFrameworkPackageName(mainConfig),builderOptions=typeof builder!="string"?builder?.options??{}:{};if(builderPackageName?builderOrFrameworkName=builderPackageName:framework&&Object.keys(frameworkPackages).includes(frameworkPackageName)&&(builderOrFrameworkName=frameworkPackageName,builderOptions=typeof framework=="object"?framework.options?.builder??{}:{}),!builderOrFrameworkName){let viteConfigFile2=await findUp2(viteConfigFiles2,{cwd:configDir});if(viteConfigFile2)logger16.info(`No builder or framework field, detected Storybook builder via: ${viteConfigFile2}`),builderOrFrameworkName="vite";else {let webpackConfigFile=await findUp2(webpackConfigFiles2,{cwd:configDir});webpackConfigFile&&(logger16.info(`No builder or framework field, detected Storybook builder via: ${webpackConfigFile}`),builderOrFrameworkName="webpack5");}}if(!builderOrFrameworkName){let storybookBuilderViteVersion=await packageManager.getPackageVersion("@storybook/builder-vite"),storybookBuilderVite2Version=await packageManager.getPackageVersion("storybook-builder-vite"),storybookBuilderWebpack5Version=await packageManager.getPackageVersion("@storybook/builder-webpack5"),storybookBuilderManagerWebpack5Version=await packageManager.getPackageVersion("@storybook/manager-webpack5");storybookBuilderViteVersion||storybookBuilderVite2Version?builderOrFrameworkName="vite":(storybookBuilderWebpack5Version||storybookBuilderManagerWebpack5Version)&&(builderOrFrameworkName="webpack5");}return builderOrFrameworkName?.includes("vite")||builderOrFrameworkName&&communityFrameworks.vite.includes(builderOrFrameworkName)?builderName="vite":(builderOrFrameworkName?.includes("webpack")||builderOrFrameworkName&&communityFrameworks.webpack5.includes(builderOrFrameworkName),builderName="webpack5"),{name:builderName,options:builderOptions}},getNextjsAddonOptions=addons=>{let nextjsAddon=addons?.find(addon=>typeof addon=="string"?addon==="storybook-addon-next":addon.name==="storybook-addon-next");return !nextjsAddon||typeof nextjsAddon=="string"?{}:nextjsAddon.options||{}};var detectRenderer=async packageJson=>{let allDependencies={...packageJson.dependencies,...packageJson.devDependencies,...packageJson.peerDependencies},matches=Object.keys(rendererPackages).filter(pkg=>!!allDependencies[pkg]),[rendererPackage]=matches;return matches.length>1&&(rendererPackage=(await prompts5([{type:"select",name:"rendererPackage",hint:"> - Use arrow-keys. Return to submit. To automate this next time, you can pass the renderer to the CLI via the --renderer flag",message:"Tried to detect a Storybook renderer in your project but found multiple. This could happen in monorepos, when projects contain multiple Storybook packages in package.json. Please select the correct one:",choices:matches.map(type=>({title:type,value:type}))}])).rendererPackage),rendererPackage};var logger17=console,newFrameworks={id:"new-frameworks",versionRange:["<7",">=7"],async check({configDir,packageManager,mainConfig,mainConfigPath,rendererPackage}){if(typeof configDir>"u")return null;let packageJson=await packageManager.retrievePackageJson(),frameworkPackageName=getFrameworkPackageName(mainConfig),rendererPackageName=rendererPackage??await getRendererPackageNameFromFramework(frameworkPackageName)??await detectRenderer(packageJson),hasFrameworkInMainConfig=!!frameworkPackageName;frameworkPackageName&&Object.values(rendererPackages).includes(frameworkPackageName)&&(hasFrameworkInMainConfig=!1);let builderConfig=mainConfig.core?.builder;if(!Object.keys(packagesMap).includes(rendererPackageName))return null;let allDependencies=await packageManager.getAllDependencies(),builderInfo=await detectBuilderInfo({mainConfig,configDir,packageManager}),newFrameworkPackage=Object.keys(frameworkPackages).find(pkg=>pkg===frameworkPackageName);if(newFrameworkPackage||(newFrameworkPackage=packagesMap[rendererPackageName]?.[builderInfo.name]),!newFrameworkPackage)return null;let renderer=rendererPackages[rendererPackageName],rendererOptions=mainConfig[`${renderer}Options`]||{},frameworkOptions=typeof mainConfig.framework=="string"?{}:mainConfig.framework?.options,dependenciesToRemove=["@storybook/builder-webpack5","@storybook/manager-webpack5","@storybook/builder-webpack4","@storybook/manager-webpack4","@storybook/builder-vite","storybook-builder-vite"],addonsToRemove=[],addonOptions={},metaFramework,nextVersion=await packageManager.getPackageVersion("next"),svelteKitVersion=await packageManager.getPackageVersion("@sveltejs/kit"),viteVersion=await packageManager.getPackageVersion("vite");if(rendererPackageName==="@storybook/react"&&nextVersion){let nextAddonOptions=getNextjsAddonOptions(mainConfig.addons);(nextVersion&&semver.gte(nextVersion,"12.0.0")||Object.keys(nextAddonOptions).length>0)&&(metaFramework="nextjs",(newFrameworkPackage==="@storybook/react-webpack5"||newFrameworkPackage==="@storybook/nextjs")&&(newFrameworkPackage="@storybook/nextjs",addonsToRemove=["storybook-addon-next","storybook-addon-next-router"].filter(dep=>allDependencies[dep]||mainConfig.addons?.find(addon=>typeof addon=="string"?dep===addon:dep===addon.name)),addonOptions=nextAddonOptions,dependenciesToRemove.push("@storybook/react-webpack5","storybook-addon-next","storybook-addon-next-router")));}else rendererPackageName==="@storybook/svelte"&&svelteKitVersion&&semver.gte(svelteKitVersion,"1.0.0")&&(metaFramework="sveltekit",newFrameworkPackage==="@storybook/svelte-vite"&&(newFrameworkPackage="@storybook/sveltekit",rendererOptions={},dependenciesToRemove.push("@storybook/svelte-vite")));let dependenciesToAdd=[newFrameworkPackage].filter(dep=>!allDependencies[dep]).filter(Boolean);if(dependenciesToRemove=dependenciesToRemove.filter(dep=>allDependencies[dep]).filter(Boolean),hasFrameworkInMainConfig&&!builderConfig&&!Object.keys(rendererOptions).length&&!Object.keys(addonOptions).length&&!dependenciesToRemove.length&&!dependenciesToAdd.length)return null;if(viteVersion&&semver.lt(viteVersion,"3.0.0"))throw new Error(dedent`
        ❌ Your project should be upgraded to use the framework package ${chalk15.bold(newFrameworkPackage)}, but we detected that you are using Vite ${chalk15.bold(viteVersion)}, which is unsupported since ${chalk15.bold("Storybook 7.0")}. Please upgrade Vite to ${chalk15.bold("3.0.0 or higher")} and rerun this migration.
      `);return invariant5(mainConfigPath,"Missing main config path."),{mainConfigPath,dependenciesToAdd,dependenciesToRemove,frameworkPackage:newFrameworkPackage,hasFrameworkInMainConfig,frameworkOptions:{...frameworkOptions,...rendererOptions,...addonOptions},rendererOptions,addonOptions,addonsToRemove,builderInfo,renderer,builderConfig,metaFramework}},prompt({dependenciesToRemove,dependenciesToAdd,hasFrameworkInMainConfig,mainConfigPath,frameworkPackage,addonOptions,renderer,rendererOptions,builderConfig,addonsToRemove,metaFramework}){let disclaimer="",migrationSteps="";return dependenciesToRemove.length>0&&(migrationSteps+=`- Remove the following dependencies:
      ${dependenciesToRemove.map(dep=>`- * ${chalk15.cyan(dep)}`).join(`
`)}
`),dependenciesToAdd.length>0&&(migrationSteps+=`- Add the following dependencies: 
      ${dependenciesToAdd.map(dep=>`- * ${chalk15.cyan(dep)}`).join(`
`)}
`),hasFrameworkInMainConfig||(migrationSteps+=`- Update or specify the ${chalk15.yellow("framework")} field in ${chalk15.blue(mainConfigPath)} with the value of "${chalk15.cyan(frameworkPackage)}".
`),Object.keys(rendererOptions).length>0&&(migrationSteps+=`- Move the ${chalk15.yellow(`${renderer}Options`)} field in ${chalk15.blue(mainConfigPath)} to ${chalk15.yellow("framework.options")}, and remove that field entirely.
      More info: ${chalk15.yellow("https://github.com/storybookjs/storybook/blob/next/MIGRATION.md#frameworkoptions-renamed")}
`),addonsToRemove.length>0&&(migrationSteps+=`- Remove the following addons from your ${chalk15.blue(mainConfigPath)}, as the new framework also supports features provided by them:
      ${addonsToRemove.map(dep=>`- * ${chalk15.cyan(dep)}`).join(`
`)}
      `),Object.keys(addonOptions).length>0&&(migrationSteps+=`- Move the addon options "${chalk15.yellow(Object.keys(addonOptions).join(", "))}" in ${chalk15.blue(mainConfigPath)} to the ${chalk15.yellow("framework.options")} field.
`),builderConfig&&(typeof builderConfig=="object"&&Object.keys(builderConfig.options||{}).length>0&&(migrationSteps+=`- Move the ${chalk15.yellow("core.builder.options")} field in ${chalk15.blue(mainConfigPath)} to ${chalk15.yellow("framework.options.builder")}
`),migrationSteps+=`- Remove the ${chalk15.yellow("core.builder")} field in ${chalk15.blue(mainConfigPath)}.
`),(dependenciesToRemove.includes("@storybook/builder-webpack4")||dependenciesToRemove.includes("@storybook/manager-webpack4"))&&(disclaimer=dedent`\n\n
      ${chalk15.underline(chalk15.bold(chalk15.cyan("Webpack 4 users")))}

      Unless you're using Storybook's Vite builder, this automigration will install a Webpack 5 based framework.
      
      Given you were using Storybook's Webpack 4 builder (default in 6.x, discontinued in 7.0), this could be a breaking change -- especially if your project has a custom webpack configuration.
      
      To learn more about migrating from Webpack4, see: ${chalk15.yellow("https://github.com/storybookjs/storybook/blob/next/MIGRATION.md#webpack4-support-discontinued")}`),metaFramework==="nextjs"&&(dependenciesToRemove.includes("storybook-addon-next-router")&&(migrationSteps+=`- Migrate the usage of the ${chalk15.cyan("storybook-addon-next-router")} addon to use the APIs from the ${chalk15.magenta("@storybook/nextjs")} framework package instead. Follow the instructions below.`),frameworkPackage==="@storybook/react-vite"?disclaimer=dedent`\n\n
          ${chalk15.bold("Important")}: We've detected you are using Storybook in a Next.js project.
  
          This migration is set to update your project to use the ${chalk15.magenta("@storybook/react-vite")} framework, but Storybook provides a framework package specifically for Next.js projects: ${chalk15.magenta("@storybook/nextjs")}.
  
          This package provides a better, out of the box experience for Next.js users, however it is only compatible with the Webpack 5 builder, so we can't automigrate for you, as you are using the Vite builder. If you switch this project to use Webpack 5 and rerun this migration, we can update your project.
          
          If you are interested in using this package, see: ${chalk15.yellow("https://github.com/storybookjs/storybook/blob/next/code/frameworks/nextjs/README.md")}
        `:frameworkPackage==="@storybook/nextjs"&&(disclaimer=dedent`\n\n
        The ${chalk15.magenta("@storybook/nextjs")} package provides great user experience for Next.js users, and we highly recommend you to read more about it at ${chalk15.yellow("https://github.com/storybookjs/storybook/blob/next/code/frameworks/nextjs/README.md")}
        `)),metaFramework==="sveltekit"&&(frameworkPackage==="@storybook/svelte-webpack5"?disclaimer=dedent`\n\n
          ${chalk15.bold("Important")}: We've detected you are using Storybook in a SvelteKit project.
  
          This migration is set to update your project to use the ${chalk15.magenta("@storybook/svelte-webpack5")} framework, but Storybook provides a framework package specifically for SvelteKit projects: ${chalk15.magenta("@storybook/sveltekit")}.
  
          This package provides a better experience for SvelteKit users, however it is only compatible with the Vite builder, so we can't automigrate for you, as you are using the Webpack builder.
          
          If you are interested in using this package, see: ${chalk15.yellow("https://github.com/storybookjs/storybook/blob/next/code/frameworks/sveltekit/README.md")}
        `:(migrationSteps+=`- Remove the ${chalk15.yellow(`${renderer}Options`)} field from ${chalk15.blue(mainConfigPath)}.
        More info: ${chalk15.yellow("https://github.com/storybookjs/storybook/blob/next/MIGRATION.md#vite-builder-uses-vite-config-automatically")}
`,disclaimer=dedent`\n\n
        The ${chalk15.magenta("@storybook/sveltekit")} package provides great user experience for SvelteKit users, and we highly recommend you to read more about it at ${chalk15.yellow("https://github.com/storybookjs/storybook/blob/next/code/frameworks/sveltekit/README.md")}
        `)),dedent`
      We've detected your project is not fully setup with the new framework format, which was introduced in Storybook 7.

      Storybook 7 introduced the concept of frameworks, which abstracts configuration for renderers (e.g. React, Vue), builders (e.g. Webpack, Vite) and defaults to make integrations easier.

      Your project should be updated to use Storybook's framework: ${chalk15.magenta(frameworkPackage)}. We can attempt to do this for you automatically.

      Here are the steps this migration will do to migrate your project:
      ${migrationSteps}

      To learn more about the new framework format, see: ${chalk15.yellow("https://github.com/storybookjs/storybook/blob/next/MIGRATION.md#new-framework-api")}${disclaimer}
    `},async run({result:{dependenciesToAdd,dependenciesToRemove,frameworkPackage,frameworkOptions,builderInfo,renderer,addonsToRemove},packageManager,dryRun,mainConfigPath,skipInstall}){let packageJson=await packageManager.retrievePackageJson();if(dependenciesToRemove.length>0&&(logger17.info(`\u2705 Removing dependencies: ${dependenciesToRemove.join(", ")}`),dryRun||await packageManager.removeDependencies({skipInstall:skipInstall||dependenciesToAdd.length>0,packageJson},dependenciesToRemove)),dependenciesToAdd.length>0&&(logger17.info(`\u2705 Installing new dependencies: ${dependenciesToAdd.join(", ")}`),!dryRun)){let versionToInstall=getStorybookVersionSpecifier(packageJson),depsToAdd=dependenciesToAdd.map(dep=>`${dep}@${versionToInstall}`);await packageManager.addDependencies({installAsDevDependencies:!0,skipInstall,packageJson},depsToAdd);}await updateMainConfig({mainConfigPath,dryRun:!!dryRun},async main=>{logger17.info("\u2705 Updating main.js"),logger17.info('\u2705 Updating "framework" field'),dryRun||main.setFieldValue(["framework","name"],frameworkPackage),dryRun||main.setFieldValue(["framework","options"],frameworkOptions),main.getFieldNode([`${renderer}Options`])&&(logger17.info(`\u2705 Moving "${renderer}Options" to "framework.options"`),dryRun||main.removeField([`${renderer}Options`])),main.getFieldNode(["core","builder"])&&(logger17.info('\u2705 Removing "core.builder" field'),dryRun||main.removeField(["core","builder"])),Object.keys(builderInfo.options).length>0&&(logger17.info('\u2705 Moving "core.builder.options" into "framework.options.builder"'),dryRun||main.setFieldValue(["framework","options","builder"],builderInfo.options));let currentCore=main.getFieldValue(["core"]);if(currentCore&&Object.keys(currentCore).length===0&&(logger17.info('\u2705 Removing "core" field'),dryRun||main.removeField(["core"])),addonsToRemove.length>0){let updatedAddons=main.getFieldValue(["addons"]).filter(addon=>typeof addon=="string"?!addonsToRemove.includes(addon):addon.name?!addonsToRemove.includes(addon.name):!1);logger17.info("\u2705 Removing unnecessary addons"),dryRun||main.setFieldValue(["addons"],updatedAddons);}});}};var RemovedAPIs=(RemovedAPIs2=>(RemovedAPIs2.addDecorator="addDecorator",RemovedAPIs2.addParameters="addParameters",RemovedAPIs2.addLoader="addLoader",RemovedAPIs2.getStorybook="getStorybook",RemovedAPIs2.setAddon="setAddon",RemovedAPIs2.clearDecorators="clearDecorators",RemovedAPIs2))(RemovedAPIs||{}),removedGlobalClientAPIs={id:"removedglobalclientapis",promptType:"manual",versionRange:["<7",">=7"],async check({previewConfigPath}){if(previewConfigPath){let contents=await readFile$1(previewConfigPath,"utf8"),usedAPIs=Object.values(RemovedAPIs).reduce((acc,item)=>(contents.includes(item)&&acc.push(item),acc),[]);if(usedAPIs.length)return {usedAPIs,previewPath:previewConfigPath}}return null},prompt({usedAPIs,previewPath}){return dedent`
      ${chalk15.bold(chalk15.red("Attention"))}: We could not automatically make this change. You'll need to do it manually.

      The following APIs (used in "${chalk15.yellow(previewPath)}") have been removed from Storybook:
      
      ${usedAPIs.map(api=>`- ${chalk15.cyan(api)}`).join(`
`)}

      Please see the migration guide for more information:
      ${chalk15.yellow("https://github.com/storybookjs/storybook/blob/next/MIGRATION.md#removed-global-client-apis")}
    `}};var logger18=console,autodocsTrue={id:"autodocsTrue",versionRange:["<7",">=7"],async check({mainConfig}){let{docs}=mainConfig,docsPageToAutodocsMapping={true:"tag",automatic:!0,false:!1};if(docs?.docsPage){let oldValue=docs?.docsPage.toString();if(!(oldValue in docsPageToAutodocsMapping))throw new Error(`Unexpected value for docs.docsPage: ${oldValue}`);return {value:docsPageToAutodocsMapping[oldValue]}}return docs?.autodocs===void 0?{value:!0}:null},prompt({value}){let autodocsFormatted=chalk15.cyan(`docs: { autodocs: ${JSON.stringify(value??!0)} }`),tagWarning=dedent`
      NOTE: if you're upgrading from an older 7.0-beta using the 'docsPage' tag,
      please update your story files to use the 'autodocs' tag instead.
    `;return value?dedent`
      We've changed the configuration of autodocs (previous docsPage), so now the value:
        - docs.autodocs: true -- means automatically create docs for every CSF file
        - docs.autodocs: 'tag' -- means only create autodocs for CSF files with the 'autodocs' tag
        - docs.autodocs: false -- means never create autodocs

      Based on your prior configuration,  we can set the \`docs.autodocs\` to keep your old behaviour:

      ${autodocsFormatted}
      ${value==="tag"?tagWarning:""}
      More info: ${chalk15.yellow("https://github.com/storybookjs/storybook/blob/next/MIGRATION.md#autodocs-changes")}
    `:dedent`
      We've detected that your main.js configuration file has not configured autodocs. In 6.x we
      we defaulted to having a autodocs for every story, in 7.x you need to opt in per-component.
      However, we can set the \`docs.autodocs\` to true to approximate the old behaviour:

      ${autodocsFormatted}

      More info: ${chalk15.yellow("https://github.com/storybookjs/storybook/blob/next/MIGRATION.md#autodocs-changes")}
    `},async run({result:{value},dryRun,mainConfigPath}){logger18.info("\u2705 Setting 'docs.autodocs' to true in main.js"),dryRun||await updateMainConfig({mainConfigPath,dryRun:!!dryRun},async main=>{main.removeField(["docs","docsPage"]),main.setFieldValue(["docs","autodocs"],value??!0);});}};var angularBuilders={id:"angular-builders",versionRange:["<7",">=7"],async check({packageManager,mainConfig}){let angularVersion=await packageManager.getPackageVersion("@angular/core"),framewworkPackageName=getFrameworkPackageName(mainConfig);if(!angularVersion||await isNxProject()||framewworkPackageName!=="@storybook/angular")return null;let angularJSON=new AngularJSON,{hasStorybookBuilder}=angularJSON;return hasStorybookBuilder||!angularJSON.rootProject&&Object.keys(angularJSON.projects).length>1?null:{mainConfig,packageManager}},prompt(){return dedent`
      We have detected that your project does not use the Storybook Angular builder yet. In Storybook 6.4 we deprecated calling Storybook directly (npm run storybook) for Angular. In Storybook 7.0, we've removed it entirely.
      
      In order to use the Storybook Angular builder, we need to add a few entries to your angular.json file. Additionally, we will add the @compodoc/compodoc package to your devDependencies if you want and we will add a few scripts to your package.json file.

      Also feel free to remove the Compodoc script from your package.json file if you don't use it apart from Storybook anymore. Storybook uses Compodoc internally and you don't have to call in separately anymore.

      Read more about the Angular builder here: ${chalk15.yellow("https://github.com/storybookjs/storybook/tree/next/code/frameworks/angular#how-do-i-migrate-to-an-angular-storybook-builder")}
    `},async run({result}){let angularJSON=new AngularJSON,{packageManager}=result,{useCompoDoc}=await prompts5({type:"confirm",name:"useCompoDoc",message:"Have you set up compodoc in Storybook previously?"}),angularProjectName=await angularJSON.getProjectName();angularJSON.addStorybookEntries({angularProjectName,storybookFolder:".storybook",useCompodoc:useCompoDoc,root:"."}),angularJSON.write(),await packageManager.addScripts({storybook:`ng run ${angularProjectName}:storybook`,"build-storybook":`ng run ${angularProjectName}:build-storybook`});}};var angularBuildersMultiproject={id:"angular-builders-multiproject",promptType:"manual",versionRange:["<7",">=7"],async check({packageManager,mainConfig}){let angularVersion=await packageManager.getPackageVersion("@angular/core"),frameworkPackageName=getFrameworkPackageName(mainConfig);if(await isNxProject()||frameworkPackageName!=="@storybook/angular"||!angularVersion||semver.lt(angularVersion,"14.0.0"))return null;let angularJSON=new AngularJSON,{hasStorybookBuilder}=angularJSON;return hasStorybookBuilder||angularJSON.rootProject||Object.keys(angularJSON.projects).length===1?null:{}},prompt(){return dedent`
    In Storybook 6.4 we have deprecated calling Storybook directly (npm run storybook) for Angular. In Storybook 7.0, we've removed it entirely. Instead you have to set up the Storybook builder in your ${chalk15.yellow("angular.json")} and execute ${chalk15.yellow("ng run <your-project>:storybook")} to start Storybook. 
    
    ❌ Your Angular workspace uses multiple projects defined in the ${chalk15.yellow("angular.json")} file and we were not able to detect a root project. Therefore we are not able to automigrate to use Angular Storybook builder. Instead, please visit ${chalk15.yellow("https://github.com/storybookjs/storybook/tree/next/code/frameworks/angular")} to do the migration manually.
    `}};var t=__toESM(require_lib3(),1),defaultRequireWrapperName="getAbsolutePath";function doesVariableOrFunctionDeclarationExist(node,name){return t.isVariableDeclaration(node)&&node.declarations.length===1&&t.isVariableDeclarator(node.declarations[0])&&t.isIdentifier(node.declarations[0].id)&&node.declarations[0].id?.name===name||t.isFunctionDeclaration(node)&&t.isIdentifier(node.id)&&node.id.name===name}function getReferenceToRequireWrapper(config,value){return t.callExpression(t.identifier(getRequireWrapperName(config)??defaultRequireWrapperName),[t.stringLiteral(value)])}function getRequireWrapperName(config){let declarationName=config.getBodyDeclarations().flatMap(node=>doesVariableOrFunctionDeclarationExist(node,"wrapForPnp")?["wrapForPnp"]:doesVariableOrFunctionDeclarationExist(node,defaultRequireWrapperName)?[defaultRequireWrapperName]:[]);return declarationName.length?declarationName[0]:null}function isRequireWrapperNecessary(node,cb=()=>{}){if(t.isStringLiteral(node))return cb(node),!0;if(t.isObjectExpression(node)){let nameProperty=node.properties.find(property=>t.isObjectProperty(property)&&t.isIdentifier(property.key)&&property.key.name==="name");if(nameProperty&&t.isStringLiteral(nameProperty.value))return cb(nameProperty),!0}return t.isArrayExpression(node)&&node.elements.some(element=>element&&isRequireWrapperNecessary(element))?(cb(node),!0):!1}function getFieldsForRequireWrapper(config){let frameworkNode=config.getFieldNode(["framework"]),builderNode=config.getFieldNode(["core","builder"]),rendererNode=config.getFieldNode(["core","renderer"]),addons=config.getFieldNode(["addons"]);return [...frameworkNode?[frameworkNode]:[],...builderNode?[builderNode]:[],...rendererNode?[rendererNode]:[],...addons&&t.isArrayExpression(addons)?[addons]:[]]}function getRequireWrapperAsCallExpression(isConfigTypescript){let functionDeclaration2={...t.functionDeclaration(t.identifier(defaultRequireWrapperName),[{...t.identifier("value"),...isConfigTypescript?{typeAnnotation:t.tsTypeAnnotation(t.tSStringKeyword())}:{}}],t.blockStatement([t.returnStatement(t.callExpression(t.identifier("dirname"),[t.callExpression(t.memberExpression(t.identifier("require"),t.identifier("resolve")),[t.callExpression(t.identifier("join"),[t.identifier("value"),t.stringLiteral("package.json")])])]))])),...isConfigTypescript?{returnType:t.tSTypeAnnotation(t.tsAnyKeyword())}:{}};return t.addComment(functionDeclaration2,"leading",`*
 * This function is used to resolve the absolute path of a package.
 * It is needed in projects that use Yarn PnP or are set up within a monorepo.
`),functionDeclaration2}function wrapValueWithRequireWrapper(config,node){isRequireWrapperNecessary(node,n=>{if(t.isStringLiteral(n)){let wrapperNode=getReferenceToRequireWrapper(config,n.value);Object.keys(n).forEach(k=>{delete n[k];}),Object.keys(wrapperNode).forEach(k=>{n[k]=wrapperNode[k];});}t.isObjectProperty(n)&&t.isStringLiteral(n.value)&&(n.value=getReferenceToRequireWrapper(config,n.value.value)),t.isArrayExpression(n)&&n.elements.forEach((element,index,elements)=>{t.isStringLiteral(element)&&(elements[index]=getReferenceToRequireWrapper(config,element.value));});});}var wrapRequire={id:"wrap-require",versionRange:["<7.2.0-rc.0",">=7.2.0-rc.0"],async check({packageManager,storybookVersion,mainConfigPath}){let isStorybookInMonorepo=await packageManager.isStorybookInMonorepo(),isPnp=await detectPnp();if(!mainConfigPath)return null;let config=await readConfig(mainConfigPath);if(!isStorybookInMonorepo&&!isPnp||!getFieldsForRequireWrapper(config).some(node=>isRequireWrapperNecessary(node)))return null;let isConfigTypescript=mainConfigPath.endsWith(".ts")||mainConfigPath.endsWith(".tsx");return {storybookVersion,isStorybookInMonorepo,isPnp,isConfigTypescript}},prompt({storybookVersion,isStorybookInMonorepo}){let sbFormatted=chalk15.cyan(`Storybook ${storybookVersion}`);return dedent`We have detected that you're using ${sbFormatted} in a ${isStorybookInMonorepo?"monorepo":"PnP"} project. 
    For Storybook to work correctly, some fields in your main config must be updated. We can do this for you automatically.
    
    More info: https://storybook.js.org/docs/react/faq#how-do-i-fix-module-resolution-in-special-environments`},async run({dryRun,mainConfigPath,result}){return new Promise((resolve2,reject)=>{updateMainConfig({dryRun:!!dryRun,mainConfigPath},mainConfig=>{try{getFieldsForRequireWrapper(mainConfig).forEach(node=>{wrapValueWithRequireWrapper(mainConfig,node);}),getRequireWrapperName(mainConfig)===null&&(mainConfig?.fileName?.endsWith(".cjs")||mainConfig?.fileName?.endsWith(".cts")||mainConfig?.fileName?.endsWith(".cjsx")||mainConfig?.fileName?.endsWith(".ctsx")?mainConfig.setRequireImport(["dirname","join"],"path"):mainConfig.setImport(["dirname","join"],"path"),mainConfig.setBodyDeclaration(getRequireWrapperAsCallExpression(result.isConfigTypescript))),resolve2();}catch(e){reject(e);}});})}};var logger19=console,reactDocgen={id:"react-docgen",versionRange:["<8.0.0-alpha.1",">=8.0.0-alpha.1"],async check({mainConfig}){let{reactDocgenTypescriptOptions,reactDocgen:rDocgen}=mainConfig.typescript||{};return getRendererName(mainConfig)!=="react"||rDocgen!==void 0?null:{reactDocgenTypescriptOptions,reactDocgen:rDocgen}},prompt({reactDocgenTypescriptOptions}){return reactDocgenTypescriptOptions?dedent`
      You have "typescript.reactDocgenTypescriptOptions" configured in your main.js,
      but "typescript.reactDocgen" is unset.
      
      Since Storybook 8.0, we changed the default React docgen analysis from 
      "react-docgen-typescript" to "react-docgen". We recommend "react-docgen"
      for most projects, since it is dramatically faster. However, it doesn't
      handle all TypeScript constructs, and may generate different results
      than "react-docgen-typescript".
      
      Should we update your config to continue to use "react-docgen-typescript"?

      https://github.com/storybookjs/storybook/blob/next/MIGRATION.md#react-docgen-component-analysis-by-default
    `:dedent`
      Since Storybook 8.0, ${chalk15.cyan("react-docgen")} is now the default for generating component controls, replacing ${chalk15.cyan("react-docgen-typescript")}. 
      This offers better performance and suits most cases. 
      However, for complex TypeScript types or specific type features, the generated controls might not be as precise.
      
      For more on this change, check the migration guide: 
      ${chalk15.yellow("https://github.com/storybookjs/storybook/blob/next/MIGRATION.md#react-docgen-component-analysis-by-default")}
      
      For known "react-docgen" limitations, see: 
      ${chalk15.yellow("https://github.com/storybookjs/storybook/issues/26606")}
      
      Press Y to revert to ${chalk15.cyan("react-docgen-typescript")}, press N to use ${chalk15.cyan("react-docgen")}
    `},async run({dryRun,mainConfigPath,result}){dryRun||await updateMainConfig({mainConfigPath,dryRun:!!dryRun},async main=>{logger19.info("\u2705 Setting typescript.reactDocgen"),main.setFieldValue(["typescript","reactDocgen"],"react-docgen-typescript");});}};var minimumStorybookVersion="8.0.0-alpha.4",removeReactDependency={id:"remove-react-dependency",promptType:"manual",versionRange:[`^7 || <${minimumStorybookVersion}`,`>=${minimumStorybookVersion}`],async check({packageManager,mainConfig,storybookVersion}){let frameworkPackageName=getFrameworkPackageName(mainConfig);if(frameworkPackageName?.includes("react")||frameworkPackageName?.includes("nextjs"))return null;let{react}=await packageManager.getAllDependencies();return react?!0:null},prompt(){return dedent`
      We detected that your project has a dependency for "react" that it might not need.
      Nothing breaks by having it, you can safely ignore this message, if you wish.

      Storybook asked you to add "react" as a direct dependency in the past when upgrading from Storybook 6 to 7.
      However, since version 8.0, Storybook no longer requires you to provide "react" as a dependency.
      Some community addons might still wrongfully list "react" and "react-dom" as required peer dependencies, but since Storybook 7.6 it should not be needed in the majority of cases.
      
      If you know you are not using React outside of Storybook, it should be safe to remove the "react" and "react-dom" dependencies from your project's package.json.
      Storybook cannot do this automatically as removing it might break your project, so it should be done manually with care.
    `}};var storyshotsMigration={id:"storyshots",versionRange:["<8.0.0-alpha.0",">=8.0.0-alpha.0"],promptType:"manual",async check({mainConfig,packageManager}){return ((await packageManager.getAllDependencies())["@storybook/addon-storyshots"]||mainConfig.addons?.find(addon=>(typeof addon=="string"?addon:addon.name).includes("@storybook/addon-storyshots")))??null},prompt(){return dedent`
      ${chalk15.bold("Attention")}: Storyshots is now officially deprecated, is no longer being maintained, and was removed in Storybook 8. 
      
      We recommend following the migration guide we've prepared to help you during this transition period:
      ${chalk15.yellow("https://storybook.js.org/docs/writing-tests/storyshots-migration-guide")}
    `}};var webpack5CompilerSetup={id:"webpack5-compiler-setup",versionRange:["<8.0.0-alpha.9",">=8.0.0-alpha.9"],promptType(result){return result.isNextJs&&!result.shouldRemoveSWCFlag?"notification":"auto"},async check({mainConfig,packageManager}){if(getAddonNames(mainConfig).find(addon=>addon.includes("babel")||addon.includes("swc")))return null;let frameworkName=Object.entries(frameworkPackages).find(([name])=>name===getFrameworkPackageName(mainConfig))?.[1],builderPackageName=getBuilderPackageName(mainConfig),customCoreBuilder=builderPackageName?builderNameToCoreBuilder[builderPackageName]:null,defaultCoreBuilder=frameworkName?frameworkToDefaultBuilder[frameworkName]:await(async()=>await packageManager.getPackageVersion("webpack")?"webpack5":"vite")();if((customCoreBuilder||defaultCoreBuilder)!=="webpack5"||(frameworkName?["angular","ember"].includes(frameworkName):!1)||!!await packageManager.getPackageVersion("react-scripts"))return null;let frameworkOptions=getFrameworkOptions(mainConfig),defaultCompiler=frameworkOptions?.builder?.useSWC?"swc":"babel",shouldRemoveSWCFlag=frameworkOptions?.builder?"useSWC"in frameworkOptions.builder:!1;return frameworkName==="nextjs"?{compiler:void 0,compilerPackageName:void 0,shouldRemoveSWCFlag,isNextJs:!0}:{defaultCompiler,shouldRemoveSWCFlag,isNextJs:!1}},prompt({defaultCompiler,shouldRemoveSWCFlag,isNextJs}){let message=[];return shouldRemoveSWCFlag&&message.push(dedent`
      We need to update your Storybook configuration for Webpack 5.
      The ${chalk15.yellow("framework.options.builder.useSWC")} flag will be removed.`),isNextJs?message.push(dedent`
      Storybook now detects whether it should use Babel or SWC as a compiler by applying the same logic as Next.js itself:\n
        - If you have a ${chalk15.yellow(".babelrc")} (or ${chalk15.yellow("babel.config.js")}) file in your project, Storybook will use Babel as the compiler.
        - If you have a ${chalk15.yellow(".babelrc")} (or ${chalk15.yellow("babel.config.js")}) file in your project and you have set 
          ${chalk15.yellow("experimental.forceSwcTransforms = true")} in your ${chalk15.yellow("next.config.js")} file, 
          Storybook will use SWC as the compiler.
        - If you don't have a ${chalk15.yellow(".babelrc")} (or ${chalk15.yellow("babel.config.js")}) file in your project, Storybook will use SWC as the compiler.
      `):defaultCompiler==="babel"?message.push(dedent`
      Storybook's Webpack5 builder is now compiler agnostic, meaning you can choose a compiler addon that best fits your project:\n
        - Babel: A vast ecosystem and is battle-tested. It's a robust choice if you have an extensive Babel setup or need specific Babel plugins for your project.
        - SWC:  Fast and easy to configure. Ideal if you want faster builds and have a straightforward configuration without the need for Babel's extensibility.\n
      In the next step, Storybook will ask you to choose a compiler to automatically set it up for you.\n
      After the migration, you can switch Webpack5 compilers by swapping the addon in your project.
      You can find more information here: ${chalk15.yellow("https://storybook.js.org/docs/8.0/builders/webpack#compiler-support")}
      `):message.push(dedent`
      Storybook's Webpack5 builder is now compiler agnostic, meaning you have to install an additional addon to set up a compiler for Webpack5.\n
      We have detected, that you want to use SWC as the compiler for Webpack5.\n
      In the next step, Storybook will install @storybook/addon-webpack5-compiler-swc and will add it to your addons list in your Storybook config.\n
      After the migration, you can switch Webpack5 compilers by swapping the addon in your project.
      You can find more information here: ${chalk15.yellow("https://storybook.js.org/docs/8.0/builders/webpack#compiler-support")}
      `),message.join(`

`)},async run({result,mainConfigPath,packageManager,skipInstall,dryRun}){let{defaultCompiler,shouldRemoveSWCFlag,isNextJs}=result;if(shouldRemoveSWCFlag&&await updateMainConfig({mainConfigPath,dryRun:!!dryRun},main=>{main.removeField(["framework","options","builder","useSWC"]);}),!isNextJs){let compiler=defaultCompiler==="babel"?await askUserForCompilerChoice():"swc",compilerPackageName=Object.entries(compilerNameToCoreCompiler).find(([,coreCompiler])=>coreCompiler===compiler)[0];await add(compilerPackageName,{packageManager:packageManager.type,skipPostinstall:!!skipInstall});}}};async function askUserForCompilerChoice(){return (await prompts5({type:"select",name:"compiler",message:"Which compiler would you like to use?",choices:[{title:"Babel",description:"Choose Babel for a vast ecosystem and battle-tested reliability.",value:"babel"},{title:"SWC",description:"Choose SWC for fast builds and simple configuration.",value:"swc"}],initial:0})).compiler}var addonsAPI={id:"addons-api",versionRange:["<8",">=8"],promptType:"notification",async check({packageManager}){return !(await packageManager.getAllDependencies())["@storybook/addons"]?null:{usesAddonsAPI:!0}},prompt(){return dedent`
      ${chalk15.bold("Attention")}: We've detected that you're using the following package which is removed in Storybook 8 and beyond:

      - ${chalk15.cyan("@storybook/addons")}
      
      This package has been deprecated and replaced with ${chalk15.cyan("@storybook/preview-api")} and ${chalk15.cyan("@storybook/manager-api")}.

      You can find more information about the new addons API in the migration guide:
      ${chalk15.yellow("https://github.com/storybookjs/storybook/blob/next/MIGRATION.md#new-addons-api")}
    `}};var MDX1_STYLE_START=/<style>{`/g,MDX1_STYLE_END=/`}<\/style>/g,MDX1_COMMENT=/<!--(.+)-->/g,MDX1_CODEBLOCK=/(?:\n~~~(?:\n|.)*?\n~~~)|(?:\n```(?:\n|.)*?\n```)/g,fixMdxStyleTags=mdx=>mdx.replace(MDX1_STYLE_START,"<style>\n  {`").replace(MDX1_STYLE_END,"  `}\n</style>"),fixMdxComments=mdx=>{let codeblocks=mdx.matchAll(MDX1_CODEBLOCK);return mdx.split(MDX1_CODEBLOCK).map(v=>v.replace(MDX1_COMMENT,(original,group)=>`{/*${group}*/}`)).reduce((acc,item,i)=>{let next=codeblocks.next();return next.done?acc+item:acc+item+next.value[0]},"")},logger20=console,mdx1to3={id:"mdx1to3",versionRange:["<7.0.0",">=8.0.0-alpha.0"],async check(){let{globby}=await import('globby'),storiesMdxFiles=await globby("./!(node_modules)**/*.(story|stories).mdx");return storiesMdxFiles.length?{storiesMdxFiles}:null},prompt({storiesMdxFiles}){return dedent`
      We've found ${chalk15.yellow(storiesMdxFiles.length)} '.stories.mdx' files in your project.
      
      Storybook has upgraded to MDX3 (https://mdxjs.com/blog/v3/). MDX3 itself doesn't contain disruptive breaking changes, whereas the transition from MDX1 to MDX2 was a significant change.
      We can try to automatically upgrade your MDX files to MDX3 format using some common patterns.
      
      After this install completes, and before you start Storybook, we strongly recommend reading the MDX2 section
      of the 7.0 migration guide. It contains useful tools for detecting and fixing any remaining issues.
      
      ${chalk15.cyan("https://storybook.js.org/migration-guides/7.0")}
    `},async run({result:{storiesMdxFiles},dryRun}){await Promise.all([...storiesMdxFiles.map(async fname=>{let contents=await fse.readFile(fname,"utf-8"),updated=fixMdxComments(fixMdxStyleTags(contents));updated===contents?logger20.info(`\u{1F197} Unmodified ${basename(fname)}`):(logger20.info(`\u2705 Modified ${basename(fname)}`),dryRun||await fse.writeFile(fname,updated));})]);}};var addonPostCSS={id:"addon-postcss",versionRange:["<7",">=7"],promptType:"notification",async check({mainConfig}){return !getAddonNames(mainConfig).find(addon=>addon.includes("@storybook/addon-postcss"))?null:{hasAddonPostcss:!0}},prompt(){return dedent`
      ${chalk15.bold("Attention")}: We've detected that you're using the following package which is incompatible with Storybook 8 and beyond:

      - ${chalk15.cyan("@storybook/addon-postcss")}
      
      Please migrate to ${chalk15.cyan("@storybook/addon-styling-webpack")} once you're done upgrading.
    `}};var logger21=console,vta={id:"visual-tests-addon",versionRange:["<8.0.7",">=8.0.7"],async check({mainConfig}){return getAddonNames(mainConfig).some(addon=>addon.includes("@chromatic-com/storybook"))?null:{}},prompt(){return dedent`
      New to Storybook 8: Storybook's Visual Tests addon helps you catch unintentional changes/bugs in your stories. The addon is powered by Chromatic, a cloud-based testing tool developed by Storybook's core team.

      Learn more: ${chalk15.yellow("https://storybook.js.org/docs/writing-tests/visual-testing")}
      
      Install Visual Tests addon in your project?
    `},async run({packageManager,dryRun,mainConfigPath,skipInstall}){if(!dryRun){let packageJson=await packageManager.retrievePackageJson();await packageManager.addDependencies({installAsDevDependencies:!0,skipInstall,packageJson},["@chromatic-com/storybook@^1"]),await updateMainConfig({mainConfigPath,dryRun:!!dryRun},async main=>{logger21.info('\u2705 Adding "@chromatic-com/storybook" addon'),main.appendValueToArray(["addons"],"@chromatic-com/storybook");});}}};var checkPackageCompatibility=async(dependency,context)=>{let{currentStorybookVersion,skipErrors,packageManager}=context;try{let dependencyPackageJson=await packageManager.getPackageJSON(dependency);if(dependencyPackageJson===null)return {packageName:dependency};let{version:packageVersion,name=dependency,dependencies,peerDependencies,homepage}=dependencyPackageJson,hasIncompatibleDependencies=!!Object.entries({...dependencies,...peerDependencies}).filter(([dep])=>versions[dep]).find(([_,versionRange])=>versionRange&&semver.validRange(versionRange)&&!semver.satisfies(currentStorybookVersion,versionRange)),isCorePackage3=versions[name],availableUpdate;return isCorePackage3&&semver.gt(currentStorybookVersion,packageVersion)&&(availableUpdate=currentStorybookVersion),{packageName:name,packageVersion,homepage,hasIncompatibleDependencies,availableUpdate}}catch(err){return skipErrors||console.log(`Error checking compatibility for ${dependency}, please report an issue:
`,err),{packageName:dependency}}},getIncompatibleStorybookPackages=async context=>{let packageManager=context.packageManager??JsPackageManagerFactory.getPackageManager(),allDeps=await packageManager.getAllDependencies(),storybookLikeDeps=Object.keys(allDeps).filter(dep=>dep.includes("storybook"));if(storybookLikeDeps.length===0&&!context.skipErrors)throw new Error("No Storybook dependencies found in the package.json");return Promise.all(storybookLikeDeps.map(dep=>checkPackageCompatibility(dep,{...context,packageManager})))},getIncompatiblePackagesSummary=(dependencyAnalysis,currentStorybookVersion)=>{let summaryMessage=[],incompatiblePackages=dependencyAnalysis.filter(dep=>dep.hasIncompatibleDependencies);return incompatiblePackages.length>0&&(summaryMessage.push(`The following packages are incompatible with Storybook ${chalk15.bold(currentStorybookVersion)} as they depend on different major versions of Storybook packages:`),incompatiblePackages.forEach(({packageName:addonName,packageVersion:addonVersion,homepage,availableUpdate})=>{let packageDescription=`${chalk15.cyan(addonName)}@${chalk15.cyan(addonVersion)}`,updateMessage=availableUpdate?` (${availableUpdate} available!)`:"",packageRepo=homepage?`
 Repo: ${chalk15.yellow(homepage)}`:"";summaryMessage.push(`- ${packageDescription}${updateMessage}${packageRepo}`);}),summaryMessage.push(`
`,"Please consider updating your packages or contacting the maintainers for compatibility details.","For more on Storybook 8 compatibility, see the linked GitHub issue:",chalk15.yellow("https://github.com/storybookjs/storybook/issues/26031"))),summaryMessage.join(`
`)};async function getLatestVersions(packageManager,packages){return Promise.all(packages.map(async([packageName])=>({packageName,beforeVersion:await packageManager.getInstalledVersion(packageName).catch(()=>null),afterVersion:await packageManager.latestVersion(packageName).catch(()=>null)})))}var upgradeStorybookRelatedDependencies={id:"upgradeStorybookRelatedDependencies",versionRange:["*.*.*","*.*.*"],promptType:"auto",promptDefaultValue:!1,async check({packageManager,storybookVersion}){let analyzedPackages=await getIncompatibleStorybookPackages({currentStorybookVersion:storybookVersion,packageManager,skipErrors:!0}),allDependencies=await packageManager.getAllDependencies(),storybookDependencies=Object.keys(allDependencies).filter(dep=>dep.includes("storybook")).filter(dep=>!isCorePackage(dep)),incompatibleDependencies=analyzedPackages.filter(pkg=>pkg.hasIncompatibleDependencies).map(pkg=>pkg.packageName),uniquePackages=Array.from(new Set([...storybookDependencies,...incompatibleDependencies])).map(packageName=>[packageName,allDependencies[packageName]]),upgradablePackages=(await getLatestVersions(packageManager,uniquePackages)).filter(({afterVersion,beforeVersion})=>beforeVersion===null||afterVersion===null?!1:gt(afterVersion,beforeVersion));return upgradablePackages.length>0?{upgradable:upgradablePackages}:null},prompt({upgradable}){return dedent`
      You're upgrading to the latest version of Storybook. We recommend upgrading the following packages:
      ${upgradable.map(({packageName,afterVersion,beforeVersion})=>`- ${cyan(packageName)}: ${cyan(beforeVersion)} => ${cyan(afterVersion)}`).join(`
`)}

      After upgrading, we will run the dedupe command, which could possibly have effects on dependencies that are not Storybook related.
      see: https://docs.npmjs.com/cli/commands/npm-dedupe

      Do you want to proceed (upgrade the detected packages)?
    `},async run({result:{upgradable},packageManager,dryRun}){if(dryRun){console.log(dedent`
        We would have upgrade the following:
        ${upgradable.map(({packageName,afterVersion,beforeVersion})=>`${packageName}: ${beforeVersion} => ${afterVersion}`).join(`
`)}
      `);return}if(upgradable.length>0){let packageJson=await packageManager.readPackageJson();upgradable.forEach(item=>{if(!item)return;let{packageName,afterVersion:version}=item,prefixed=`^${version}`;packageJson.dependencies?.[packageName]&&(packageJson.dependencies[packageName]=prefixed),packageJson.devDependencies?.[packageName]&&(packageJson.devDependencies[packageName]=prefixed),packageJson.peerDependencies?.[packageName]&&(packageJson.peerDependencies[packageName]=prefixed);}),await packageManager.writePackageJson(packageJson),await packageManager.installDependencies(),await packageManager.executeCommand({command:"dedupe",args:[],stdio:"ignore"}).catch(()=>{}),console.log(),console.log(dedent`
        We upgraded ${yellow(upgradable.length)} packages:
        ${upgradable.map(({packageName,afterVersion,beforeVersion})=>`- ${cyan(packageName)}: ${cyan(beforeVersion)} => ${cyan(afterVersion)}`).join(`
`)}
        `);}console.log();}};var logger22=console,MIGRATION="https://github.com/storybookjs/storybook/blob/next/MIGRATION.md#mainjs-docsautodocs-is-deprecated",autodocsTags={id:"autodocs-tags",versionRange:["*.*.*",">=8.0.*"],async check({mainConfig,mainConfigPath,previewConfigPath}){let autodocs=mainConfig?.docs?.autodocs;if(autodocs===void 0)return null;if(autodocs===!0&&!previewConfigPath)throw Error(dedent`
        ❌ Failed to remove the deprecated ${chalk15.cyan("docs.autodocs")} setting from ${chalk15.cyan(mainConfigPath)}.
        
        There is no preview config file in which to add the ${chalk15.cyan("autodocs")} tag.

        Please perform the migration by hand: ${chalk15.yellow(MIGRATION)}
      `);return {autodocs,mainConfigPath,previewConfigPath}},prompt({autodocs,mainConfigPath,previewConfigPath}){let falseMessage="",trueMessage="";return autodocs===!1?falseMessage=dedent`


        There is no ${chalk15.cyan("docs.autodocs = false")} equivalent.
        You'll need to check your stories to ensure none are tagged with ${chalk15.cyan("autodocs")}.
      `:autodocs===!0&&(trueMessage=` and update ${chalk15.cyan(previewConfigPath)}`),dedent`
      The ${chalk15.cyan("docs.autodocs")} setting in ${chalk15.cyan(mainConfigPath)} is deprecated.${falseMessage}
        
      Learn more: ${chalk15.yellow(MIGRATION)}
      
      Remove ${chalk15.cyan("docs.autodocs")}${trueMessage}?
    `},async run({dryRun,mainConfigPath,result}){if(!dryRun){if(result.autodocs===!0){logger22.info(`\u2705 Adding "autodocs" tag to ${result.previewConfigPath}`);let previewConfig=await readConfig(result.previewConfigPath);previewConfig.getFieldNode(["tags"])?previewConfig.appendValueToArray(["tags"],"autodocs"):previewConfig.setFieldValue(["tags"],["autodocs"]),await writeConfig(previewConfig);}await updateMainConfig({mainConfigPath,dryRun:!!dryRun},async main=>{logger22.info(`\u2705 Removing "docs.autodocs" from ${mainConfigPath}`),main.removeField(["docs","autodocs"]);});}}};var MIGRATION2="https://github.com/storybookjs/storybook/blob/next/MIGRATION.md#previewjs-globals-renamed-to-initialglobals",initialGlobals={id:"initial-globals",versionRange:["*.*.*",">=8.0.*"],async check({previewConfigPath}){if(!previewConfigPath)return null;let previewConfig=loadConfig((await readFile$1(previewConfigPath)).toString()).parse(),globals=previewConfig.getFieldNode(["globals"]);return globals?{globals,previewConfig,previewConfigPath}:null},prompt({previewConfigPath}){return dedent`
      The ${chalk15.cyan("globals")} setting in ${chalk15.cyan(previewConfigPath)} is deprecated
      and has been renamed to ${chalk15.cyan("initialGlobals")}.
        
      Learn more: ${chalk15.yellow(MIGRATION2)}
      
      Rename ${chalk15.cyan("globals")} to ${chalk15.cyan("initalGlobals")}?
    `},async run({dryRun,result}){result.previewConfig.removeField(["globals"]),result.previewConfig.setFieldNode(["initialGlobals"],result.globals),dryRun||await writeFile(result.previewConfigPath,formatConfig(result.previewConfig));}};var allFixes=[addonsAPI,newFrameworks,cra5,webpack5,vue3,addonPostCSS,viteConfigFile,eslintPlugin,builderVite,sbBinary,sbScripts,removedGlobalClientAPIs,mdxgfm,autodocsTrue,angularBuildersMultiproject,angularBuilders,wrapRequire,reactDocgen,storyshotsMigration,removeReactDependency,removeLegacyMDX1,webpack5CompilerSetup,mdx1to3,upgradeStorybookRelatedDependencies,vta,autodocsTags,initialGlobals];var ansiRegex2=({onlyFirst=!1}={})=>{let pattern=["[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)","(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))"].join("|");return new RegExp(pattern,onlyFirst?void 0:"g")},cleanLog=str=>str.replace(ansiRegex2(),"").replace(/╮│/g,`\u256E
\u2502`).replace(/││/g,`\u2502
\u2502`).replace(/│╰/g,`\u2502
\u2570`).replace(/⚠️ {2}failed to check/g,`${EOL}\u26A0\uFE0F  failed to check`);var messageDivider=`

`,segmentDivider=`

\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500

`;function getGlossaryMessages(fixSummary,fixResults,logFile){let messages=[];return fixSummary.succeeded.length>0&&(messages.push(chalk15.bold("Successful migrations:")),messages.push(fixSummary.succeeded.map(m=>chalk15.green(m)).join(", "))),Object.keys(fixSummary.failed).length>0&&(messages.push(chalk15.bold("Failed migrations:")),messages.push(Object.entries(fixSummary.failed).map(([id,error])=>`${chalk15.redBright(id)}:
${error}`).join(`
`)),messages.push(`You can find the full logs in ${chalk15.cyan(logFile)}`)),fixSummary.manual.length>0&&(messages.push(chalk15.bold("Manual migrations:")),messages.push(fixSummary.manual.map(m=>fixResults[m]==="manual_succeeded"?chalk15.green(m):chalk15.blue(m)).join(", "))),fixSummary.skipped.length>0&&(messages.push(chalk15.bold("Skipped migrations:")),messages.push(fixSummary.skipped.map(m=>chalk15.cyan(m)).join(", "))),messages}function getMigrationSummary({fixResults,fixSummary,logFile,installationMetadata}){let messages=[];messages.push(getGlossaryMessages(fixSummary,fixResults,logFile).join(messageDivider)),messages.push(dedent`If you'd like to run the migrations again, you can do so by running '${chalk15.cyan("npx storybook automigrate")}'
    
    The automigrations try to migrate common patterns in your project, but might not contain everything needed to migrate to the latest version of Storybook.
    
    Please check the changelog and migration guide for manual migrations and more information: ${chalk15.yellow("https://storybook.js.org/docs/8.0/migration-guide")}
    And reach out on Discord if you need help: ${chalk15.yellow("https://discord.gg/storybook")}
  `);let hasNoFixes=Object.values(fixResults).every(r=>r==="unnecessary"),hasFailures=Object.values(fixResults).some(r=>r==="failed"||r==="check_failed"),title=hasNoFixes?"No migrations were applicable to your project":hasFailures?"Migration check ran with failures":"Migration check ran successfully";return boxen(messages.filter(Boolean).join(segmentDivider),{borderStyle:"round",padding:1,title,borderColor:hasFailures?"red":"green"})}function getPrimaryVersion(name,installationMetadata){if(!name)return;let packageMetadata=installationMetadata?.dependencies[name];if(packageMetadata)return packageMetadata[0]?.version}function getMismatchingVersionsWarnings(installationMetadata,allDependencies){if(!installationMetadata)return;let messages=[];try{let frameworkPackageName=Object.keys(installationMetadata?.dependencies||[]).find(packageName=>Object.keys(frameworkPackages).includes(packageName)),cliVersion=getPrimaryVersion("storybook",installationMetadata),frameworkVersion=getPrimaryVersion(frameworkPackageName,installationMetadata);if(!cliVersion||!frameworkVersion||semver.eq(cliVersion,frameworkVersion))return;messages.push(`${chalk15.bold("Attention:")} There seems to be a mismatch between your Storybook package versions. This can result in a broken Storybook installation.`);let versionToCompare,packageToDisplay;semver.lt(cliVersion,frameworkVersion)?(versionToCompare=frameworkVersion,packageToDisplay=frameworkPackageName):(versionToCompare=cliVersion,packageToDisplay="storybook"),messages.push(`The version of your storybook core packages should align with ${chalk15.yellow(versionToCompare)} (from the ${chalk15.cyan(packageToDisplay)} package) or higher.`);let filteredDependencies=Object.entries(installationMetadata?.dependencies||[]).filter(([name,packages])=>Object.keys(versions).includes(name)?packages[0].version!==versionToCompare:!1);if(filteredDependencies.length>0){let packageJsonSuffix="(in your package.json)";messages.push("Based on your lockfile, these dependencies should be aligned:",filteredDependencies.map(([name,dep])=>`${chalk15.hex("#ff9800")(name)}: ${dep[0].version} ${allDependencies?.[name]?packageJsonSuffix:""}`).sort((a,b)=>(b.includes(packageJsonSuffix)?1:0)-(a.includes(packageJsonSuffix)?1:0)).join(`
`));}return messages.push(`You can run ${chalk15.cyan("npx storybook@latest upgrade")} to upgrade all of your Storybook packages to the latest version.

      Alternatively you can try manually changing the versions to match in your package.json. We also recommend regenerating your lockfile, or running the following command to possibly deduplicate your Storybook package versions: ${chalk15.cyan(installationMetadata?.dedupeCommand)}`),messages.join(`

`)}catch{return}}function hasMultipleVersions(versions7){return versions7.find(v=>{let major=semver.major(v);if(major===0){let minor=semver.minor(v);if(minor===0){let patch=semver.patch(v);return versions7.some(v2=>semver.patch(v2)!==patch)}return versions7.some(v2=>semver.minor(v2)!==minor)}return versions7.some(v2=>semver.major(v2)!==major)})}var messageDivider2=`

`,allowList=["@storybook/csf","@storybook/addons","@storybook/channel-postmessage","@storybook/channel-websocket","@storybook/client-api","@storybook/core-client","@storybook/preview-web","@storybook/store","@storybook/components","@storybook/router","@storybook/theming","@storybook/api","@storybook/manager-api"],disallowList=[Object.keys(rendererPackages),Object.keys(frameworkPackages),"storybook","@storybook/instrumenter","@storybook/core","@storybook/core-server","@storybook/manager","@storybook/preview"];function getDuplicatedDepsWarnings(installationMetadata){try{if(!installationMetadata||!installationMetadata?.duplicatedDependencies||Object.keys(installationMetadata.duplicatedDependencies).length===0)return;let messages=[],{critical,trivial}=Object.entries(installationMetadata?.duplicatedDependencies).reduce((acc,[dep,packageVersions2])=>{if(allowList.includes(dep))return acc;let hasMultipleMajorVersions=hasMultipleVersions(packageVersions2);return disallowList.includes(dep)&&hasMultipleMajorVersions?acc.critical.push(`${chalk15.redBright(dep)}:
${packageVersions2.join(", ")}`):acc.trivial.push(`${chalk15.hex("#ff9800")(dep)}:
${packageVersions2.join(", ")}`),acc},{critical:[],trivial:[]});return critical.length===0&&trivial.length===0||(critical.length>0&&(messages.push(`${chalk15.bold("Critical:")} The following dependencies are duplicated and WILL cause unexpected behavior:`),messages.push(critical.join(messageDivider2),`
`)),trivial.length>0&&(messages.push(`${chalk15.bold("Attention:")} The following dependencies are duplicated which might cause unexpected behavior:`),messages.push(trivial.join(messageDivider2))),messages.push(`
`,`Please try de-duplicating these dependencies by running ${chalk15.cyan(`${installationMetadata.dedupeCommand}`)}`),messages.push(`
`,`You can find more information for a given dependency by running ${chalk15.cyan(`${installationMetadata.infoCommand} <package-name>`)}`)),messages}catch{return}}var logger23=console,LOG_FILE_NAME="doctor-storybook.log",LOG_FILE_PATH=join(process.cwd(),LOG_FILE_NAME),TEMP_LOG_FILE_PATH="",originalStdOutWrite=process.stdout.write.bind(process.stdout),originalStdErrWrite=process.stderr.write.bind(process.stdout),augmentLogsToFile=async()=>{let{temporaryFile}=await import('tempy');TEMP_LOG_FILE_PATH=temporaryFile({name:LOG_FILE_NAME});let logStream=createWriteStream(TEMP_LOG_FILE_PATH);process.stdout.write=d=>(originalStdOutWrite(d),logStream.write(cleanLog(d))),process.stderr.write=d=>logStream.write(cleanLog(d));},cleanup=()=>{process.stdout.write=originalStdOutWrite,process.stderr.write=originalStdErrWrite;},doctor=async({configDir:userSpecifiedConfigDir,packageManager:pkgMgr}={})=>{await augmentLogsToFile();let foundIssues=!1,logDiagnostic=(title,message)=>{foundIssues=!0,logger23.info(boxen(message,{borderStyle:"round",padding:1,title,borderColor:"#F1618C"}));};logger23.info("\u{1FA7A} The doctor is checking the health of your Storybook..");let packageManager=JsPackageManagerFactory.getPackageManager({force:pkgMgr}),storybookVersion,mainConfig;try{let storybookData=await getStorybookData({configDir:userSpecifiedConfigDir,packageManager});storybookVersion=storybookData.storybookVersion,mainConfig=storybookData.mainConfig;}catch(err){err.message.includes("No configuration files have been found")&&logger23.info(dedent`[Storybook doctor] Could not find or evaluate your Storybook main.js config directory at ${chalk15.blue(userSpecifiedConfigDir||".storybook")} so the doctor command cannot proceed. You might be running this command in a monorepo or a non-standard project structure. If that is the case, please rerun this command by specifying the path to your Storybook config directory via the --config-dir option.`),logger23.info(dedent`[Storybook doctor] ❌ ${err.message}`),logger23.info("Please fix the error and try again.");}if(storybookVersion||(logger23.info(dedent`
      [Storybook doctor] ❌ Unable to determine Storybook version so the command will not proceed.
      🤔 Are you running storybook doctor from your project directory? Please specify your Storybook config directory with the --config-dir flag.
      `),process.exit(1)),!mainConfig)throw new Error("mainConfig is undefined");let allDependencies=await packageManager.getAllDependencies(),incompatibleStorybookPackagesList=await getIncompatibleStorybookPackages({currentStorybookVersion:storybookVersion}),incompatiblePackagesMessage=getIncompatiblePackagesSummary(incompatibleStorybookPackagesList,storybookVersion);incompatiblePackagesMessage&&logDiagnostic("Incompatible packages found",incompatiblePackagesMessage);let installationMetadata=await packageManager.findInstallations(["@storybook/*","storybook"]);if(!incompatiblePackagesMessage){let mismatchingVersionMessage=getMismatchingVersionsWarnings(installationMetadata,allDependencies);if(mismatchingVersionMessage)logDiagnostic("Diagnostics",[mismatchingVersionMessage].join(`

-------

`));else {let list=installationMetadata?getDuplicatedDepsWarnings(installationMetadata):getDuplicatedDepsWarnings();Array.isArray(list)&&list.length>0&&logDiagnostic("Duplicated dependencies found",list?.join(`
`));}}let commandMessage=`You can always recheck the health of your project by running:
${chalk15.cyan("npx storybook doctor")}`;logger23.info(),foundIssues?(logger23.info(commandMessage),logger23.info(),logger23.info(`Full logs are available in ${chalk15.cyan(LOG_FILE_PATH)}`),await move(TEMP_LOG_FILE_PATH,join(process.cwd(),LOG_FILE_NAME),{overwrite:!0})):(logger23.info("\u{1F973} Your Storybook project looks good!"),logger23.info(commandMessage),await remove(TEMP_LOG_FILE_PATH)),logger23.info(),cleanup();};var logger24=console,LOG_FILE_NAME2="migration-storybook.log",LOG_FILE_PATH2=join(process.cwd(),LOG_FILE_NAME2),TEMP_LOG_FILE_PATH2="",originalStdOutWrite2=process.stdout.write.bind(process.stdout),originalStdErrWrite2=process.stderr.write.bind(process.stdout),augmentLogsToFile2=async()=>{let{temporaryFile}=await import('tempy');TEMP_LOG_FILE_PATH2=temporaryFile({name:LOG_FILE_NAME2});let logStream=createWriteStream(TEMP_LOG_FILE_PATH2);process.stdout.write=d=>(originalStdOutWrite2(d),logStream.write(cleanLog(d))),process.stderr.write=d=>logStream.write(cleanLog(d));},cleanup2=()=>{process.stdout.write=originalStdOutWrite2,process.stderr.write=originalStdErrWrite2;},logAvailableMigrations=()=>{let availableFixes=allFixes.map(f=>chalk15.yellow(f.id)).map(x=>`- ${x}`).join(`
`);console.log(),logger24.info(dedent`
    The following migrations are available:
    ${availableFixes}
  `);};var automigrate=async({fixId,fixes:inputFixes,dryRun,yes,packageManager,list,configDir,mainConfigPath,storybookVersion,beforeVersion,renderer:rendererPackage,skipInstall,hideMigrationSummary=!1,isUpgrade,isLatest})=>{if(list)return logAvailableMigrations(),null;let selectedFixes=inputFixes||allFixes.filter(fix=>!(fix.id===upgradeStorybookRelatedDependencies.id&&isLatest===!1&&fixId!==upgradeStorybookRelatedDependencies.id)),fixes=fixId?selectedFixes.filter(f=>f.id===fixId):selectedFixes;if(fixId&&fixes.length===0)return logger24.info(`\u{1F4ED} No migrations found for ${chalk15.magenta(fixId)}.`),logAvailableMigrations(),null;await augmentLogsToFile2(),logger24.info("\u{1F50E} checking possible migrations..");let{fixResults,fixSummary,preCheckFailure}=await runFixes({fixes,packageManager,rendererPackage,skipInstall,configDir,mainConfigPath,storybookVersion,beforeVersion,isUpgrade:!!isUpgrade,dryRun,yes});if(Object.values(fixResults).some(r=>r==="failed"||r==="check_failed")?await move(TEMP_LOG_FILE_PATH2,join(process.cwd(),LOG_FILE_NAME2),{overwrite:!0}):await remove(TEMP_LOG_FILE_PATH2),!hideMigrationSummary){let installationMetadata=await packageManager.findInstallations(["@storybook/*","storybook"]);logger24.info(),logger24.info(getMigrationSummary({fixResults,fixSummary,logFile:LOG_FILE_PATH2,installationMetadata})),logger24.info();}return cleanup2(),{fixResults,preCheckFailure}};async function runFixes({fixes,dryRun,yes,rendererPackage,skipInstall,configDir,packageManager,mainConfigPath,storybookVersion,beforeVersion,isUpgrade}){let fixResults={},fixSummary={succeeded:[],failed:{},manual:[],skipped:[]};for(let i=0;i<fixes.length;i+=1){let f=fixes[i],result;try{let{mainConfig,previewConfigPath}=await getStorybookData({configDir,packageManager});(isUpgrade&&semver.satisfies(beforeVersion,f.versionRange[0],{includePrerelease:!0})&&semver.satisfies(storybookVersion,f.versionRange[1],{includePrerelease:!0})||!isUpgrade)&&(result=await f.check({packageManager,configDir,rendererPackage,mainConfig,storybookVersion,previewConfigPath,mainConfigPath}));}catch(error){logger24.info(`\u26A0\uFE0F  failed to check fix ${chalk15.bold(f.id)}`),error instanceof Error&&(logger24.error(`
${error.stack}`),fixSummary.failed[f.id]=error.message),fixResults[f.id]="check_failed";}if(result){let promptType=typeof f.promptType=="function"?await f.promptType(result):f.promptType??"auto";logger24.info(`
\u{1F50E} found a '${chalk15.cyan(f.id)}' migration:`);let message=f.prompt(result),getTitle=()=>{switch(promptType){case"auto":return "Automigration detected";case"manual":return "Manual migration detected";case"notification":return "Migration notification"}};logger24.info(boxen(message,{borderStyle:"round",padding:1,borderColor:"#F1618C",title:getTitle()}));let runAnswer;try{if(dryRun)runAnswer={fix:!1};else if(yes)runAnswer={fix:!0},promptType==="manual"&&(fixResults[f.id]="manual_succeeded",fixSummary.manual.push(f.id));else if(promptType==="manual"){fixResults[f.id]="manual_succeeded",fixSummary.manual.push(f.id),logger24.info();let{shouldContinue}=await prompts5({type:"toggle",name:"shouldContinue",message:"Select continue once you have made the required changes, or quit to exit the migration process",initial:!0,active:"continue",inactive:"quit"},{onCancel:()=>{throw new Error}});if(!shouldContinue){fixResults[f.id]="manual_skipped";break}}else promptType==="auto"?runAnswer=await prompts5({type:"confirm",name:"fix",message:`Do you want to run the '${chalk15.cyan(f.id)}' migration on your project?`,initial:f.promptDefaultValue??!0},{onCancel:()=>{throw new Error}}):promptType==="notification"&&(runAnswer=await prompts5({type:"confirm",name:"fix",message:"Do you want to continue?",initial:!0},{onCancel:()=>{throw new Error}}));}catch{break}if(promptType==="auto")if(invariant5(runAnswer,"runAnswer must be defined if not promptOnly"),runAnswer.fix)try{invariant5(typeof f.run=="function","run method should be available in fix."),invariant5(mainConfigPath,"Main config path should be defined to run migration."),await f.run({result,packageManager,dryRun,mainConfigPath,skipInstall}),logger24.info(`\u2705 ran ${chalk15.cyan(f.id)} migration`),fixResults[f.id]="succeeded",fixSummary.succeeded.push(f.id);}catch(error){fixResults[f.id]="failed",fixSummary.failed[f.id]=error instanceof Error?error.message:"Failed to run migration",logger24.info(`\u274C error when running ${chalk15.cyan(f.id)} migration`),logger24.info(error),logger24.info();}else fixResults[f.id]="skipped",fixSummary.skipped.push(f.id);}else fixResults[f.id]=fixResults[f.id]||"unnecessary";}return {fixResults,fixSummary}}var excludesFalse=x=>x!==!1,blockers=()=>[import('./block-storystorev6-AAXLZAKE.js'),import('./block-dependencies-versions-NU5EBUEM.js'),import('./block-node-version-JHQUZHQA.js')],segmentDivider2=`

\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500

`,autoblock=async(options,list=blockers())=>{if(list.length===0)return null;logger.info("Checking for upgrade blockers...");let faults=(await Promise.all(list.map(async i=>{let{blocker}=await i,result=await blocker.check(options);return result?{id:blocker.id,value:!0,log:blocker.log(options,result)}:!1}))).filter(excludesFalse);if(faults.length>0){let messages={welcome:"Storybook has found potential blockers in your project that need to be resolved before upgrading:",reminder:chalk15.yellow("Fix the above issues and try running the upgrade command again.")};return logger.plain(boxen([messages.welcome].concat([`

`]).concat([faults.map(i=>i.log).join(segmentDivider2)]).concat([segmentDivider2,messages.reminder]).join(""),{borderStyle:"round",padding:1,borderColor:"#FC521F"})),faults[0].id}return logger.plain("No blockers found."),logger.line(),null};var versionRegex=/(@storybook\/[^@]+)@(\S+)/,getStorybookVersion=line=>{if(line.startsWith("npm "))return null;let match=versionRegex.exec(line);return !match||!semver.clean(match[2])?null:{package:match[1],version:match[2]}},getInstalledStorybookVersion=async packageManager=>{let installations=await packageManager.findInstallations(Object.keys(versions));if(installations)return Object.entries(installations.dependencies)[0]?.[1]?.[0].version},deprecatedPackages=[{minVersion:"6.0.0-alpha.0",url:"https://github.com/storybookjs/storybook/blob/next/MIGRATION.md#60-deprecations",deprecations:["@storybook/addon-notes","@storybook/addon-info","@storybook/addon-contexts","@storybook/addon-options","@storybook/addon-centered"]}],formatPackage=pkg=>`${pkg.package}@${pkg.version}`,warnPackages=pkgs=>pkgs.forEach(pkg=>logger.warn(`- ${formatPackage(pkg)}`)),checkVersionConsistency=()=>{let storybookPackages=sync("npm",["ls"],{stdio:"pipe",shell:!0}).output.toString().split(`
`).map(getStorybookVersion).filter(item=>!!item).filter(pkg=>isCorePackage(pkg.package));if(!storybookPackages.length){logger.warn("No storybook core packages found."),logger.warn("'npm ls | grep storybook' can show if multiple versions are installed.");return}storybookPackages.sort((a,b)=>semver.rcompare(a.version,b.version));let latestVersion=storybookPackages[0].version,outdated=storybookPackages.filter(pkg=>pkg.version!==latestVersion);outdated.length>0&&(logger.warn(`Found ${outdated.length} outdated packages (relative to '${formatPackage(storybookPackages[0])}')`),logger.warn("Please make sure your packages are updated to ensure a consistent experience."),warnPackages(outdated)),deprecatedPackages.forEach(({minVersion:minVersion2,url,deprecations})=>{if(semver.gte(latestVersion,minVersion2)){let deprecated=storybookPackages.filter(pkg=>deprecations.includes(pkg.package));deprecated.length>0&&(logger.warn(`Found ${deprecated.length} deprecated packages since ${minVersion2}`),logger.warn(`See ${url}`),warnPackages(deprecated));}});},doUpgrade=async({skipCheck,packageManager:packageManagerName,dryRun,configDir:userSpecifiedConfigDir,yes,...options})=>{let packageManager=JsPackageManagerFactory.getPackageManager({force:packageManagerName}),beforeVersion=await getInstalledStorybookVersion(packageManager)??"0.0.0",currentCLIVersion=versions.storybook,isCanary=currentCLIVersion.startsWith("0.0.0")||beforeVersion.startsWith("portal:")||beforeVersion.startsWith("workspace:");if(!await hasStorybookDependencies(packageManager))throw new UpgradeStorybookInWrongWorkingDirectory;if(!isCanary&&lt(currentCLIVersion,beforeVersion))throw new UpgradeStorybookToLowerVersionError({beforeVersion,currentVersion:currentCLIVersion});!isCanary&&eq(currentCLIVersion,beforeVersion)&&logger.warn(new UpgradeStorybookToSameVersionError({beforeVersion}).message);let[latestCLIVersionOnNPM,packageJson]=await Promise.all([packageManager.latestVersion("storybook"),packageManager.retrievePackageJson()]),isCLIOutdated=lt(currentCLIVersion,latestCLIVersionOnNPM),isCLIExactLatest=currentCLIVersion===latestCLIVersionOnNPM,isCLIPrerelease=prerelease(currentCLIVersion)!==null,isUpgrade=lt(beforeVersion,currentCLIVersion),borderColor=isCLIOutdated?"#FC521F":"#F1618C",messages={welcome:`Upgrading Storybook from version ${chalk15.bold(beforeVersion)} to version ${chalk15.bold(currentCLIVersion)}..`,notLatest:chalk15.red(dedent`
      This version is behind the latest release, which is: ${chalk15.bold(latestCLIVersionOnNPM)}!
      You likely ran the upgrade command through npx, which can use a locally cached version, to upgrade to the latest version please run:
      ${chalk15.bold("npx storybook@latest upgrade")}
      
      You may want to CTRL+C to stop, and run with the latest version instead.
    `),prerelease:chalk15.yellow("This is a pre-release version.")};logger.plain(boxen([messages.welcome].concat(isCLIOutdated&&!isCLIPrerelease?[messages.notLatest]:[]).concat(isCLIPrerelease?[messages.prerelease]:[]).join(`
`),{borderStyle:"round",padding:1,borderColor}));let results,{configDir:inferredConfigDir,mainConfig:mainConfigPath}=getStorybookInfo(packageJson,userSpecifiedConfigDir),configDir=userSpecifiedConfigDir||inferredConfigDir||".storybook",mainConfig=await loadMainConfig({configDir});if(!beforeVersion)throw new UpgradeStorybookUnknownCurrentVersionError;if(!results&&typeof mainConfig!="boolean"&&typeof mainConfigPath<"u"&&!options.force){let blockResult=await autoblock({packageManager,configDir,packageJson,mainConfig,mainConfigPath});blockResult&&(results={preCheckFailure:blockResult});}if(!dryRun&&!results){let toUpgradedDependencies=deps=>Object.keys(deps||{}).filter(dependency=>dependency in versions).map(dependency=>{let char="^";return isCLIOutdated&&(char=""),isCanary&&(char=""),`${dependency}@${char}${versions[dependency]}`}),upgradedDependencies=toUpgradedDependencies(packageJson.dependencies),upgradedDevDependencies=toUpgradedDependencies(packageJson.devDependencies);logger.info(`Updating dependencies in ${chalk15.cyan("package.json")}..`),upgradedDependencies.length>0&&await packageManager.addDependencies({installAsDevDependencies:!1,skipInstall:!0,packageJson},upgradedDependencies),upgradedDevDependencies.length>0&&await packageManager.addDependencies({installAsDevDependencies:!0,skipInstall:!0,packageJson},upgradedDevDependencies),await packageManager.installDependencies();}if(!skipCheck&&!results&&mainConfigPath&&(checkVersionConsistency(),results=await automigrate({dryRun,yes,packageManager,configDir,mainConfigPath,beforeVersion,storybookVersion:currentCLIVersion,isUpgrade,isLatest:isCLIExactLatest})),!options.disableTelemetry){let{preCheckFailure,fixResults}=results||{};await telemetry$1("upgrade",{beforeVersion,afterVersion:currentCLIVersion,...{automigrationResults:preCheckFailure?null:fixResults,automigrationPreCheckFailure:preCheckFailure||null}});}};async function upgrade(options){await withTelemetry$1("upgrade",{cliOptions:options},()=>doUpgrade(options));}var baseTemplates={"cra/default-js":{name:"Create React App Latest (Webpack | JavaScript)",script:`
      npx create-react-app {{beforeDir}} && cd {{beforeDir}} &&       jq '.browserslist.production[0] = ">0.9%"' package.json > tmp.json && mv tmp.json package.json
    `,expected:{framework:"@storybook/react-webpack5",renderer:"@storybook/react",builder:"@storybook/builder-webpack5"},skipTasks:["e2e-tests-dev","bench"],modifications:{mainConfig:config=>({stories:config.getFieldValue(["stories"])?.map(s=>typeof s=="string"?s.replace(/\|(tsx?|ts)\b|\b(tsx?|ts)\|/g,""):s)})}},"cra/default-ts":{name:"Create React App Latest (Webpack | TypeScript)",script:`
      npx create-react-app {{beforeDir}} --template typescript && cd {{beforeDir}} &&       jq '.browserslist.production[0] = ">0.9%"' package.json > tmp.json && mv tmp.json package.json
    `,skipTasks:["smoke-test","bench"],expected:{framework:"@storybook/react-webpack5",renderer:"@storybook/react",builder:"@storybook/builder-webpack5"}},"nextjs/13-ts":{name:"Next.js v13.5 (Webpack | TypeScript)",script:'yarn create next-app {{beforeDir}} -e https://github.com/vercel/next.js/tree/next-13/examples/hello-world && cd {{beforeDir}} && npm pkg set "dependencies.next"="^13.5.6" && yarn && git add . && git commit --amend --no-edit && cd ..',expected:{framework:"@storybook/nextjs",renderer:"@storybook/react",builder:"@storybook/builder-webpack5"},modifications:{mainConfig:{features:{experimentalRSC:!0}},extraDependencies:["server-only"]},skipTasks:["e2e-tests-dev","bench"]},"nextjs/default-js":{name:"Next.js Latest (Webpack | JavaScript)",script:'yarn create next-app {{beforeDir}} --javascript --eslint --tailwind --app --import-alias="@/*" --src-dir',expected:{framework:"@storybook/nextjs",renderer:"@storybook/react",builder:"@storybook/builder-webpack5"},modifications:{mainConfig:{features:{experimentalRSC:!0}},extraDependencies:["server-only"]},skipTasks:["e2e-tests-dev","bench"]},"nextjs/default-ts":{name:"Next.js Latest (Webpack | TypeScript)",script:'yarn create next-app {{beforeDir}} --typescript --eslint --tailwind --app --import-alias="@/*" --src-dir',expected:{framework:"@storybook/nextjs",renderer:"@storybook/react",builder:"@storybook/builder-webpack5"},modifications:{mainConfig:{features:{experimentalRSC:!0}},extraDependencies:["server-only"]},skipTasks:["e2e-tests-dev","bench"]},"nextjs/prerelease":{name:"Next.js Prerelease (Webpack | TypeScript)",script:'npx create-next-app@canary {{beforeDir}} --typescript --eslint --tailwind --app --import-alias="@/*" --src-dir',expected:{framework:"@storybook/nextjs",renderer:"@storybook/react",builder:"@storybook/builder-webpack5"},modifications:{mainConfig:{features:{experimentalRSC:!0}},extraDependencies:["server-only"]},skipTasks:["e2e-tests-dev","bench"]},"react-vite/default-js":{name:"React Latest (Vite | JavaScript)",script:"npm create vite --yes {{beforeDir}} -- --template react",expected:{framework:"@storybook/react-vite",renderer:"@storybook/react",builder:"@storybook/builder-vite"},skipTasks:["e2e-tests-dev","bench"]},"react-vite/default-ts":{name:"React Latest (Vite | TypeScript)",script:"npm create vite --yes {{beforeDir}} -- --template react-ts",expected:{framework:"@storybook/react-vite",renderer:"@storybook/react",builder:"@storybook/builder-vite"},skipTasks:["bench"]},"react-vite/prerelease-ts":{name:"React Prerelease (Vite | TypeScript)",script:`
      npm create vite --yes {{beforeDir}} -- --template react-ts &&       cd {{beforeDir}} &&       yarn add react@beta react-dom@beta &&       jq '.resolutions += {"@types/react": "npm:types-react@beta", "@types/react-dom": "npm:types-react-dom@beta"}' package.json > tmp.json && mv tmp.json package.json &&       yarn add --dev @types/react@npm:types-react@beta @types/react-dom@npm:types-react-dom@beta
      `,expected:{framework:"@storybook/react-vite",renderer:"@storybook/react",builder:"@storybook/builder-vite"},skipTasks:["e2e-tests-dev","bench"]},"react-webpack/18-ts":{name:"React Latest (Webpack | TypeScript)",script:"yarn create webpack5-react {{beforeDir}}",expected:{framework:"@storybook/react-webpack5",renderer:"@storybook/react",builder:"@storybook/builder-webpack5"},skipTasks:["e2e-tests-dev","bench"]},"react-webpack/17-ts":{name:"React v17 (Webpack | TypeScript)",script:'yarn create webpack5-react {{beforeDir}} --version-react="17" --version-react-dom="17"',expected:{framework:"@storybook/react-webpack5",renderer:"@storybook/react",builder:"@storybook/builder-webpack5"},skipTasks:["e2e-tests-dev","bench"]},"react-webpack/prerelease-ts":{name:"React Prerelease (Webpack | TypeScript)",script:`
      yarn create webpack5-react {{beforeDir}} --version-react="beta" --version-react-dom="beta" &&       cd {{beforeDir}} &&       jq '.resolutions += {"@types/react": "npm:types-react@beta", "@types/react-dom": "npm:types-react-dom@beta"}' package.json > tmp.json && mv tmp.json package.json &&       yarn add --dev @types/react@npm:types-react@beta @types/react-dom@npm:types-react-dom@beta
      `,expected:{framework:"@storybook/react-webpack5",renderer:"@storybook/react",builder:"@storybook/builder-webpack5"},skipTasks:["e2e-tests-dev","bench"]},"solid-vite/default-js":{name:"SolidJS Latest (Vite | JavaScript)",script:"npx degit solidjs/templates/js {{beforeDir}}",expected:{framework:"storybook-solidjs-vite",renderer:"storybook-solidjs",builder:"@storybook/builder-vite"},inDevelopment:!0,skipTasks:["e2e-tests-dev","bench"]},"solid-vite/default-ts":{name:"SolidJS Latest (Vite | TypeScript)",script:"npx degit solidjs/templates/ts {{beforeDir}}",expected:{framework:"storybook-solidjs-vite",renderer:"storybook-solidjs",builder:"@storybook/builder-vite"},inDevelopment:!0,skipTasks:["e2e-tests-dev","bench"]},"vue3-vite/default-js":{name:"Vue v3 (Vite | JavaScript)",script:"npm create vite --yes {{beforeDir}} -- --template vue",expected:{framework:"@storybook/vue3-vite",renderer:"@storybook/vue3",builder:"@storybook/builder-vite"},skipTasks:["e2e-tests-dev","bench"]},"vue3-vite/default-ts":{name:"Vue v3 (Vite | TypeScript)",script:"npm create vite --yes {{beforeDir}} -- --template vue-ts",expected:{framework:"@storybook/vue3-vite",renderer:"@storybook/vue3",builder:"@storybook/builder-vite"},skipTasks:["e2e-tests-dev","bench"]},"html-webpack/default":{name:"HTML Latest (Webpack | JavaScript)",script:"yarn create webpack5-html {{beforeDir}}",expected:{framework:"@storybook/html-webpack5",renderer:"@storybook/html",builder:"@storybook/builder-webpack5"},skipTasks:["e2e-tests-dev","bench"]},"html-vite/default-js":{name:"HTML Latest (Vite | JavaScript)",script:'npm create vite --yes {{beforeDir}} -- --template vanilla && cd {{beforeDir}} && echo "export default {}" > vite.config.js',expected:{framework:"@storybook/html-vite",renderer:"@storybook/html",builder:"@storybook/builder-vite"},skipTasks:["e2e-tests-dev","bench"]},"html-vite/default-ts":{name:"HTML Latest (Vite | TypeScript)",script:'npm create vite --yes {{beforeDir}} -- --template vanilla-ts && cd {{beforeDir}} && echo "export default {}" > vite.config.js',expected:{framework:"@storybook/html-vite",renderer:"@storybook/html",builder:"@storybook/builder-vite"},skipTasks:["e2e-tests-dev","bench"]},"svelte-vite/default-js":{name:"Svelte Latest (Vite | JavaScript)",script:"npm create vite --yes {{beforeDir}} -- --template svelte",expected:{framework:"@storybook/svelte-vite",renderer:"@storybook/svelte",builder:"@storybook/builder-vite"},skipTasks:["e2e-tests-dev","bench"]},"svelte-vite/default-ts":{name:"Svelte Latest (Vite | TypeScript)",script:"npm create vite --yes {{beforeDir}} -- --template svelte-ts",expected:{framework:"@storybook/svelte-vite",renderer:"@storybook/svelte",builder:"@storybook/builder-vite"},skipTasks:["smoke-test","e2e-tests-dev","bench"]},"angular-cli/prerelease":{name:"Angular CLI Prerelease (Webpack | TypeScript)",script:"npx -p @angular/cli@next ng new angular-v16 --directory {{beforeDir}} --routing=true --minimal=true --style=scss --strict --skip-git --skip-install --package-manager=yarn --ssr",expected:{framework:"@storybook/angular",renderer:"@storybook/angular",builder:"@storybook/builder-webpack5"},skipTasks:["e2e-tests-dev","bench"]},"angular-cli/default-ts":{name:"Angular CLI Latest (Webpack | TypeScript)",script:"npx -p @angular/cli ng new angular-latest --directory {{beforeDir}} --routing=true --minimal=true --style=scss --strict --skip-git --skip-install --package-manager=yarn --ssr",expected:{framework:"@storybook/angular",renderer:"@storybook/angular",builder:"@storybook/builder-webpack5"},skipTasks:["e2e-tests-dev","bench"]},"angular-cli/15-ts":{name:"Angular CLI v15 (Webpack | TypeScript)",script:"npx -p @angular/cli@15 ng new angular-v15 --directory {{beforeDir}} --routing=true --minimal=true --style=scss --strict --skip-git --skip-install --package-manager=yarn",expected:{framework:"@storybook/angular",renderer:"@storybook/angular",builder:"@storybook/builder-webpack5"},skipTasks:["e2e-tests-dev","bench"]},"svelte-kit/skeleton-js":{name:"SvelteKit Latest (Vite | JavaScript)",script:"yarn create svelte-with-args --name=svelte-kit/skeleton-js --directory={{beforeDir}} --template=skeleton --types=null --no-prettier --no-eslint --no-playwright --no-vitest --no-svelte5",expected:{framework:"@storybook/sveltekit",renderer:"@storybook/svelte",builder:"@storybook/builder-vite"},skipTasks:["e2e-tests-dev","bench"]},"svelte-kit/skeleton-ts":{name:"SvelteKit Latest (Vite | TypeScript)",script:"yarn create svelte-with-args --name=svelte-kit/skeleton-ts --directory={{beforeDir}} --template=skeleton --types=typescript --no-prettier --no-eslint --no-playwright --no-vitest --no-svelte5",expected:{framework:"@storybook/sveltekit",renderer:"@storybook/svelte",builder:"@storybook/builder-vite"},skipTasks:["e2e-tests-dev","bench"]},"svelte-kit/prerelease-ts":{name:"SvelteKit Prerelease (Vite | TypeScript)",script:"yarn create svelte-with-args --name=svelte-kit/prerelease-ts --directory={{beforeDir}} --template=skeleton --types=typescript --no-prettier --no-eslint --no-playwright --no-vitest --svelte5",expected:{framework:"@storybook/sveltekit",renderer:"@storybook/svelte",builder:"@storybook/builder-vite"},skipTasks:["e2e-tests-dev","bench"]},"lit-vite/default-js":{name:"Lit Latest (Vite | JavaScript)",script:'npm create vite --yes {{beforeDir}} -- --template lit && cd {{beforeDir}} && echo "export default {}" > vite.config.js',expected:{framework:"@storybook/web-components-vite",renderer:"@storybook/web-components",builder:"@storybook/builder-vite"},skipTasks:["smoke-test","e2e-tests-dev","bench"]},"lit-vite/default-ts":{name:"Lit Latest (Vite | TypeScript)",script:'npm create vite --yes {{beforeDir}} -- --template lit-ts && cd {{beforeDir}} && echo "export default {}" > vite.config.js',expected:{framework:"@storybook/web-components-vite",renderer:"@storybook/web-components",builder:"@storybook/builder-vite"},skipTasks:["smoke-test","e2e-tests-dev","bench"]},"vue-cli/default-js":{name:"Vue CLI v3 (Webpack | JavaScript)",script:'npx -p @vue/cli vue create {{beforeDir}} --default --packageManager=yarn --force --merge && cd {{beforeDir}} && echo "module.exports = {}" > webpack.config.js',expected:{framework:"@storybook/vue3-webpack5",renderer:"@storybook/vue3",builder:"@storybook/builder-webpack5"},skipTasks:["smoke-test","e2e-tests-dev","bench"]},"preact-vite/default-js":{name:"Preact Latest (Vite | JavaScript)",script:"npm create vite --yes {{beforeDir}} -- --template preact",expected:{framework:"@storybook/preact-vite",renderer:"@storybook/preact",builder:"@storybook/builder-vite"},modifications:{extraDependencies:["preact-render-to-string"]},skipTasks:["e2e-tests-dev","bench"]},"preact-vite/default-ts":{name:"Preact Latest (Vite | TypeScript)",script:"npm create vite --yes {{beforeDir}} -- --template preact-ts",expected:{framework:"@storybook/preact-vite",renderer:"@storybook/preact",builder:"@storybook/builder-vite"},modifications:{extraDependencies:["preact-render-to-string"]},skipTasks:["e2e-tests-dev","bench"]},"qwik-vite/default-ts":{name:"Qwik CLI Latest (Vite | TypeScript)",script:"npm create qwik basic {{beforeDir}}",inDevelopment:!0,expected:{framework:"storybook-framework-qwik",renderer:"storybook-framework-qwik",builder:"storybook-framework-qwik"},skipTasks:["e2e-tests","e2e-tests-dev","bench"]},"ember/3-js":{name:"Ember v3 (Webpack | JavaScript)",script:"npx --package ember-cli@3.28.1 ember new {{beforeDir}}",inDevelopment:!0,expected:{framework:"@storybook/ember",renderer:"@storybook/ember",builder:"@storybook/builder-webpack5"}},"ember/default-js":{name:"Ember v4 (Webpack | JavaScript)",script:"npx --package ember-cli@4.12.1 ember new {{beforeDir}} --yarn && cd {{beforeDir}} && yarn add --dev @storybook/ember-cli-storybook && yarn build",inDevelopment:!0,expected:{framework:"@storybook/ember",renderer:"@storybook/ember",builder:"@storybook/builder-webpack5"}}},internalTemplates={"internal/react18-webpack-babel":{name:"React with Babel Latest (Webpack | TypeScript)",script:"yarn create webpack5-react {{beforeDir}}",expected:{framework:"@storybook/react-webpack5",renderer:"@storybook/react",builder:"@storybook/builder-webpack5"},modifications:{extraDependencies:["@storybook/addon-webpack5-compiler-babel"],editAddons:addons=>[...addons,"@storybook/addon-webpack5-compiler-babel"].filter(a=>a!=="@storybook/addon-webpack5-compiler-swc")},isInternal:!0,skipTasks:["e2e-tests-dev","bench"]},"internal/react16-webpack":{name:"React 16 (Webpack | TypeScript)",script:"yarn create webpack5-react {{beforeDir}} --version-react=16 --version-react-dom=16 --version-@types/react=16 --version-@types/react-dom=16",expected:{framework:"@storybook/react-webpack5",renderer:"@storybook/react",builder:"@storybook/builder-webpack5"},skipTasks:["e2e-tests-dev","bench"],isInternal:!0},"internal/server-webpack5":{name:"Server Webpack5",script:'yarn init -y && echo "module.exports = {}" > webpack.config.js',expected:{framework:"@storybook/server-webpack5",renderer:"@storybook/server",builder:"@storybook/builder-webpack5"},isInternal:!0,skipTasks:["bench"]}},benchTemplates={"bench/react-vite-default-ts":{...baseTemplates["react-vite/default-ts"],name:"Bench (react-vite/default-ts)",isInternal:!0,modifications:{skipTemplateStories:!0},skipTasks:["e2e-tests-dev","test-runner","test-runner-dev","e2e-tests","chromatic"]},"bench/react-webpack-18-ts":{...baseTemplates["react-webpack/18-ts"],name:"Bench (react-webpack/18-ts)",isInternal:!0,modifications:{skipTemplateStories:!0},skipTasks:["e2e-tests-dev","test-runner","test-runner-dev","e2e-tests","chromatic"]},"bench/react-vite-default-ts-nodocs":{...baseTemplates["react-vite/default-ts"],name:"Bench (react-vite/default-ts, no docs)",isInternal:!0,modifications:{skipTemplateStories:!0,disableDocs:!0},skipTasks:["e2e-tests-dev","test-runner","test-runner-dev","e2e-tests","chromatic"]},"bench/react-vite-default-ts-test-build":{...baseTemplates["react-vite/default-ts"],name:"Bench (react-vite/default-ts, test-build)",isInternal:!0,modifications:{skipTemplateStories:!0,testBuild:!0},skipTasks:["e2e-tests-dev","test-runner","test-runner-dev","e2e-tests"]},"bench/react-webpack-18-ts-test-build":{...baseTemplates["react-webpack/18-ts"],name:"Bench (react-webpack/18-ts, test-build)",isInternal:!0,modifications:{skipTemplateStories:!0,testBuild:!0},skipTasks:["e2e-tests-dev","test-runner","test-runner-dev","e2e-tests"]}},allTemplates={...baseTemplates,...internalTemplates,...benchTemplates};var logger27=console,toChoices=c=>({title:allTemplates[c].name,value:c}),sandbox=async({output:outputDirectory,filterValue,init,...options})=>{let selectedConfig=allTemplates[filterValue],templateId=selectedConfig?filterValue:null,{packageManager:pkgMgr}=options,packageManager=JsPackageManagerFactory.getPackageManager({force:pkgMgr}),latestVersion=await packageManager.latestVersion("storybook"),nextVersion=await packageManager.latestVersion("storybook@next").catch(e=>"0.0.0"),currentVersion=versions.storybook,isPrerelease=prerelease(currentVersion),isOutdated=lt(currentVersion,isPrerelease?nextVersion:latestVersion),borderColor=isOutdated?"#FC521F":"#F1618C",downloadType=!isOutdated&&init?"after-storybook":"before-storybook",branch=isPrerelease?"next":"main",messages={welcome:`Creating a Storybook ${chalk15.bold(currentVersion)} sandbox..`,notLatest:chalk15.red(dedent`
      This version is behind the latest release, which is: ${chalk15.bold(latestVersion)}!
      You likely ran the init command through npx, which can use a locally cached version, to get the latest please run:
      ${chalk15.bold("npx storybook@latest sandbox")}
      
      You may want to CTRL+C to stop, and run with the latest version instead.
    `),longInitTime:chalk15.yellow("The creation of the sandbox will take longer, because we will need to run init."),prerelease:chalk15.yellow("This is a pre-release version.")};if(logger27.log(boxen([messages.welcome].concat(isOutdated&&!isPrerelease?[messages.notLatest]:[]).concat(init&&(isOutdated||isPrerelease)?[messages.longInitTime]:[]).concat(isPrerelease?[messages.prerelease]:[]).join(`
`),{borderStyle:"round",padding:1,borderColor})),!selectedConfig){let filterRegex=new RegExp(`^${filterValue||""}`,"i"),keys=Object.keys(allTemplates),choices=keys.reduce((acc,group)=>{let current=allTemplates[group];return (!filterValue||current.name.match(filterRegex)||group.match(filterRegex)||current.expected.builder.match(filterRegex)||current.expected.framework.match(filterRegex)||current.expected.renderer.match(filterRegex))&&acc.push(group),acc},[]);if(choices.length===0&&(logger27.info(boxen(dedent`
            🔎 You filtered out all templates. 🔍

            After filtering all the templates with "${chalk15.yellow(filterValue)}", we found no results. Please try again with a different filter.

            Available templates:
            ${keys.map(key=>chalk15.blue`- ${key}`).join(`
`)}
            `.trim(),{borderStyle:"round",padding:1,borderColor:"#F1618C"})),process.exit(1)),choices.length===1?[templateId]=choices:(logger27.info(boxen(dedent`
            🤗 Welcome to ${chalk15.yellow("sb sandbox")}! 🤗

            Create a ${chalk15.green("new project")} to minimally reproduce Storybook issues.

            1. select an environment that most closely matches your project setup.
            2. select a location for the reproduction, outside of your project.

            After the reproduction is ready, we'll guide you through the next steps.
            `.trim(),{borderStyle:"round",padding:1,borderColor:"#F1618C"})),templateId=await promptSelectedTemplate(choices)),!!!(templateId??null)){logger27.error("Somehow we got no templates. Please rerun this command!");return}if(selectedConfig=templateId?allTemplates[templateId]:void 0,!selectedConfig)throw new Error("\u{1F6A8} Sandbox: please specify a valid template type")}let selectedDirectory=outputDirectory,outputDirectoryName=outputDirectory||templateId;if(selectedDirectory&&existsSync(`${selectedDirectory}`)&&logger27.info(`\u26A0\uFE0F  ${selectedDirectory} already exists! Overwriting...`),!selectedDirectory){let{directory}=await prompts5({type:"text",message:"Enter the output directory",name:"directory",initial:outputDirectoryName??void 0,validate:async directoryName=>existsSync(directoryName)?`${directoryName} already exists. Please choose another name.`:!0},{onCancel:()=>{logger27.log("Command cancelled by the user. Exiting..."),process.exit(1);}});selectedDirectory=directory;}invariant5(selectedDirectory);try{let templateDestination=path8.isAbsolute(selectedDirectory)?selectedDirectory:path8.join(process.cwd(),selectedDirectory);logger27.info(`\u{1F3C3} Adding ${selectedConfig.name} into ${templateDestination}`),logger27.log(`\u{1F4E6} Downloading sandbox template (${chalk15.bold(downloadType)})...`);try{let gitPath=`github:storybookjs/sandboxes/${templateId}/${downloadType}#${branch}`;if(await downloadTemplate(gitPath,{force:!0,dir:templateDestination}),(await readdir(templateDestination)).length===0){let selected=chalk15.yellow(templateId);throw new Error(dedent`
          Template downloaded from ${chalk15.blue(gitPath)} is empty.
          Are you use it exists? Or did you want to set ${selected} to inDevelopment first?
        `)}if(downloadType==="before-storybook"&&init){let before=process.cwd();process.chdir(templateDestination),await doInitiate({dev:process.env.CI!=="true"&&process.env.IN_STORYBOOK_SANBOX!=="true",...options}),process.chdir(before);}}catch(err){throw logger27.error(`\u{1F6A8} Failed to download sandbox template: ${String(err)}`),err}let initMessage=init?chalk15.yellow(dedent`
          yarn install
          yarn storybook
        `):`Recreate your setup, then ${chalk15.yellow("npx storybook@latest init")}`;logger27.info(boxen(dedent`
        🎉 Your Storybook reproduction project is ready to use! 🎉

        ${chalk15.yellow(`cd ${selectedDirectory}`)}
        ${initMessage}

        Once you've recreated the problem you're experiencing, please:

        1. Document any additional steps in ${chalk15.cyan("README.md")}
        2. Publish the repository to github
        3. Link to the repro repository in your issue

        Having a clean repro helps us solve your issue faster! 🙏
      `.trim(),{borderStyle:"round",padding:1,borderColor:"#F1618C"}));}catch(error){throw logger27.error("\u{1F6A8} Failed to create sandbox"),error}};async function promptSelectedTemplate(choices){let{template}=await prompts5({type:"select",message:"\u{1F308} Select the template",name:"template",choices:choices.map(toChoices)},{onCancel:()=>{logger27.log("Command cancelled by the user. Exiting..."),process.exit(1);}});return template||null}var exec2=async(command,options={},{startMessage,errorMessage,dryRun}={})=>{if(startMessage&&logger.info(startMessage),dryRun){logger.info(`
> ${command}
`);return}return logger.info(command),new Promise((resolve2,reject)=>{let child=spawn$1(command,{...options,shell:!0,stdio:"pipe"});child.stderr.pipe(process.stdout),child.stdout.pipe(process.stdout),child.on("exit",code=>{code===0?resolve2(void 0):(logger.error(chalk15.red(`An error occurred while executing: \`${command}\``)),errorMessage&&logger.info(errorMessage),reject(new Error(`command exited with code: ${code}: `)));});})},link=async({target,local,start})=>{let storybookDir=process.cwd();try{if((await fse.readJSON("package.json")).name!=="@storybook/root")throw new Error}catch{throw new Error("Expected to run link from the root of the storybook monorepo")}let reproDir=target,reproName=path8.basename(target);if(!local){let reprosDir=path8.join(storybookDir,"../storybook-repros");logger.info(`Ensuring directory ${reprosDir}`),await fse.ensureDir(reprosDir),logger.info(`Cloning ${target}`),await exec2(`git clone ${target}`,{cwd:reprosDir}),reproName=path8.basename(target,path8.extname(target)),reproDir=path8.join(reprosDir,reproName);}let reproPackageJson=await fse.readJSON(path8.join(reproDir,"package.json")),version=sync("yarn",["--version"],{cwd:reproDir,stdio:"pipe",shell:!0}).stdout.toString();if(!/^[2-4]\./.test(version)){logger.warn(`\u{1F6A8} Expected yarn 2 or higher in ${reproDir}!`),logger.warn(""),logger.warn("Please set it up with `yarn set version berry`,"),logger.warn(`then link '${reproDir}' with the '--local' flag.`);return}logger.info(`Linking ${reproDir}`),await exec2(`yarn link --all --relative ${storybookDir}`,{cwd:reproDir}),logger.info(`Installing ${reproName}`),await exec2("yarn install",{cwd:reproDir}),reproPackageJson.devDependencies?.vite||await exec2("yarn add -D webpack-hot-middleware",{cwd:reproDir}),await exec2("yarn add @types/node@18",{cwd:reproDir}),start&&(logger.info(`Running ${reproName} storybook`),await exec2("yarn run storybook",{cwd:reproDir}));};function printError(error){instance.heading="",error instanceof Error?error.error?logger.error(error.error):error.stats&&error.stats.compilation.errors?error.stats.compilation.errors.forEach(e=>logger.plain(e)):logger.error(error):error.compilation?.errors&&error.compilation.errors.forEach(e=>logger.plain(e)),logger.line(),logger.warn(error.close?dedent`
          FATAL broken build!, will close the process,
          Fix the error below and restart storybook.
        `:dedent`
          Broken build, fix the error above.
          You may need to refresh the browser.
        `),logger.line();}var dev=async cliOptions=>{process.env.NODE_ENV=process.env.NODE_ENV||"development";let packageJson=await findPackage(__dirname);invariant5(packageJson,"Failed to find the closest package.json file.");let options={...cliOptions,configDir:cliOptions.configDir||"./.storybook",configType:"DEVELOPMENT",ignorePreview:!!cliOptions.previewUrl&&!cliOptions.forceBuildPreview,cache,packageJson};await withTelemetry("dev",{cliOptions,presetOptions:options,printError},()=>buildDevStandalone(options));};var build=async cliOptions=>{let packageJson=await findPackage(__dirname);invariant5(packageJson,"Failed to find the closest package.json file.");let options={...cliOptions,configDir:cliOptions.configDir||"./.storybook",outputDir:cliOptions.outputDir||"./storybook-static",ignorePreview:!!cliOptions.previewUrl&&!cliOptions.forceBuildPreview,configType:"PRODUCTION",cache:cache,packageJson};await withTelemetry("build",{cliOptions,presetOptions:options},()=>buildStaticStandalone(options));};var args=process.argv.slice(2);if(["migrate","automigrate"].includes(args[0])){let command=["npx",`@storybook/toolbox@${versions.storybook}`,...args];console.log(command.join(" ")),spawn(command[0],command.slice(1),{stdio:"inherit"}).on("exit",code=>{code!=null&&process.exit(code),process.exit(1);});}else {addToGlobalContext("cliVersion",versions.storybook);let pkg=findPackageSync(__dirname);invariant5(pkg,"Failed to find the closest package.json file.");let consoleLogger=console,command=name=>program.command(name).option("--disable-telemetry","Disable sending telemetry data",process.env.STORYBOOK_DISABLE_TELEMETRY&&process.env.STORYBOOK_DISABLE_TELEMETRY!=="false").option("--debug","Get more logs in debug mode",!1).option("--enable-crash-reports","Enable sending crash reports to telemetry data");command("init").description("Initialize Storybook into your project.").option("-f --force","Force add Storybook").option("-s --skip-install","Skip installing deps").option("--package-manager <npm|pnpm|yarn1|yarn2>","Force package manager for installing deps").option("--use-pnp","Enable pnp mode for Yarn 2+").option("-p --parser <babel | babylon | flow | ts | tsx>","jscodeshift parser").option("-t --type <type>","Add Storybook for a specific project type").option("-y --yes","Answer yes to all prompts").option("-b --builder <webpack5 | vite>","Builder library").option("-l --linkable","Prepare installation for link (contributor helper)").option("--dev","Launch the development server after completing initialization. Enabled by default",process.env.CI!=="true"&&process.env.IN_STORYBOOK_SANDBOX!=="true").option("--no-dev","Complete the initialization of Storybook without launching the Storybook development server").action(options=>{initiate(options).catch(()=>process.exit(1));}),command("add <addon>").description("Add an addon to your Storybook").option("--package-manager <npm|pnpm|yarn1|yarn2>","Force package manager for installing dependencies").option("-c, --config-dir <dir-name>","Directory where to load Storybook configurations from").option("-s --skip-postinstall","Skip package specific postinstall config modifications").action((addonName,options)=>add(addonName,options)),command("remove <addon>").description("Remove an addon from your Storybook").option("--package-manager <npm|pnpm|yarn1|yarn2>","Force package manager for installing dependencies").action((addonName,options)=>withTelemetry("remove",{cliOptions:options},async()=>{await removeAddon(addonName,options),options.disableTelemetry||await telemetry("remove",{addon:addonName,source:"cli"});})),command("upgrade").description(`Upgrade your Storybook packages to v${versions.storybook}`).option("--package-manager <npm|pnpm|yarn1|yarn2>","Force package manager for installing dependencies").option("-y --yes","Skip prompting the user").option("-f --force","force the upgrade, skipping autoblockers").option("-n --dry-run","Only check for upgrades, do not install").option("-s --skip-check","Skip postinstall version and automigration checks").option("-c, --config-dir <dir-name>","Directory where to load Storybook configurations from").action(async options=>upgrade(options).catch(()=>process.exit(1))),command("info").description("Prints debugging information about the local environment").action(async()=>{consoleLogger.log(chalk15.bold(`
Storybook Environment Info:`));let activePackageManager=(await JsPackageManagerFactory.getPackageManager()).type.replace(/\d/,""),output=await envinfo.run({System:["OS","CPU","Shell"],Binaries:["Node","Yarn","npm","pnpm"],Browsers:["Chrome","Edge","Firefox","Safari"],npmPackages:"{@storybook/*,*storybook*,sb,chromatic}",npmGlobalPackages:"{@storybook/*,*storybook*,sb,chromatic}"}),activePackageManagerLine=output.match(new RegExp(`${activePackageManager}:.*`,"i"));consoleLogger.log(output.replace(activePackageManagerLine,chalk15.bold(`${activePackageManagerLine} <----- active`)));}),command("sandbox [filterValue]").alias("repro").description("Create a sandbox from a set of possible templates").option("-o --output <outDir>","Define an output directory").option("--no-init","Whether to download a template without an initialized Storybook",!1).action((filterValue,options)=>sandbox({filterValue,...options}).catch(e=>{logger.error(e),process.exit(1);})),command("link <repo-url-or-directory>").description("Pull down a repro from a URL (or a local directory), link it, and run storybook").option("--local","Link a local directory already in your file system").option("--no-start","Start the storybook",!0).action((target,{local,start})=>link({target,local,start}).catch(e=>{logger.error(e),process.exit(1);})),command("doctor").description("Check Storybook for known problems and provide suggestions or fixes").option("--package-manager <npm|pnpm|yarn1|yarn2>","Force package manager").option("-c, --config-dir <dir-name>","Directory of Storybook configuration").action(async options=>{await doctor(options).catch(e=>{logger.error(e),process.exit(1);});}),command("dev").option("-p, --port <number>","Port to run Storybook",str=>parseInt(str,10)).option("-h, --host <string>","Host to run Storybook").option("-c, --config-dir <dir-name>","Directory where to load Storybook configurations from").option("--https","Serve Storybook over HTTPS. Note: You must provide your own certificate information.").option("--ssl-ca <ca>","Provide an SSL certificate authority. (Optional with --https, required if using a self-signed certificate)",parseList).option("--ssl-cert <cert>","Provide an SSL certificate. (Required with --https)").option("--ssl-key <key>","Provide an SSL key. (Required with --https)").option("--smoke-test","Exit after successful start").option("--ci","CI mode (skip interactive prompts, don't open browser)").option("--no-open","Do not open Storybook automatically in the browser").option("--loglevel <level>","Control level of logging during build").option("--quiet","Suppress verbose build output").option("--no-version-updates","Suppress update check",!0).option("--debug-webpack","Display final webpack configurations for debugging purposes").option("--webpack-stats-json [directory]","Write Webpack stats JSON to disk (synonym for `--stats-json`)").option("--stats-json [directory]","Write stats JSON to disk").option("--preview-url <string>","Disables the default storybook preview and lets your use your own").option("--force-build-preview","Build the preview iframe even if you are using --preview-url").option("--docs","Build a documentation-only site using addon-docs").option("--exact-port","Exit early if the desired port is not available").option("--initial-path [path]","URL path to be appended when visiting Storybook for the first time").action(async options=>{logger.setLevel(program.loglevel),consoleLogger.log(chalk15.bold(`${pkg.name} v${pkg.version}`)+chalk15.reset(`
`)),getEnvConfig(options,{port:"SBCONFIG_PORT",host:"SBCONFIG_HOSTNAME",staticDir:"SBCONFIG_STATIC_DIR",configDir:"SBCONFIG_CONFIG_DIR",ci:"CI"}),parseInt(`${options.port}`,10)&&(options.port=parseInt(`${options.port}`,10)),await dev({...options,packageJson:pkg}).catch(()=>process.exit(1));}),command("build").option("-o, --output-dir <dir-name>","Directory where to store built files").option("-c, --config-dir <dir-name>","Directory where to load Storybook configurations from").option("--quiet","Suppress verbose build output").option("--loglevel <level>","Control level of logging during build").option("--debug-webpack","Display final webpack configurations for debugging purposes").option("--webpack-stats-json [directory]","Write Webpack stats JSON to disk (synonym for `--stats-json`)").option("--stats-json [directory]","Write stats JSON to disk").option("--preview-url <string>","Disables the default storybook preview and lets your use your own").option("--force-build-preview","Build the preview iframe even if you are using --preview-url").option("--docs","Build a documentation-only site using addon-docs").option("--test","Build stories optimized for testing purposes.").action(async options=>{process.env.NODE_ENV=process.env.NODE_ENV||"production",logger.setLevel(program.loglevel),consoleLogger.log(chalk15.bold(`${pkg.name} v${pkg.version}
`)),getEnvConfig(options,{staticDir:"SBCONFIG_STATIC_DIR",outputDir:"SBCONFIG_OUTPUT_DIR",configDir:"SBCONFIG_CONFIG_DIR"}),await build({...options,packageJson:pkg,test:!!options.test||process.env.SB_TESTBUILD==="true"}).catch(()=>process.exit(1));}),program.on("command:*",([invalidCmd])=>{consoleLogger.error(` Invalid command: %s.
 See --help for a list of available commands.`,invalidCmd);let suggestion=program.commands.map(cmd=>cmd._name).find(cmd=>leven(cmd,invalidCmd)<3);suggestion&&consoleLogger.info(`
 Did you mean ${suggestion}?`),process.exit(1);}),program.usage("<command> [options]").version(String(pkg.version)).parse(process.argv);}
